# -*- coding: UTF-8 -*-
# Copyright 2003 - 2008: Julien Bourdaillet (julien.bourdaillet@lip6.fr), Jean-Gabriel Ganascia (jean-gabriel.ganascia@lip6.fr)
# This file is part of MEDITE.
#
#    MEDITE is free software; you can redistribute it and/or modify
#    it under the terms of the GNU General Public License as published by
#    the Free Software Foundation; either version 2 of the License, or
#    (at your option) any later version.
#
#    MEDITE is distributed in the hope that it will be useful,
#    but WITHOUT ANY WARRANTY; without even the implied warranty of
#    MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
#    GNU General Public License for more details.
#
#    You should have received a copy of the GNU General Public License
#    along with Foobar; if not, write to the Free Software
#    Foundation, Inc., 51 Franklin St, Fifth Floor, Boston, MA  02110-1301  USA
#----------------------------------------------------------------------------
# Nom:          cInformations.py
# Objet:        Classe qui interface entre les fichiers xml et l'interface graphique
#----------------------------------------------------------------------------


#from xml.dom.pulldom import *
#from xml.dom.minidom import Document
import os
import posixpath
import traceback
import logging,gc,sys
# import xml                                                  # Ajoutee 28.03.2019  
# from xml import *
# import xml.dom                                              # Ajoutee 28.03.2019  
# import xml.dom.minidom
# from xml.dom.minidom import *                               # Ajoutee 28.03.2019 
# import xml.dom.pulldom
# import Ft.Xml, Ft.Xml.XPath                                # Desactivee 28.03.2019, 4Suite n'existe plus.
# from Ft.Xml import MarkupWriter                            # Desactivee 28.03.2019, 4Suite n'existe plus.
from xml.sax import make_parser, SAXException
from xml.sax.handler import ContentHandler
import lxml                                                 # Ajoutee 28.03.2019 
import lxml.includes                                        # Ajoutee 28.03.2019 
import lxml.etree                                           # Ajoutee 28.03.2019 
from lxml.etree import XPath                                # Ajoutee 14.05.2019
#import lxml.etree.XPath                                     # Ajoutee 28.03.2019 
from string import *
# import numpy.oldnumeric as Numeric                        # Desactivee 04.04.2019 
import numpy as np                                          # Ajoutee 04.04.2019 
from Utile.constantesDonnees import *
from Utile.exceptionsDonnees import *

from Donnees.resultatAppli import *
from Utile.codageXml import *
from Donnees.arbre import *
import Utile.decodage
from Donnees.planTravail import *
import Controleurs.DGManager
import Controleurs.FInfoManager

import Donnees.resultatAppli

import xml                                                  # Ajoutee 28.03.2019  
from xml import *
import xml.dom                                              # Ajoutee 28.03.2019  
import xml.dom.minidom
from xml.dom.minidom import *                               # Ajoutee 28.03.2019 
import sys                                                  # Ajoutee 28.03.2019
from bs4 import BeautifulSoup                               # Ajoutee 15.05.2019
#import xml.sax.saxutils                                     # Ajoutee 28.05.2019
from xml.sax.saxutils import XMLGenerator                              # Ajoutee 28.05.2019

class CInformations(object):
    def __init__(self, stream=False):
        """ stream ecrit un nouveau doc en stream, il ecrase le fichier existant
        mais permet d'ecrire des gros doc xml""" 
        self.dgm = Controleurs.DGManager.DGManager()
        self.stream = stream
        # print("1. Module: Controleurs.cInformations, Class: CInformations, Methode: __init__, Ligne 77 ---> ")

    # Methode qui enregistre les informations d'un couple d'états
    def existeInformations__(self, planTravail):
        """Methode qui renvoie vrai si des informations existent sur un couple de etats
        pre: isinstance(planTravail, Donnees.planTravail.PlanTravail) """
        if planTravail.getParam().isNull(): return False                    
        nomDG = self.dgm.getDG(planTravail.getAuteur(), planTravail.getOeuvre())
        fim =  Controleurs.FInfoManager.FInfoManager(Controleurs.DGManager.Auteur(planTravail.getAuteur()), Controleurs.DGManager.Oeuvre(planTravail.getOeuvre()))
        fic = lireDocXml(fim.getFileInfo())
        pParametres = planTravail.getParam()
        liste = fic.getElementsByTagName(B_INFORMATIONS)
        # print("1-1. Module: Controleurs.cInformations, Class: CInformations, Methode: existeInformations__, Ligne 89, \nliste=[", str(liste), "], \nnomDG=", nomDG, ", planTravail.getAuteur()=", planTravail.getAuteur(), ", planTravail.getOeuvre()=", planTravail.getOeuvre(), " ")
        # for nodeprint in liste:
            # print("2. Module: Controleurs.cInformations, Class: CInformations, Methode: existeInformations__, Ligne 91, nomDG=", nomDG)
            # print("3. Module: Controleurs.cInformations, Class: CInformations, Methode: existeInformations__, Ligne 92, \nnode.getAttribute(B_VERS_SOURCE)=", nodeprint.getAttribute(B_VERS_SOURCE), ", planTravail.getVersionSource()=", planTravail.getVersionSource())
            # print("4. Module: Controleurs.cInformations, Class: CInformations, Methode: existeInformations__, Ligne 93, \nnode.getAttribute(B_ETAT_SOURCE)=", nodeprint.getAttribute(B_ETAT_SOURCE), ", planTravail.getEtatSource()=", planTravail.getEtatSource())
            # print("5. Module: Controleurs.cInformations, Class: CInformations, Methode: existeInformations__, Ligne 94, \nnode.getAttribute(B_ETAT_CIBLE)=", nodeprint.getAttribute(B_ETAT_CIBLE), ", planTravail.getEtatCible()=", planTravail.getEtatCible())
            # print("6. Module: Controleurs.cInformations, Class: CInformations, Methode: existeInformations__, Ligne 95, \nnode.getAttribute(B_ETAT_CIBLE)=", nodeprint.getAttribute(B_ETAT_CIBLE), ", planTravail.getEtatCible()=", planTravail.getEtatCible())
            # print("7. Module: Controleurs.cInformations, Class: CInformations, Methode: existeInformations__, Ligne 96, \nnode.getAttribute(B_PARAM_1)=", nodeprint.getAttribute(B_PARAM_1), ", pParametres.getp1()= %s ", pParametres.getp1())
            # print("8. Module: Controleurs.cInformations, Class: CInformations, Methode: existeInformations__, Ligne 97, \nnode.getAttribute(B_PARAM_2)=", nodeprint.getAttribute(B_PARAM_2), ", pParametres.getp2()= %s ", pParametres.getp2())
            # print("9. Module: Controleurs.cInformations, Class: CInformations, Methode: existeInformations__, Ligne 98, \nnode.getAttribute(B_PARAM_3)=", nodeprint.getAttribute(B_PARAM_3), ", pParametres.getp3()= %s ", pParametres.getp3())
            # print("10. Module: Controleurs.cInformations, Class: CInformations, Methode: existeInformations__, Ligne 99, \nnode.getAttribute(B_PARAM_4)=", nodeprint.getAttribute(B_PARAM_4), ", pParametres.getp4()= %s ", pParametres.getp4())
            # print("11. Module: Controleurs.cInformations, Class: CInformations, Methode: existeInformations__, Ligne 100, \nnode.getAttribute(B_PARAM_5)=", nodeprint.getAttribute(B_PARAM_5), ", pParametres.getp5()= %s ", pParametres.getp5())
            # print("12. Module: Controleurs.cInformations, Class: CInformations, Methode: existeInformations__, Ligne 101, \nnode.getAttribute(B_PARAM_6)=", nodeprint.getAttribute(B_PARAM_6), ", pParametres.getp6()= %s ", pParametres.getp6())
            # print("13. Module: Controleurs.cInformations, Class: CInformations, Methode: existeInformations__, Ligne 102, \nnode.getAttribute(B_PARAM_7)=", nodeprint.getAttribute(B_PARAM_7), ", pParametres.getp7()= %s ", pParametres.getp7())
        for node in liste : 
            if (node.getAttribute(B_VERS_SOURCE)== planTravail.getVersionSource() and 
                node.getAttribute(B_ETAT_SOURCE)== planTravail.getEtatSource() and 
                node.getAttribute(B_VERS_CIBLE) == planTravail.getVersionCible() and 
                node.getAttribute(B_ETAT_CIBLE) == planTravail.getEtatCible() and
                node.getAttribute(B_PARAM_1) == '%s'%pParametres.getp1() and
                node.getAttribute(B_PARAM_2) == '%s'%pParametres.getp2() and
                node.getAttribute(B_PARAM_3) == '%s'%pParametres.getp3() and
                node.getAttribute(B_PARAM_4) == '%s'%pParametres.getp4() and
                node.getAttribute(B_PARAM_5) == '%s'%pParametres.getp5() and
                node.getAttribute(B_PARAM_6) == '%s'%pParametres.getp6() and
                node.getAttribute(B_PARAM_7) == '%s'%pParametres.getp7()):
                    return True
        return False

    # Methode qui enregistre les informations d'un couple d'états
    def existeInformations(self, planTravail):
        """Methode qui renvoie vrai si des informations existent sur un couple de etats
        pre: isinstance(planTravail, Donnees.planTravail.PlanTravail) """
        if planTravail.getParam().isNull(): return False                    
        nomDG = self.dgm.getDG(planTravail.getAuteur(), planTravail.getOeuvre())
        fim =  Controleurs.FInfoManager.FInfoManager(Controleurs.DGManager.Auteur(planTravail.getAuteur()), Controleurs.DGManager.Oeuvre(planTravail.getOeuvre()))
        pParametres = planTravail.getParam()
        f = open(fim.getFileInfo())

        # print("14. Module: Controleurs.cInformations, Class: CInformations, Methode: existeInformations, Ligne 128, \nfim.getFileInfo()=[", str(fim.getFileInfo()), "] ")
        text = f.read()
        # print("15. Module: Controleurs.cInformations, Class: CInformations, Methode: existeInformations, Ligne 130, \ntext=[", text, "], \nplanTravail.getAuteur()=", planTravail.getAuteur(), ", planTravail.getOeuvre()=", planTravail.getOeuvre(), " ")
        f.close()
        # on coupe après arbre pour ne garder que les infos de l'arbre des versions
        # on cherhce les balises <informations atributs...>
        deb = text.find('<informations') ; transfo = text.find('<transformations>') 
        fin = text.find('</informations>')
        while deb != -1:
            # on ajoute '<xml ...' pour avoir un Document et extraire le noeud informations
            chaine_informations = '<?xml version="1.0"  encoding="utf-8" ?><root>' + \
                text[deb:transfo] +'</informations></root>'                                     # ---> à faire plus tard...Modifiee 12.09.2019, 22.07.2019, ancienne ligne:  chaine_informations = '<?xml version="1.0"  encoding="iso-8859-1" ?><root>' + \text[deb:transfo] +'</informations></root>' 
            # print ("16. Module: Controleurs.cInformations, Class: CInformations, Methode: existeInformations, Ligne 140, \nchaine_informations=[", chaine_informations, "] ")                                    # Ajoutee pour debogage 
            xml_informations = xml.dom.minidom.parseString(chaine_informations, parser=None)                            # Modifiee 28.03.2019, ancienne ligne:  xml_informations = Ft.Xml.Parse(chaine_informations)
            # print ("17. Module: Controleurs.cInformations, Class: CInformations, Methode: existeInformations, Ligne 142, \nxml_informations=[", xml_informations, "] ")                                  # Ajoutee 14.05.2019 pour debogage 
            #liste = xml_informations.getElementsByTagName(B_INFORMATIONS) # liste avec 1 seul element n�cessairement
            #nodeListe = Ft.Xml.XPath.Evaluate(u'(/root/'+B_INFORMATIONS+')',contextNode = xml_informations)
            nodeListe = xml_informations.getElementsByTagName(B_INFORMATIONS)                       # Ajoutee 14.05.2019 
            # print("18. Module: Controleurs.cInformations, Class: CInformations, Methode: existeInformations, Ligne 146, \nnombre de nodes informations=[", len(nodeListe), "] ")                   # Ajoutee 14.05.2019 pour debogage
            if len(nodeListe) != 0:
                node = nodeListe[0]
                # print("19. Module: Controleurs.cInformations, Class: CInformations, Methode: existeInformations, Ligne 149, nomDG=", nomDG)
                # print("20. Module: Controleurs.cInformations, Class: CInformations, Methode: existeInformations, Ligne 150, \nnode.getAttribute(B_VERS_SOURCE)=", node.getAttribute(B_VERS_SOURCE), ", planTravail.getVersionSource()=", planTravail.getVersionSource())
                # print("21. Module: Controleurs.cInformations, Class: CInformations, Methode: existeInformations, Ligne 151, \nnode.getAttribute(B_ETAT_SOURCE)=", node.getAttribute(B_ETAT_SOURCE), ", planTravail.getEtatSource()=", planTravail.getEtatSource())
                # print("22. Module: Controleurs.cInformations, Class: CInformations, Methode: existeInformations, Ligne 152, \nnode.getAttribute(B_ETAT_CIBLE)=", node.getAttribute(B_ETAT_CIBLE), ", planTravail.getEtatCible()=", planTravail.getEtatCible())
                # print("23. Module: Controleurs.cInformations, Class: CInformations, Methode: existeInformations, Ligne 153, \nnode.getAttribute(B_ETAT_CIBLE)=", node.getAttribute(B_ETAT_CIBLE), ", planTravail.getEtatCible()=", planTravail.getEtatCible())
                # print("24. Module: Controleurs.cInformations, Class: CInformations, Methode: existeInformations, Ligne 154, \nnode.getAttribute(B_PARAM_1)=", node.getAttribute(B_PARAM_1), ", pParametres.getp1()= %s ", pParametres.getp1())
                # print("25. Module: Controleurs.cInformations, Class: CInformations, Methode: existeInformations, Ligne 155, \nnode.getAttribute(B_PARAM_2)=", node.getAttribute(B_PARAM_2), ", pParametres.getp2()= %s ", pParametres.getp2())
                # print("26. Module: Controleurs.cInformations, Class: CInformations, Methode: existeInformations, Ligne 156, \nnode.getAttribute(B_PARAM_3)=", node.getAttribute(B_PARAM_3), ", pParametres.getp3()= %s ", pParametres.getp3())
                # print("27. Module: Controleurs.cInformations, Class: CInformations, Methode: existeInformations, Ligne 157, \nnode.getAttribute(B_PARAM_4)=", node.getAttribute(B_PARAM_4), ", pParametres.getp4()= %s ", pParametres.getp4())
                # print("28. Module: Controleurs.cInformations, Class: CInformations, Methode: existeInformations, Ligne 158, \nnode.getAttribute(B_PARAM_5)=", node.getAttribute(B_PARAM_5), ", pParametres.getp5()= %s ", pParametres.getp5())
                # print("29. Module: Controleurs.cInformations, Class: CInformations, Methode: existeInformations, Ligne 159, \nnode.getAttribute(B_PARAM_6)=", node.getAttribute(B_PARAM_6), ", pParametres.getp6()= %s ", pParametres.getp6())
                # print("30. Module: Controleurs.cInformations, Class: CInformations, Methode: existeInformations, Ligne 160, \nnode.getAttribute(B_PARAM_7)=", node.getAttribute(B_PARAM_7), ", pParametres.getp7()= %s ", pParametres.getp7())                
                if (node.getAttributeNS(node.namespaceURI, B_VERS_SOURCE)== planTravail.getVersionSource() and 
                    node.getAttributeNS(node.namespaceURI, B_ETAT_SOURCE)== planTravail.getEtatSource() and 
                    node.getAttributeNS(node.namespaceURI, B_VERS_CIBLE) == planTravail.getVersionCible() and 
                    node.getAttributeNS(node.namespaceURI, B_ETAT_CIBLE) == planTravail.getEtatCible() and
                    node.getAttributeNS(node.namespaceURI, B_PARAM_1) == '%s'%pParametres.getp1() and
                    node.getAttributeNS(node.namespaceURI, B_PARAM_2) == '%s'%pParametres.getp2() and
                    node.getAttributeNS(node.namespaceURI, B_PARAM_3) == '%s'%pParametres.getp3() and
                    node.getAttributeNS(node.namespaceURI, B_PARAM_4) == '%s'%pParametres.getp4() and
                    node.getAttributeNS(node.namespaceURI, B_PARAM_5) == '%s'%pParametres.getp5() and
                    node.getAttributeNS(node.namespaceURI, B_PARAM_6) == '%s'%pParametres.getp6() and
                    node.getAttributeNS(node.namespaceURI, B_PARAM_7) == '%s'%pParametres.getp7()):
                        return True
            deb = text.find('<informations',fin+15) ; transfo = text.find('<transformations>',fin+15) 
            fin = text.find('</informations>',fin+15)
        return False
        
    # Methode qui enregistre les transformations d'un couple d'états
    def enregistrerTransformations__(self, planTravail,pTransformations):
        """pre: isinstance(planTravail, Donnees.planTravail.PlanTravail)  and \
                isinstance(pTransformations, Donnees.transformations.Transformations)"""
        nomDG = self.dgm.getDG(planTravail.getAuteur(), planTravail.getOeuvre())
        fim =  Controleurs.FInfoManager.FInfoManager(Controleurs.DGManager.Auteur(planTravail.getAuteur()), Controleurs.DGManager.Oeuvre(planTravail.getOeuvre()))
        # print("30-1. Module: Controleurs.cInformations, Class: CInformations, Methode: enregistrerTransformations__, Ligne 183, \nnomDG=", nomDG, ", planTravail.getAuteur()=", planTravail.getAuteur(), ", planTravail.getOeuvre()=", planTravail.getOeuvre(), " ")
        if self.stream:
                self.enregistrerTransformationsStream(planTravail, pTransformations)
        elif not self.existeInformations(planTravail):
                xmlInfo = self.__creerInformations(planTravail, pTransformations)
                fic = lireDocXml(fim.getFileInfo())
                nodeRoot = fic._get_firstChild()
                nodeRoot.appendChild(xmlInfo)
                ecrireDocXml(fim.getFileInfo(),fic)
        # print("31. Module: Controleurs.cInformations, Class: CInformations, Methode: enregistrerTransformations__, Ligne 192, \nnomDG=", nomDG, ", planTravail.getAuteur()=", planTravail.getAuteur(), ", planTravail.getOeuvre()=", planTravail.getOeuvre())
            
    # Methode qui enregistre les transformations d'un couple d'états
    def enregistrerTransformations(self, planTravail,pTransformations):
        """
        Avec Ft.Xml
        pre: isinstance(planTravail, Donnees.planTravail.PlanTravail)  and \
                isinstance(pTransformations, Donnees.transformations.Transformations)"""
        nomDG = self.dgm.getDG(planTravail.getAuteur(), planTravail.getOeuvre())
        fim =  Controleurs.FInfoManager.FInfoManager(Controleurs.DGManager.Auteur(planTravail.getAuteur()), Controleurs.DGManager.Oeuvre(planTravail.getOeuvre()))
        # print("31-1. Module: Controleurs.cInformations, Class: CInformations, Methode: enregistrerTransformations, Ligne 202, \nnomDG=", nomDG, ", planTravail.getAuteur()=", planTravail.getAuteur(), ", planTravail.getOeuvre()=", planTravail.getOeuvre(), " ")
        if self.stream:
                self.enregistrerTransformationsStream(planTravail, pTransformations)
        elif not self.existeInformations(planTravail):
        #else :
                xmlInfo = self.__creerInformations(planTravail, pTransformations)
                fic = lireDocXmlFt(fim.getFileInfo())
                nodeRoot = fic.firstChild
                nodeRoot.appendChild(xmlInfo)
                ecrireDocXmlFt(fim.getFileInfo(),fic)
        # print("32. Module: Controleurs.cInformations, Class: CInformations, Methode: enregistrerTransformations, Ligne 212, \nnomDG=", nomDG, ", planTravail.getAuteur()=", planTravail.getAuteur(), ", planTravail.getOeuvre()=", planTravail.getOeuvre())
                
    # Methode qui enregistre le commentaire d'un couple d'états
    def enregistrerCommentaire(self, planTravail, pCommentaire):
        """pre: isinstance(planTravail, Donnees.planTravail.PlanTravail) and \
                isinstance(pCommentaire, str)"""
        nomDG = self.dgm.getDG(planTravail.getAuteur(), planTravail.getOeuvre())
        fim =  Controleurs.FInfoManager.FInfoManager(Controleurs.DGManager.Auteur(planTravail.getAuteur()), 
                                                     Controleurs.DGManager.Oeuvre(planTravail.getOeuvre()))
        commentaire = Commentaire(encodingNode(pCommentaire))
        fic = lireDocXml(fim.getFileInfo())
        liste = fic.getElementsByTagName(B_INFORMATIONS)
        infos = self.__rechercherInfos(liste, planTravail)
        lc = infos.getElementsByTagName(B_COMMENTAIRE)
        if lc == [] : ## creer et ajouter le noeud 'commentaire'
            comment = self.__creerCommentaire(commentaire)
            infos.appendChild(comment)
            ecrireDocXml(fim.getFileInfo(),fic)
        else : # il existe deja un commentaire, une exception est lancee
            c = (lc[0]._get_firstChild()).toxml()
            comment = Commentaire(c)
            raise CommentaireDejaExistant('le commentaire de"'+planTravail.getVersionSource() +'/'+planTravail.getEtatSource()+
                  '" et "'+planTravail.getVersionCible()+'/'+planTravail.getEtatCible()+'" est deja existant', comment)
        # print("33. Module: Controleurs.cInformations, Class: CInformations, Methode: enregistrerCommentaire, Ligne 235, \nnomDG=", nomDG, ", pCommentaire=", pCommentaire, ", commentaire=", commentaire)
                  
    # Methode qui remplace le commentaire existant par le nouveau 
    def remplacerCommentaire(self, planTravail, pCommentaire):
        """pre: isinstance(planTravail, Donnees.planTravail.PlanTravail)and \
                isinstance(pCommentaire, str)"""
        nomDG = self.dgm.getDG(planTravail.getAuteur(), planTravail.getOeuvre())
        fim =  Controleurs.FInfoManager.FInfoManager(Controleurs.DGManager.Auteur(planTravail.getAuteur()), 
                                                     Controleurs.DGManager.Oeuvre(planTravail.getOeuvre()))
        commentaire = Commentaire(pCommentaire)
        fic = lireDocXml(fim.getFileInfo())
        liste = fic.getElementsByTagName(B_INFORMATIONS)
        infos = self.__rechercherInfos(liste, planTravail)
        lc = infos.getElementsByTagName(B_COMMENTAIRE)
        comment = self.__creerCommentaire(commentaire)
        if lc != [] :
            infos.removeChild(lc[0])
        infos.appendChild(comment)
        ecrireDocXml(fim.getFileInfo(),fic)
        # print("34. Module: Controleurs.cInformations, Class: CInformations, Methode: remplacerCommentaire, Ligne 254, \nnomDG=", nomDG, ", pCommentaire=", pCommentaire)
                                   
    # Methode qui ajoute le nouveau commentaire a l'ancien 
    def ajouterCommentaire(self, planTravail, pCommentaire):
        """pre: isinstance(planTravail, Donnees.planTravail.PlanTravail) and \
                isinstance(pCommentaire, str)"""
        nomDG = self.dgm.getDG(planTravail.getAuteur(), planTravail.getOeuvre())
        fim =  Controleurs.FInfoManager.FInfoManager(Controleurs.DGManager.Auteur(planTravail.getAuteur()), 
                                                     Controleurs.DGManager.Oeuvre(planTravail.getOeuvre()))
        commentaire = Commentaire(pCommentaire)
        fic = lireDocXml(fim.getFileInfo())
        liste = fic.getElementsByTagName(B_INFORMATIONS)
        infos = self.__rechercherInfos(liste, planTravail)
        lc = infos.getElementsByTagName(B_COMMENTAIRE)
        if lc == []:## creer et ajouter le noeud 'commentaire'
            comment = self.__creerCommentaire(commentaire)
            infos.appendChild(comment)
        else :
            xmldoc=Document()
            comment =' '+ commentaire.getCommentaire()
            lc[0].appendChild(xmldoc.createTextNode(comment))
        ecrireDocXml(fim.getFileInfo(), fic)
        # print("35. Module: Controleurs.cInformations, Class: CInformations, Methode: ajouterCommentaire, Ligne 276, \nnomDG=", nomDG, ", pCommentaire=", pCommentaire)
        
    # Methode qui supprime le commentaire d'un couple d'états
    def supprimerCommentaire(self, planTravail):
        """pre: isinstance(planTravail, Donnees.planTravail.PlanTravail) """
        nomDG = self.dgm.getDG(planTravail.getAuteur(), planTravail.getOeuvre())
        fim =  Controleurs.FInfoManager.FInfoManager(Controleurs.DGManager.Auteur(planTravail.getAuteur()), Controleurs.DGManager.Oeuvre(planTravail.getOeuvre()))
        fic = lireDocXml(fim.getFileInfo())
        liste = fic.getElementsByTagName(B_INFORMATIONS)
        # print("35-1. Module: Controleurs.cInformations, Class: CInformations, Methode: supprimerCommentaire, Ligne 285, \nnomDG=", nomDG, ", planTravail.getAuteur()=", planTravail.getAuteur(), ", planTravail.getOeuvre()=", planTravail.getOeuvre(), " ")
        infos = self.__rechercherInfos(liste, planTravail)
        lc = infos.getElementsByTagName(B_COMMENTAIRE)
        if lc != [] :
            infos.removeChild(lc[0])
            ecrireDocXml(fim.getFileInfo(), fic)
        else :
            raise CommentaireNonTrouve('les informations de "'+planTravail.getVersionSource() +'/'+planTravail.getEtatSource()+
                                          '" et "'+planTravail.getVersionCible()+'/'+planTravail.getEtatCible()+'" n\'ont pas de commentaire')
        # print("36. Module: Controleurs.cInformations, Class: CInformations, Methode: supprimerCommentaire, Ligne 294, \nnomDG=", nomDG, ", planTravail.getAuteur()=", planTravail.getAuteur(), ", planTravail.getOeuvre()=", planTravail.getOeuvre(), " ")

    # Methode qui supprime les informations d'un couple d'états
    def supprimerInformations(self, planTravail):
        """pre: isinstance(planTravail, Donnees.planTravail.PlanTravail) """
        nomDG = self.dgm.getDG(planTravail.getAuteur(), planTravail.getOeuvre())
        fim =  Controleurs.FInfoManager.FInfoManager(Controleurs.DGManager.Auteur(planTravail.getAuteur()), Controleurs.DGManager.Oeuvre(planTravail.getOeuvre()))
        fic = lireDocXml(fim.getFileInfo())
        noderoot = fic.getElementsByTagName(B_ROOT)
        liste = fic.getElementsByTagName(B_INFORMATIONS)
        # print("36-1. Module: Controleurs.cInformations, Class: CInformations, Methode: supprimerInformations, Ligne 304, \nnomDG=", nomDG, ", planTravail.getAuteur()=", planTravail.getAuteur(), ", planTravail.getOeuvre()=", planTravail.getOeuvre(), " ")
        infos = self.__rechercherInfos(liste, planTravail)
        if infos != None:## suppression du noeud
            noderoot[0].removeChild(infos)
            ecrireDocXml(fim.getFileInfo(),fic)
        # print("37. Module: Controleurs.cInformations, Class: CInformations, Methode: supprimerInformations, Ligne 309, \nnomDG=", nomDG)
           
    def enregistrerInformations(self, planTravail,pTransformations, pCommentaire):
        """ Methode qui enregistre les informations (transformations + commentaire) d'un couple de etats
        pre: isinstance(planTravail, Donnees.planTravail.PlanTravail) """
        if not self.existeInformations(planTravail ):
            self.enregistrerTransformations(planTravail, pTransformations)
        self.enregistrerCommentaire(planTravail, pCommentaire)
        # print("38. Module: Controleurs.cInformations, Class: CInformations, Methode: enregistrerInformations, Ligne 317, \npCommentaire=", pCommentaire)
        
    # Methode qui retourne toutes les informations d'un couple d'états
    # Methode qui renvoie toutes les informations existantes pour un dossier genetique
    def rechercherToutesInformationsDG__(self, pNom, pTitre):
        nomDG = self.dgm.getDG(pNom, pTitre)
        fim =  Controleurs.FInfoManager.FInfoManager(Controleurs.DGManager.Auteur(pNom), Controleurs.DGManager.Oeuvre(pTitre))
        fic = lireDocXml(fim.getFileInfo())
        liste = fic.getElementsByTagName(B_INFORMATIONS)
        # print("38-1. Module: Controleurs.cInformations, Class: CInformations, Methode: rechercherToutesInformationsDG, Ligne 326, \nliste=[", str(liste), "], \npNom=", pNom, ", pTitre=", pTitre, " ")
        listeInfos = []
        for node in liste :
            vSource = node.getAttribute(B_VERS_SOURCE)
            fSource = node.getAttribute(B_ETAT_SOURCE)
            vCible = node.getAttribute(B_VERS_CIBLE)
            fCible = node.getAttribute(B_ETAT_CIBLE)
            par1 = int(node.getAttribute(B_PARAM_1))                               # Modifiee 28.03.2019, ancienne ligne:  par1 = atoi(node.getAttribute(B_PARAM_1))
            par2 = int(node.getAttribute(B_PARAM_2))                               # Modifiee 28.03.2019, ancienne ligne:  par2 = atoi(node.getAttribute(B_PARAM_2))
            par3 = int(node.getAttribute(B_PARAM_3))                               # Modifiee 28.03.2019, ancienne ligne:  par3 = atoi(node.getAttribute(B_PARAM_3))
            par4 = int(node.getAttribute(B_PARAM_4))                               # Modifiee 28.03.2019, ancienne ligne:  par4 = atoi(node.getAttribute(B_PARAM_4))
            par5 = int(node.getAttribute(B_PARAM_5))                               # Modifiee 28.03.2019, ancienne ligne:  par5 = atoi(node.getAttribute(B_PARAM_5))
            par6 = int(node.getAttribute(B_PARAM_6))                               # Modifiee 28.03.2019, ancienne ligne:  par6 = atoi(node.getAttribute(B_PARAM_6))
            par7 = int(node.getAttribute(B_PARAM_7))                               # Modifiee 28.03.2019, ancienne ligne:  par7 = atoi(node.getAttribute(B_PARAM_7))
            listeInfos.append([vSource,fSource,vCible,fCible,par1,par2,par3,par4,par5,par6,par7])
        # print("39. Module: Controleurs.cInformations, Class: CInformations, Methode: rechercherToutesInformationsDG__, Ligne 341, \nlisteInfos= %s ", listeInfos)
        return listeInfos
        
    def rechercherToutesInformationsDG(self, pNom, pTitre):
        nomDG = self.dgm.getDG(pNom, pTitre)
        fim =  Controleurs.FInfoManager.FInfoManager(Controleurs.DGManager.Auteur(pNom), Controleurs.DGManager.Oeuvre(pTitre))
        f = open(fim.getFileInfo())
        text = f.read()
        # print("39-1. text=[" + text + "]")                                         # Ajoutee pour debogage 
        f.close()
        # print("39-2. Module: Controleurs.cInformations, Class: CInformations, Methode: rechercherToutesInformationsDG, Ligne 351, \ntext=[", text, "], \npNom=", pNom, ", pTitre=", pTitre, " ")
        listeInfos = []
        # on coupe après arbre pour ne garder que les infos de l'arbre des versions
        # on cherhce les balises <informations atributs...>
        deb = text.find('<informations') ; transfo = text.find('<transformations>') 
        fin = text.find('</informations>')
        while deb != -1:
            # on ajoute '<xml ...' pour avoir un Document et extraire le noeud informations
            chaine_informations = '<?xml version="1.0"  encoding="utf-8" ?><root>' + \
                text[deb:transfo] +'</informations></root>'             # Modifie  12.09.2019:  chaine_informations = '<?xml version="1.0"  encoding="iso-8859-1" ?><root>' + \text[deb:transfo] +'</informations></root>' 
            # print ("40. Module: Controleurs.cInformations, Class: CInformations, Methode: rechercherToutesInformationsDG, Ligne 361, \nchaine_informations=[", chaine_informations, "] ")                                              # Ajoutee pour debogage 
            xml_informations = xml.dom.minidom.parseString(chaine_informations, parser=None)                            # Modifiee 28.03.2019, ancienne ligne:   xml_informations = Ft.Xml.Parse(chaine_informations) 
            # print ("41. Module: Controleurs.cInformations, Class: CInformations, Methode: rechercherToutesInformationsDG, Ligne 363 \nxml_informations=[", str(xml_informations), "] ")  
            #liste = xml_informations.getElementsByTagName(B_INFORMATIONS)        # liste avec 1 seul element nécessairement
            #nodeListe = lxml.etree.XPath.evaluate(u'(/root/'+B_INFORMATIONS+')',contextNode = xml_informations)         # Modifiee 28.03.2019, ancienne ligne:  nodeListe = Ft.Xml.XPath.Evaluate(u'(/root/'+B_INFORMATIONS+')',contextNode = xml_informations)
            nodeListe = xml_informations.getElementsByTagName(B_INFORMATIONS)                                           # Ajoutee 27.05.2019 
            # print("41-1. nombre de nodes informations=[" + str(len(nodeListe) + "]"))                                      # Ajoutee 14.05.2019 pour debogage
            if len(nodeListe) != 0:
                node = nodeListe[0]
                vSource = node.getAttributeNS(node.namespaceURI, B_VERS_SOURCE)
                fSource = node.getAttributeNS(node.namespaceURI, B_ETAT_SOURCE)
                vCible = node.getAttributeNS(node.namespaceURI, B_VERS_CIBLE)
                fCible = node.getAttributeNS(node.namespaceURI, B_ETAT_CIBLE)
                par1 = int(node.getAttributeNS(node.namespaceURI, B_PARAM_1))                      # Modifiee 28.03.2019, ancienne ligne:  par1 = atoi(node.getAttributeNS(node.namespaceURI, B_PARAM_1))
                par2 = int(node.getAttributeNS(node.namespaceURI, B_PARAM_2))                      # Modifiee 28.03.2019, ancienne ligne:  par2 = atoi(node.getAttributeNS(node.namespaceURI, B_PARAM_2))
                par3 = int(node.getAttributeNS(node.namespaceURI, B_PARAM_3))                      # Modifiee 28.03.2019, ancienne ligne:  par3 = atoi(node.getAttributeNS(node.namespaceURI, B_PARAM_3))
                par4 = int(node.getAttributeNS(node.namespaceURI, B_PARAM_4))                      # Modifiee 28.03.2019, ancienne ligne:  par4 = atoi(node.getAttributeNS(node.namespaceURI, B_PARAM_4))
                par5 = int(node.getAttributeNS(node.namespaceURI, B_PARAM_5))                      # Modifiee 28.03.2019, ancienne ligne:  par5 = atoi(node.getAttributeNS(node.namespaceURI, B_PARAM_5))
                par6 = int(node.getAttributeNS(node.namespaceURI, B_PARAM_6))                      # Modifiee 28.03.2019, ancienne ligne:  par6 = atoi(node.getAttributeNS(node.namespaceURI, B_PARAM_6))
                par7 = int(node.getAttributeNS(node.namespaceURI, B_PARAM_7))                      # Modifiee 28.03.2019, ancienne ligne:  par7 = atoi(node.getAttributeNS(node.namespaceURI, B_PARAM_7))
                listeInfos.append([vSource,fSource,vCible,fCible,par1,par2,par3,par4,par5,par6,par7])
            deb = text.find('<informations',fin+15) ; transfo = text.find('<transformations>',fin+15) 
            fin = text.find('</informations>',fin+15)
        # print("42. Module: GUI.cInformations, Class: CInformations, Methode: rechercherToutesInformationsDG, Ligne 384, \nlisteInfos= %s ", listeInfos)
        return listeInfos

    # Methode qui retourne toutes les informations 
    # de tous les couples enregistrés d'états d'un DG
    # renvoie une liste d'objets Information
    def rechercherLInformationsDG(self, pNom, pTitre):
        nomDG = self.dgm.getDG(pNom, pTitre)
        fim =  Controleurs.FInfoManager.FInfoManager(Controleurs.DGManager.Auteur(pNom), Controleurs.DGManager.Oeuvre(pTitre))
        fic = lireDocXml(fim.getFileInfo())
        liste = fic.getElementsByTagName(B_INFORMATIONS)
        # print("42-1. Module: Controleurs.cInformations, Class: CInformations, Methode: rechercherLInformationsDG, Ligne 395, \nliste=[", str(liste), "], \npNom=", pNom, ", pTitre=", pTitre, " ")
        listeInfos = []
        for infos in liste :
            tmpInfo = self.__getInformations_(infos, pNom, pTitre)       # Modifie 19.09.2019, ancienne:  tmpInfo = self.__getInformations(infos, pNom, pTitre)
            listeInfos.append(tmpInfo)
        # print("43. Module: Controleurs.cInformations, Class: CInformations, Methode: rechercherLInformationsDG, Ligne 400, \nlisteInfos %s ", listeInfos)
        return listeInfos
        
    def generateLInformationsDG__(self, pNom, pTitre):
        """ Generateur des informations de comparaisons
        Le generateur evite de charger plusieurs informations en meme temps lorsque celes ci son grosses (plusieurs Mo)
        On evite de faire un SAX en recherchant dans le fichier XML les balises <informations></informations>
        une par une et a la main, c'est pas propre mais efficace """
        nomDG = self.dgm.getDG(pNom, pTitre)
        fim =  Controleurs.FInfoManager.FInfoManager(Controleurs.DGManager.Auteur(pNom), Controleurs.DGManager.Oeuvre(pTitre))
        f = open(fim.getFileInfo())
        text = f.read()
        f.close()
        # print("43-1. Module: Controleurs.cInformations, Class: CInformations, Methode: generateLInformationsDG, Ligne 413, text=[", text, ", \nnomDG=", nomDG, ", pNom=", pNom, ", pTitre=", pTitre, " ") 
        # on coupe après arbre pour ne garder que les infos de l'arbre des versions
        deb = text.find('<informations') ; fin = text.find('</informations>')
        while deb != -1:
            # on ajoute '<xml ...' pour avoir un Document et extraire le noeud informations
            chaine_informations = '<?xml version="1.0"  encoding="utf-8" ?><root>' + \
                text[deb:fin+15] +'</root>'         # Modifie  12.09.2019: # +15 pour la longueur de la balise </informations>, ancienne:  chaine_informations = '<?xml version="1.0"  encoding="iso-8859-1" ?><root>' + \text[deb:fin+15] +'</root>' 
            #logging.debug(chaine_informations)
            xml_informations = xml.dom.minidom.parseString(chaine_informations)
            liste = xml_informations.getElementsByTagName(B_INFORMATIONS) # liste avec 1 seul element nécessairement
            objet_informations = self.__getInformations_(liste[0], pNom, pTitre)         # Modifie 19.09.2019, ancienne: objet_informations = self.__getInformations(liste[0], pNom, pTitre)
            #objet_informations = self.__getInformations(xml_informations.getElementsByTagName(B_INFORMATIONS)[0], pNom, pTitre)
            #for child in liste[0].childNodes:
            #    logging.debug(child)
            #    child.unlink()
            liste = None 
            xml_informations.unlink() ; xml_informations = None 
            #unreachable = gc.collect()
            #logging.debug( 'unreachable='+str(unreachable))
            yield objet_informations
            deb = text.find('<informations',fin+15) ; fin = text.find('</informations>',fin+15)
        # print("44. Module: Controleurs.cInformations, Class: CInformations, Methode: generateLInformationsDG__, Ligne 434, \npNom=", pNom, ", pTitre=", pTitre, ", \nchaine_informations=", chaine_informations, ", \nxml_informations=[", str(xml_informations), "] ")
     
    def generateLInformationsDG(self, pNom, pTitre):
        """ Avec Ft.Xml.Domlette 
        Generateur des informations de comparaisons
        Le generateur evite de charger plusieurs informations en meme temps lorsque celes ci son grosses (plusieurs Mo)
        On evite de faire un SAX en recherchant dans le fichier XML les balises <informations></informations>
        une par une et a la main, c'est pas propre mais efficace """
        nomDG = self.dgm.getDG(pNom, pTitre)
        fim =  Controleurs.FInfoManager.FInfoManager(Controleurs.DGManager.Auteur(pNom), Controleurs.DGManager.Oeuvre(pTitre))
        f = open(fim.getFileInfo())
        text = f.read()
        # print("45. Module: Controleurs.cInformations, Class: CInformations, Methode: generateLInformationsDG, Ligne 447, text=[", text, "\nplanTravail.getAuteur()=", planTravail.getAuteur(), ", planTravail.getOeuvre()=", planTravail.getOeuvre(), " ")                 # Ajoutee pour debogage 
        f.close()
        # on coupe après arbre pour ne garder que les infos de l'arbre des versions
        deb = text.find('<informations') ; fin = text.find('</informations>')
        while deb != -1:
            # on ajoute '<xml ...' pour avoir un Document et extraire le noeud informations
            chaine_informations = '<?xml version="1.0"  encoding="utf-8" ?><root>' + \
                text[deb:fin+15] +'</root>'         # Modifie 12.09.2019, # +15 pour la longueur de la balise </informations>, ancienne:  chaine_informations = '<?xml version="1.0"  encoding="iso-8859-1" ?><root>' + \text[deb:fin+15] +'</root>'
            # print ("46. Module: Controleurs.cInformations, Class: CInformations, Methode: generateLInformationsDG, Ligne 455, \nchaine_informations=[", chaine_informations, "] ")                                    # Ajoutee pour debogage 
            #logging.debug(chaine_informations)
            #xml_informations = xml.dom.minidom.parseString(chaine_informations)
            #xml_informations = Ft.Xml.Parse(chaine_informations)                                            # Desactivee 14.05.2019
            xml_informations = xml.dom.minidom.parseString(chaine_informations, parser=None)                # Ajoutee 14.05.2019 
            #liste = xml_informations.getElementsByTagName(B_INFORMATIONS)     # liste avec 1 seul element nécessairement
            #nodeListe = Ft.Xml.XPath.Evaluate(u'(/root/'+B_INFORMATIONS+')',contextNode = xml_informations)                        # Desactivee 14.05.2019 
            # print ("47. Module: Controleurs.cInformations, Class: CInformations, Methode: generateLInformationsDG, Ligne 462, \nxml_informations=[", str(xml_informations), "] ")                                        # Ajoutee 14.05.2019 pour debogage 
            nodeListe = xml_informations.getElementsByTagName(B_INFORMATIONS)                                   # Ajoutee 14.05.2019 
            # print("48. Module: Controleurs.cInformations, Class: CInformations, Methode: generateLInformationsDG, Ligne 464, \nnombre de nodes informations=[ %s ", len(nodeListe), "]")                              # Ajoutee 14.05.2019 pour debogage
            if len(nodeListe) != 0:        
                objet_informations = self.__getInformations_(nodeListe[0], pNom, pTitre)         # Modifie 19.09.2019, ancienne: objet_informations = self.__getInformations(nodeListe[0], pNom, pTitre)
                nodeListe = None ; xml_informations = None #.unlink()
                logging.debug('fin rechercherInformations')
                yield objet_informations
            deb = text.find('<informations',fin+15) ; fin = text.find('</informations>',fin+15)
        # print("49. Module: Controleurs.cInformations, Class: CInformations, Methode: generateLInformationsDG, Ligne 471, \npNom=", pNom, ", pTitre=", pTitre)

    def rechercherToutesInformations__(self, planTravail):
        """pre: isinstance(planTravail, Donnees.planTravail.PlanTravail) """
        nomDG = self.dgm.getDG(planTravail.getAuteur(), planTravail.getOeuvre())
        fim =  Controleurs.FInfoManager.FInfoManager(Controleurs.DGManager.Auteur(planTravail.getAuteur()), Controleurs.DGManager.Oeuvre(planTravail.getOeuvre()))
        fic = lireDocXml(fim.getFileInfo())
        liste = fic.getElementsByTagName(B_INFORMATIONS)
        # print("49-1. Module: Controleurs.cInformations, Class: CInformations, Methode: rechercherToutesInformations__, Ligne 479 ---> \nliste=", str(liste), " ") 
        listeInfos = []
        for infos in liste :
            # print("49-2. Module: Controleurs.cInformations, Class: CInformations, Methode: rechercherToutesInformations__, Ligne 481 ---> \ninfos=", str(infos), " ")
            if (infos.getAttribute(B_VERS_SOURCE)== planTravail.getVersionSource()  and 
                 infos.getAttribute(B_ETAT_SOURCE)== planTravail.getEtatSource() and 
                 infos.getAttribute(B_VERS_CIBLE) == planTravail.getVersionCible() and 
                 infos.getAttribute(B_ETAT_CIBLE) == planTravail.getEtatCible()):
                    tmpInfo = self.__getInformations_(infos, planTravail.getAuteur(), planTravail.getOeuvre())   # Modifie 19.09.2019, ancienne: tmpInfo = self.__getInformations(infos, planTravail.getAuteur(), planTravail.getOeuvre())
                    listeInfos.append(tmpInfo)
        # print("50. Module: Controleurs.cInformations, Class: CInformations, Methode: rechercherToutesInformations__, Ligne 488, \nnomDG=[", nomDG, "], planTravail.getAuteur()=[", planTravail.getAuteur(), "], planTravail.getOeuvre()=[", planTravail.getOeuvre(), "] ")
        return listeInfos
        
    # Methode qui retourne toutes les informations d'un couple d'états
    def rechercherToutesInformations(self, planTravail):
        """pre: isinstance(planTravail, Donnees.planTravail.PlanTravail) """
        nomDG = self.dgm.getDG(planTravail.getAuteur(), planTravail.getOeuvre())
        fim =  Controleurs.FInfoManager.FInfoManager(Controleurs.DGManager.Auteur(planTravail.getAuteur()), 
                                                     Controleurs.DGManager.Oeuvre(planTravail.getOeuvre()))
        listeInfos = []                                             
        f = open(fim.getFileInfo())
        text = f.read()
        # print("51. Module: Controleurs.cInformations, Class: CInformations, Methode: rechercherToutesInformations, Ligne 500, \ntext=[", text, ", \nplanTravail.getAuteur()=", planTravail.getAuteur(), ", planTravail.getOeuvre()=", planTravail.getOeuvre(), " ")                 # Ajoutee pour debogage 
        f.close()
        # on coupe après arbre pour ne garder que les infos de l'arbre des versions
        deb = text.find('<informations') ; fin = text.find('</informations>')
        while deb != -1:
            # on ajoute '<xml ...' pour avoir un Document et extraire le noeud informations
            chaine_informations = '<?xml version="1.0"  encoding="utf-8" ?><root>' + \
                text[deb:fin+15] +'</root>'             # Modifie 12.09.2019, # +15 pour la longueur de la balise </informations>, ancienne: chaine_informations = '<?xml version="1.0"  encoding="iso-8859-1" ?><root>' + \text[deb:fin+15] +'</root>'
            # print ("52. Module: Controleurs.cInformations, Class: CInformations, Methode: rechercherToutesInformations, Ligne 508, \nchaine_informations=[", chaine_informations, "] ")                                              # Ajoutee pour debogage 
            #logging.debug(chaine_informations)
            #xml_informations = xml.dom.minidom.parseString(chaine_informations)
            #xml_informations = Ft.Xml.Parse(chaine_informations)                                                        # Desactivee 14.05.2019 
            xml_informations = xml.dom.minidom.parseString(chaine_informations, parser=None)                            # Ajoutee 14.05.2019 
            #liste = xml_informations.getElementsByTagName(B_INFORMATIONS)     # liste avec 1 seul element n�cessairement
            #nodeListe = Ft.Xml.XPath.Evaluate(u'(/root/'+B_INFORMATIONS+')',contextNode = xml_informations)             # Desactivee 14.05.2019 
            # print ("53. Module: Controleurs.cInformations, Class: CInformations, Methode: rechercherToutesInformations, Ligne 515, \nxml_informations=[", str(xml_informations), "] ")                                                    # Ajoutee 14.05.2019 pour debogage 
            nodeListe = xml_informations.getElementsByTagName(B_INFORMATIONS)                                           # Ajoutee 14.05.2019 
            # print("54. Module: Controleurs.cInformations, Class: CInformations, Methode: rechercherToutesInformations, Ligne 517, \nnombre de nodes informations=[ %s ", len(nodeListe), "]")                                      # Ajoutee 14.05.2019 pour debogage
            if len(nodeListe) != 0:   
                node = nodeListe[0]
                if (node.getAttributeNS(node.namespaceURI, B_VERS_SOURCE) == planTravail.getVersionSource()  and 
                    node.getAttributeNS(node.namespaceURI, B_ETAT_SOURCE) == planTravail.getEtatSource() and 
                    node.getAttributeNS(node.namespaceURI, B_VERS_CIBLE) == planTravail.getVersionCible() and 
                    node.getAttributeNS(node.namespaceURI, B_ETAT_CIBLE) == planTravail.getEtatCible()):
                        listeInfos.append(self.__getInformations_(node, planTravail.getAuteur(), planTravail.getOeuvre()))       # Modifie 19.09.2019, ancienne: listeInfos.append(self.__getInformations(node, planTravail.getAuteur(), planTravail.getOeuvre()))
            deb = text.find('<informations',fin+15) ; fin = text.find('</informations>',fin+15)
        # print("55. Module: Controleurs.cInformations, Class: CInformations, Methode: rechercherToutesInformations, Ligne 526, \nnomDG=", nomDG, ", planTravail.getAuteur()=", planTravail.getAuteur(), ", planTravail.getOeuvre()=", planTravail.getOeuvre())
        return listeInfos
    
    
    # Methode qui retourne les informations d'un couple d'états et des parametres precis
    def __rechercherInformations(self, planTravail):
        """pre: isinstance(planTravail, Donnees.planTravail.PlanTravail) """
        nomDG = self.dgm.getDG(planTravail.getAuteur(), planTravail.getOeuvre())
        fim =  Controleurs.FInfoManager.FInfoManager(Controleurs.DGManager.Auteur(planTravail.getAuteur()), Controleurs.DGManager.Oeuvre(planTravail.getOeuvre()))
        pParametres = planTravail.getParam()
        fic = lireDocXml(fim.getFileInfo())
        liste = fic.getElementsByTagName(B_INFORMATIONS)
        # print("55-1. Module: Controleurs.cInformations, Class: CInformations, Methode: __rechercherInformations, Ligne 538, \nliste=[", str(liste), "], \nplanTravail.getAuteur()=", planTravail.getAuteur(), ", planTravail.getOeuvre()=", planTravail.getOeuvre(), " ") 
        # for nodeprint in liste : 
            # print("56. Module: Controleurs.cInformations, Class: CInformations, Methode: __rechercherInformations, Ligne 540, nomDG=", nomDG)
            # print("57. Module: Controleurs.cInformations, Class: CInformations, Methode: __rechercherInformations, Ligne 541, \nnode.getAttribute(B_VERS_SOURCE)=", nodeprint.getAttribute(B_VERS_SOURCE), ", planTravail.getVersionSource()=", planTravail.getVersionSource())
            # print("58. Module: Controleurs.cInformations, Class: CInformations, Methode: __rechercherInformations, Ligne 542, \nnode.getAttribute(B_ETAT_SOURCE)=", nodeprint.getAttribute(B_ETAT_SOURCE), ", planTravail.getEtatSource()=", planTravail.getEtatSource())
            # print("59. Module: Controleurs.cInformations, Class: CInformations, Methode: __rechercherInformations, Ligne 543, \nnode.getAttribute(B_VERS_CIBLE)=", nodeprint.getAttribute(B_VERS_CIBLE), ", planTravail.getVersionCible()=", planTravail.getVersionCible())
            # print("60. Module: Controleurs.cInformations, Class: CInformations, Methode: __rechercherInformations, Ligne 544, \nnode.getAttribute(B_ETAT_CIBLE)=", nodeprint.getAttribute(B_ETAT_CIBLE), ", planTravail.getEtatCible()=", planTravail.getEtatCible())
            # print("61. Module: Controleurs.cInformations, Class: CInformations, Methode: __rechercherInformations, Ligne 545, \nnode.getAttribute(B_PARAM_1)=", nodeprint.getAttribute(B_PARAM_1), ", pParametres.getp1()= %s ", pParametres.getp1())
            # print("62. Module: Controleurs.cInformations, Class: CInformations, Methode: __rechercherInformations, Ligne 546, \nnode.getAttribute(B_PARAM_2)=", nodeprint.getAttribute(B_PARAM_2), ", pParametres.getp2()= %s ", pParametres.getp2())
            # print("63. Module: Controleurs.cInformations, Class: CInformations, Methode: __rechercherInformations, Ligne 547, \nnode.getAttribute(B_PARAM_3)=", nodeprint.getAttribute(B_PARAM_3), ", pParametres.getp3()= %s ", pParametres.getp3())
            # print("64. Module: Controleurs.cInformations, Class: CInformations, Methode: __rechercherInformations, Ligne 548, \nnode.getAttribute(B_PARAM_4)=", nodeprint.getAttribute(B_PARAM_4), ", pParametres.getp4()= %s ", pParametres.getp4())
            # print("65. Module: Controleurs.cInformations, Class: CInformations, Methode: __rechercherInformations, Ligne 549, \nnode.getAttribute(B_PARAM_5)=", nodeprint.getAttribute(B_PARAM_5), ", pParametres.getp5()= %s ", pParametres.getp5())
            # print("66. Module: Controleurs.cInformations, Class: CInformations, Methode: __rechercherInformations, Ligne 550, \nnode.getAttribute(B_PARAM_6)=", nodeprint.getAttribute(B_PARAM_6), ", pParametres.getp6()= %s ", pParametres.getp6())
            # print("67. Module: Controleurs.cInformations, Class: CInformations, Methode: __rechercherInformations, Ligne 551, \nnode.getAttribute(B_PARAM_7)=", nodeprint.getAttribute(B_PARAM_7), ", pParametres.getp7()= %s ", pParametres.getp7())                
        for node in liste : 
            if (node.getAttribute(B_VERS_SOURCE)== planTravail.getVersionSource() and 
                node.getAttribute(B_ETAT_SOURCE)== planTravail.getEtatSource() and 
                node.getAttribute(B_VERS_CIBLE) == planTravail.getVersionCible() and 
                node.getAttribute(B_ETAT_CIBLE) == planTravail.getEtatCible() and
                node.getAttribute(B_PARAM_1) == '%s'%pParametres.getp1() and
                node.getAttribute(B_PARAM_2) == '%s'%pParametres.getp2() and
                node.getAttribute(B_PARAM_3) == '%s'%pParametres.getp3() and
                node.getAttribute(B_PARAM_4) == '%s'%pParametres.getp4() and
                node.getAttribute(B_PARAM_5) == '%s'%pParametres.getp5() and
                node.getAttribute(B_PARAM_6) == '%s'%pParametres.getp6() and
                node.getAttribute(B_PARAM_7) == '%s'%pParametres.getp7()):
                    return self.__getInformations_(node,planTravail.getAuteur(),planTravail.getOeuvre())     # Modifie 19.09.2019, ancienne: return self.__getInformations(node,planTravail.getAuteur(),planTravail.getOeuvre())
        return None

    def rechercherInformations__(self, planTravail):
        """ Recherche une information de comparaisons
        On recherche la chaine informations dans le fichier xml sans le parser en DOM ce qui est
        tres lourd quand le fichier est gros,
        une fois trouve, on extrait la chaine contenant la bonne balise informations et on
        la parse effectivement en DOM
        pas propre mais beaucoup plus rapide que la methode __rechercherInformations
        quand les fichiers sont gros """
        logging.debug('begin rechercherInformations')
        fim =  Controleurs.FInfoManager.FInfoManager(Controleurs.DGManager.Auteur(planTravail.getAuteur()), 
                                                     Controleurs.DGManager.Oeuvre(planTravail.getOeuvre()))
        pParametres = planTravail.getParam()
        f = open(fim.getFileInfo())
        text = f.read()
        # print("68. Module: Controleurs.cInformations, Class: CInformations, Methode: rechercherInformations__, Ligne 581, \ntext=[", text, "], \nplanTravail.getAuteur()", planTravail.getAuteur(), ", planTravail.getOeuvre()=", planTravail.getOeuvre(), " ")                  # Ajoutee pour debogage 
        f.close()
        # on cherche les balises <informations atributs...>
        deb = text.find('<informations') ; transfo = text.find('<transformations>') 
        fin = text.find('</informations>')
        while deb != -1:
            # on ajoute '<xml ...' pour avoir un Document et extraire le noeud informations
            chaine_informations = '<?xml version="1.0"  encoding="utf-8" ?><root>' + \
                text[deb:transfo] +'</informations></root>'             # Modifie 12.09.2019, ancienne:  chaine_informations = '<?xml version="1.0"  encoding="iso-8859-1" ?><root>' + \text[deb:transfo] +'</informations></root>' 
            # print ("68-1. Module: Controleurs.cInformations, Class: CInformations, Methode: rechercherInformations__, Ligne 590, \nchaine_informations=[", chaine_informations, "] ")                              # Ajoutee pour debogage 
            #logging.debug(chaine_informations)
            xml_informations = xml.dom.minidom.parseString(chaine_informations)
            # print ("69. Module: Controleurs.cInformations, Class: CInformations, Methode: rechercherInformations__, Ligne 593, \nxml_informations=[", str(xml_informations), "] ")                                    # Ajoutee pour debogage 
            liste = xml_informations.getElementsByTagName(B_INFORMATIONS)                           # Ajoutee 14.05.2019  
            # print("70. Module: Controleurs.cInformations, Class: CInformations, Methode: rechercherInformations__, Ligne 595 \nnombre de nodes informations=[ %s ", len(liste), "] ")                      # Ajoutee 14.05.2019 pour debogage
            node = liste[0]                     # liste avec 1 seul element nécessairement
            # print("69. Module: Controleurs.cInformations, Class: CInformations, Methode: rechercherInformations__, Ligne 597, \nnode.getAttribute(B_VERS_SOURCE)=", node.getAttribute(B_VERS_SOURCE), ", planTravail.getVersionSource()=", planTravail.getVersionSource())
            # print("70. Module: Controleurs.cInformations, Class: CInformations, Methode: rechercherInformations__, Ligne 598, \nnode.getAttribute(B_ETAT_SOURCE)=", node.getAttribute(B_ETAT_SOURCE), ", planTravail.getEtatSource()=", planTravail.getEtatSource())
            # print("71. Module: Controleurs.cInformations, Class: CInformations, Methode: rechercherInformations__, Ligne 599, \nnode.getAttribute(B_ETAT_CIBLE)=", node.getAttribute(B_ETAT_CIBLE), ", planTravail.getEtatCible()=", planTravail.getEtatCible())
            # print("72. Module: Controleurs.cInformations, Class: CInformations, Methode: rechercherInformations__, Ligne 600, \nnode.getAttribute(B_ETAT_CIBLE)=", node.getAttribute(B_ETAT_CIBLE), ", planTravail.getEtatCible()=", planTravail.getEtatCible())
            # print("73. Module: Controleurs.cInformations, Class: CInformations, Methode: rechercherInformations__, Ligne 601, \nnode.getAttribute(B_PARAM_1)=", node.getAttribute(B_PARAM_1), ", pParametres.getp1()= %s ", pParametres.getp1())
            # print("74. Module: Controleurs.cInformations, Class: CInformations, Methode: rechercherInformations__, Ligne 602, \nnode.getAttribute(B_PARAM_2)=", node.getAttribute(B_PARAM_2), ", pParametres.getp2()= %s ", pParametres.getp2())
            # print("75. Module: Controleurs.cInformations, Class: CInformations, Methode: rechercherInformations__, Ligne 603, \nnode.getAttribute(B_PARAM_3)=", node.getAttribute(B_PARAM_3), ", pParametres.getp3()= %s ", pParametres.getp3())
            # print("76. Module: Controleurs.cInformations, Class: CInformations, Methode: rechercherInformations__, Ligne 604, \nnode.getAttribute(B_PARAM_4)=", node.getAttribute(B_PARAM_4), ", pParametres.getp4()= %s ", pParametres.getp4())
            # print("77. Module: Controleurs.cInformations, Class: CInformations, Methode: rechercherInformations__, Ligne 605, \nnode.getAttribute(B_PARAM_5)=", node.getAttribute(B_PARAM_5), ", pParametres.getp5()= %s ", pParametres.getp5())
            # print("78. Module: Controleurs.cInformations, Class: CInformations, Methode: rechercherInformations__, Ligne 606, \nnode.getAttribute(B_PARAM_6)=", node.getAttribute(B_PARAM_6), ", pParametres.getp6()= %s ", pParametres.getp6())
            # print("79. Module: Controleurs.cInformations, Class: CInformations, Methode: rechercherInformations__, Ligne 607, \nnode.getAttribute(B_PARAM_7)=", node.getAttribute(B_PARAM_7), ", pParametres.getp7()= %s ", pParametres.getp7())                            
            if (node.getAttribute(B_VERS_SOURCE)== planTravail.getVersionSource() and 
                node.getAttribute(B_ETAT_SOURCE)== planTravail.getEtatSource() and 
                node.getAttribute(B_VERS_CIBLE) == planTravail.getVersionCible() and 
                node.getAttribute(B_ETAT_CIBLE) == planTravail.getEtatCible() and
                node.getAttribute(B_PARAM_1) == '%s'%pParametres.getp1() and
                node.getAttribute(B_PARAM_2) == '%s'%pParametres.getp2() and
                node.getAttribute(B_PARAM_3) == '%s'%pParametres.getp3() and
                node.getAttribute(B_PARAM_4) == '%s'%pParametres.getp4() and
                node.getAttribute(B_PARAM_5) == '%s'%pParametres.getp5() and
                node.getAttribute(B_PARAM_6) == '%s'%pParametres.getp6() and
                node.getAttribute(B_PARAM_7) == '%s'%pParametres.getp7()):
                    # on a le bon noeud informations, on récupère le noeud et tous ses fils
                    chaine_informations = '<?xml version="1.0"  encoding="utf-8" ?><root>' + \
                        text[deb:fin+15] +'</root>'                 # Modifie 12.09.2019, ancienne:  chaine_informations = '<?xml version="1.0"  encoding="iso-8859-1" ?><root>' + \text[deb:fin+15] +'</root>' 
                    xml_informations = xml.dom.minidom.parseString(chaine_informations)
                    liste = xml_informations.getElementsByTagName(B_INFORMATIONS) 
                    objet_informations = self.__getInformations_(liste[0], planTravail.getAuteur(),planTravail.getOeuvre())      # Modifie 19.09.2019, ancienne: objet_informations = self.__getInformations(liste[0], planTravail.getAuteur(),planTravail.getOeuvre())
                    liste = None ; xml_informations.unlink()
                    logging.debug('fin rechercherInformations')
                    return objet_informations
            deb = text.find('<informations',fin+15) ; transfo = text.find('<transformations>',fin+15) 
            fin = text.find('</informations>',fin+15)
        # print("80. Module: Controleurs.cInformations, Class: CInformations, Methode: rechercherInformations__, Ligne 630 ")
        return None
        
    def rechercherInformations(self, planTravail):
        """ 
        Recherche avec Ft.Xml.Domlette
        Recherche une information de comparaisons
        On recherche la chaine informations dans le fichier xml sans le parser en DOM ce qui est
        tres lours quand le fichier est gros,
        une fois trouve, on extrait la chaine conteant la bonne balise informations et on
        la parse effectivement en DOM
        pas propre mais beaucoup plus rapide que la methode __rechercherInformations
        quand les fichiers sont gros """
        logging.debug('begin rechercherInformations')
        fim =  Controleurs.FInfoManager.FInfoManager(Controleurs.DGManager.Auteur(planTravail.getAuteur()), 
                                                     Controleurs.DGManager.Oeuvre(planTravail.getOeuvre()))
        pParametres = planTravail.getParam()
        f = open(fim.getFileInfo())
        text = f.read()
        # print("81. Module: Controleurs.cInformations, Class: CInformations, Methode: rechercherInformations, Ligne 649, \ntext=[", text, "], \nplanTravail.getAuteur()", planTravail.getAuteur(), ", planTravail.getOeuvre()=", planTravail.getOeuvre(), " ")                 # Ajoutee pour debogage 
        f.close()
        # on cherhce les balises <informations atributs...>
        deb = text.find('<informations') ; transfo = text.find('<transformations>') 
        fin = text.find('</informations>')
        while deb != -1:
            # on ajoute '<xml ...' pour avoir un Document et extraire le noeud informations
            chaine_informations = '<?xml version="1.0"  encoding="utf-8" ?><root>' + \
                text[deb:transfo] +'</informations></root>'                     # Modifie 12.09.2019, ancienne:  chaine_informations = '<?xml version="1.0"  encoding="iso-8859-1" ?><root>' + \text[deb:transfo] +'</informations></root>'
            # print ("82. Module: Controleurs.cInformations, Class: CInformations, Methode: rechercherInformations, Ligne 658, \nchaine_informations=[", chaine_informations, "] ")            # Ajoutee pour debogage 
            #logging.debug(chaine_informations)
            #xml_informations = xml.dom.minidom.parseString(chaine_informations)
            #xml_informations = Ft.Xml.Parse(chaine_informations)                                            # Desactivee 14.05.2019 
            xml_informations = xml.dom.minidom.parseString(chaine_informations, parser=None)                # Ajoutee 14.05.2019 
            # print ("83. Module: GUI.cInformations, Class: CInformations, Methode: rechercherInformations, Ligne 663, \nxml_informations=[", str(xml_informations), "] ")                                        # Ajoutee pour debogage 
            #liste = xml_informations.getElementsByTagName(B_INFORMATIONS) 
            #node = liste[0] # liste avec 1 seul element nécessairement
            nodeListe = lxml.etree.XPath.Evaluate(u'(/root/'+B_INFORMATIONS+
                            '[@'+B_VERS_SOURCE+'="'+planTravail.getVersionSource()+'"]' + 
                            '[@'+B_ETAT_SOURCE+'="'+planTravail.getEtatSource()+'"]' +
                            '[@'+B_VERS_CIBLE+'="'+planTravail.getVersionCible()+'"]' + 
                            '[@'+B_ETAT_CIBLE+'="'+planTravail.getEtatCible()+'"]' + 
                            '[@'+B_PARAM_1+'="'+str(pParametres.getp1())+'"]' +  
                            '[@'+B_PARAM_2+'="'+str(pParametres.getp2())+'"]' + 
                            '[@'+B_PARAM_3+'="'+str(pParametres.getp3())+'"]' + 
                            '[@'+B_PARAM_4+'="'+str(pParametres.getp4())+'"]' + 
                            '[@'+B_PARAM_5+'="'+str(pParametres.getp5())+'"]' + 
                            '[@'+B_PARAM_6+'="'+str(pParametres.getp6())+'"]'+ 
                            '[@'+B_PARAM_7+'="'+str(pParametres.getp7())+'"])' 
                            ,contextNode = xml_informations)                     # Modifiee 14.05.2019, ancienne ligne:  nodeListe = Ft.Xml.XPath.Evaluate(u'(/root/'+B_INFORMATIONS+'[@'+B_VERS_SOURCE+'="'+planTravail.getVersionSource()+'"]' + '[@'+B_ETAT_SOURCE+'="'+planTravail.getEtatSource()+'"]' +'[@'+B_VERS_CIBLE+'="'+planTravail.getVersionCible()+'"]' + '[@'+B_ETAT_CIBLE+'="'+planTravail.getEtatCible()+'"]' + '[@'+B_PARAM_1+'="'+str(pParametres.getp1())+'"]' +  '[@'+B_PARAM_2+'="'+str(pParametres.getp2())+'"]' + '[@'+B_PARAM_3+'="'+str(pParametres.getp3())+'"]' + '[@'+B_PARAM_4+'="'+str(pParametres.getp4())+'"]' + '[@'+B_PARAM_5+'="'+str(pParametres.getp5())+'"]' + '[@'+B_PARAM_6+'="'+str(pParametres.getp6())+'"]'+ '[@'+B_PARAM_7+'="'+str(pParametres.getp7())+'"])' ,contextNode = xml_informations) 
            # print("84. Module: Controleurs.cInformations, Class: CInformations, Methode: rechercherInformations, Ligne 679, \nnombre de nodes informations=[ %s ", len(nodeListe), "]")                      # Ajoutee 14.05.2019 pour debogage
            if len(nodeListe) != 0:        
                # on a le bon noeud informations, on récupère le noeud et tous ses fils
                chaine_informations = '<?xml version="1.0"  encoding="utf-8" ?><root>' + \
                    text[deb:fin+15] +'</root>'                     # Modifie 12.09.2019, ancienne:  chaine_informations = '<?xml version="1.0"  encoding="iso-8859-1" ?><root>' + \text[deb:fin+15] +'</root>'  
                # print ("85. Module: Controleurs.cInformations, Class: CInformations, Methode: rechercherInformations, Ligne 684, \nchaine_informations=[", chaine_informations, "] ")                       # Ajoutee pour debogage 
                #xml_informations = xml.dom.minidom.parseString(chaine_informations)
                #xml_informations = Ft.Xml.Parse(chaine_informations)                                            # Desactivee 14.05.2019 
                xml_informations = xml.dom.minidom.parseString(chaine_informations, parser=None)                # Ajoutee 14.05.2019 
                # print ("86. Module: Controleurs.cInformations, Class: CInformations, Methode: rechercherInformations, Ligne 688, \nxml_informations=[", str(xml_informations), "] ")                         # Ajoutee pour debogage 
                #liste = xml_informations.getElementsByTagName(B_INFORMATIONS)
                #liste = Ft.Xml.XPath.Evaluate(u'(//'+B_INFORMATIONS+')',contextNode = xml_informations)        # Desactivee 14.05.2019
                liste = xml_informations.getElementsByTagName(B_INFORMATIONS)                               # Ajoutee 14.05.2019 
                # print("87. Module: Controleurs.cInformations, Class: CInformations, Methode: rechercherInformations, Ligne 692, \nnombre de nodes informations=[ %s ", len(liste), "] ")                          # Ajoutee 14.05.2019 pour debogage
                objet_informations = self.__getInformations_(liste[0], planTravail.getAuteur(),planTravail.getOeuvre())      # Modifie 19.09.2019, ancienne: objet_informations = self.__getInformations(liste[0], planTravail.getAuteur(),planTravail.getOeuvre())
                liste = None ; xml_informations = None      #.unlink()
                logging.debug('fin rechercherInformations')
                return objet_informations
            deb = text.find('<informations',fin+15) ; transfo = text.find('<transformations>',fin+15) 
            fin = text.find('</informations>',fin+15)
        # print("88. Module: Controleurs.cInformations, Class: CInformations, Methode: rechercherInformations, Ligne 699 ")
        return None
        
        
    def __rechercherInfos(self, pListeBalise, planTravail):
        """ Methode privee qui renvoie la balise "informations" recherchee
        pre: isinstance(planTravail, Donnees.planTravail.PlanTravail) and \
             isinstance(pListeBalise, list)"""
        pParametres = planTravail.getParam()
        # for nodeprint in pListeBalise : 
            # print("89. Module: Controleurs.cInformations, Class: CInformations, Methode: __rechercherInfos, Ligne 709, \npListeBalise= %s ", pListeBalise)
            # print("90. Module: Controleurs.cInformations, Class: CInformations, Methode: __rechercherInfos, Ligne 710, \nnode.getAttribute(B_VERS_SOURCE)=", nodeprint.getAttribute(B_VERS_SOURCE), ", planTravail.getVersionSource()=", planTravail.getVersionSource())
            # print("91. Module: Controleurs.cInformations, Class: CInformations, Methode: __rechercherInfos, Ligne 711, \nnode.getAttribute(B_ETAT_SOURCE)=", nodeprint.getAttribute(B_ETAT_SOURCE), ", planTravail.getEtatSource()=", planTravail.getEtatSource())
            # print("92. Module: Controleurs.cInformations, Class: CInformations, Methode: __rechercherInfos, Ligne 712, \nnode.getAttribute(B_ETAT_CIBLE)=", nodeprint.getAttribute(B_ETAT_CIBLE), ", planTravail.getEtatCible()=", planTravail.getEtatCible())
            # print("93. Module: Controleurs.cInformations, Class: CInformations, Methode: __rechercherInfos, Ligne 713, \nnode.getAttribute(B_ETAT_CIBLE)=", nodeprint.getAttribute(B_ETAT_CIBLE), ", planTravail.getEtatCible()=", planTravail.getEtatCible())
            # print("94. Module: Controleurs.cInformations, Class: CInformations, Methode: __rechercherInfos, Ligne 714, \nnode.getAttribute(B_PARAM_1)=", nodeprint.getAttribute(B_PARAM_1), ", pParametres.getp1()= %s ", pParametres.getp1())
            # print("95. Module: Controleurs.cInformations, Class: CInformations, Methode: __rechercherInfos, Ligne 715, \nnode.getAttribute(B_PARAM_2)=", nodeprint.getAttribute(B_PARAM_2), ", pParametres.getp2()= %s ", pParametres.getp2())
            # print("96. Module: Controleurs.cInformations, Class: CInformations, Methode: __rechercherInfos, Ligne 716, \nnode.getAttribute(B_PARAM_3)=", nodeprint.getAttribute(B_PARAM_3), ", pParametres.getp3()= %s ", pParametres.getp3())
            # print("97. Module: Controleurs.cInformations, Class: CInformations, Methode: __rechercherInfos, Ligne 717, \nnode.getAttribute(B_PARAM_4)=", nodeprint.getAttribute(B_PARAM_4), ", pParametres.getp4()= %s ", pParametres.getp4())
            # print("98. Module: Controleurs.cInformations, Class: CInformations, Methode: __rechercherInfos, Ligne 718, \nnode.getAttribute(B_PARAM_5)=", nodeprint.getAttribute(B_PARAM_5), ", pParametres.getp5()= %s ", pParametres.getp5())
            # print("99. Module: Controleurs.cInformations, Class: CInformations, Methode: __rechercherInfos, Ligne 719, \nnode.getAttribute(B_PARAM_6)=", nodeprint.getAttribute(B_PARAM_6), ", pParametres.getp6()= %s ", pParametres.getp6())
            # print("100. Module: Controleurs.cInformations, Class: CInformations, Methode: __rechercherInfos, Ligne 720, \nnode.getAttribute(B_PARAM_7)=", nodeprint.getAttribute(B_PARAM_7), ", pParametres.getp7()= %s ", pParametres.getp7())                
        for node in pListeBalise :
            if (node.getAttribute(B_VERS_SOURCE)== planTravail.getVersionSource()  and 
                node.getAttribute(B_ETAT_SOURCE)== planTravail.getEtatSource() and 
                node.getAttribute(B_VERS_CIBLE) == planTravail.getVersionCible() and 
                node.getAttribute(B_ETAT_CIBLE) == planTravail.getEtatCible() and
                node.getAttribute(B_PARAM_1) == '%s'%pParametres.getp1() and
                node.getAttribute(B_PARAM_2) == '%s'%pParametres.getp2() and
                node.getAttribute(B_PARAM_3) == '%s'%pParametres.getp3() and
                node.getAttribute(B_PARAM_4) == '%s'%pParametres.getp4() and
                node.getAttribute(B_PARAM_5) == '%s'%pParametres.getp5() and
                node.getAttribute(B_PARAM_6) == '%s'%pParametres.getp6() and
                node.getAttribute(B_PARAM_7) == '%s'%pParametres.getp7()):
                    return node
        # print("101. Module: Controleurs.cInformations, Class: CInformations, Methode: __rechercherInfos, Ligne 734 ")            
        return None                 
#        raise InformationsNonTrouvees('les informations de "'+pVersionSource+
#                                      '/'+pEtatSource+'" et "'+pVersionCible+
#                                      '/'+pEtatCible+'" n\'existent pas')

        
    # Methode privee qui renvoie vrai si l'index passe en parametre est l'un
    # des premiers indices de la liste de couple passee en parametre
    def __appartientListe(self, pIndex, pListe):
        # print("102. Module: Controleurs.cInformations, Class: CInformations, Methode: __appartientListe, Ligne 744 ")
        for i in pListe :
            if pIndex == i[0]:
                return 1   ## VRAI
        return 0 ## FALSE


                
    # Methode privee pour rechercher dans une liste de couples d'indices
    # le couple dont le 1er indice est passe en parametre
    def __getCpleIndices(self, pListe, indice):
        # print("103. Module: Controleurs.cInformations, Class: CInformations, Methode: __getCpleIndices, Ligne 755 ")
        for i in pListe :
            if i[0] == indice :
                return i
        return None

    # Methode privee pour creer les sous balises de deplacement dans la balise
    # passee en parametre
    def __sousBalises(self, pBalise, pTextNorm, pBlocText, pLDepl):
        textNetBloc = pTextNorm+pBlocText
        lg = len(pTextNorm)
        xmldoc = Document()
        for i in range(len(pTextNorm), len(textNetBloc)):
            cple = self.__getCpleIndices(pLDepl, i)
            if cple != None:
                m1 = encodingNode(textNetBloc[lg : cple[0] ])
                mot1 = xmldoc.createTextNode(m1)
                pBalise.appendChild(mot1)
                m2 = encodingNode(textNetBloc[cple[0] : cple[1] ])
                mot2 = xmldoc.createTextNode(m2)
                baliseDepl = xmldoc.createElement(B_TEXT_DEPL)
                baliseDepl.appendChild(mot2)
                pBalise.appendChild(baliseDepl)
                i = len(textNetBloc[lg: cple[1] ])
                lg += i
        m3 = encodingNode(textNetBloc[lg :])
        mot3 = xmldoc.createTextNode(m3)
        pBalise.appendChild(mot3)
        # print("104. Module: Controleurs.cInformations, Class: CInformations, Methode: __sousBalises, Ligne 783, \npTextNorm=", pTextNorm, ", \npBlocText=", pBlocText, ", \npLDepl=", pLDepl)

    ## Fonction privee pour recuperer les textes sans les codes xml
    def __recupMot(self, pMot):
        mot = pMot.replace('&quot;', '"')\
              .replace('&amp;', '&')\
              .replace('&lt;', '<')\
              .replace('&gt;', '>')
        # print("105. Module: GUI.cInformations, Class: CInformations, Methode: __recupMot, Ligne 791, \npMot=",pMot, ", mot=", mot)
        return mot
        
    # Methode privee pour retrouver les caracteres deplaces d'une balise
    def __recupereListe(self, pBalise, pListe, pListeDepl, pTextes, pBlocs):
        # print("106. Module: Controleurs.cInformations, Class: CInformations, Methode: __recupereListe, Ligne 796, \npListe= %s ", pListe, ", \npListeDepl= %s ", pListeDepl, ", \npTextes= %s ", pTextes, ", \npBlocs= %s ", pBlocs)
        lg1 = len(pTextes)
        motListe= ''
        noeud = pBalise._get_firstChild()
        while noeud != None :
            if noeud.hasChildNodes() and noeud.tagName == B_TEXT_DEPL :
                nFils = noeud._get_firstChild()
                mot = ''
                while nFils != None :
                    mot += self.__recupMot(nFils.toxml())
                    noeud.removeChild(nFils)
                    nFils = noeud._get_firstChild()
                lg2 = len(pTextes)
                pTextes += mot
                motListe += mot
                pListeDepl.append( [lg2,len(pTextes)] )         
            else :
                mot = self.__recupMot(noeud.toxml())
                pTextes += mot
                motListe += mot  
            pBalise.removeChild(noeud)
            noeud = pBalise._get_firstChild()
        pListe.append( [lg1, len(pTextes)] )
        pBlocs.append(pTextes[lg1:])
        # print("107. Module: Controleurs.cInformations, Class: CInformations, Methode: __recupereListe, Ligne 820, \nmotListe=", motListe, ", \npListe= %s ", pListe, ", \npListeDepl= %s ", pListeDepl, ", \npTextes= %s ", pTextes, ", \npBlocs= %s ", pBlocs)
        return pTextes[lg1:]
        
    # Methode privee qui creer le noeud <information> a inserer dans le fichier xml
    def __creerInformations_(self, planTravail, pResultat):
        """pre: isinstance(planTravail, Donnees.planTravail.PlanTravail) and \ 
                isinstance(pResultat, Donnees.resultatAppli.Resultat)
        post: isinstance(__return__, xml.dom.minidom.Node) """
        pParametres = planTravail.getParam()
        # print("108. Module: Controleurs.cInformations, Class: CInformations, Methode: __creerInformations_, Ligne 829, Parametres: \np1=", pParametres.getp1(), ", p2=", pParametres.getp2(), ", p3=", pParametres.getp3(),", p4=", pParametres.getp4(),", p5=", pParametres.getp5(),", p6=", pParametres.getp6(),", p7=", pParametres.getp7())
        xmldoc = Document()
        # Balise Information
        xmltagInfo = xmldoc.createElement(B_INFORMATIONS)
        xmltagInfo.setAttribute(B_VERS_SOURCE,planTravail.getVersionSource() )
        xmltagInfo.setAttribute(B_ETAT_SOURCE,planTravail.getEtatSource())
        xmltagInfo.setAttribute(B_VERS_CIBLE,planTravail.getVersionCible())
        xmltagInfo.setAttribute(B_ETAT_CIBLE,planTravail.getEtatCible())        
        xmltagInfo.setAttribute(B_PARAM_1,'%s'%pParametres.getp1())        
        xmltagInfo.setAttribute(B_PARAM_2,'%s'%pParametres.getp2())        
        xmltagInfo.setAttribute(B_PARAM_3,'%s'%pParametres.getp3())
        xmltagInfo.setAttribute(B_PARAM_4,'%s'%pParametres.getp4())
        xmltagInfo.setAttribute(B_PARAM_5,'%s'%pParametres.getp5())
        xmltagInfo.setAttribute(B_PARAM_6,'%s'%pParametres.getp6())
        xmltagInfo.setAttribute(B_PARAM_7,'%s'%pParametres.getp7())
            # Balise Transformations
        xmlTransfo = xmldoc.createElement(B_TRANSFORMATIONS)
        xmlLgsource = xmldoc.createElement(B_LGSOURCE)
        xmlLgsource.setAttribute(B_LG, str(pResultat.getLgSource()))
        xmlTransfo.appendChild(xmlLgsource)
                # Insertions
        xmlInsert = xmldoc.createElement(B_INSERTIONS)
        listeInsert = pResultat.getListeInsertions()
        for deb,fin in listeInsert :
            node = xmldoc.createElement(B_INS)
            node.setAttribute(B_DEB, str(deb))
            node.setAttribute(B_FIN, str(fin))      
            xmlInsert.appendChild(node)
        xmlTransfo.appendChild(xmlInsert)
                # Suppressions
        xmlSupp = xmldoc.createElement(B_SUPPRESSIONS)
        listeSupp = pResultat.getListeSuppressions()
        for deb,fin in listeSupp :
            node = xmldoc.createElement(B_SUP)
            node.setAttribute(B_DEB, str(deb))
            node.setAttribute(B_FIN, str(fin))      
            xmlSupp.appendChild(node)
        xmlTransfo.appendChild(xmlSupp)
                # Deplacements
        xmlDepl = xmldoc.createElement(B_DEPLACEMENTS)
        listeDepl = pResultat.getListeDeplacements()
        for deb,fin in listeDepl :
            node = xmldoc.createElement(B_DEP)
            node.setAttribute(B_DEB, str(deb))
            node.setAttribute(B_FIN, str(fin))   
            xmlDepl.appendChild(node)
        xmlTransfo.appendChild(xmlDepl)
                # Remplacement
        xmlRemp = xmldoc.createElement(B_REMPLACEMENTS)
        listeRemp = pResultat.getListeRemplacements()
        for deb,fin in listeRemp :
            node = xmldoc.createElement(B_REMP)
            node.setAttribute(B_DEB, str(deb))
            node.setAttribute(B_FIN, str(fin))
            xmlRemp.appendChild(node)
        xmlTransfo.appendChild(xmlRemp)
        #blocs communs
        xmlBlocsCom = xmldoc.createElement(B_BLOCSCOMMUNS)
        listeBlocsCommuns = pResultat.getBlocsCommuns()
        for deb,fin in listeBlocsCommuns :
            node = xmldoc.createElement(B_BC)
            node.setAttribute(B_DEB, str(deb))
            node.setAttribute(B_FIN, str(fin))
            xmlBlocsCom.appendChild(node)
        xmlTransfo.appendChild(xmlBlocsCom)
##########################################################
########## blocs non definis
        xmlNonDef = xmldoc.createElement(B_NONDEF)
        listeBlocsNonDefinis = pResultat.getNonDef()
        for deb,fin in listeBlocsNonDefinis :
            node = xmldoc.createElement(B_ND)
            node.setAttribute(B_DEB, str(deb))
            node.setAttribute(B_FIN, str(fin))
            xmlNonDef.appendChild(node)
        xmlTransfo.appendChild(xmlNonDef)
################################################################
        # blocs déplacés
        xmlBlocsDep = xmldoc.createElement(B_BLOCSDEPLACES)
        listeBlocsDep = pResultat.getPairesBlocsDeplaces()
        for (b1deb,b1fin),(b2deb,b2fin) in listeBlocsDep :
            node = xmldoc.createElement(B_DEP)
            node.setAttribute(B1_D, str(b1deb))
            node.setAttribute(B1_F, str(b1fin))
            node.setAttribute(B2_D, str(b2deb))
            node.setAttribute(B2_F, str(b2fin))
            xmlBlocsDep.appendChild(node)
        xmlTransfo.appendChild(xmlBlocsDep)       
        # Insertion de la balise B_TRANSFORMATIONS dans la balise B_INFORMATIONS
        xmltagInfo.appendChild(xmlTransfo)
        return xmltagInfo
       
    # Methode privee qui creer le noeud <information> a inserer dans le fichier xml
    def __creerInformations(self, planTravail, pResultat):
        """
        Avec Ft.Xml
        pre: isinstance(planTravail, Donnees.planTravail.PlanTravail) and \ 
                isinstance(pResultat, Donnees.resultatAppli.Resultat)
        post: isinstance(__return__, xml.dom.minidom.Node) """
        pParametres = planTravail.getParam()
        # print("109. Module: Controleurs.cInformations, Class: CInformations, Methode: __creerInformations, Ligne 928, Parametres: \np1=", pParametres.getp1(), ", p2=", pParametres.getp2(), ", p3=", pParametres.getp3(),", p4=", pParametres.getp4(),", p5=", pParametres.getp5(),", p6=", pParametres.getp6(),", p7=", pParametres.getp7())
        #xmldoc = Ft.Xml.Document()
        #xmldoc = doc = Ft.Xml.Domlette.implementation.createDocument(Ft.Xml.EMPTY_NAMESPACE, None, None)            # Desactive et remplac� par ligne suivante, 27.05.2019
        xmldoc = doc = xml.dom.minidom.getDOMImplementation().createDocument(xml.dom.minidom.EMPTY_NAMESPACE, 'xml', None)
        # Balise Information
        xmltagInfo = xmldoc.createElementNS(xmldoc.namespaceURI, B_INFORMATIONS)
        xmltagInfo.setAttributeNS(xmltagInfo.namespaceURI, B_VERS_SOURCE,planTravail.getVersionSource() )
        xmltagInfo.setAttributeNS(xmltagInfo.namespaceURI, B_ETAT_SOURCE,planTravail.getEtatSource())
        xmltagInfo.setAttributeNS(xmltagInfo.namespaceURI, B_VERS_CIBLE,planTravail.getVersionCible())
        xmltagInfo.setAttributeNS(xmltagInfo.namespaceURI, B_ETAT_CIBLE,planTravail.getEtatCible())        
        xmltagInfo.setAttributeNS(xmltagInfo.namespaceURI, B_PARAM_1,'%s'%pParametres.getp1())        
        xmltagInfo.setAttributeNS(xmltagInfo.namespaceURI, B_PARAM_2,'%s'%pParametres.getp2())        
        xmltagInfo.setAttributeNS(xmltagInfo.namespaceURI, B_PARAM_3,'%s'%pParametres.getp3())
        xmltagInfo.setAttributeNS(xmltagInfo.namespaceURI, B_PARAM_4,'%s'%pParametres.getp4())
        xmltagInfo.setAttributeNS(xmltagInfo.namespaceURI, B_PARAM_5,'%s'%pParametres.getp5())
        xmltagInfo.setAttributeNS(xmltagInfo.namespaceURI, B_PARAM_6,'%s'%pParametres.getp6())
        xmltagInfo.setAttributeNS(xmltagInfo.namespaceURI, B_PARAM_7,'%s'%pParametres.getp7())
        # Balise Transformations
        xmlTransfo = xmldoc.createElementNS(xmldoc.namespaceURI, B_TRANSFORMATIONS)
        xmlLgsource = xmldoc.createElementNS(xmldoc.namespaceURI, B_LGSOURCE)
        xmlLgsource.setAttributeNS(xmlLgsource.namespaceURI, B_LG, str(pResultat.getLgSource()))
        xmlTransfo.appendChild(xmlLgsource)
        # Insertions
        xmlInsert = xmldoc.createElementNS(xmldoc.namespaceURI, B_INSERTIONS)
        listeInsert = pResultat.getListeInsertions()
        # print("110. Module: Controleurs.cInformations, Class: CInformations, Methode: __creerInformations, Ligne 953, \nlistInsert=[", listeInsert, "] ")
        for deb,fin in listeInsert :
            node = xmldoc.createElementNS(xmldoc.namespaceURI, B_INS)
            node.setAttributeNS(node.namespaceURI, B_DEB, str(deb))
            node.setAttributeNS(xmldoc.namespaceURI, B_FIN, str(fin))      
            xmlInsert.appendChild(node)
        xmlTransfo.appendChild(xmlInsert)
        # Suppressions
        xmlSupp = xmldoc.createElementNS(xmldoc.namespaceURI, B_SUPPRESSIONS)
        listeSupp = pResultat.getListeSuppressions()
        # print("111. Module: Controleurs.cInformations, Class: CInformations, Methode: __creerInformations, Ligne 963, \nlisteSupp=[", listeSupp, "] ")
        for deb,fin in listeSupp :
            node = xmldoc.createElementNS(xmldoc.namespaceURI, B_SUP)
            node.setAttributeNS(node.namespaceURI, B_DEB, str(deb))
            node.setAttributeNS(node.namespaceURI, B_FIN, str(fin))      
            xmlSupp.appendChild(node)
        xmlTransfo.appendChild(xmlSupp)
        # Deplacements
        xmlDepl = xmldoc.createElementNS(xmldoc.namespaceURI, B_DEPLACEMENTS)
        listeDepl = pResultat.getListeDeplacements()
        # print("112. Module: Controleurs.cInformations, Class: CInformations, Methode: __creerInformations, Ligne 973, \nlisteDepl=[", listeDepl, "] ")
        for deb,fin in listeDepl :
            node = xmldoc.createElementNS(xmldoc.namespaceURI, B_DEP)
            node.setAttributeNS(node.namespaceURI, B_DEB, str(deb))
            node.setAttributeNS(node.namespaceURI, B_FIN, str(fin))   
            xmlDepl.appendChild(node)
        xmlTransfo.appendChild(xmlDepl)
        # Remplacement
        xmlRemp = xmldoc.createElementNS(xmldoc.namespaceURI, B_REMPLACEMENTS)
        listeRemp = pResultat.getListeRemplacements()
        # print("113. Module: Controleurs.cInformations, Class: CInformations, Methode: __creerInformations, Ligne 983, \nlisteRemp=[", listeRemp, "] ")
        for deb,fin in listeRemp :
            node = xmldoc.createElementNS(xmldoc.namespaceURI, B_REMP)
            node.setAttributeNS(node.namespaceURI, B_DEB, str(deb))
            node.setAttributeNS(node.namespaceURI, B_FIN, str(fin))
            xmlRemp.appendChild(node)
        xmlTransfo.appendChild(xmlRemp)
        #blocs communs
        xmlBlocsCom = xmldoc.createElementNS(xmldoc.namespaceURI, B_BLOCSCOMMUNS)
        listeBlocsCommuns = pResultat.getBlocsCommuns()
        # print("114. Module: Controleurs.cInformations, Class: CInformations, Methode: __creerInformations, Ligne 993, \nlisteBlocsCommuns=[", listeBlocsCommuns, "] ")
        for deb,fin in listeBlocsCommuns :
            node = xmldoc.createElementNS(xmldoc.namespaceURI, B_BC)
            node.setAttributeNS(node.namespaceURI, B_DEB, str(deb))
            node.setAttributeNS(node.namespaceURI, B_FIN, str(fin))
            xmlBlocsCom.appendChild(node)
        xmlTransfo.appendChild(xmlBlocsCom)
###########################################################################################
        #blocs non definis
        xmlNonDef = xmldoc.createElementNS(xmldoc.namespaceURI, B_NONDEF)
        listeNonDef = pResultat.getNonDef()
        # print("115. Module: Controleurs.cInformations, Class: CInformations, Methode: __creerInformations, Ligne 1004, \nlisteNonDef=[", listeNonDef, "] ")
        for deb,fin in listeNonDef :
            node = xmldoc.createElementNS(xmldoc.namespaceURI, B_ND)
            node.setAttributeNS(node.namespaceURI, B_DEB, str(deb))
            node.setAttributeNS(node.namespaceURI, B_FIN, str(fin))
            xmlNonDef.appendChild(node)
        xmlTransfo.appendChild(xmlNonDef)


#####################################################################################
        # blocs déplacés
        xmlBlocsDep = xmldoc.createElementNS(xmldoc.namespaceURI, B_BLOCSDEPLACES)
        listeBlocsDep = pResultat.getPairesBlocsDeplaces()
        # print("116. Module: Controleurs.cInformations, Class: CInformations, Methode: __creerInformations, Ligne 1017, \nlisteBlocsDep=[", listeBlocsDep, "] ")
        for (b1deb,b1fin),(b2deb,b2fin) in listeBlocsDep :
            node = xmldoc.createElementNS(xmldoc.namespaceURI, B_DEP)
            node.setAttributeNS(node.namespaceURI, B1_D, str(b1deb))
            node.setAttributeNS(node.namespaceURI, B1_F, str(b1fin))
            node.setAttributeNS(node.namespaceURI, B2_D, str(b2deb))
            node.setAttributeNS(node.namespaceURI, B2_F, str(b2fin))
            xmlBlocsDep.appendChild(node)
        xmlTransfo.appendChild(xmlBlocsDep)       
        # Insertion de la balise B_TRANSFORMATIONS dans la balise B_INFORMATIONS
        xmltagInfo.appendChild(xmlTransfo)
        return xmltagInfo
        
    def __creerCommentaire(self, pCommentaire):
        """ Methode privee qui creer le noeud <commentaire> a inserer dans le fichier xml
        pre: isinstance(pCommentaire,Donnees.commentaire.Commentaire)
        post: isinstance(__return__, xml.dom.minidom.Node) """
        comment = pCommentaire.getCommentaire()
        # print("117. Module: Controleurs.cInformations, Class: CInformations, Methode: __creerCommentaire, Ligne 1036, \ncomment=[", comment, "] ") 
        xmldoc = Document()
        xmltagComment = xmldoc.createElement(B_COMMENTAIRE)
        xmltagComment.appendChild(xmldoc.createTextNode(comment))
        return xmltagComment
       
    def __getInformations(self,nodeInfos, pNom, pTitre):
        """ On recupere dans fic les informations du fichier Informations.xml dont
         le chemin est passe en parametre
        pre: isinstance(nodeInfos, xml.dom.minidom.Node) and \
             isinstance(pNom,str) and isinstance(pTitre,str) """
        # print("117-1. Module: Controleurs.cInformations, Class: CInformations, Methode: __getInformations, Ligne 1046 ---> \nnodeInfos=", str(nodeInfos), ", pNom=", pNom, ", pTitre=", pTitre, " ")
        logging.debug('begin __getInformations')     
        pVersionSource = nodeInfos.getAttributeNS(nodeInfos.namespaceURI,B_VERS_SOURCE) 
        pEtatSource =  nodeInfos.getAttributeNS(nodeInfos.namespaceURI,B_ETAT_SOURCE)
        pVersionCible = nodeInfos.getAttributeNS(nodeInfos.namespaceURI,B_VERS_CIBLE) 
        pEtatCible = nodeInfos.getAttributeNS(nodeInfos.namespaceURI,B_ETAT_CIBLE) 
        pParametres = Parametres(int(nodeInfos.getAttributeNS(nodeInfos.namespaceURI,B_PARAM_1)), int(nodeInfos.getAttributeNS(nodeInfos.namespaceURI,B_PARAM_2)), 
                int(nodeInfos.getAttributeNS(nodeInfos.namespaceURI,B_PARAM_3)),int(nodeInfos.getAttributeNS(nodeInfos.namespaceURI,B_PARAM_4)),
                int(nodeInfos.getAttributeNS(nodeInfos.namespaceURI,B_PARAM_5)),int(nodeInfos.getAttributeNS(nodeInfos.namespaceURI,B_PARAM_6)),
                int(nodeInfos.getAttributeNS(nodeInfos.namespaceURI,B_PARAM_7)))               # Modifie 28.03.2019, 'atoi' est remplace par 'int'
        # on concatène les 2 fichiers
        pathSource=self.dgm.getEtatPath(pNom,pTitre,pVersionSource,pEtatSource)
        pathCible=self.dgm.getEtatPath(pNom,pTitre,pVersionCible,pEtatCible)
        fs = open(pathSource)
        fc = open(pathCible)            
        textesConca = fs.read() + fc.read()
        fs.close()
        fc.close()      
        # print("118. Module: Controleurs.cInformations, Class: CInformations, Methode: __getInformations, Ligne 1064, \npVersionSource=", pVersionSource, " pEtatSource=", pEtatSource, " pVersionCible=", pVersionCible, " pEtatCible=", pEtatCible) 
        # print("119. Module: Controleurs.cInformations, Class: CInformations, Methode: __getInformations, Ligne 1065, \nParametres=[", int(nodeInfos.getAttributeNS(nodeInfos.namespaceURI,B_PARAM_1)), int(nodeInfos.getAttributeNS(nodeInfos.namespaceURI,B_PARAM_2)), 
        #         int(nodeInfos.getAttributeNS(nodeInfos.namespaceURI,B_PARAM_3)),int(nodeInfos.getAttributeNS(nodeInfos.namespaceURI,B_PARAM_4)), 
        #         int(nodeInfos.getAttributeNS(nodeInfos.namespaceURI,B_PARAM_5)),int(nodeInfos.getAttributeNS(nodeInfos.namespaceURI,B_PARAM_6)), 
        #         int(nodeInfos.getAttributeNS(nodeInfos.namespaceURI,B_PARAM_7)))
        # print("120. Module: Controleurs.cInformations, Class: CInformations, Methode: __getInformations, Ligne 1069, \ntextesConca=[", textesConca, "] ")
                ## creer un objet de type 'Transformations'
        #i = nodeInfos.getElementsByTagName(B_LGSOURCE)
        #lgsource=0
        #if i != []:
        #    lgsource = int(i[0].getAttribute(B_LG))
        lgsource = int(nodeInfos.xpath(B_TRANSFORMATIONS+'/'+B_LGSOURCE+'/@' +B_LG))         # Modifie 19.09.2019, ancienne:  lgsource = int(nodeInfos.xpath(u'string('+B_TRANSFORMATIONS+'/'+B_LGSOURCE+'/@' +B_LG+')')) 
        # print("121. Module: Controleurs.cInformations, Class: CInformations, Methode: __getInformations, Ligne 1076, \nlgsource=[", lgsource, "] ")
        #print lgsource
        listInsert = []
        #i = nodeInfos.getElementsByTagName(B_INSERTIONS)
        #if i != [] :
        #    li = i[0].getElementsByTagName(B_INS)
        #    for m in li :
        #        listInsert.append((int(m.getAttribute(B_DEB)),int(m.getAttribute(B_FIN))))
        #nodeInsertions = nodeInfos.xpath(u'string(//'+B_INSERTIONS+')')
        n = nodeInfos.xpath(u'('+B_TRANSFORMATIONS+'/'+B_INSERTIONS+')')[0]
        # print("122. Module: Controleurs.cInformations, Class: CInformations, Methode: __getInformations, Ligne 1086, \nn.localName=[", n.localName, "] ")
        #print n.localName
        if n.localName == B_INSERTIONS: 
            #for child in Ft.Xml.XPath.Evaluate(u'('+B_INS+')',n):
            for child in n.xpath(u'('+B_INS+')'):
                listInsert.append((int(child.getAttributeNS(child.namespaceURI,B_DEB)),int(child.getAttributeNS(child.namespaceURI,B_FIN))))
            # print("123. Module: Controleurs.cInformations, Class: CInformations, Methode: __getInformations, Ligne 1092, \nlistInsert=[", listInsert, "] ")
        #        print (int(child.getAttributeNS(child.namespaceURI,B_DEB)),int(child.getAttributeNS(child.namespaceURI,B_FIN)))
        #sys.stdout.flush()    
        listSupp = []
        #s = nodeInfos.getElementsByTagName(B_SUPPRESSIONS)
        #if s != [] :
        #    ls = s[0].getElementsByTagName(B_SUP)
        #    for m in ls :
        #        listSupp.append((int(m.getAttribute(B_DEB)),int(m.getAttribute(B_FIN))))
        n = nodeInfos.xpath(u'('+B_TRANSFORMATIONS+'/'+B_SUPPRESSIONS+')')[0]
        if n.localName == B_SUPPRESSIONS: 
            #for child in Ft.Xml.XPath.Evaluate(u'(/'+B_SUP+')',n):
            for child in n.xpath(u'('+B_SUP+')'):
                listSupp.append((int(child.getAttributeNS(child.namespaceURI,B_DEB)),int(child.getAttributeNS(child.namespaceURI,B_FIN))))
            # print("124. Module: Controleurs.cInformations, Class: CInformations, Methode: __getInformations, Ligne 1106, \nlistSupp=[", listSupp, "] ")
        listDepl = []
        #d = nodeInfos.getElementsByTagName(B_DEPLACEMENTS)
        #if d != []:
        #    ld = d[0].getElementsByTagName(B_DEP)
        #    for m in ld :
        #        listDepl.append((int(m.getAttribute(B_DEB)),int(m.getAttribute(B_FIN))))
        n = nodeInfos.xpath(u'('+B_TRANSFORMATIONS+'/'+B_DEPLACEMENTS+')')[0]
        if n.localName == B_DEPLACEMENTS: 
            #for child in Ft.Xml.XPath.Evaluate(u'(//'+B_DEP+')',contextNode=n):
            #for child in n.xpath(u'(/'+B_DEP+')'):
            for child in n.xpath(u'('+B_DEP+')'):
                #print child
                try:
                    listDepl.append((int(child.getAttributeNS(child.namespaceURI,B_DEB)),int(child.getAttributeNS(child.namespaceURI,B_FIN))))
                except Exception as e:                              # Modifiee 28.03.2019, ancienne ligne:  except Exception,e: 
                    print (e)                                       # Modifiee 28.03.2019, ancienne ligne:  print e
                    print (child)                                   # Modifiee 28.03.2019, ancienne ligne:  print child
                    print (child.localName)                         # Modifiee 28.03.2019, ancienne ligne:  print child.localName
                    print (child.attributes)                        # Modifiee 28.03.2019, ancienne ligne:  print child.attributes
                    sys.stdout.flush()
                    sys.exit()
            # print("125. Module: Controleurs.cInformations, Class: CInformations, Methode: __getInformations, Ligne 1128, \nlistDepl=[", listDepl, "] ")
        listRemp = []
        #r = nodeInfos.getElementsByTagName(B_REMPLACEMENTS)
        #if r != []:
        #    lr = r[0].getElementsByTagName(B_REMP)
        #    for m in lr :
        #        listRemp.append((int(m.getAttribute(B_DEB)),int(m.getAttribute(B_FIN))))
        n = nodeInfos.xpath(u'('+B_TRANSFORMATIONS+'/'+B_REMPLACEMENTS+')')[0]
        if n.localName == B_REMPLACEMENTS: 
            #for child in Ft.Xml.XPath.Evaluate(u'(/'+B_REMP+')',n):
            for child in n.xpath(u'('+B_REMP+')'):
                listRemp.append((int(child.getAttributeNS(child.namespaceURI,B_DEB)),int(child.getAttributeNS(child.namespaceURI,B_FIN))))
            # print("126. Module: Controleurs.cInformations, Class: CInformations, Methode: __getInformations, Ligne 1140, \nlistRemp=[", listRemp, "] ") 
        listBlocCom = []
        #r = nodeInfos.getElementsByTagName(B_BLOCSCOMMUNS)
        #if r != []:
        #    lr = r[0].getElementsByTagName(B_BC)
        #    for m in lr :
        #        listBlocCom.append((int(m.getAttribute(B_DEB)),int(m.getAttribute(B_FIN))))
        n = nodeInfos.xpath(u'('+B_TRANSFORMATIONS+'/'+B_BLOCSCOMMUNS+')')[0]
        if n.localName == B_BLOCSCOMMUNS: 
            #for child in Ft.Xml.XPath.Evaluate(u'(/'+B_BC+')',n):
            for child in n.xpath(u'('+B_BC+')'):
                listBlocCom.append((int(child.getAttributeNS(child.namespaceURI,B_DEB)),int(child.getAttributeNS(child.namespaceURI,B_FIN))))
            # print("127. Module: Controleurs.cInformations, Class: CInformations, Methode: __getInformations, Ligne 1152, \nlistBlocCom=[", listBlocCom, "] ") 
######################################################################
        listNonDef = []
        #r = nodeInfos.getElementsByTagName(B_NONDEF)
        #if r != []:
        #    lr = r[0].getElementsByTagName(B_ND)
        #    for m in lr :
        #        listBlocCom.append((int(m.getAttribute(B_DEB)),int(m.getAttribute(B_FIN))))
        n = nodeInfos.xpath(u'('+B_TRANSFORMATIONS+'/'+B_NONDEF+')')[0]
        if n.localName == B_NONDEF: 
            #for child in Ft.Xml.XPath.Evaluate(u'(/'+B_BC+')',n):
            for child in n.xpath(u'('+B_ND+')'):
                listNonDef.append((int(child.getAttributeNS(child.namespaceURI,B_DEB)),int(child.getAttributeNS(child.namespaceURI,B_FIN))))
            # print("128. Module: Controleurs.cInformations, Class: CInformations, Methode: __getInformations, Ligne 1165, \nlistNonDef=[", listNonDef, "] ") 


########################################################

        
        listBlocDep = []
        #r = nodeInfos.getElementsByTagName(B_BLOCSDEPLACES)
        #if r != []:
        #    lr = r[0].getElementsByTagName(B_DEP)
        #    for m in lr :
        #        listBlocDep.append(((int(m.getAttribute(B1_D)),int(m.getAttribute(B1_F))),
        #                            (int(m.getAttribute(B2_D)),int(m.getAttribute(B2_F)))))
        n = nodeInfos.xpath(u'('+B_TRANSFORMATIONS+'/'+B_BLOCSDEPLACES+')')[0]
        if n.localName == B_BLOCSDEPLACES: 
            #for child in Ft.Xml.XPath.Evaluate(u'(/'+B_DEP+')',n):
            for child in n.xpath(u'('+B_DEP+')'):
                listBlocDep.append(((int(child.getAttributeNS(child.namespaceURI,B1_D)),int(child.getAttributeNS(child.namespaceURI,B1_F))),
                                    (int(child.getAttributeNS(child.namespaceURI,B2_D)),int(child.getAttributeNS(child.namespaceURI,B2_F)))))
            # print("129. Module: Controleurs.cInformations, Class: CInformations, Methode: __getInformations, Ligne 1186, \nlistBlocDep=[", listBlocDep, "] ") 
        #transfo = Transformations(listInsert, listSupp, listDepl, listRemp, textSource, textCible)
        res = Resultat(listInsert, listSupp, listDepl, listRemp,lgsource,textesConca,listBlocCom,listBlocDep)
##################################################
        res._nonDef= listNonDef
###################################################
        ## creer un objet de type 'Commentaire' si la balise B_COMMENTAIRE existe
        #c = nodeInfos.getElementsByTagName(B_COMMENTAIRE)
        #if c != []:
        #    comment = Commentaire((c[0]._get_firstChild()).toxml())
        #else :
        #    comment = Commentaire('')
        # c = Ft.Xml.XPath.Evaluate(u'(//'+B_COMMENTAIRE+')', contextNode=nodeInfos)        # # Desactive et remplac� par ligne suivante, 27.05.2019
        c = nodeInfos.getElementsByTagName(B_COMMENTAIRE)
        if len(c) != 0:
            
            comment = Commentaire(c[0].firstChild.nodeValue)
            
        else:
            comment = Commentaire('')
        # print("130. Module: Controleurs.cInformations, Class: CInformations, Methode: __getInformations, Ligne 1204, \ncomment=[", comment, "] ")
        logging.debug('fin __getInformations') 
        ## creer et retourner un objet du type 'Informations'
        return Informations(pVersionSource, pEtatSource, pVersionCible,
                            pEtatCible,pParametres, res, comment)
                            
    def __getInformations_(self,nodeInfos, pNom, pTitre):
        """ 
        Avec des Numeric.array plutot que des listes
        On recupere dans fic les informations du fichier Informations.xml dont
         le chemin est passe en parametre
        pre: isinstance(nodeInfos, xml.dom.minidom.Node) and \
             isinstance(pNom,str) and isinstance(pTitre,str) """
        logging.debug('begin __getInformations')     
        pVersionSource = nodeInfos.getAttribute(B_VERS_SOURCE) 
        pEtatSource =  nodeInfos.getAttribute(B_ETAT_SOURCE)
        pVersionCible = nodeInfos.getAttribute(B_VERS_CIBLE) 
        pEtatCible = nodeInfos.getAttribute(B_ETAT_CIBLE) 
        pParametres = Parametres(int(nodeInfos.getAttribute(B_PARAM_1)), int(nodeInfos.getAttribute(B_PARAM_2)), 
                int(nodeInfos.getAttribute(B_PARAM_3)),int(nodeInfos.getAttribute(B_PARAM_4)),
                int(nodeInfos.getAttribute(B_PARAM_5)),int(nodeInfos.getAttribute(B_PARAM_6)),
                int(nodeInfos.getAttribute(B_PARAM_7)))                                            # Modifiee 28.03.2019, 'atoi' est remplace par 'int' 
        # on concaténe les 2 fichiers
        pathSource=self.dgm.getEtatPath(pNom,pTitre,pVersionSource,pEtatSource)
        pathCible=self.dgm.getEtatPath(pNom,pTitre,pVersionCible,pEtatCible)
        fs = open(pathSource)
        fc = open(pathCible)            
        textesConca = fs.read() + fc.read()
        fs.close()
        fc.close()      
        # print("131. Module: Controleurs.cInformations, Class: CInformations, Methode: __getInformations_, Ligne 1234, \npVersionSource=", pVersionSource, " pEtatSource=", pEtatSource, " pVersionCible=", pVersionCible, " pEtatCible=", pEtatCible) 
        # print("132. Module: Controleurs.cInformations, Class: CInformations, Methode: __getInformations_, Ligne 1235, \nParametres=[", int(nodeInfos.getAttributeNS(nodeInfos.namespaceURI,B_PARAM_1)), int(nodeInfos.getAttributeNS(nodeInfos.namespaceURI,B_PARAM_2)), 
        #         int(nodeInfos.getAttributeNS(nodeInfos.namespaceURI,B_PARAM_3)),int(nodeInfos.getAttributeNS(nodeInfos.namespaceURI,B_PARAM_4)), 
        #         int(nodeInfos.getAttributeNS(nodeInfos.namespaceURI,B_PARAM_5)),int(nodeInfos.getAttributeNS(nodeInfos.namespaceURI,B_PARAM_6)), 
        #         int(nodeInfos.getAttributeNS(nodeInfos.namespaceURI,B_PARAM_7)))
        # print("133. Module: Controleurs.cInformations, Class: CInformations, Methode: __getInformations_, Ligne 1239, \ntextesConca=[", textesConca, "] ")
                ## creer un objet de type 'Transformations'
        i = nodeInfos.getElementsByTagName(B_LGSOURCE)
        lgsource=0
        if i != []:
            lgsource = int(i[0].getAttribute(B_LG))
        # print("134. Module: Controleurs.cInformations, Class: CInformations, Methode: __getInformations_, Ligne 1245, \nlgsource=[", lgsource, "] ")
        # print("135. Module: Controleurs.cInformations, Class: CInformations, Methode: __getInformations_, Ligne 1246, \ni=[", i, "] ")
        #listInsert = []
        i = nodeInfos.getElementsByTagName(B_INSERTIONS)
        # print("136. Module: Controleurs.cInformations, Class: CInformations, Methode: __getInformations_, Ligne 1249, \ni=[", i, "] ")
        if i != [] :
            li = i[0].getElementsByTagName(B_INS)
            nb = len(li) ; i = 0
            tabIns = np.zeros((nb,2), np.int16)       # Modifiee 04.04.2019, ancienne ligne:  tabIns = Numeric.zeros((nb,2), Numeric.Int16)
            for m in li :
                #listInsert.append((int(m.getAttribute(B_DEB)),int(m.getAttribute(B_FIN))))
                tabIns[i][0] =  int(m.getAttribute(B_DEB))
                tabIns[i][1] =  int(m.getAttribute(B_FIN))
                i += 1
            # print("137. Module: Controleurs.cInformations, Class: CInformations, Methode: __getInformations_, Ligne 1259, \ntabIns=[", tabIns, "] ")
        #listSupp = []
        s = nodeInfos.getElementsByTagName(B_SUPPRESSIONS)
        if s != [] :
            ls = s[0].getElementsByTagName(B_SUP)
            nb = len(ls) ; i = 0
            tabSup = np.zeros((nb,2), np.int16)       # Modifiee 04.04.2019, ancienne ligne:  tabSup = Numeric.zeros((nb,2), Numeric.Int16)
            for m in ls :
                #listSupp.append((int(m.getAttribute(B_DEB)),int(m.getAttribute(B_FIN))))
                tabSup[i][0] =  int(m.getAttribute(B_DEB))
                tabSup[i][1] =  int(m.getAttribute(B_FIN))
                i += 1
            # print("138. Module: Controleurs.cInformations, Class: CInformations, Methode: __getInformations_, Ligne 1271, \ntabSup=[", tabSup, "] ")
        #listDepl = []
        d = nodeInfos.getElementsByTagName(B_DEPLACEMENTS)
        if d != []:
            ld = d[0].getElementsByTagName(B_DEP)
            nb = len(ld) ; i = 0
            tabDep = np.zeros((nb,2), np.int16)      # Modifiee 04.04.2019, ancienne ligne: tabDep = Numeric.zeros((nb,2), Numeric.Int16) 
            for m in ld :
                #listDepl.append((int(m.getAttribute(B_DEB)),int(m.getAttribute(B_FIN))))
                tabDep[i][0] =  int(m.getAttribute(B_DEB))
                tabDep[i][1] =  int(m.getAttribute(B_FIN))
                i += 1
            # print("139. Module: Controleurs.cInformations, Class: CInformations, Methode: __getInformations_, Ligne 1283, \ntabDep=[", tabDep, "] ")
        #listRemp = []
        r = nodeInfos.getElementsByTagName(B_REMPLACEMENTS)
        if r != []:
            lr = r[0].getElementsByTagName(B_REMP)
            nb = len(lr) ; i = 0
            tabRemp = np.zeros((nb,2), np.int16)      # Modifiee 04.04.2019, ancienne ligne: tabRemp = Numeric.zeros((nb,2), Numeric.Int16) 
            for m in lr :
                #listRemp.append((int(m.getAttribute(B_DEB)),int(m.getAttribute(B_FIN))))
                tabRemp[i][0] =  int(m.getAttribute(B_DEB))
                tabRemp[i][1] =  int(m.getAttribute(B_FIN))
                i += 1
            # print("140. Module: Controleurs.cInformations, Class: CInformations, Methode: __getInformations_, Ligne 1295, \ntabRemp=[", tabRemp, "] ")
        #listBlocCom = []
        r = nodeInfos.getElementsByTagName(B_BLOCSCOMMUNS)
        if r != []:
            lr = r[0].getElementsByTagName(B_BC)
            nb = len(lr) ; i = 0
            tabBC = np.zeros((nb,2), np.int16)      # Modifiee 04.04.2019, ancienne ligne: tabBC = Numeric.zeros((nb,2), Numeric.Int16)
            for m in lr :
                #listBlocCom.append((int(m.getAttribute(B_DEB)),int(m.getAttribute(B_FIN))))
                tabBC[i][0] =  int(m.getAttribute(B_DEB))
                tabBC[i][1] =  int(m.getAttribute(B_FIN))
                i += 1
            # print("141. Module: Controleurs.cInformations, Class: CInformations, Methode: __getInformations_, Ligne 1307, \ntabBC=[", tabBC, "] ")
###########################################################################
        #listNonDef = []
        nd = nodeInfos.getElementsByTagName(B_NONDEF)
        if nd != [] :
            lnd = nd[0].getElementsByTagName(B_NONDEF)
            nb = len(lnd) ; i = 0
            tabNonDef = np.zeros((nb,2), np.int16)      # Modifiee 04.04.2019, ancienne ligne: NonDef = Numeric.zeros((nb,2), Numeric.Int16) 
            for m in lnd :
                #listSupp.append((int(m.getAttribute(B_DEB)),int(m.getAttribute(B_FIN))))
                tabNonDef[i][0] =  int(m.getAttribute(B_DEB))
                tabNonDef[i][1] =  int(m.getAttribute(B_FIN))
                i += 1
            # print("142. Module: Controleurs.cInformations, Class: CInformations, Methode: __getInformations_, Ligne 1320, \ntabNonDef=[", tabNonDef, "] ")
##################################################################
                
        #listBlocDep = []
        r = nodeInfos.getElementsByTagName(B_BLOCSDEPLACES)
        if r != []:
            lr = r[0].getElementsByTagName(B_DEP)
            nb = len(lr) ; i = 0
            tabBD = np.zeros((nb,2,2), np.int16)      # Modifiee 04.04.2019, ancienne ligne: tabBD = Numeric.zeros((nb,2,2), Numeric.int16) 
            for m in lr :
                #listBlocDep.append(((int(m.getAttribute(B1_D)),int(m.getAttribute(B1_F))),
                #                    (int(m.getAttribute(B2_D)),int(m.getAttribute(B2_F)))))
                tabBD[i][0][0] =  int(m.getAttribute(B1_D))
                tabBD[i][0][1] =  int(m.getAttribute(B1_F))
                tabBD[i][1][0] =  int(m.getAttribute(B2_D))
                tabBD[i][1][1] =  int(m.getAttribute(B2_F))
                i += 1
            # print("143. Module: Controleurs.cInformations, Class: CInformations, Methode: __getInformations_, Ligne 1337, \ntabBD=[", tabBD, "] ")
        #transfo = Transformations(listInsert, listSupp, listDepl, listRemp, textSource, textCible)
        #res = Resultat(listInsert, listSupp, listDepl, listRemp,lgsource,textesConca,listBlocCom,listBlocDep)
        res = Resultat(tabIns, tabSup, tabDep, tabRemp,lgsource,textesConca, tabBC, tabBD)
        res.setNonDef(tabNonDef)
        #listInsert = None; listSupp = None; listDepl = None; listRemp = None;listBlocCom = None;listBlocDep = None
        ## creer un objet de type 'Commentaire' si la balise B_COMMENTAIRE existe
        c = nodeInfos.getElementsByTagName(B_COMMENTAIRE)
        if c != []:
            comment = Commentaire((c[0]._get_firstChild()).toxml())
        else :
            comment = Commentaire('')
        # print("144. Module: Controleurs.cInformations, Class: CInformations, Methode: __getInformations_, Ligne 1349, \ncomment=[", comment, "] ")
        logging.debug('fin __getInformations') 
        ## creer et retourner un objet du type 'Informations'
        return Informations(pVersionSource, pEtatSource, pVersionCible,
                            pEtatCible,pParametres, res, comment)
                            
    def enregistrerTransformationsStream(self, planTravail, pResultat):
        """ enregistre un fichier xml par streaming
        
        evite de construire un DOM complet ce qui consomme trop de memoire pour
        de gros fichiers source: taille des 2 fichiers superieure a 3.5 Mo 
        ecrase le fichier existant eventuel
        toutes les chaines ecrites doivent etre en unicode (utf-8 par defaut)
        """
        def u(x):
            return str(x)                   # Modifiee 28.03.2019, ancienne ligne:  return unicode(x)
        nomDG = self.dgm.getDG(planTravail.getAuteur(), planTravail.getOeuvre())
        fim =  Controleurs.FInfoManager.FInfoManager(Controleurs.DGManager.Auteur(planTravail.getAuteur()), 
                                                     Controleurs.DGManager.Oeuvre(planTravail.getOeuvre()))
        pParametres = planTravail.getParam()
        # print("145. Module: Controleurs.cInformations, Class: CInformations, Methode: enregistrerTransformationsStream, Ligne 1369, \nnomDG=[", nomDG, "] ")
        # print("146. Module: Controleurs.cInformations, Class: CInformations, Methode: enregistrerTransformationsStream, Ligne 1370, \nfim.getFileInfo()=[", fim.getFileInfo(), "] ")
        # print("147. Module: Controleurs.cInformations, Class: CInformations, Methode: enregistrerTransformationsStream, Ligne 1371, \npParametres=[", pParametres, "] ")                                    # Ajoutee pour debogage 
        output_file = open(fim.getFileInfo(), 'w')      # Modifiee 04.04.2019, ancienne ligne:  output_file = file(fim.getFileInfo(), 'w') 
        # reprogrammé avec saxutils et XMLGenerator
        """
        writer = MarkupWriter(output_file, indent=u"yes") 
        writer.startDocument()
        writer.startElement(B_INFORMATIONS, attributes={
            B_VERS_SOURCE : u(planTravail.getVersionSource()),
            B_ETAT_SOURCE : u(planTravail.getEtatSource()),
            B_VERS_CIBLE : u(planTravail.getVersionCible()),
            B_ETAT_CIBLE : u(planTravail.getEtatCible()),        
            B_PARAM_1 : u('%s'%pParametres.getp1()),   
            B_PARAM_2 : u('%s'%pParametres.getp2()),        
            B_PARAM_3 : u('%s'%pParametres.getp3()),
            B_PARAM_4 : u('%s'%pParametres.getp4()),
            B_PARAM_5 : u('%s'%pParametres.getp5()),
            B_PARAM_6 : u('%s'%pParametres.getp6()),
            B_PARAM_7 : u('%s'%pParametres.getp7())})
        # Balise Transformations
        writer.startElement(B_TRANSFORMATIONS)
        writer.simpleElement(B_LGSOURCE, attributes={B_LG : u(pResultat.getLgSource())})
        # Insertions
        writer.startElement(B_INSERTIONS)
        listeInsert = pResultat.getListeInsertions()
        for deb,fin in listeInsert :
            writer.simpleElement(B_INS, attributes={B_DEB : u(deb), B_FIN : u(fin)})
        writer.endElement(B_INSERTIONS)
        # Suppressions
        writer.startElement(B_SUPPRESSIONS)
        listeSupp = pResultat.getListeSuppressions()
        for deb,fin in listeSupp :
            writer.simpleElement(B_SUP, attributes={B_DEB : u(deb), B_FIN : u(fin)})
        writer.endElement(B_SUPPRESSIONS)    
        # Deplacements
        writer.startElement(B_DEPLACEMENTS)
        listeDepl = pResultat.getListeDeplacements()
        for deb,fin in listeDepl :
            writer.simpleElement(B_DEP, attributes={B_DEB : u(deb), B_FIN : u(fin)})
        writer.endElement(B_DEPLACEMENTS)  
        # Remplacement
        writer.startElement(B_REMPLACEMENTS)
        listeRemp = pResultat.getListeRemplacements()
        for deb,fin in listeRemp :
            writer.simpleElement(B_REMP, attributes={B_DEB : u(deb), B_FIN : u(fin)})
        writer.endElement(B_REMPLACEMENTS)
        #blocs communs
        writer.startElement(B_BLOCSCOMMUNS)
        listeBlocsCommuns = pResultat.getBlocsCommuns()
        for deb,fin in listeBlocsCommuns :
            writer.simpleElement(B_BC, attributes={B_DEB : u(deb), B_FIN : u(fin)})
        writer.endElement(B_BLOCSCOMMUNS)   
        #############################################################
        #blocs non definis
        writer.startElement(B_NONDEF)
        listeBlocsNonDefinis = pResultat.getNonDef()
        for deb,fin in listeBlocsNonDefinis :   # Modifiee 04.04.2019, ancienne ligne:  for deb,fin in listeBlocsnonDefinis :
            writer.simpleElement(B_ND, attributes={B_DEB : u(deb), B_FIN : u(fin)})
        writer.endElement(B_NONDEF)
        ############################################################
        
        # blocs deplaces
        writer.startElement(B_BLOCSDEPLACES)
        listeBlocsDep = pResultat.getPairesBlocsDeplaces()
        for (b1deb,b1fin),(b2deb,b2fin) in listeBlocsDep :
            writer.simpleElement(B_DEP, attributes={B1_D : u(b1deb), B1_F : u(b1fin),
                                                    B2_D : u(b2deb), B2_F : u(b2fin)})
        writer.endElement(B_BLOCSDEPLACES)
        writer.endElement(B_TRANSFORMATIONS)      
        writer.endElement(B_INFORMATIONS)
        writer.endDocument()
        """
        #########################################################
        #    reprogramme avec saxutils et XMLGenerator
        # print("148-1. Module: Controleurs.cInformations, Class: CInformations, Methode: enregistrerTransformationsStream, Ligne 1444, \nplanTravail.getVersionSource()=[", planTravail.getVersionSource(), "], planTravail.getEtatSource()=[", planTravail.getEtatSource(), "], planTravail.getVersionCible()=[", planTravail.getVersionCible(), "], planTravail.getEtatCible()=[", planTravail.getEtatCible())
        # print("148. Module: Controleurs.cInformations, Class: CInformations, Methode: enregistrerTransformationsStream, Ligne 1445, \npParametres.getp1()=[", pParametres.getp1(), "], pParametres.getp2()=[", pParametres.getp2(), "], pParametres.getp3()=[", pParametres.getp3(),"], pParametres.getp4()=[", pParametres.getp4(),"], pParametres.getp5()=[", pParametres.getp5(),"], pParametres.getp6()=[", pParametres.getp6(),"], pParametres.getp7()=[", pParametres.getp7(), "] ")
        wgen = XMLGenerator(output_file, 'utf-8')
        wgen.startDocument()
        wgen.startElement(B_INFORMATIONS, {
            B_VERS_SOURCE : u(planTravail.getVersionSource()),
            B_ETAT_SOURCE : u(planTravail.getEtatSource()),
            B_VERS_CIBLE : u(planTravail.getVersionCible()),
            B_ETAT_CIBLE : u(planTravail.getEtatCible()),        
            B_PARAM_1 : u('%s'%pParametres.getp1()),   
            B_PARAM_2 : u('%s'%pParametres.getp2()),        
            B_PARAM_3 : u('%s'%pParametres.getp3()),
            B_PARAM_4 : u('%s'%pParametres.getp4()),
            B_PARAM_5 : u('%s'%pParametres.getp5()),
            B_PARAM_6 : u('%s'%pParametres.getp6()),
            B_PARAM_7 : u('%s'%pParametres.getp7())})
        # Balise Transformations
        # print("149. Module: Controleurs.cInformations, Class: CInformations, Methode: enregistrerTransformationsStream, Ligne 1461, \npResultat.getLgSource()=[", pResultat.getLgSource(), "] ") 
        wgen.startElement(B_TRANSFORMATIONS)    
        wgen.startElement(B_LGSOURCE, {B_LG : u(pResultat.getLgSource())})
        wgen.endElement(B_LGSOURCE)  
        # Insertions
        wgen.startElement(B_INSERTIONS)
        listeInsert = pResultat.getListeInsertions()
        # print("150. Module: Controleurs.cInformations, Class: CInformations, Methode: enregistrerTransformationsStream, Ligne 1468, \nlisteInsert=[", listeInsert, "] ") 
        for deb,fin in listeInsert :
            wgen.startElement(B_INS, {B_DEB : u(deb), B_FIN : u(fin)})
            wgen.endElement(B_INS)
        wgen.endElement(B_INSERTIONS)        
        # Suppressions
        wgen.startElement(B_SUPPRESSIONS)
        listeSupp = pResultat.getListeSuppressions()
        # print("151. Module: Controleurs.cInformations, Class: CInformations, Methode: enregistrerTransformationsStream, Ligne 1476, \nlisteSupp=[", listeSupp, "] ")
        for deb,fin in listeSupp :
            wgen.startElement(B_SUP, {B_DEB : u(deb), B_FIN : u(fin)})
            wgen.endElement(B_SUP)
        wgen.endElement(B_SUPPRESSIONS)    
        # Deplacements
        wgen.startElement(B_DEPLACEMENTS)
        listeDepl = pResultat.getListeDeplacements()
        # print("152. Module: Controleurs.cInformations, Class: CInformations, Methode: enregistrerTransformationsStream, Ligne 1484, \nlisteDepl=[", listeDepl, "] ")
        for deb,fin in listeDepl :
            wgen.startElement(B_DEP, {B_DEB : u(deb), B_FIN : u(fin)})
            wgen.endElement(B_DEP)
        wgen.endElement(B_DEPLACEMENTS)  
        # Remplacement
        wgen.startElement(B_REMPLACEMENTS)
        listeRemp = pResultat.getListeRemplacements()
        # print("153. Module: Controleurs.cInformations, Class: CInformations, Methode: enregistrerTransformationsStream, Ligne 1492, \nlisteRemp=[", listeRemp, "] ")
        for deb,fin in listeRemp :
            wgen.startElement(B_REMP, {B_DEB : u(deb), B_FIN : u(fin)})
            wgen.endElement(B_REMP)
        wgen.endElement(B_REMPLACEMENTS)
        #blocs communs
        wgen.startElement(B_BLOCSCOMMUNS)
        listeBlocsCommuns = pResultat.getBlocsCommuns()
        # print("154. Module: Controleurs.cInformations, Class: CInformations, Methode: enregistrerTransformationsStream, Ligne 1500, \nlisteBlocsCommuns=[", listeBlocsCommuns, "] ")
        for deb,fin in listeBlocsCommuns :
            wgen.startElement(B_BC, {B_DEB : u(deb), B_FIN : u(fin)})
            wgen.endElement(B_BC)
        wgen.endElement(B_BLOCSCOMMUNS)   
#############################################################        
        #blocs non definis
        wgen.startElement(B_NONDEF)
        listeBlocsNonDefinis = pResultat.getNonDef()
        # print("155. Module: Controleurs.cInformations, Class: CInformations, Methode: enregistrerTransformationsStream, Ligne 1509, \nlisteBlocsNonDefinis=[", listeBlocsNonDefinis, "] ")
        for deb,fin in listeBlocsNonDefinis :                       # Modifiee 04.04.2019, ancienne ligne:  for deb,fin in listeBlocsnonDefinis :
            wgen.startElement(B_ND, {B_DEB : u(deb), B_FIN : u(fin)})
            wgen.endElement(B_ND)
        wgen.endElement(B_NONDEF)
############################################################
        # blocs déplacés
        wgen.startElement(B_BLOCSDEPLACES)
        listeBlocsDep = pResultat.getPairesBlocsDeplaces()
        # print("156. Module: Controleurs.cInformations, Class: CInformations, Methode: enregistrerTransformationsStream, Ligne 1518, \nlisteBlocsDep=[", listeBlocsDep, "] ")
        for (b1deb,b1fin),(b2deb,b2fin) in listeBlocsDep :
            wgen.startElement(B_DEP, {B1_D : u(b1deb), B1_F : u(b1fin),
                                                    B2_D : u(b2deb), B2_F : u(b2fin)})
            wgen.endElement(B_DEP)
        wgen.endElement(B_BLOCSDEPLACES)
        #
        wgen.endElement(B_TRANSFORMATIONS)      
        wgen.endElement(B_INFORMATIONS)
        wgen.endDocument()
        #        
#########################################################        
#
class InformationsContentHandler(ContentHandler):
    def __init__(self,name):
        # print("157. Module: Controleurs.cInformations, Class: CInformations, Methode: InformationsContentHandler, Ligne 1533, name=[", name, "] ")
        self.look_for = name
        self.is_name, self.is_mobile = None, None
        self.buffer = ''
    def startElement(self,name,attrs):
        if name == 'phone' and attrs.get('type') == 'mobile':
            self.is_mobile = 1
        elif name == 'name': self.is_name = 1
        # print("158. Module: Controleurs.cInformations, Class: CInformations, Methode: InformationsContentHandler, Ligne 1541, name=[", name, "], attrs.get('type')=[", attrs.get('type'), "] ")
    def endElement(self,name):
        # print("159. Module: Controleurs.cInformations, Class: CInformations, Methode: InformationsContentHandler, Ligne 1543, self.is_name=[", self.is_name, "] ")
        if self.is_name:
            self.current_name = self.buffer.strip()
            self.buffer = ''
            self.is_name = None
        elif self.is_mobile and self.current_name == self.look_for:
            self.mobile = self.buffer
            raise SAXException('Found mobile phone') # stop parsing
    def characters(self,chars):
        if self.is_name or self.is_mobile: self.buffer += chars    
        # print("160. Module: Controleurs.cInformations, Class: CInformations, Methode: InformationsContentHandler, Ligne 1553, self.buffer=[", self.buffer, "] ")
    def find_mobile_phone(self,name):                                # Modifiee 28.03.2019, ancienne ligne:  def find_mobile_phone(name): 
        handler = ContentHandler(name)                 # Modifiee 28.03.2019, ancienne ligne:  handler = PhoneContentHandler(name)    
        parser = make_parser()
        parser.setContentHandler(handler)
        try:
            parser.parse(open('addressbook.xml'))
            # print("161. Module: Controleurs.cInformations, Class: CInformations, Methode: InformationsContentHandler, Ligne 1560, - essai de faire parser")
        except SAXException:
            # print("162. Module: Controleurs.cInformations, Class: CInformations, Methode: InformationsContentHandler, Ligne 1562, - parser n'est pas reussi, handler.mobile=[", handler.mobile, "] ")
            return handler.mobile
        return None

    if __name__ == '__main__':
        import sys
        name = ' '.join(sys.argv[1:])
        phone = find_mobile_phone(name)
        if phone:
            print ('Mobile phone is',phone)                         # Modifiee 28.03.2019, ancienne ligne: print 'Mobile phone is',phone
        else:
            print ('No mobile phone found for',name)                  # Modifiee 28.03.2019, ancienne ligne:  print 'No mobile phone found for',name
