# -*- coding: UTF-8 -*-
# Copyright 2003 - 2008: Julien Bourdaillet (julien.bourdaillet@lip6.fr), Jean-Gabriel Ganascia (jean-gabriel.ganascia@lip6.fr)
# This file is part of MEDITE.
#
#    MEDITE is free software; you can redistribute it and/or modify
#    it under the terms of the GNU General Public License as published by
#    the Free Software Foundation; either version 2 of the License, or
#    (at your option) any later version.
#
#    MEDITE is distributed in the hope that it will be useful,
#    but WITHOUT ANY WARRANTY; without even the implied warranty of
#    MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
#    GNU General Public License for more details.
#
#    You should have received a copy of the GNU General Public License
#    along with Foobar; if not, write to the Free Software
#    Foundation, Inc., 51 Franklin St, Fifth Floor, Boston, MA  02110-1301  USA
#----------------------------------------------------------------------------
# Nom:          cMedite.py
# Objet:        Classe qui interface entre l'application Medite du client
#               et l'interface graphique
#----------------------------------------------------------------------------

import profile, traceback, pstats
import os, time, chardet, ast                    # Modifiee 21.06.2019, chardet est ajoutee
from MediteApplication.MediteAppli import *
from Utile.constantesDonnees import *
from Utile.exceptionsDonnees import *
from Donnees.resultatAppli import *
from Donnees.arbre import Arbre
import Donnees.planTravail
from . import DGManager          # Modifiee 13.02.2019, ancienne ligne: import DGManager
import Utile.decodage
from MediteApplication.mediteFeng import *

# appli = ecartTextes
# Classe de type 'concepteur' qui fait le lien entre l'interface graphique
# et l'application du client
class CMedite(object):

    def initialiser(self,planTravail):
        """pre: isinstance(planTravail,Donnees.planTravail.PlanTravail) """
        dgm = DGManager.DGManager()
        nomDG =  dgm.getDG(planTravail.getAuteur(), planTravail.getOeuvre())
        # print("0-1. Module Controleurs.cMedite, Classe CMedite, Methode initialiser, ligne 45 ---> \nnomDG=[", nomDG, "] ")
        pathSource=dgm.getEtatPath(planTravail.getAuteur(), planTravail.getOeuvre(),planTravail.getVersionSource(),planTravail.getEtatSource())
        pathCible =dgm.getEtatPath(planTravail.getAuteur(), planTravail.getOeuvre(),planTravail.getVersionCible(),planTravail.getEtatCible())
        fs = open(pathSource)
        fc = open(pathCible)
        pParametres = planTravail.getParam()
        p1 = pParametres.getp1()
        p2 = float(100)/pParametres.getp2()
        p3 = float(pParametres.getp3()) /100
        pcarOuMot = pParametres.getp4() #not pParametres.getp4() #1 mode car / 0 mode mot
        pcaseSensitive = pParametres.getp5()
        pseparatorSensivitive = pParametres.getp6()
        pdiacriticSensitive = pParametres.getp7()
        #print p1 ; print p2 ; print p3 ; print pcarOuMot 
        # print("0-2. Module Controleurs.cMedite, Classe CMedite, Methode initialiser, ligne 59 ---> \npParametres=[", pParametres, "] ")     #print pcaseSensitive ; print pseparatorSensivitive ; print pdiacriticSensitive 
        try:
            texte1 = fs.read()
            texte2 = fc.read()
            #texte1 = Utile.decodage.loadFile(pathSource) 
            #texte2 = Utile.decodage.loadFile(pathCible) 
            #texte1 = texte1[1:]
            #texte2 = texte2[1:]
            logging.debug('len(texte1)='+str(len(texte1))+' / len(texte2)='+str(len(texte2))) 
            if isinstance(texte1, str):                                                     # Modifiee 27.02.2019, ancienne ligne:   if isinstance(texte1, unicode):  
                # print("1. Module Controleurs.cMedite, Classe CMedite, Methode initialiser, ligne 69 ---> \ntexte1=[", texte1, "] ")
                # print("2. Module Controleurs.cMedite, Classe CMedite, Methode initialiser, ligne 70 ---> \ntype(texte1)=", type(texte1))
                # print("3. Module Controleurs.cMedite, Classe CMedite, Methode initialiser, ligne 71 ---> class(texte1)=", texte1.__class__.__name__)
                # print("4. Module cMedite, Classe CMedite, Methode initialiser, ligne 72 ---> encoding(texte1)=", chardet.detect(texte1).get("encoding"))
                # texte1 = texte1.encode('utf-8')                                        # Désactivée 02.09.2019
                logging.debug('transfo texte1 uni 2 utf')
            if isinstance(texte2, str):                                                     # Modifiee 27.02.2019, ancienne ligne:   if isinstance(texte2, unicode): 
                # print("5. Module Controleurs.cMedite, Classe CMedite, Methode initialiser, ligne 75 ---> \ntexte1=[", texte2, "] ")
                # print("6. Module Controleurs.cMedite, Classe CMedite, Methode initialiser, ligne 77 ---> \ntype(texte2)=", type(texte2))
                # print("7. Module Controleurs.cMedite, Classe CMedite, Methode initialiser, ligne 78 ---> class(texte2)=", texte2.__class__.__name__)
                # print("8. Module cMedite, Classe CMedite, Methode initialiser, ligne 79 ---> encoding(texte2)=", chardet.detect(texte2).get("encoding"))
                # texte2 = texte2.encode('utf-8')                                        # Désactivée 02.09.2019
                logging.debug('transfo texte2 uni 2 utf')                
            fs.close()
            fc.close()
            logging.debug('len(texte1)='+str(len(texte1))+' / len(texte2)='+str(len(texte2))) 
            #for x in texte1:
            #    logging.debug(x+str(ord(x)))
            # print ("7. Module Controleurs.cMedite, Classe CMedite, Methode initialiser, ligne 85 ---> pCar=",pcarOuMot)                         # Modifiee 27.02.2019, ancienne ligne:   print 'pCar',pcarOuMot  
            appli = ecartTextesRecur2(texte1, texte2, p1, p2, p3, pcarOuMot,
                            pcaseSensitive, pseparatorSensivitive, pdiacriticSensitive,
                            planTravail,algoAligneur='HIS')
            resultat = appli.initialiser()  #;print appli.bbl.evaluation()
            logging.debug('len(texte1)='+str(len(texte1))+' / len(texte2)='+str(len(texte2)))
            logging.debug(resultat)
            
            if isinstance(texte1, str) and isinstance(texte2, str):                          # Modifiee 27.02.2019, ancienne ligne:   if isinstance(texte1, unicode) and isinstance(texte2, unicode):    
                # mapper = Utile.decodage.mapperUnicodeUtf(texte1+texte2, 'utf-8')                # Désactivée 11.09.2019 
                # print("8. Module Controleurs.cMedite, Classe CMedite, Methode initialiser, ligne 97 ---> \nmapper=[", mapper, "] ")
                # print("9. Module Controleurs.cMedite, Classe CMedite, Methode initialiser, ligne 98 ---> \ntype(mapper)=", type(mapper))
                # print("10. Module Controleurs.cMedite, Classe CMedite, Methode initialiser, ligne 99 ---> class(mapper)=", mapper.__class__.__name__)
                # print("11. Module cMedite, Classe CMedite, Methode initialiser, ligne 100 ---> encoding(mapper)=", chardet.detect(mapper).get("encoding"))
                res = texte1+texte2         #Modifiee 11.09.2019,     res = mapper.uniToUtfResultat(texte1+texte2)                                 # Désactivée 11.09.2019 # Modifiee 27.02.2019, ancienne ligne:   res = mapper.uniToUtfResultat(backup) 
                # print("12. Module Controleurs.cMedite, Classe CMedite, Methode initialiser, ligne 102 ---> \nres=[", res, "] ")
                # print("13. Module Controleurs.cMedite, Classe CMedite, Methode initialiser, ligne 103 ---> \ntype(res)=", type(res))
                # print("14. Module Controleurs.cMedite, Classe CMedite, Methode initialiser, ligne 104 ---> class(res)=", res.__class__.__name__)
                # print("15. Module cMedite, Classe CMedite, Methode initialiser, ligne 105 ---> encoding(res)=", chardet.detect(res).get("encoding"))
                logging.debug(resultat)
            # lancement de medite avec feng
            #appli = fengAlgoMedite(texte1,texte2,p2,pcaseSensitive, pseparatorSensivitive, pdiacriticSensitive,planTravail,calculDep=True)
            #resultat = appli.run()
            

            
        except Exception as e1:                                                              # Modifiee 27.02.2019, ancienne ligne:   except Exception,e1: 
            sys.stderr.write( str(e1))  
            traceback.print_exc()
            sys.stderr.flush()
                
        if False:
            logging.debug(str(appli.insertions)) 
            logging.debug("\n------------------------------------------------\n")
            logging.debug(str(appli.suppressions))
            logging.debug("\n------------------------------------------------\n")
            logging.debug(str(appli.occs_deplaces))
            logging.debug("\n------------------------------------------------\n")
            logging.debug(str(appli.tous_remplacements))
            logging.debug("\n------------------------------------------------\n")
            logging.debug(str(appli.lg_texte1))
            logging.debug("\n------------------------------------------------\n")
            #logging.debug(str(appli.texte_original))
            logging.debug("\n------------------------------------------------\n")
            logging.debug(str(appli.blocsCommuns))
            logging.debug("\n------------------------------------------------ begin appli.lDepl\n")
            logging.debug(str(appli.lDepl))
            logging.debug("\n------------------------------------------------ end appli.lDepl\n")
            logging.debug( resultat)
            
        return resultat
    # Methode qui lance l'application MEDITE qui compare deux états
    def comparerEtats(self, planTravail):
        """pre: isinstance(planTravail,Donnees.planTravail.PlanTravail) """
        print("16. Module Controleurs.cMedite, Classe CMedite, Methode comparerEtats, ligne 141 ---> \ndgm.getDG(planTravail.getAuteur(), planTravail.getOeuvre()) ---> ", str(planTravail.getAuteur()), ", ", str(planTravail.getOeuvre())) 
        dgm = DGManager.DGManager()
        nomDG =  dgm.getDG(planTravail.getAuteur(), planTravail.getOeuvre())
        
        pathSource=dgm.getEtatPath(planTravail.getAuteur(), planTravail.getOeuvre(),planTravail.getVersionSource(),planTravail.getEtatSource())
        pathCible =dgm.getEtatPath(planTravail.getAuteur(), planTravail.getOeuvre(),planTravail.getVersionCible(),planTravail.getEtatCible())
        fs = open(pathSource)
        fc = open(pathCible)
        pParametres = planTravail.getParam()
        p1 = pParametres.getp1()
        p2 = float(100)/pParametres.getp2()
        p3 = float(pParametres.getp3()) /100
        pcarOuMot = not pParametres.getp4() #not pParametres.getp4() #1 mode car / 0 mode mot
        pcaseSensitive = pParametres.getp5()
        pseparatorSensivitive = pParametres.getp6()
        pdiacriticSensitive = pParametres.getp7()
        #print p1 ; print p2 ; print p3 ; print pcarOuMot 
        #print pcaseSensitive ; print pseparatorSensivitive ; print pdiacriticSensitive 
        try:
            texte1 = fs.read()
            # print("17. Module Controleurs.cMedite, Classe CMedite, Methode comparerEtats, ligne 161 ---> \ntexte1=[", texte1, "] ")
            # print("18. Module Controleurs.cMedite, Classe CMedite, Methode comparerEtats, ligne 162 ---> type(texte1)=", type(texte1))
            # print("19. Module Controleurs.cMedite, Classe CMedite, Methode comparerEtats, ligne 163 ---> class(texte1)=", texte1.__class__.__name__)
            # print("20. Module cMedite, Classe CMedite, Methode comparerEtats, ligne 164 ---> encoding(texte1)=", chardet.detect(texte1).get("encoding"))
            # print("11112. Module cMedite ---> encoding(texte1)=", chardet.detect(texte1.encode))
            texte2 = fc.read()
            # print("21. Module Controleurs.cMedite, Classe CMedite, Methode comparerEtats, ligne 167 ---> \ntexte2=[", texte2, "] ")
            # print("22. Module Controleurs.cMedite, Classe CMedite, Methode comparerEtats, ligne 168---> type(texte2)=", type(texte2))
            # print("23. Module Controleurs.cMedite, Classe CMedite, Methode comparerEtats, ligne 169 ---> class(texte2)=", texte2.__class__.__name__)
            # print("24. Module cMedite, Classe CMedite, Methode comparerEtats, ligne 170 ---> encoding(texte2)=", chardet.detect(texte2).get("encoding"))
            # print("22223. Module cMedite ---> encoding(texte2)=", chardet.detect(texte2.encode))
            #texte1 = Utile.decodage.loadFile(pathSource) 
            #texte2 = Utile.decodage.loadFile(pathCible) 
            #texte1 = texte1[1:]
            #texte2 = texte2[1:]
            logging.debug('len(texte1)='+str(len(texte1))+' / len(texte2)='+str(len(texte2))) 
            if isinstance(texte1, str):                                                   # Modifiee 27.02.2019, ancienne ligne:   if isinstance(texte1, unicode): 
                # print("25. Module Controleurs.cMedite, Classe CMedite, Methode comparerEtats, ligne 178) ---> type(texte1)=", type(texte1))
                # texte1 = texte1.encode('utf-8')                                         # Désactivée 02.09.2019 
                # print("26. Module Controleurs.cMedite, Classe CMedite, Methode comparerEtats, ligne 180) ---> encoding(texte1)=", chardet.detect(texte1).get("encoding"))
                logging.debug('transfo texte1 uni 2 utf')
            if isinstance(texte2, str):                                                   # Modifiee 27.02.2019, ancienne ligne:    if isinstance(texte2, unicode): 
                # print("27. Module Controleurs.cMedite, Classe CMedite, Methode comparerEtats, ligne 183) ---> type(texte2)=", type(texte2))
                # texte2 = texte2.encode('utf-8')                                         # Désactivée 02.09.2019 
                # print("28. Module Controleurs.cMedite, Classe CMedite, Methode comparerEtats, ligne 185) ---> encoding(texte2)=", chardet.detect(texte2).get("encoding"))
                logging.debug('transfo texte2 uni 2 utf')                
            fs.close()
            fc.close()
            logging.debug('len(texte1)='+str(len(texte1))+' / len(texte2)='+str(len(texte2))) 
            #for x in texte1:
            #    logging.debug(x+str(ord(x)))
            appli = ecartTextesRecur2(texte1, texte2, p1, p2, p3, pcarOuMot,
                            pcaseSensitive, pseparatorSensivitive, pdiacriticSensitive,
                            planTravail,algoAligneur='HIS')
            
            resultat = appli.run()#;print appli.bbl.evaluation()
            logging.debug('len(texte1)='+str(len(texte1))+' / len(texte2)='+str(len(texte2)))
            logging.debug(resultat)

            # print("28. Module Controleurs.cMedite, Classe CMedite, Methode comparerEtats, ligne 200 ---> \ntype(texte1)=", type(texte1), ", type(texte2)=", type(texte2), " ")
            # print("29. Module Controleurs.cMedite, Classe CMedite, Methode comparerEtats, ligne 201 ---> \nencoding(texte1)=", chardet.detect(ast.literal_eval(texte1)), ", encoding(texte2)=", chardet.detect(ast.literal_eval(texte2)), " ")
            # print("29. Module Controleurs.cMedite, Classe CMedite, Methode comparerEtats, ligne 202 ---> \nclass(texte1)=", texte1.__class__.__name__, ", class(texte2)=", texte2.__class__.__name__, " ")
            if isinstance(texte1, str) and isinstance(texte2, str):                      # Modifiee 27.02.2019, ancienne ligne:   if isinstance(texte1, unicode) and isinstance(texte2, unicode): 
                # mapper = Utile.decodage.mapperUnicodeUtf(texte1+texte2, 'utf-8')        # Désactivée 11.09.2019  
                # res = mapper.uniToUtfResultat(texte1+texte2)                             # Désactivée 11.09.2019  # Modifiee 27.02.2019, ancienne ligne:    res = mapper.uniToUtfResultat(backup)  
                logging.debug(resultat)
            # lancement de medite avec feng
            #appli = fengAlgoMedite(texte1,texte2,p2,pcaseSensitive, pseparatorSensivitive, pdiacriticSensitive,planTravail,calculDep=True)
            #resultat = appli.run()
             
        except Exception as e1:                                                          # Modifiee 27.02.2019, ancienne ligne:   except Exception,e1: 
            sys.stderr.write( str(e1))  
            traceback.print_exc()
            sys.stderr.flush()
                
        if False:
            logging.debug(str(appli.insertions)) 
            logging.debug("\n------------------------------------------------\n")
            logging.debug(str(appli.suppressions))
            logging.debug("\n------------------------------------------------\n")
            logging.debug(str(appli.occs_deplaces))
            logging.debug("\n------------------------------------------------\n")
            logging.debug(str(appli.tous_remplacements))
            logging.debug("\n------------------------------------------------\n")
            logging.debug(str(appli.lg_texte1))
            logging.debug("\n------------------------------------------------\n")
            #logging.debug(str(appli.texte_original))
            logging.debug("\n------------------------------------------------\n")
            logging.debug(str(appli.blocsCommuns))
            logging.debug("\n------------------------------------------------ begin appli.lDepl\n")
            logging.debug(str(appli.lDepl))
            logging.debug("\n------------------------------------------------ end appli.lDepl\n")
            logging.debug( resultat)
            
        return resultat

        
        
        
