# -*- coding: UTF-8 -*-
# Copyright 2003 - 2008: Julien Bourdaillet (julien.bourdaillet@lip6.fr), Jean-Gabriel Ganascia (jean-gabriel.ganascia@lip6.fr)
# This file is part of MEDITE.
#
#    MEDITE is free software; you can redistribute it and/or modify
#    it under the terms of the GNU General Public License as published by
#    the Free Software Foundation; either version 2 of the License, or
#    (at your option) any later version.
#
#    MEDITE is distributed in the hope that it will be useful,
#    but WITHOUT ANY WARRANTY; without even the implied warranty of
#    MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
#    GNU General Public License for more details.
#
#    You should have received a copy of the GNU General Public License
#    along with Foobar; if not, write to the Free Software
#    Foundation, Inc., 51 Franklin St, Fifth Floor, Boston, MA  02110-1301  USA
#----------------------------------------------------------------------------
# Nom:          cTravail.py
# Objet:        Classe qui interface entre les donnees et l'interface graphique
#----------------------------------------------------------------------------
import os, posixpath, sys #, site, wxPython
#from wxPython.lib.colourselect import *
#from wxPython.wx import *
import wx
#import wx.lib
from Utile.constantesDonnees import *
from Donnees.planTravail import *

class CTravail(object):
    """  C'est la classe de type 'Controleur' qui fait le lien entre les donnees Travail et
     l'interface"""
    def __init__(self):
        self.__travail = DonneesTravail()
        if not posixpath.exists(REPPRIVE) :
            os.mkdir(REPPRIVE)
        # print("1. Module Controleurs.cTravail, Classe CTravail, Methode __init__, ligne 37 ---> \nself.__travail=[", self.__travail, "] ")
    def enregistrerListePlans(self, pListe):
        """ Methode pour enregistrer le plan de travail """        
        self.__travail.enregistrerListePlans(pListe)
        # print("2. Module Controleurs.cTravail, Classe CTravail, Methode enregistrerListePlans, ligne 41 ---> \npListe=[", pListe, "] ")
    # Methode pour enregistrer le plan de travail
#    def enregistrerPlan(self, pPlan):
#        self.__travail.enregistrerPlan(pPlan)
        
    def enregistrerParametres(self, pParametres):
        """ Methode pour enregistrer les parametres """
        self.__travail.enregistrerParametres(pParametres)
        # print("3. Module Controleurs.cTravail, Classe CTravail, Methode enregistrerParametres, ligne 49 ---> \npParametres=[", pParametres, "] ")
    def enregistrerCouleurs(self, pCouleurs):
        """ Methode pour enregistrer les couleurs """
        # passer de la forme (r,g,b) a la forme [r,g,b]
        cI = pCouleurs.getCoulInsert()
        cIr = cI.Red()
        cIg = cI.Green()
        cIb = cI.Blue()
        
        cS = pCouleurs.getCoulSupp()
        cSr = cS.Red()
        cSg = cS.Green()
        cSb = cS.Blue()
        
        cR =  pCouleurs.getCoulRemp()
        cRr = cR.Red()
        cRg = cR.Green()
        cRb = cR.Blue()

        cDep = pCouleurs.getDeplacement()

#########################################
        cND = pCouleurs.getCoulNonDef()
        cNDr = cND.Red()
        cNDg = cND.Green()
        cNDb = cND.Blue()
##########################################
        # print("4. Module Controleurs.cTravail, Classe CTravail, Methode enregistrerCouleurs, ligne 76 ---> \ncI=[", cI, "], cIr=[", cIr, "], cIg=[", cIg, "], cIb=[", cIb, "], \ncS=[", cS, "], cSr=[", cSr, "], cSg=[", cSg, "], cSb=[", cSb, "], \ncR=[", cR, "], cRr=[", cRr, "], cRg=[", cRg, "], cRb=[", cRb, "], \ncDep=[", cDep, "], cNDr=[", cNDr, "], cNDg=[", cNDg, "], cNDb=[", cNDb, "] ")
        coulMemo = CouleursMemorisees([cIr,cIg,cIb], [cSr,cSg,cSb], [cRr,cRg,cRb],[cNDr,cNDg,cNDb], [cDep])
        self.__travail.enregistrerCouleurs(coulMemo)

    def chargerListePlans(self):
        """ Methode pour recuperer la liste des plans de travail """
        # print("5. Module Controleurs.cTravail, Classe CTravail, Methode chargerListePlans, ligne 82 ---> ")
        return self.__travail.chargerListePlans()
        
    # methode pour recuperer les donnees du plan de travail
#    def chargerPlan(self):
#        return self.__travail.chargerPlan()

    def chargerCouleurs(self):
        """ Methode pour recuperer les couleurs """
        # passer de la forme [r,g,b] a la forme (r,g,b) 
        couleurs = self.__travail.chargerCouleurs()
        
        cI = couleurs.getCoulInsert()
        cIi = wx.Colour(cI[0],cI[1],cI[2])
        
        cS = couleurs.getCoulSupp()
        cSi = wx.Colour(cS[0],cS[1],cS[2])
        
        cR =  couleurs.getCoulRemp()
        cRi = wx.Colour(cR[0],cR[1],cR[2])

        cND = couleurs.getCoulNonDef()
        cNDi = wx.Colour(cND[0],cND[1],cND[2])

        cE = couleurs.getEcriture()
        cEi = wx.Colour(cE[0],cE[1],cE[2])
        # print("5-1. Module Controleurs.cTravail, Classe CTravail, Methode chargerCouleurs, ligne 108 ---> \ncI=[", cI, "], cS=[", cS, "], cR=[", cR, "], cND=[", cND, "], cE=[", cE, "], couleurs.getDeplacement()=[", couleurs.getDeplacement(), "] ") 
        cD = couleurs.getDeplacement()[0]
        # print("6. Module Controleurs.cTravail, Classe CTravail, Methode chargerCouleurs, ligne 110 ---> \ncI=[", cI, "], cS=[", cS, "], cR=[", cR, "], cND=[", cND, "], cE=[", cE, "], cD=[", cD) 
        return CouleursInterface(cIi,cSi, cRi,cNDi, cEi, cD)
    
    def chargerCouleursDefaut(self):
        """ Methode pour recuperer les couleurs de defaut """
        cIi = wx.Colour(DEFAUT_INSERTION[0],DEFAUT_INSERTION[1], DEFAUT_INSERTION[2])
        cSi = wx.Colour(DEFAUT_SUPPRESSION[0],DEFAUT_SUPPRESSION[1], DEFAUT_SUPPRESSION[2])
        cRi = wx.Colour(DEFAUT_REMPLACEMENT[0],DEFAUT_REMPLACEMENT[1],DEFAUT_REMPLACEMENT[2])
        cNDi = wx.Colour(DEFAUT_NONDEFINIS[0],DEFAUT_NONDEFINIS[1],DEFAUT_NONDEFINIS[2])
        cEi = wx.Colour(DEFAUT_ECRITURE_BLANC[0],DEFAUT_ECRITURE_BLANC[1],DEFAUT_ECRITURE_BLANC[2])
        cD = DEFAUT_SOULIGNE_DEPLACEMENT
        # print("7. Module Controleurs.cTravail, Classe CTravail, Methode chargerCouleursDefaut, ligne 121 ---> \ncIi=[", cIi, "], cSi=[", cSi, "], cRi=[", cRi, "], cNDi=[", cNDi, "], cEi=[", cEi, "], cD=[", cD) 
        return CouleursInterface(cIi,cSi,cRi,cNDi,cEi,cD)

    def chargerParametres(self):
        """ Methode pour recuperer les parametres """
        # print("8. Module Controleurs.cTravail, Classe CTravail, Methode chargerParametres, ligne 126 ---> ")
        return self.__travail.chargerParametres()
    
    def chargerParametresDefaut(self):
        """ Methode pour recuperer les parametres de defaut """
        # print("9. Module Controleurs.cTravail, Classe CTravail, Methode chargerParametresDefaut, ligne 131 ---> \nDEFAUT__LONG_MIN_PIVOT=[", DEFAUT__LONG_MIN_PIVOT, "], DEFAUT_RATION__MIN_REMP=[", DEFAUT_RATION__MIN_REMP, "], DEFAUT_RATIO_SEUIL_LISSAGE=[", DEFAUT_RATIO_SEUIL_LISSAGE, "], DEFAULT_CAR_OU_MOT=[", DEFAULT_CAR_OU_MOT, "] ")
        return Parametres(DEFAUT__LONG_MIN_PIVOT,
                          DEFAUT_RATION__MIN_REMP,
                          DEFAUT_RATIO_SEUIL_LISSAGE,
                          DEFAULT_CAR_OU_MOT)
