# -*- coding: UTF-8 -*-
# Copyright 2003 - 2008: Julien Bourdaillet (julien.bourdaillet@lip6.fr), Jean-Gabriel Ganascia (jean-gabriel.ganascia@lip6.fr)
# This file is part of MEDITE.
#
#    MEDITE is free software; you can redistribute it and/or modify
#    it under the terms of the GNU General Public License as published by
#    the Free Software Foundation; either version 2 of the License, or
#    (at your option) any later version.
#
#    MEDITE is distributed in the hope that it will be useful,
#    but WITHOUT ANY WARRANTY; without even the implied warranty of
#    MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
#    GNU General Public License for more details.
#
#    You should have received a copy of the GNU General Public License
#    along with Foobar; if not, write to the Free Software
#    Foundation, Inc., 51 Franklin St, Fifth Floor, Boston, MA  02110-1301  USA
#----------------------------------------------------------------------------
# Nom:          informations.py
# Objet:        Classe qui regroupe les informations d'un couple d'�tats
#----------------------------------------------------------------------------


from Donnees.transformations import *
from Donnees.commentaire import *

class Informations:

    # Constructeur de la classe
    def __init__(self, pVersionSource, pEtatSource, pVersionCible, pEtatCible, pParametres, pTransformations, pCommentaire = None): 
        self.__versionSource = pVersionSource
        self.__etatSource = pEtatSource 
        self.__versionCible = pVersionCible
        self.__etatCible = pEtatCible
        self.__parametres = pParametres
        self.__transformations = pTransformations
        self.__commentaire = pCommentaire
        # print("1. Module: Donnees.informations, Classe: Informations, Methode: __init__, Ligne: 38 ---> pVersionSource=", pVersionSource, ", pEtatSource=", pEtatSource, ", pVersionCible=", pVersionCible, ", pEtatCible=", pEtatCible, " ")
        # print("2. Module: Donnees.informations, Classe: Informations, Methode: __init__, Ligne: 39 ---> \npParametres.getp1()=", pParametres.getp1(), ", pParametres.getp2()=", pParametres.getp2(), ", pParametres.getp3()=", pParametres.getp3(), ", pParametres.getp4()=", pParametres.getp4(), ", pParametres.getp5()=", pParametres.getp5(), ", pParametres.getp6()=", pParametres.getp6(), ", pParametres.getp7()=", pParametres.getp7(), " ")
        # print("3. Module: Donnees.informations, Classe: Informations, Methode: __init__, Ligne: 40 ---> pCommentaire=", str(pCommentaire), " ")


    # Methodes d'acces aux attributs
    def getVersionSource(self):
        # print("4. Module: Donnees.informations, Classe: Informations, Methode: getVersionSource, Ligne: 45 ---> self.__versionSource=", self.__versionSource, " ")
        return self.__versionSource

    def getEtatSource(self):
        # print("5. Module: Donnees.informations, Classe: Informations, Methode: getEtatSource, Ligne: 49 ---> self.__etatSource=", self.__etatSource, " ")
        return self.__etatSource

    def getVersionCible(self):
        # print("6. Module: Donnees.informations, Classe: Informations, Methode: getVersionCible, Ligne: 53 ---> self.__versionCible=", self.__versionCible, " ")
        return self.__versionCible

    def getEtatCible(self):
        # print("7. Module: Donnees.informations, Classe: Informations, Methode: getEtatCible, Ligne: 57 ---> self.__etatCible=", self.__etatCible, " ")
        return self.__etatCible

    def getParametres(self):
        # print("8. Module: Donnees.informations, Classe: Informations, Methode: getParametres, Ligne: 61 ---> \nself.__parametres.getp1()=", self.__parametres.getp1(), ", self.__parametres.getp2()=", self.__parametres.getp2(), ", self.__parametres.getp3()=", self.__parametres.getp3(), ", self.__parametres.getp4()=", self.__parametres.getp4(), ", self.__parametres.getp5()=", self.__parametres.getp5(), ", self.__parametres.getp6()=", self.__parametres.getp6(), ", self.__parametres.getp7()=", self.__parametres.getp7(), " ")        
        return self.__parametres

    def getTransformations(self):
        # print("9. Module: Donnees.informations, Classe: Informations, Methode: getTransformations, Ligne: 65 ---> ")
        return self.__transformations
    
    def getCommentaire(self):
        # print("10. Module: Donnees.informations, Classe: Informations, Methode: getCommentaire, Ligne: 69 ---> self.__commentaire.getp1()=", self.__commentaire.getp1(), " ")
        return self.__commentaire


    # Methodes qui verifient si les transformations ou le commentaire existent
    # Si ils existent, la fonction retourne vrai, et faux sinon
    def existeCommentaire(self):
        # print("11. Module: Donnees.informations, Classe: Informations, Methode: existeCommentaire, Ligne: 76 ---> ") 
        if self.__commentaire == None:
            return 1    ## FAUX
        else:
            return 0    ## VRAI

    def existeTransformations(self):
        # print("12. Module: Donnees.informations, Classe: Informations, Methode: existeTransformations, Ligne: 83 ---> ") 
        if self.__transformations == None:
            return 1    ## FAUX
        else:
            return 0    ## VRAI        


    # Methode de modification d'attribut
    # Seul le commentaire est modifiable
    def setCommentaire(self, pCommentaire):
        self.__commentaire = pCommentaire
        # print("13. Module: Donnees.informations, Classe: Informations, Methode: setCommentaire, Ligne: 94 ---> pCommentaire=", pCommentaire, " ") 

