# -*- coding: UTF-8 -*-
# Copyright 2003 - 2008: Julien Bourdaillet (julien.bourdaillet@lip6.fr), Jean-Gabriel Ganascia (jean-gabriel.ganascia@lip6.fr)
# This file is part of MEDITE.
#
#    MEDITE is free software; you can redistribute it and/or modify
#    it under the terms of the GNU General Public License as published by
#    the Free Software Foundation; either version 2 of the License, or
#    (at your option) any later version.
#
#    MEDITE is distributed in the hope that it will be useful,
#    but WITHOUT ANY WARRANTY; without even the implied warranty of
#    MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
#    GNU General Public License for more details.
#
#    You should have received a copy of the GNU General Public License
#    along with Foobar; if not, write to the Free Software
#    Foundation, Inc., 51 Franklin St, Fifth Floor, Boston, MA  02110-1301  USA
#----------------------------------------------------------------------------
# Nom:          planTravail.py
# Objet:        Fichier qui regroupe la classe PlanTravail,
#               la classe des parametres, la classe des couleurs
#               et la classe qui permet d'acc�der aux trois
#----------------------------------------------------------------------------

from Utile.constantesDonnees import *
from Utile.exceptionsDonnees import *
import json, shelve                             # Modifie 13.09.2019, ancienne:  import shelve
import posixpath
import sys, wx
from datetime import datetime

class ListePlanTravail:
    def __init__(self):
        self.__listePlanTravail = []
        # print("1. Module: Donnees.planTravail, Classe: ListePlanTravail, Methode: __init__, Ligne: 35 ---> self.__listePlanTravail=", self.__listePlanTravail, " ")

    def getListe(self):
        # print("2. Module: Donnees.planTravail, Classe: ListePlanTravail, Methode: getListe, Ligne: 38 ---> self.__listePlanTravail=", self.__listePlanTravail, " ")
        return self.__listePlanTravail
        
    def appendPlanTravail(self, planTravail):
        self.__listePlanTravail.append(planTravail)
        # print("3. Module: Donnees.planTravail, Classe: ListePlanTravail, Methode: appendPlanTravail, Ligne: 43 ---> planTravail=", planTravail, ", self.__listePlanTravail=", self.__listePlanTravail, " ")

    def deletePlanTravail(self,plan):
        self.__listePlanTravail.remove(plan)
        # print("4. Module: Donnees.planTravail, Classe: ListePlanTravail, Methode: deletePlanTravail, Ligne: 47 ---> plan=", plan, " ")
        
    def flushListe(self):
        self.__listePlanTravail = []
        # print("5. Module: Donnees.planTravail, Classe: ListePlanTravail, Methode: flushListe, Ligne: 51 ---> self.__listePlanTravail=", self.__listePlanTravail, " ") 
        
    def estVide(self):
        # print("6. Module: Donnees.planTravail, Classe: ListePlanTravail, Methode: estVide, Ligne: 54 ---> len(self.__listePlanTravail)=", len(self.__listePlanTravail), " ") 
        if len(self.__listePlanTravail) == 0:
            return True
        else: return False
        
    def toString(self):
        res = ''
        if len(self.__listePlanTravail) == 0:
            res = "listePlanTravil vide"
        else:
            for plan in self.__listePlanTravail:
                res += plan.toString()
                
        # print("7. Module: Donnees.planTravail, Classe: ListePlanTravail, Methode: toString, Ligne: 67 ---> res=", res, " ") 
        return res
        
# classe qui regroupe les donnees du plan de travail du chercheur
class PlanTravail:
    # constructeur de la classe
    def __init__(self, pAuteur, pOeuvre, pVS, pFS, pVC, pFC, pParam):
        self.__auteur = pAuteur
        self.__oeuvre = pOeuvre
        self.__versSource = pVS
        self.__feuilSource = pFS
        self.__versCible = pVC
        self.__feuilCible = pFC
        self.__param = pParam
        # print("8. Module: Donnees.planTravail, Classe: PlanTravail, Methode: __init__, Ligne: 81 ---> \nself.__auteur=", self.__auteur, ", self.__oeuvre=", self.__oeuvre, ", self.__versSource=", self.__versSource, ", self.__feuilSource=", self.__feuilSource, ", self.__versCible=", self.__versCible, ", self.__feuilCible=", self.__feuilCible, ", self.__param=", self.__param, " ") 

    def toString(self):
        # print("9. Module: Donnees.planTravail, Classe: PlanTravail, Methode: toString, Ligne: 84 ---> Auteur=", self.getAuteur(), ", Oeuvre= ", self.getOeuvre(), ", Version Source=", self.getVersionSource(), ", Etat Source=", self.getEtatSource(), ", Version Cible=", self.getVersionCible(), ", Etat Cible=", self.getEtatCible(), ", Parametres=", self.getParam().toString(), " ")
        return 'Auteur = ' +self.getAuteur()+ " / Oeuvre = "+self.getOeuvre()+ " / Version Source = "+self.getVersionSource()+" / Etat Source = "+self.getEtatSource()+" / Version Cible = "+self.getVersionCible()+ " / Etat Cible = "+self.getEtatCible()+ " / " +str(self.getParam())+"\n"
        
    # Methode d'acces aux attributs prives
    def getAuteur(self):
        # print("10. Module: Donnees.planTravail, Classe: PlanTravail, Methode: getAuteur, Ligne: 89 ---> self.__auteur=", self.__auteur, " ")
        return self.__auteur

    def getOeuvre(self):
        # print("11. Module: Donnees.planTravail, Classe: PlanTravail, Methode: getOeuvre, Ligne: 93 ---> self.__oeuvre=", self.__oeuvre, " ")
        return self.__oeuvre

    def getVersionSource(self):
        # print("12. Module: Donnees.planTravail, Classe: PlanTravail, Methode: getVersionSource, Ligne: 97 ---> self.__versSource=", self.__versSource, " ")
        return self.__versSource
    
    def getEtatSource(self):
        # print("13. Module: Donnees.planTravail, Classe: PlanTravail, Methode: getEtatSource, Ligne: 101 ---> self.__feuilSource=", self.__feuilSource, " ")
        return self.__feuilSource
    
    def getVersionCible(self):
        # print("14. Module: Donnees.planTravail, Classe: PlanTravail, Methode: getVersionCible, Ligne: 105 ---> self.__versCible=", self.__versCible, " ")
        return self.__versCible 
    
    def getEtatCible(self):
        # print("15. Module: Donnees.planTravail, Classe: PlanTravail, Methode: getEtatCible, Ligne: 109 ---> self.__feuilCible=", self.__feuilCible, " ")
        return self.__feuilCible
        
    def getParam(self):
        # print("16. Module: Donnees.planTravail, Classe: PlanTravail, Methode: getParam, Ligne: 113 ---> self.__param=", str(self.__param), " ")
        return self.__param
        
    # Methode de mise à jour des attributs prives
    def setAuteur(self, pAuteur):
        self.__auteur = pAuteur
        # print("17. Module: Donnees.planTravail, Classe: PlanTravail, Methode: setAuteur, Ligne: 119 ---> self.__auteur=", self.__auteur, " ")

    def setOeuvre(self, pOeuvre):
        self.__oeuvre = pOeuvre
        # print("18. Module: Donnees.planTravail, Classe: PlanTravail, Methode: setOeuvre, Ligne: 123 ---> self.__oeuvre=", self.__oeuvre, " ")

    def setVersionSource(self, pVS):
        self.__versSource = pVS
        # print("19. Module: Donnees.planTravail, Classe: PlanTravail, Methode: setVersionSource, Ligne: 127 ---> self.__versSource=", self.__versSource, " ")
    
    def setEtatSource(self, pFS):
        self.__feuilSource = pFS
        # print("20. Module: Donnees.planTravail, Classe: PlanTravail, Methode: setEtatSource, Ligne: 131 ---> self.__feuilSource=", self.__feuilSource, " ")
    
    def setVersionCible(self, pVC):
        self.__versCible = pVC
        # print("21. Module: Donnees.planTravail, Classe: PlanTravail, Methode: setVersionCible, Ligne: 135 ---> self.__versCible=", self.__versCible, " ")
    
    def setEtatCible(self, pFC):
        self.__feuilCible = pFC
        # print("22. Module: Donnees.planTravail, Classe: PlanTravail, Methode: setEtatCible, Ligne: 139 ---> self.__feuilCible=", self.__feuilCible, " ")

    def setParam(self, pParam):
        self.__param = pParam
        # print("23. Module: Donnees.planTravail, Classe: PlanTravail, Methode: setParam, Ligne: 143 ---> self.__param=", str(self.__param), " ")
        
# classe qui regroupe les parametres de lissage
# 1 - longueur minimale des chaines pivots (et deplacees)
# 2 - ratio minimal de longueur des chaines pour valider un remplacement
# 3 - seuil du rapport de longueur des chaines pour valider un lissage
# 4 - mode mot ou caractère pour l'algo medite  
class Parametres:
    # constructeur de la classe
    def __init__(self, pP1=5, pP2=50, pP3=50, pP4=0, pP5=1, pP6=1, pP7=1):
        self.__p1 = pP1
        self.__p2 = pP2
        self.__p3 = pP3
        self.__p4 = pP4
        self.__p5 = pP5
        self.__p6 = pP6
        self.__p7 = pP7
        # print("24. Module: Donnees.planTravail, Classe: Parametres, Methode: __init__, Ligne: 160 ---> \nself.__p1=", self.__p1, ", self.__p2=", self.__p2, ", self.__p3=", self.__p3, ", self.__p4=", self.__p4, ", self.__p5=", self.__p5, ", self.__p6=", self.__p6, ", self.__p7=", self.__p7, " ")

        
    def isNull(self):
        # print("25. Module: Donnees.planTravail, Classe: Parametres, Methode: isNull, Ligne 164 ---> ")
        if self.getp1()==0 and self.getp2()==0 and self.getp3()==0: return True
        else: return False
        
    def toString(self):
        # print("26. Module: Donnees.planTravail, Classe: Parametres, Methode: toString, Ligne 169 ---> self.getp1()=[", self.getp1(), "], self.getp2()=[", self.getp2(), "], self.getp3()=[", self.getp3(), "], self.getp4()=[", self.getp4(), "], self.getp5()=[", self.getp5(), "], self.getp6()=[", self.getp6(), "], self.getp7()=[", self.getp7(), "] ") 
        # print("27. Module: Donnees.planTravail, Classe: Parametres, Methode: toString, Ligne 170 ---> str(self.getp1())=[", str(self.getp1()), "], str(self.getp2())=[", str(self.getp2()), "], str(self.getp3())=[", str(self.getp3()), "], str(self.getp4())=[", str(self.getp4()), "], str(self.getp5())=[", str(self.getp5()), "], str(self.getp6())=[", str(self.getp6()), "], str(self.getp7())=[", str(self.getp7()), "] ") 
        return "Param: p1 = "+str(self.getp1())+" / p2 = "+str(self.getp2())+ \
        " / p3 = "+str(self.getp3())+" / p4 = "+str(self.getp4())+ \
        " / p5 = "+str(self.getp5())+" / p6 = "+str(self.getp6())+ \
        " / p7 = "+str(self.getp7())+"\n"
    
    # Methode d'acces aux attributs prives
    def getp1(self):
        # print("28. Module: Donnees.planTravail, Classe: Parametres, Methode: getp1, Ligne 178 ---> self.__p1=", self.__p1, " ") 
        return self.__p1

    def getp2(self):
        # print("29. Module: Donnees.planTravail, Classe: Parametres, Methode: getp2, Ligne 182 ---> self.__p2=", self.__p2, " ") 
        return self.__p2

    def getp3(self):
        # print("30. Module: Donnees.planTravail, Classe: Parametres, Methode: getp3, Ligne 186 ---> self.__p3=", self.__p3, " ") 
        return self.__p3

    def getp4(self):
        # print("31. Module: Donnees.planTravail, Classe: Parametres, Methode: getp4, Ligne 190 ---> self.__p4=", self.__p4, " ") 
        return self.__p4
        
    def getp5(self):
        # print("32. Module: Donnees.planTravail, Classe: Parametres, Methode: getp5, Ligne 194 ---> self.__p5=", self.__p5, " ") 
        return self.__p5

    def getp6(self):
        # print("33. Module: Donnees.planTravail, Classe: Parametres, Methode: getp6, Ligne 198 ---> self.__p6=", self.__p6, " ")
        return self.__p6
        
    def getp7(self):
        # print("34. Module: Donnees.planTravail, Classe: Parametres, Methode: getp7, Ligne 202 ---> self.__p7=", self.__p7, " ")
        return self.__p7
        
    # Methode de mise a jour des attributs prives
    def setp1(self, pP1):
        self.__p1 = pP1
        # print("35. Module: Donnees.planTravail, Classe: Parametres, Methode: setp1, Ligne 208 ---> self.__p1=", self.__p1, " ") 
    def setp2(self,pP2):
        self.__p2 = pP2
        # print("36. Module: Donnees.planTravail, Classe: Parametres, Methode: setp2, Ligne 211 ---> self.__p2=", self.__p2, " ") 

    def setp3(self, pP3):
        self.__p3 = pP3 
        # print("37. Module: Donnees.planTravail, Classe: Parametres, Methode: setp3, Ligne 215 ---> self.__p3=", self.__p3, " ") 
        
    def setp4(self, pP4):
        self.__p4 = pP4 
        # print("38. Module: Donnees.planTravail, Classe: Parametres, Methode: setp4, Ligne 219 ---> self.__p4=", self.__p4, " ") 

    def setp5(self, pP5):
        self.__p5 = pP5 
        # print("39. Module: Donnees.planTravail, Classe: Parametres, Methode: setp5, Ligne 223 ---> self.__p5=", self.__p5, " ") 
        
    def setp6(self, pP6):
        self.__p6 = pP6 
        # print("40. Module: Donnees.planTravail, Classe: Parametres, Methode: setp6, Ligne 227 ---> self.__p6=", self.__p6, " ") 
    
    def setp7(self, pP7):
        self.__p7 = pP7
        # print("41. Module: Donnees.planTravail, Classe: Parametres, Methode: setp7, Ligne 231 ---> self.__p7=", self.__p7, " ") 
        
# classe qui regroupe les couleurs de visualisation des transformations
# de la forme [Red, Green, Blue] pour chaque couleur
class CouleursMemorisees:
    # constructeur de la classe
    def __init__(self, pCoulInsert, pCoulSupp, pCoulRemp,pCoulND, pDeplacement):
        self.__coulRemp = pCoulRemp
        self.__coulSupp = pCoulSupp
        self.__coulInsert = pCoulInsert
        self.__coulNonDef = pCoulND
        self.__ecriture = DEFAUT_ECRITURE_BLANC
        self.__deplacement = pDeplacement #DEFAUT_SOULIGNE_DEPLACEMENT ## =1 VRAI
        # print("42. Module: Donnees.planTravail, Classe: CouleursMemorisees, Methode: __init__, Ligne 244 ---> self.__coulRemp=", self.__coulRemp, ", self.__coulSupp=", self.__coulSupp, ", self.__coulInsert=", self.__coulInsert, ", self.__coulNonDef=", self.__coulNonDef, ", self.__ecriture=", self.__ecriture, ", self.__deplacement=", self.__deplacement, " ") 
        
    # Methode d'acces aux attributs prives
    def getCoulRemp(self):
        # print("43. Module: Donnees.planTravail, Classe: CouleursMemorisees, Methode: getCoulRemp, Ligne 248 ---> self.__coulRemp=", self.__coulRemp, " ") 
        return self.__coulRemp

    def getCoulSupp(self):
        # print("44. Module: Donnees.planTravail, Classe: CouleursMemorisees, Methode: getCoulSupp, Ligne 252 ---> self.__coulSupp=", self.__coulSupp, " ")
        return self.__coulSupp

    def getCoulInsert(self):
        # print("45. Module: Donnees.planTravail, Classe: CouleursMemorisees, Methode: getCoulInsert, Ligne 256 ---> self.__coulInsert=", self.__coulInsert, " ")
        return self.__coulInsert
    
    def getEcriture(self):
        # print("46. Module: Donnees.planTravail, Classe: CouleursMemorisees, Methode: getEcriture, Ligne 260 ---> self.__ecriture=", self.__ecriture, " ")
        return self.__ecriture

    def getDeplacement(self):
        # print("47. Module: Donnees.planTravail, Classe: CouleursMemorisees, Methode: getDeplacement, Ligne 264 ---> self.__deplacement=", self.__deplacement, " ")
        return self.__deplacement

    def getCoulNonDef(self):
        # print("48. Module: Donnees.planTravail, Classe: CouleursMemorisees, Methode: getCoulNonDef, Ligne 268 ---> self.__coulNonDef=", self.__coulNonDef, " ")
        return self.__coulNonDef
        
    # Methode de mise a jour des attributs prives
    def setCoulRemp(self, pCoulRemp):
        self.__coulRemp = pCoulRemp
        # print("49. Module: Donnees.planTravail, Classe: CouleursMemorisees, Methode: setCoulRemp, Ligne 274 ---> self.__coulRemp=", self.__coulRemp, " ")

    def setCoulNonDef(self,pCoulRemp):
        self.__coulNonDef = pCoulRemp    
        # print("50. Module: Donnees.planTravail, Classe: CouleursMemorisees, Methode: setCoulNonDef, Ligne 278 ---> self.__coulNonDef=", self.__coulNonDef, " ")
        
    def setCoulInsert(self, pCoulInsert):
        self.__coulInsert = pCoulInsert
        # print("51. Module: Donnees.planTravail, Classe: CouleursMemorisees, Methode: setCoulInsert, Ligne 282 ---> self.__coulInsert=", self.__coulInsert, " ")
        
    def setCoulSupp(self, pCoulSupp):
        self.__coulSupp = pCoulSupp
        # print("52. Module: Donnees.planTravail, Classe: CouleursMemorisees, Methode: setCoulSupp, Ligne 286 ---> self.__coulSupp=", self.__coulSupp, " ")

# classe qui regroupe les couleurs de visualisation des transformations
# de la forme (Red, Green, Blue) pour chaque couleur
class CouleursInterface:
    # constructeur de la classe
    def __init__(self, pCoulInsert, pCoulSupp, pCoulRemp,pCoulND, pEcriture, pDeplacement):#pSouligne):
        self.__coulRemp = pCoulRemp
        self.__coulSupp = pCoulSupp
        self.__coulInsert = pCoulInsert
        self.__ecriture = pEcriture
        self.__deplacement = pDeplacement
        self.__coulNonDef = pCoulND
        # print("53. Module: Donnees.planTravail, Classe: CouleursInterface, Methode: __init__, Ligne 299 ---> self.__coulRemp=", self.__coulRemp, ", self.__coulSupp=", self.__coulSupp, ", self.__coulInsert=", self.__coulInsert, ", self.__ecriture=", self.__ecriture, ", self.__deplacement=", self.__deplacement, ", self.__coulNonDef=", self.__coulNonDef," ")
        
    # Methode d'acces aux attributs prives
    def getCoulRemp(self):
        # print("54. Module: Donnees.planTravail, Classe: CouleursInterface, Methode: getCoulRemp, Ligne 303 ---> self.__coulRemp=", self.__coulRemp, " ")
        return self.__coulRemp

    def getCoulSupp(self):
        # print("55. Module: Donnees.planTravail, Classe: CouleursInterface, Methode: getCoulSupp, Ligne 307 ---> self.__coulSupp=", self.__coulSupp, " ") 
        return self.__coulSupp

    def getCoulInsert(self):
        # print("56. Module: Donnees.planTravail, Classe: CouleursInterface, Methode: getCoulInsert, Ligne 311 ---> self.__coulInsert=", self.__coulInsert, " ") 
        return self.__coulInsert
        
    def getEcriture(self):
        # print("57. Module: Donnees.planTravail, Classe: CouleursInterface, Methode: getEcriture, Ligne 3159 ---> self.__ecriture=", self.__ecriture, " ") 
        return self.__ecriture
 
    #def getSouligne(self):
    #    return self.__souligneDep

    def getDeplacement(self):
        # print("58. Module: Donnees.planTravail, Classe: CouleursInterface, Methode: getDeplacement, Ligne 322 ---> self.__deplacement=", self.__deplacement, " ") 
        return self.__deplacement

    def getCoulNonDef(self):
        # print("59. Module: Donnees.planTravail, Classe: CouleursInterface, Methode: getCoulNonDef, Ligne 326 ---> self.__coulNonDef=", self.__coulNonDef, " ") 
        return self.__coulNonDef
        
    # Methode de mise a jour des attributs prives
    def setCoulRemp(self, pCoulRemp):
        self.__coulRemp = pCoulRemp
        # print("60. Module: Donnees.planTravail, Classe: CouleursInterface, Methode: setCoulRemp, Ligne 332 ---> self.__coulRemp=", self.__coulRemp, " ") 

    def setCoulNonDef(self,pCoulRemp):
        self.__coulNonDef = pCoulRemp
        # print("61. Module: Donnees.planTravail, Classe: CouleursInterface, Methode: setCoulNonDef, Ligne 336 ---> self.__coulNonDef=", self.__coulNonDef, " ") 
        
    def setCoulInsert(self, pCoulInsert):
        # print("61-2. Module: Donnees.planTravail, Classe: CouleursInterface, Methode: setCoulInsert, Ligne 339 ---> pCoulInsert=", str(pCoulInsert), " ") 
        self.__coulInsert = pCoulInsert
        # print("62. Module: Donnees.planTravail, Classe: CouleursInterface, Methode: setCoulInsert, Ligne 341 ---> self.__coulInsert=", self.__coulInsert, " ") 
        
    def setCoulSupp(self, pCoulSupp):
        # print("62-1. Module: Donnees.planTravail, Classe: CouleursInterface, Methode: setCoulSupp, Ligne 344 ---> pCoulSupp=[", pCoulSupp, "] ")
        self.__coulSupp = pCoulSupp
        # print("63. Module: Donnees.planTravail, Classe: CouleursInterface, Methode: setCoulSupp, Ligne 346 ---> self.__coulSupp=[", self.__coulSupp, "] ") 
    
    def setDeplacement(self,pDeplacement):
        self.__deplacement = pDeplacement
        # print("64. Module: Donnees.planTravail, Classe: CouleursInterface, Methode: setDeplacement, Ligne 348 ---> self.__deplacement=", self.__deplacement, " ") 

        
#classe pour acceder au fichier qui detient les donnees de travail
# sérialiseur des objets de donn�e
class DonneesTravail:
    # methode pour recuperer la liste des plans de travail
    def chargerListePlans(self):
        # print("\n65. Module: Donnees.planTravail, Classe: DonneesTravail, Methode: chargerListePlans, Ligne: 356 ---> ", datetime.now().strftime("%d/%m/%Y - %H:%M:%S"), "---------------------------------------------------------------")
        # print("66. Module: Donnees.planTravail, Classe: DonneesTravail, Methode: chargerListePlans, Ligne: 357 ---> PLANTRAVAIL=[", PLANTRAVAIL, "] ")
        # print("67. Module: Donnees.planTravail, Classe: DonneesTravail, Methode: chargerListePlans, Ligne: 358 ---> posixpath.isfile(PLANTRAVAIL)=", posixpath.isfile(PLANTRAVAIL + '.dat'))  
        # print("\n68. Module: Donnees.planTravail, Classe: DonneesTravail, Methode: chargerListePlans, Ligne: 359 ---> ", datetime.now().strftime("%d/%m/%Y - %H:%M:%S"), "---------------------------------------------------------------") 
        
        if posixpath.isfile(PLANTRAVAIL + '.dat'):             # Modifiee 14.06.2019, ancienne ligne: if posixpath.isfile(PLANTRAVAIL):  
            ficTravail = shelve.open(PLANTRAVAIL)           
            listePlans = ficTravail['listePlans']
            # print("69. Module: Donnees.planTravail, Classe: DonneesTravail, Methode: chargerListePlans, Ligne: 364 ---> listePlans(fichier trouvé)=[", listePlans, "] ")        # Modifiee 01.07.2019, ancienne ligne: print("Module: planTravail,   listePlans(fichier trouv�) ---> ", str(listePlans))
            ficTravail.close()
            return listePlans
        else :
            # print("70. Module: Donnees.planTravail, Classe: DonneesTravail, Methode: chargerListePlans, Ligne: 368 ---> listePlans(fichier)=", PLANTRAVAIL, " n'est pas trouve.")
            raise FichierNonTrouve()

    # methode pour recuperer les donnees du plan de travail
    #def chargerPlan(self):
    #    if posixpath.isfile(PLANTRAVAIL):
    #        ficTravail = shelve.open(PLANTRAVAIL)
    #        plan = ficTravail['plan']
    #        ficTravail.close()
    #        return plan
    #    else :
    #        raise FichierNonTrouve()

    # methode pour recuperer les couleurs, il retourne couleurs - instance de la classe CouleursInterface. 
    def chargerCouleurs(self):
        if posixpath.isfile(FIC_COULEURS):                          # Modifiee 14.06.2019, ancienne ligne:  if posixpath.isfile(FIC_COULEURS): 
            file_json_couleurs = open(FIC_COULEURS)                 # Modifie 17.09.2019, ancienne:  ficTravail = shelve.open(FIC_COULEURS)
            couleurs_dict = json.load(file_json_couleurs)           # Modifie 17.09.2019, ancienne:  couleurs = ficTravail['couleurs']
            couleurs = CouleursMemorisees([couleurs_dict["couleurs"]["coulInsert"][0], couleurs_dict["couleurs"]["coulInsert"][1], couleurs_dict["couleurs"]["coulInsert"][2]], [couleurs_dict["couleurs"]["coulSupp"][0], couleurs_dict["couleurs"]["coulSupp"][1], couleurs_dict["couleurs"]["coulSupp"][2]], [couleurs_dict["couleurs"]["coulRemp"][0], couleurs_dict["couleurs"]["coulRemp"][1], couleurs_dict["couleurs"]["coulRemp"][2]], [couleurs_dict["couleurs"]["coulNonDef"][0], couleurs_dict["couleurs"]["coulNonDef"][1], couleurs_dict["couleurs"]["coulNonDef"][2]], [couleurs_dict["couleurs"]["coulDepl"][0]])                # Modifie 17.09.2019, ancienne:  ficTravail.close()
            # print("71. Module: Donnees.planTravail, Classe: DonneesTravail, Methode: chargerCouleurs, Ligne: 387 ---> couleurs=", couleurs, " ")
            return couleurs         
        else :
            raise FichierNonTrouve()

    # methode pour recuperer les parametres
    def chargerParametres(self):
        if posixpath.isfile(FIC_PARAMETRES):                        # Modifiee 14.06.2019, ancienne ligne: if posixpath.isfile(FIC_PARAMETRES):  
            file_json_parametres = open(FIC_PARAMETRES)             # Modifie 13.09.2019, ancienne:  ficTravail = shelve.open(FIC_PARAMETRES)
            parametres_dict = json.load(file_json_parametres)       # Ajoute 13.09.2019 
            parametres = Parametres(parametres_dict["parametres"][0], parametres_dict["parametres"][1], parametres_dict["parametres"][2], parametres_dict["parametres"][3], parametres_dict["parametres"][4], parametres_dict["parametres"][5], parametres_dict["parametres"][6])           # parametres = ficTravail['parametres']
            file_json_parametres.close()                    # Modifie 13.09.2019, ancienne:  ficTravail.close()
            # print("72. Module: Donnees.planTravail, Classe: DonneesTravail, Methode: chargerParametres, Ligne: 399 ---> parametres=", parametres_dict["parametres"], " ")
            return parametres
        else :
            raise FichierNonTrouve()

    # methode pour enregistrer la liste des plans de travail
    def enregistrerListePlans(self, pListePlans):
        ficTravail = shelve.open(PLANTRAVAIL)                   # Modifiee 13.09.2019, 14.06.2019, ancienne ligne: ficTravail = shelve.open(PLANTRAVAIL) 
        ficTravail['listePlans']= pListePlans
        ficTravail.close()
        # print("73. Module: Donnees.planTravail, Classe: DonneesTravail, Methode: enregistrerListePlans, Ligne: 409 ---> \npListePlans=", pListePlans, " ")
        
    # methode pour enregistrer le plan de travail
#    def enregistrerPlan(self, pPlan):
#        ficTravail = shelve.open(PLANTRAVAIL)
#        ficTravail['plan']= pPlan
#        ficTravail.close()
        
    # methode pour enregistrer les couleurs, il recoit pCoul - instance de la classe CouleursMemorisees
    def enregistrerCouleurs(self, pCoul):
        couleurs_dict = {"couleurs": {"coulInsert": pCoul.getCoulInsert(), "coulSupp": pCoul.getCoulSupp(), "coulRemp": pCoul.getCoulRemp(), "coulNonDef": pCoul.getCoulNonDef(), "coulDepl": pCoul.getDeplacement()}}
        file_json_couleurs = open(FIC_COULEURS, "w")                # Modifie 17.09.2019, ancienne:  ficTravail = shelve.open(FIC_COULEURS)
        json.dump(couleurs_dict, file_json_couleurs)                # Modifie 17.09.2019, ancienne:  ficTravail['couleurs']= pCoul
        file_json_couleurs.close()                                  # Modifie 17.09.2019, ancienne:  ficTravail.close()
        # print("74. Module: Donnees.planTravail, Classe: DonneesTravail, Methode: enregistrerCouleurs, Ligne: 425 ---> \npCoul.getCoulInsert()=", pCoul.getCoulInsert(), ", pCoul.getCoulSupp()=", pCoul.getCoulSupp(), ", pCoul.getCoulRemp()=", pCoul.getCoulRemp(), ", pCoul.getCoulNonDef()=", pCoul.getCoulNonDef(), ", pCoul.getDeplacement()=", pCoul.getDeplacement(), ", ")

    # methode pour enregistrer les parametres
    def enregistrerParametres(self, pPara):
        parametres_dict = {"parametres": (pPara.getp1(), pPara.getp2(), pPara.getp3(), pPara.getp4(), pPara.getp5(), pPara.getp6(), pPara.getp7())}            # Modifiee 13.09.2019, 14.06.2019, ancienne ligne: ficTravail = shelve.open(FIC_PARAMETRES)
        file_json_parametres = open(FIC_PARAMETRES, "w")                    # Ajoute 13.09.2019  
        json.dump(parametres_dict, file_json_parametres)                    # Modifie 13.09.2019, ancienne:  ficTravail['parametres']= pPara
        file_json_parametres.close()                                        # Modifie 13.09.2019, ancienne:  ficTravail.close()
        # print("75. Module: Donnees.planTravail, Classe: DonneesTravail, Methode: enregistrerParametres, Ligne: 433 ---> pPara=", parametres_dict["parametres"], " ")
        
    # Methode pour lire anciens fichiers avec shelve   
    # def gdbm_shelve(self, filename, flag="c"):                            # Desactive 13.09.2019  
        # print("76. Module: Donnees.planTravail, Classe: DonneesTravail, Methode: gdbm_shelve, Ligne: 432 ---> ")    # Desactive 13.09.2019
        # mod = __import__("gdbm")                                        # Desactive 13.09.2019
        # return shelve.Shelf(mod.open(filename, flag))                    # Desactive 13.09.2019
    
