# -*- coding: UTF-8 -*-
# Copyright 2003 - 2008: Julien Bourdaillet (julien.bourdaillet@lip6.fr), Jean-Gabriel Ganascia (jean-gabriel.ganascia@lip6.fr)
# This file is part of MEDITE.
#
#    MEDITE is free software; you can redistribute it and/or modify
#    it under the terms of the GNU General Public License as published by
#    the Free Software Foundation; either version 2 of the License, or
#    (at your option) any later version.
#
#    MEDITE is distributed in the hope that it will be useful,
#    but WITHOUT ANY WARRANTY; without even the implied warranty of
#    MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
#    GNU General Public License for more details.
#
#    You should have received a copy of the GNU General Public License
#    along with Foobar; if not, write to the Free Software
#    Foundation, Inc., 51 Franklin St, Fifth Floor, Boston, MA  02110-1301  USA
#----------------------------------------------------------------------------
# Nom:          transformations.py
# Objet:        Classe qui regoupe les donnees d'une comparaison d'un couple
#               d'état ( utilisee pour construire le fichier xml )
#----------------------------------------------------------------------------

import sys,Utile.decodage

class Transformations: 
    # Constructeur de la classe
    def __init__(self, pInsertions, pSuppressions, pDeplacements, pRemplacements, pTexteSource, pTexteCible):
        ## les attributs ci-dessous sont des listes de sequence de caracteres
        self.__insertions =pInsertions
        self.__suppressions =pSuppressions
        self.__deplacements = pDeplacements
        self.__remplacements = pRemplacements
        ## les attributs ci-dessous sont des noeuds xml
        self.__texteSource = pTexteSource
        self.__texteCible = pTexteCible
        # print("1. Module: Donnees.transformations, Classe: Transformations, Methode: __init__, Ligne: 37 ---> \nself.__insertions=", self.__insertions, ", \nself.__suppressions=", self.__suppressions, ", \nself.__deplacements=", self.__deplacements, ", \nself.__remplacements=", self.__remplacements, ", \nself.__texteSource=", str(self.__texteSource), ", \nself.__texteCible=", str(self.__texteCible), " ") 


    # Methodes d'acces aux attributs privees
    def getInsertions(self):
        # print("2. Module: Donnees.transformations, Classe: Transformations, Methode: getInsertions, Ligne: 42 ---> \nself.__insertions=", self.__insertions, " ")
        return self.__insertions

    def getSuppressions(self):
        # print("3. Module: Donnees.transformations, Classe: Transformations, Methode: getSuppressions, Ligne: 46 ---> \nself.__suppressions=", self.__suppressions, " ")
        return self.__suppressions

    def getDeplacements(self):
        # print("4. Module: Donnees.transformations, Classe: Transformations, Methode: getDeplacements, Ligne: 50 ---> \nself.__deplacements=", self.__deplacements, " ")
        return self.__deplacements

    def getRemplacements (self):
        # print("5. Module: Donnees.transformations, Classe: Transformations, Methode: getRemplacements, Ligne: 54 ---> \nself.__remplacements=", self.__remplacements, " ")
        return self.__remplacements

    def getSource(self):
        # print("6. Module: Donnees.transformations, Classe: Transformations, Methode: getSource, Ligne: 58 ---> \nself.__texteSource=", self.__texteSource, " ")
        return self.__texteSource

    def getCible(self):
        # print("7. Module: Donnees.transformations, Classe: Transformations, Methode: getCible, Ligne: 62 ---> \nself.__texteCible=", self.__texteCible, " ")
        return self.__texteCible

    def toString(self):
        s = u"Type TRANSFORMATION\nInsertions : "
        for i in self.__insertions:
            s += i+u" / "
        s += u"\nSuppressions : "
        for i in self.__suppressions:
            s += i+u" / "
        s += u"\nDéplacements : "
        for i in self.__deplacements:
            s += i+u" / "
        s += "\nRemplacements  : "
        if self.__remplacements:
            for i in self.__remplacements:
                s += str(i).encode("iso-8859-2", "replace")+" / "                       # Modifiee 21.03.2019, ancienne ligne:   s += unicode(i).encode("iso-8859-2", "replace")+" / "
##################################################################
       
        s += "\nTexteSource : "
        #s += unicode(self.__texteSource.toxml()).encode("iso-8859-2", "replace")
        s2 =  self.__texteSource.toxml()                               # Modifie 24.09.2019, ancienne:  s2,x,y = Utile.decodage.decode_string_heuristically(self.__texteSource.toxml())
        s += s2
#	if self.__texteSource != []:
#  	  for i in self.__texteSource:
#	    s += unicode(i).encode("iso-8859-2", "replace")+" / "    
        s += "\nTexteCible : "
        s2 =  self.__texteCible.toxml()                     # Modifie 24.09.2019, ancienne:  s2,x,y = Utile.decodage.decode_string_heuristically(self.__texteCible.toxml())
        s += s2
#	s += unicode(self.__texteCible).encode("iso-8859-2", "replace")
#	if self.__texteCible != []:
#	  for i in self.__texteCible:
#	    s += unicode(i).encode("iso-8859-2", "replace")+" / "    
        sys.stderr.write(s)                                 # Modifie 24.09.2019, ancienne:  sys.stderr.write(str(s).encode("iso-8859-2", "replace"))                       # Modifiee 21.03.2019, ancienne ligne:   sys.stderr.write(unicode(s).encode("iso-8859-2", "replace")) 
        sys.stderr.flush()
        # print("8. Module: Donnees.transformations, Classe: Transformations, Methode: toString, Ligne: 97 ---> \ns=\n[", s, "] ")
