# -*- coding: UTF-8 -*-
# Copyright 2003 - 2008: Julien Bourdaillet (julien.bourdaillet@lip6.fr), Jean-Gabriel Ganascia (jean-gabriel.ganascia@lip6.fr)
# This file is part of MEDITE.
#
#    MEDITE is free software; you can redistribute it and/or modify
#    it under the terms of the GNU General Public License as published by
#    the Free Software Foundation; either version 2 of the License, or
#    (at your option) any later version.
#
#    MEDITE is distributed in the hope that it will be useful,
#    but WITHOUT ANY WARRANTY; without even the implied warranty of
#    MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
#    GNU General Public License for more details.
#
#    You should have received a copy of the GNU General Public License
#    along with Foobar; if not, write to the Free Software
#    Foundation, Inc., 51 Franklin St, Fifth Floor, Boston, MA  02110-1301  USA
#----------------------------------------------------------------------------
# Nom:          MainPanel.py
# Objet:        Classe correspondant au panel principal de l'interface medite
#----------------------------------------------------------------------------
#from wxPython.wx import *
#from wx import Panel
#from wxPython.stc import *
import wx
import wx.adv
import wx.stc
from Utile.constantesGUI import *
from GUI.Legende import *
from GUI.Parametres import *
from GUI.FormulairesMenuMedite import *         # Ajoutee 06.06.2019 
# from .Medite import *
import traceback
import GUI.FMPanel
import MediteApplication.synthetic
#from wxPython.lib.rcsizer import RowColSizer
#from wxPython.lib.grids import wxGridSizer, wxFlexGridSizer
# import __main__              # Desactive 05.02.2019 !!!, ajoute la ligne suivante: 
import __init__                      # Ajoute 14.05.2019
from __init__ import *             # Ajoute 05.02.2019, 14.05.2019 

#----------------------------------------------------------------------------

class MainPanel(wx.Notebook):
    """ Notebook gérant les différents panels autour d'une comparaison """
    def __init__(self, parent, planTravail):
        wx.Notebook.__init__(self, parent, -1)
        self.planTravail = planTravail
        compPanel = ComparaisonPanel(self, self.planTravail)
        self.InsertPage(0, compPanel, "Comparaison", True) #panel de comparaison en position 0
        #self.SetClientSize(self.GetChildren()[0].GetSize())
        #self.SetBestFittingSize(wx.Size(900, 700))
        self.Refresh() 
        # print("1. Module: GUI.MainPanel, Class: MainPanel, Methode: __init__, Ligne 54 ") 
    def getComparaisonPanel(self):
        """Renvoie le panel de comparaison """
        # print("2. Module: GUI.MainPanel, Class: MainPanel, Methode: getComparaisonPanel, Ligne 57 ")
        return self.GetPage(0)
    def isTreePanel(self):
        # print("3. Module: GUI.MainPanel, Class: MainPanel, Methode: isTreePanel, Ligne 60 ")
        return False
    def getTitre(self):
        # print("4. Module: GUI.MainPanel, Class: MainPanel, Methode: getTitre, Ligne 63 ")
        return self.getComparaisonPanel().getTitre()
    def setTitre(self, titre):        
        # print("5. Module: GUI.MainPanel, Class: MainPanel, Methode: getTitre, Ligne 66 ")
        self.getComparaisonPanel().setTitre(titre)
    def addStatPanel(self,frequencyMatrix,textMatrix):
        """ Ajoute des pages avec les panels de stat 
        pre: isinstance(frequencyMatrix,MediteAppli.Synthetic.TagFrequencyMatrix)
             isinstance(frequencyMatrix,MediteAppli.Synthetic.TextFrequencyMatrix)
        """
        fmPanelHisto = GUI.FMPanel.FMPanelHisto(self,frequencyMatrix)      # Modifie 05.02.2019, ajoute GUI.
        self.AddPage(fmPanelHisto, u"Histogrammes", True)
        
        fmPanelCam = GUI.FMPanel.FMPanelCamembert(self,frequencyMatrix)    # Modifie 05.02.2019, ajoute GUI.
        self.AddPage(fmPanelCam, u"Etiquetage", True)
        
        fm2 = MediteApplication.synthetic.TagFrequencyMatrix2(frequencyMatrix) 
        fmPanelCam2 = GUI.FMPanel.FMPanelCamembert2(self,fm2)              # Modifie 05.02.2019, ajoute GUI.
        self.AddPage(fmPanelCam2, u"Etiquetage2", True)
        
        fm3 = MediteApplication.synthetic.TagFrequencyMatrix3(frequencyMatrix)
        fmPanelCam3 = GUI.FMPanel.FMPanelCamembert3(self,fm3)              # Modifie 05.02.2019, ajoute GUI.
        self.AddPage(fmPanelCam3, u"Etiquetage3", True)
        
        fmPanelCam4 = GUI.FMPanel.FMPanelCamembert4(self,textMatrix)       # Modifie 05.02.2019, ajoute GUI.
        self.AddPage(fmPanelCam4, u"Etiquetage4", True) 
        # print("6. Module: GUI.MainPanel, Class: MainPanel, Methode: getTitre, Ligne 89 ")


class ComparaisonPanel2(wx.Panel):
    """ Classe du panel principal permettant d'afficher les informations du dossier genetique courant
    les deux fenetres des états source et cible, et les fenetres transformations et commentaire
    """
    def __init__(self, parent, planTravail):
        wx.Panel.__init__(self, parent, -1)

        self.planTravail = planTravail 
        self.initialised = False
        
        self.remainingSpace = wx.Panel(self, -1, style=wx.SUNKEN_BORDER)
        self.fenetreMedite = parent.GetParent().GetParent()
        
        w,h = self.fenetreMedite.GetSize()
        w2 = (w//2)-10                                                                   # Modifiee 24.06.2019, ancienne ligne: w2 = (w/2)-10 
        ## line = wxStaticLine(self, -1, pos = wx.Point(0,0))
        
        # Fenetre d informations du dossier genetique charge
        infoDGWin = wx.adv.SashLayoutWindow(self, ID_WINDOW_TOP, wx.DefaultPosition,
                                 wx.Size(300, 200), wx.NO_BORDER|wx.adv.SW_3DSASH)                  # Modifiee 05.06.2019, ancienne ligne:  infoDGWin = wx.SashLayoutWindow(self, ID_WINDOW_TOP, wx.DefaultPosition, wx.Size(300, 200), wx.NO_BORDER|wx.SW_3DSASH)
        infoDGWin.SetDefaultSize(wx.Size(1000, 50))
        infoDGWin.SetMinimumSizeY(50)
        infoDGWin.SetOrientation(wx.adv.LAYOUT_HORIZONTAL)                                  # Modifiee 05.06.2019, ancienne ligne:  infoDGWin.SetOrientation(wx.LAYOUT_HORIZONTAL)
        infoDGWin.SetAlignment(wx.adv.LAYOUT_TOP)                                           # Modifiee 05.06.2019, ancienne ligne:  infoDGWin.SetAlignment(wx.LAYOUT_TOP) 
        infoDGWin.SetSashVisible(wx.adv.SASH_BOTTOM, True)                                  # Modifiee 05.06.2019, ancienne ligne:  infoDGWin.SetSashVisible(wx.SASH_BOTTOM, True) 

        fe = wx.FontEnumerator()
        fe.EnumerateFacenames()
        listFont = fe.GetFacenames()
        listFont.sort()
        s1 = wx.StaticText(self, -1, "Police : ", (150, 10))
        self.lbFont = wx.ListBox(self, -1, wx.DefaultPosition, (180, 10),
                             listFont, wx.LB_SINGLE)
        self.Bind(wx.EVT_LISTBOX, self.OnSelectFont, id=self.lbFont.GetId())
        
        self.textAuteur =  wx.StaticText(infoDGWin, -1, "Auteur : ", (10, 10))
        #nomAuteur = self.fenetreMedite.planTravail.getAuteur()
        nomAuteur = self.planTravail.getAuteur()
        if nomAuteur == '': ecrireA = u"DG Non Charg\xe9"
        else: ecrireA = nomAuteur
        ##        ecrireA = "DG Non Charg\xe9"
        self.textInfoAuteur= wx.StaticText(infoDGWin, -1, ecrireA, (70, 10))

        #nomOeuvre = self.fenetreMedite.planTravail.getOeuvre()
        nomOeuvre = self.planTravail.getOeuvre()
        if nomOeuvre == '': ecrireO =  u"DG Non Charg\xe9 "
        else: ecrireO = nomOeuvre
        ##        ecrireO =  "DG Non Charg\xe9 "
        self.textOeuvre =  wx.StaticText(infoDGWin, -1, "Oeuvre : ",(w2+100, 10), (90, -1))
        self.textInfoOeuvre= wx.StaticText(infoDGWin, -1,ecrireO,(w2+170, 10))

        #nomVS = self.fenetreMedite.planTravail.getVersionSource()        
        nomVS = self.planTravail.getVersionSource()
        self.textVS = wx.StaticText(infoDGWin, -1, "VS : ",(10, 30))
        self.textInfoVersionS= wx.StaticText(infoDGWin, -1, nomVS, (35, 30))

        #nomFS = self.fenetreMedite.planTravail.getEtatSource()
        nomFS = self.planTravail.getEtatSource()
        self.textFS = wx.StaticText(infoDGWin, -1, "FS : ",(200, 30))
        self.textInfoEtatS= wx.StaticText(infoDGWin, -1, nomFS, (225, 30))

        self.indiceS = wx.TextCtrl(infoDGWin, -1, "",wx.Point(w2-50,28),wx.Size(30,18),wx.TE_READONLY)

        #nomVC = self.fenetreMedite.planTravail.getVersionCible()        
        nomVC = self.planTravail.getVersionCible()
        self.textVC = wx.StaticText(infoDGWin, -1, "VC : ",(w2+100, 30))
        self.textInfoVersionC= wx.StaticText(infoDGWin, -1, nomVC, (w2+125, 30))

        #nomFC = self.fenetreMedite.planTravail.getEtatCible()        
        nomFC = self.planTravail.getEtatCible()
        self.textFC = wx.StaticText(infoDGWin, -1, "FC : ",(w2+300, 30))
        self.textInfoEtatC= wx.StaticText(infoDGWin, -1, nomFC, (w2+325, 30))

        self.indiceC = wx.TextCtrl(infoDGWin, -1, "",wx.Point(w2+20,28),wx.Size(30,18),wx.TE_READONLY)

        infoDGWin.SetAutoLayout(True)
        self.topWindow = infoDGWin
        # print("7. Module: GUI.MainPanel, Class: ComparaisonPanel2, Methode: __init__, Ligne 169, \nself.planTravail=", str(self.planTravail), ", \nnomAuteur=", nomAuteur, ", nomOeuvre=", nomOeuvre, ", nomVS=", nomVS, ", nomFS=", nomFS, ", nomVC=", nomVC, ", nomFC=", nomFC)

        # Fenetre avec un noteBook affichant les resultats d'une comparaison
        # le commentaire, la legende
        infoResultat = wx.adv.SashLayoutWindow(self, ID_WINDOW_BOTTOM,
                                 wx.DefaultPosition, wx.Size(300, 400),
                                 wx.NO_BORDER|wx.adv.SW_3D)                         # Modifiee 17.06.2019, ancienne ligne: infoResultat = wx.SashLayoutWindow(self, ID_WINDOW_BOTTOM, wx.DefaultPosition, wx.Size(300, 200), wx.NO_BORDER|wx.SW_3D)
        infoResultat.SetDefaultSize(wx.Size(1000, 250))                              # Modifiee 17.06.2019, ancienne ligne: infoResultat.SetDefaultSize(wx.Size(1000, 200))      
        infoResultat.SetOrientation(wx.adv.LAYOUT_HORIZONTAL)                       # Modifiee 05.06.2019, ancienne ligne: infoResultat.SetOrientation(wx.LAYOUT_HORIZONTAL)
        infoResultat.SetAlignment(wx.adv.LAYOUT_BOTTOM)                             # Modifiee 05.06.2019, ancienne ligne: infoResultat.SetAlignment(wx.LAYOUT_BOTTOM) 
        infoResultat.SetSashVisible(wx.adv.SASH_TOP, True)                          # Modifiee 05.06.2019, ancienne ligne: infoResultat.SetSashVisible(wx.SASH_TOP, True) 
        
        ID_NB = 6545
        self.nb=wx.Notebook(infoResultat, ID_NB,  style=wx.NB_BOTTOM)
        self.nb.SetBestFittingSize(wx.Size(1000, 300))                          # Modifiee 17.06.2019, ancienne ligne: self.nb.SetBestFittingSize(wx.Size(1000, 200)) 
        # transfo
        self.transformations=wx.TextCtrl(self.nb, -1, "", wx.DefaultPosition, wx.DefaultSize,
                                        wx.TE_MULTILINE|wx.TE_READONLY)
        self.nb.AddPage(self.transformations,"TRANSFORMATIONS")
        # comment
        self.commentaire=wx.TextCtrl(self.nb, -1, "", wx.DefaultPosition, wx.DefaultSize,
                                        wx.TE_MULTILINE)#|wx.TE_RICH2)
        self.nb.AddPage(self.commentaire,"COMMENTAIRE")
        # legende
        self.legende = PanelLegende(self.nb, self.fenetreMedite)
        self.nb.AddPage(self.legende,"LEGENDE")
        # Parametres
        self.param = PanelParametres(self.nb, self.fenetreMedite)
        self.nb.AddPage(self.param,"PARAMETRES")
        # wx.EVT_NOTEBOOK_PAGE_CHANGING(self,ID_NB, self.OnNBPageChanging)                        # Desactivee 05.06.2019 et remplace par la ligne suivante:  
        self.Bind(wx.EVT_NOTEBOOK_PAGE_CHANGING, self.OnNBPageChanging, id=ID_NB)
        self.bottomWindow = infoResultat
        self.bottomWindow.Refresh()

        # Fenetre affichant l'état source
        winLeft =  wx.adv.SashLayoutWindow(self, ID_WINDOW_LEFT,
                                  wx.DefaultPosition, wx.Size(200, 30),
                                  wx.NO_BORDER|wx.adv.SW_3D)                        # Modifiee 05.06.2019, ancienne ligne: winLeft =  wx.SashLayoutWindow(self, ID_WINDOW_LEFT, wx.DefaultPosition, wx.Size(200, 30), wx.NO_BORDER|wx.SW_3D)
        ## w2 correspond a la largeur//2 de la fenetre Medite                         # Modifiee 24.06.2019, ancienne ligne: ## w2 correspond a la largeur/2 de la fenetre Medite  
        winLeft.SetDefaultSize(wx.Size(w2, 1000))                                    # Modifiee 17.06.2019, ancienne ligne: winLeft.SetDefaultSize(wx.Size(w2, 1000))  
        winLeft.SetOrientation(wx.adv.LAYOUT_VERTICAL)                              # Modifiee 05.06.2019, ancienne ligne: winLeft.SetOrientation(wx.LAYOUT_VERTICAL)
        winLeft.SetAlignment(wx.adv.LAYOUT_LEFT)                                    # Modifiee 05.06.2019, ancienne ligne: winLeft.SetAlignment(wx.LAYOUT_LEFT)
        winLeft.SetSashVisible(wx.adv.SASH_RIGHT, True)                             # Modifiee 05.06.2019, ancienne ligne: winLeft.SetSashVisible(wx.SASH_RIGHT, True)
        winLeft.SetExtraBorderSize(0)
        self.textWindowLeft = wx.TextCtrl(winLeft, -1, "", wx.DefaultPosition, wx.DefaultSize,
                                wx.TE_MULTILINE|wx.TE_READONLY|wx.TE_RICH2)
        self.textWindowLeft.SetValue(u"\xe9tat source")
        # wx.EVT_LEFT_DOWN(self.textWindowLeft, self.indiceBlocLeft)                              # Desactivee 05.06.2019 et remplace par la ligne suivante: 
        self.textWindowLeft.Bind(wx.EVT_LEFT_DOWN, self.indiceBlocLeft)
        #EVT_LEFT_UP(self.textWindowLeft, self.selectBlocLeft)
        self.leftWindow = winLeft

        # Fenetre affichant l'état cible
        winRight = wx.adv.SashLayoutWindow(self, ID_WINDOW_RIGHT,
                                 wx.DefaultPosition, wx.Size(200, 30),
                                 wx.NO_BORDER|wx.adv.SW_3D)                         # Modifiee 05.06.2019, ancienne ligne: winRight = wx.SashLayoutWindow(self, ID_WINDOW_RIGHT, wx.DefaultPosition, wx.Size(200, 30), wx.NO_BORDER|wx.SW_3D)
        winRight.SetDefaultSize(wx.Size(w2, 1000))                                  # Modifiee 17.06.2019, ancienne ligne: winRight.SetDefaultSize(wx.Size(w2, 1000)) 
        winRight.SetOrientation(wx.adv.LAYOUT_VERTICAL)                             # Modifiee 05.06.2019, ancienne ligne:  winRight.SetOrientation(wx.LAYOUT_VERTICAL)
        winRight.SetAlignment(wx.adv.LAYOUT_RIGHT)                                  # Modifiee 05.06.2019, ancienne ligne:  winRight.SetAlignment(wx.LAYOUT_RIGHT)
        winRight.SetSashVisible(wx.adv.SASH_LEFT, True)                             # Modifiee 05.06.2019, ancienne ligne:  winRight.SetSashVisible(wx.SASH_LEFT, True)
        winRight.SetExtraBorderSize(0)
        self.textWindowRight = wx.TextCtrl(winRight, -1, "", wx.DefaultPosition, wx.DefaultSize,
                                wx.TE_MULTILINE|wx.TE_READONLY|wx.TE_RICH2) 
        self.textWindowRight.SetValue(u"\xe9tat cible")
        # wx.EVT_LEFT_DOWN(self.textWindowRight, self.indiceBlocRight)                                    # Desactivee 05.06.2019 et remplace par la ligne suivante: 
        self.textWindowRight.Bind(wx.EVT_LEFT_DOWN, self.indiceBlocRight)
        #EVT_LEFT_UP(self.textWindowRight, self.selectBlocRight)
        self.rightWindow = winRight
                
        # wx.EVT_SASH_DRAGGED_RANGE(self, ID_WINDOW_TOP,ID_WINDOW_BOTTOM, self.OnSashDrag)                    # Desactivee 05.06.2019 et remplace par la ligne suivante: 
        self.Bind(wx.adv.EVT_SASH_DRAGGED_RANGE, self.OnSashDrag, id=ID_WINDOW_TOP)
        # wx.EVT_SIZE(self, self.OnSize)                                                                  # Desactivee 05.06.2019 et remplace par la ligne suivante: 
        self.Bind(wx.EVT_SIZE, self.OnSize)
        # print("8. Module: GUI.MainPanel, Class: ComparaisonPanel2, Methode: __init__, Ligne 242 ")
        
    def getTitre(self):
        # print("9. Module: GUI.MainPanel, Class: ComparaisonPanel2, Methode: getTitre, Ligne 245 ")
        return self.planTravail.getEtatSource()+"-"+self.planTravail.getEtatCible()
        
    def setTitre(self, titre):
        # print("10. Module: GUI.MainPanel, Class: ComparaisonPanel2, Methode: setTitre, Ligne 249, titre=", titre)
        self.SetTitle(titre)
        
    def OnSelectFont(self,event):
        face = self.lbFont.GetStringSelection()
        font = wx.Font(10, wx.DEFAULT, wx.NORMAL, wx.NORMAL, False, face)
        #self.txt.SetLabel(face)
        self.textWindowLeft.SetFont(font)
        self.textWindowRight.SetFont(font)
        self.transformations.SetFont(font)
        self.commentaire.SetFont(font)
        # print("11. Module: GUI.MainPanel, Class: ComparaisonPanel2, Methode: OnSelectFont, Ligne 260 face= %s", face, ", font= %s", font)
        
    def OnNBPageChanging(self,event):
        self.legende.bInser.SetBackgroundColour(self.legende.coulInsert)
        self.legende.bSupp.SetBackgroundColour(self.legende.coulSupp)
        self.legende.bRemp.SetBackgroundColour(self.legende.coulRemp)
        # print("12. Module: GUI.MainPanel, Class: ComparaisonPanel2, Methode: OnNBPageChanging, Ligne 266 ")
        
    #Methode qui permet de redimensionner les fenetres des �tats source et cible    
    def OnSashDrag(self, event):
        if event.GetDragStatus() == wx.adv.SASH_STATUS_OUT_OF_RANGE:                                # Modifie 05.06.2019, ancienne ligne:  if event.GetDragStatus() == wx.SASH_STATUS_OUT_OF_RANGE: 
            return
        eID = event.GetId()
        if eID == ID_WINDOW_TOP:
            self.topWindow.SetDefaultSize(wx.Size(1000, event.GetDragRect().height))
        elif eID == ID_WINDOW_LEFT:
            self.leftWindow.SetDefaultSize(wx.Size(event.GetDragRect().width, 1000))                # Modifie 17.06.2019, ancienne ligne:  self.leftWindow.SetDefaultSize(wx.Size(event.GetDragRect().width, 1000))   
        elif eID == ID_WINDOW_RIGHT :
            self.rightWindow.SetDefaultSize(wx.Size(event.GetDragRect().width, 1000))               # Modifie 17.06.2019, ancienne ligne:  self.rightWindow.SetDefaultSize(wx.Size(event.GetDragRect().width, 1000)) 
        elif eID == ID_WINDOW_BOTTOM:
            self.bottomWindow.SetDefaultSize(wx.Size(1000, event.GetDragRect().height))

        wx.adv.LayoutAlgorithm().LayoutWindow(self, self.remainingSpace)                            # Modifie 05.06.2019, ancienne ligne:  wx.LayoutAlgorithm().LayoutWindow(self, self.remainingSpace) 
        self.remainingSpace.Refresh()
        # print("13. Module: GUI.MainPanel, Class: ComparaisonPanel2, Methode: OnSashDrag, Ligne 284 ")

    # Methode qui redimensionne la fenetre
    def OnSize(self, event):
        wx.adv.LayoutAlgorithm().LayoutWindow(self) #, self.remainingSpace)                    # Modifiee 05.06.2019, ancienne ligne: wx.LayoutAlgorithm().LayoutWindow(self) #, self.remainingSpace) 
        w,h=event.GetSize()
        self.size(w)
        # print("14. Module: GUI.MainPanel, Class: ComparaisonPanel2, Methode: OnSize, Ligne 291 ")
    def sizeF(self):
        w,h=self.fenetreMedite.GetSize()
        self.size(w)
        # print("15. Module: GUI.MainPanel, Class: ComparaisonPanel2, Methode: sizeF, Ligne 295 ")
    def size(self,w):        
        width=w//2                                                                   # Modifiee 24.06.2019, ancienne ligne: width=w/2
        self.leftWindow.SetDefaultSize(wx.Size(width, 1000))                        # Modifie 17.06.2019, ancienne ligne:  self.leftWindow.SetDefaultSize(wx.Size(width, 1000)) 
        self.rightWindow.SetDefaultSize(wx.Size(w-width, 1000))                     # Modifie 17.06.2019, ancienne ligne:  self.rightWindow.SetDefaultSize(wx.Size(w-width, 1000))
        #self.indiceS.SetPosition((width-55,28))
        #self.indiceC.SetPosition((width+15,28))
        #self.textOeuvre.setPosition((w/4,10))
        #self.textInfoOeuvre.SetPosition((w/4+70,10))
        # print("16. Module: GUI.MainPanel, Class: ComparaisonPanel2, Methode: size, Ligne 304 ")
        
    # Methodes qui gere les clics dans les fenetres source et cible
    def indiceBlocRight(self,evt):
        if self.transformations.GetValue()!='':
            evt.Skip()
            wx.CallAfter(self.positionRight, evt)
        # print("17. Module: GUI.MainPanel, Class: ComparaisonPanel2, Methode: indiceBlocRight, Ligne 311 ")
        
    def indiceBlocLeft(self,evt):
        if self.transformations.GetValue()!='':
            evt.Skip()
            wx.CallAfter(self.positionLeft, evt)
        # print("18. Module: GUI.MainPanel, Class: ComparaisonPanel2, Methode: indiceBlocLeft, Ligne 317 ")

    ## Methodes qui gère les correspondances entre blocs et entre déplacements
    def positionLeft(self, evt):
        try:
            ip = self.textWindowLeft.GetInsertionPoint()
            transfo = self.resultatTransfoAffichageOnly

            depl = self.indiceSourceToPaireBlocsDepl(ip,transfo)
            # print("19. Module: GUI.MainPanel, Class: ComparaisonPanel2, Methode: positionLeft, Ligne 326, \ntransfo=", transfo, ", \ndepl=", str(depl))
            if depl != None:
                self.textWindowRight.ShowPosition(depl)
                self.textWindowLeft.ShowPosition(ip)
                return
            
            numBloc,posDansBloc = self.numeroBlocsCommunsSource(ip,transfo)
            if numBloc != None :
                self.indiceS.SetValue("%s"%(numBloc+1))
                self.indiceC.SetValue("%s"%(numBloc+1))
                indic = self.numBlocCibleToIndice(numBloc,transfo)

                #self.textWindowLeft.ShowPosition(ip)
                self.textWindowRight.ShowPosition(indic+posDansBloc)
                #self.textWindowLeft.SetSelection(ip-10,ip+10)
                #self.textWindowRight.SetSelection(indic+posDansBloc-10,indic+posDansBloc+10)
            else:
                self.indiceS.SetValue('')
                self.indiceC.SetValue('')
            # print("20. Module: GUI.MainPanel, Class: ComparaisonPanel2, Methode: positionLeft, Ligne 345, \nnumBloc= %s", numBloc, ", \nposDansBloc= %s", posDansBloc)
        except Exception as e1:                                 # Modifie 05.02.2019, ancienne ligne:  except Exception,e1: 
            sys.stderr.write(str(e1))  
            traceback.print_exc()
            sys.stderr.flush()     

    def positionRight(self, evt):
        try:
            ip = self.textWindowRight.GetInsertionPoint()
            transfo = self.resultatTransfoAffichageOnly
            depl = self.indiceCibleToPaireBlocsDepl(ip,transfo)
            # print("21. Module: GUI.MainPanel, Class: ComparaisonPanel2, Methode: positionRight, Ligne 356, \ntransfo=", transfo, ", \ndepl=", str(depl))
        
            if depl != None:
                self.textWindowLeft.ShowPosition(depl)
                #self.textWindowRight.ShowPosition(ip)
                return
        
            numBloc,posDansBloc = self.numeroBlocsCommunsCible(ip,transfo)
            if numBloc != None :
                self.indiceC.SetValue("%s"%(numBloc+1))
                self.indiceS.SetValue("%s"%(numBloc+1))
                indic = self.numBlocSourceToIndice(numBloc,transfo)
            
                #self.textWindowRight.ShowPosition(ip)
                self.textWindowLeft.ShowPosition(indic+posDansBloc)
                #self.textWindowRight.SetSelection(ip-10,ip+10)
                #self.textWindowLeft.SetSelection(indic+posDansBloc-10,indic+posDansBloc+10)
            else:
                self.indiceC.SetValue('')
                self.indiceS.SetValue('')
            # print("22. Module: GUI.MainPanel, Class: ComparaisonPanel2, Methode: positionRight, Ligne 376, \nnumBloc= %s", numBloc, ", \nposDansBloc= %s", posDansBloc)
        except Exception as e1:  # Modifie 05.02.2019, ancienne ligne:  except Exception,e1: 
            sys.stderr.write(str(e1))  
            traceback.print_exc()
            sys.stderr.flush()
    ##########################################################################       
    ## Methodes qui gere les evenements de selection dans l'une des fenetres##
    ##########################################################################


            
    def selectBlocLeft(self, evt):
        deb,fin = self.textWindowLeft.GetSelection()
        element=(deb,fin)
        if deb < fin :# and ( self.fenetreMedite.getCompPanel().resultatTransfo.isTransformation(element) or self.fenetreMedite.getCompPanel().resultatTransfo.isNonDef(element)[0]):
            self.fenetreMedite.enableMenuTransformationsLeft(evt,element)
        else :
            self.fenetreMedite.disableMenuTransformations()
        # print("23. Module: GUI.MainPanel, Class: ComparaisonPanel2, Methode: selectBlocLeft, Ligne 394, \nelement= %s", element)
            
##        #print 'select Left !!!\n'
##        #print self.resultatTransfo.getListeRemplacements()
##        if self.transformations.GetValue()!='':
##            print self.textWindowLeft.GetSelection()
##            start, end = self.textWindowLeft.GetSelection()
##            print start
##            transfo = self.resultatTransfoAffichageOnly
##            blocsDepl = transfo.getListeDeplacements()
##            textes = transfo.getTextesConcatenes()
##            #####test###################
##            #transfo.changerInsertions()
##            #s=transfo.getListeInsertions()
##            #print s
##            #############################
##            nbB = len(blocsDepl)//2
##            selec = textes[start:end]
##            #print selec
##            for X in blocsDepl[nbB:] :
##                if textes[X[0]:X[1]] == selec:
##                    print 'selection source faite'
##                    indic = X[0]-transfo.getLgSource()
##                    self.textWindowRight.ShowPosition(indic)
##                    self.textWindowLeft.ShowPosition(X[0])
##                    return
##             
    def selectBlocRight(self, evt):
        deb,fin = self.textWindowRight.GetSelection()
        element= (deb+self.fenetreMedite.getCompPanel().resultatTransfo.getLgSource(),fin+self.fenetreMedite.getCompPanel().resultatTransfo.getLgSource())        # Modifiee 19.06.2019, ancienne ligne: element= (deb+self.resultatTransfo.getLgSource(),fin+self.resultatTransfo.getLgSource())
        if deb < fin :#and (self.fenetreMedite.getCompPanel().resultatTransfo.isTransformation(element) or self.fenetreMedite.getCompPanel().resultatTransfo.isNonDef(element)[0]):
            self.fenetreMedite.enableMenuTransformationsRight(evt,element)
        else :
            self.fenetreMedite.disableMenuTransformations()
        # print("24. Module: GUI.MainPanel, Class: ComparaisonPanel2, Methode: selectBlocRight, Ligne 428, \nelement= %s", element)
##        #print 'select Right !!!\n'
##        if self.transformations.GetValue()!='':
##            start, end = self.textWindowRight.GetSelection()
##            transfo = self.resultatTransfoAffichageOnly
##            blocsDepl = transfo.getListeDeplacements()
##            textes = transfo.getTextesConcatenes()
##            lgTextS = transfo.getLgSource()
##            nbB = len(blocsDepl)//2
##            selec = textes[start+lgTextS:end+lgTextS]
##            print selec
##            lgSelect = len(selec)
##            s = start+lgTextS
##            for X in blocsDepl[0:nbB] :
##                if textes[X[0]:X[1]] == selec:
##                    print 'selection cible faite'
##                    indic = X[0]
##                    self.textWindowLeft.ShowPosition(indic)
##                    self.textWindowRight.ShowPosition(X[0]-transfo.getLgSource())
##                    return

#############################################################################################

    def initialiser(self):
        # print("25. Module: GUI.MainPanel, Class: ComparaisonPanel2, Methode: initialiser, Ligne 452 ")
        x =self.resultatTransfo

###############################################################################        

    def numeroBlocsCommunsSource(self, indice, pTransfo):
        #sys.stderr.write("indice="+str(indice)+"\n")
        n = 0
        tableau = pTransfo.getBlocsCommuns()
        # print("26. Module: GUI.MainPanel, Class: ComparaisonPanel2, Methode: numeroBlocsCommunsSource, Ligne 461, \npTransfo= %s", pTransfo, ", \ntableau= %s", tableau)
        for cple in tableau[:len(tableau)//2]:                                  # Modifiee 24.06.2019, ancienne ligne: for cple in tableau[:len(tableau)/2] : 
            #sys.stderr.write("cple="+str(cple)+"\n")
            if indice>=cple[0] and indice<cple[1]:
                return n, indice-cple[0]#-indice
            n+=1
        return None,None
        
    def numeroBlocsCommunsCible(self, indice, pTransfo):
    #    n = 0
    #    for cple in pTransfo.getBlocsCommuns() :
    #       sys.stderr.write("n="+str(n)+" / cple="+str(cple[0])+" "+str(cple[1])+" / lS="+str(pTransfo.getLgSource())+"\n")
    #       sys.stderr.flush()
    #       n+=1
        n=0
        indiceC = indice+pTransfo.getLgSource()
        tableau = pTransfo.getBlocsCommuns()
        #lgTextS = pTransfo.getLgSource()
        taille = len(tableau)//2                                             # Modifiee 24.06.2019, ancienne ligne: taille = len(tableau)/2
        # print("27. Module: GUI.MainPanel, Class: ComparaisonPanel2, Methode: numeroBlocsCommunsCible, Ligne 480, \npTransfo= %s", pTransfo, ", \ntableau= %s", tableau)
        for cple in tableau :
            if indiceC>=cple[0] and indiceC<cple[1]:
                return n-taille, indiceC-cple[0]#-lgTextS #-indiceC
            n+=1
        return None,None
        
    def numBlocSourceToIndice(self, numBloc,pTransfo):
        blocs = pTransfo.getBlocsCommuns()
        cple = blocs[numBloc]#-1]
        # print("28. Module: GUI.MainPanel, Class: ComparaisonPanel2, Methode: numBlocSourceToIndice, Ligne 490,  \npTransfo= %s", pTransfo, ", \nblocs= %s", blocs)
        return cple[0]
    
    def numBlocCibleToIndice(self, numBloc,pTransfo):
        lgTextS = pTransfo.getLgSource()
        blocs = pTransfo.getBlocsCommuns()
        taille = len(blocs)//2                                                # Modifiee 24.06.2019, ancienne ligne: taille = len(blocs)/2 
        i = numBloc+taille #-1
        
        cple = blocs[i]
        indice = cple[0]-lgTextS
        # print("29. Module: GUI.MainPanel, Class: ComparaisonPanel2, Methode: numBlocCibleToIndice, Ligne 501, \npTransfo= %s", pTransfo, ", \nlgTextS=", lgTextS, ", \nblocs= %s", blocs)
        return indice
    
    def indiceSourceToPaireBlocsDepl(self, indice, pTransfo):
        pairesBlocsDepl = pTransfo.getPairesBlocsDeplaces()
        lgTextS = pTransfo.getLgSource()
        # print("30. Module: GUI.MainPanel, Class: ComparaisonPanel2, Methode: numBlocCibleToIndice, Ligne 507, \npTransfo= %s", pTransfo, ", \npairesBlocsDepl= %s", pairesBlocsDepl, ", \nlgTextS= %s", lgTextS)
        for b1,b2 in pairesBlocsDepl:
            if (indice >= b1[0] and indice<b1[1]):
                return b2[0]-lgTextS
        
    def indiceCibleToPaireBlocsDepl(self, indice, pTransfo):
        pairesBlocsDepl = pTransfo.getPairesBlocsDeplaces()
        lgTextS = pTransfo.getLgSource()
        # print("31. Module: GUI.MainPanel, Class: ComparaisonPanel2, Methode: indiceCibleToPaireBlocsDepl, Ligne 515, \npTransfo= %s", pTransfo, ", \npairesBlocsDepl= %s", pairesBlocsDepl, ", \nlgTextS= %s", lgTextS)
        for b1,b2 in pairesBlocsDepl:
            if (indice+lgTextS >= b2[0] and indice+lgTextS<b2[1]):
                return b1[0]
                
class ComparaisonPanel(ComparaisonPanel2):
    def __init__(self, parent, planTravail):
        wx.Panel.__init__(self, parent, -1)
        self.planTravail = planTravail 
        self.initialised = False
        self.fenetreMedite = parent.GetParent().GetParent()
        
        self.remainingSpace = wx.Panel(self, -1, style=wx.SUNKEN_BORDER)
        self.Bind(wx.adv.EVT_SASH_DRAGGED_RANGE, self.OnSashDrag,
            id=ID_WINDOW_TOP, id2=ID_WINDOW_BOTTOM,)                        # Modifiee 05.06.2019, ancienne ligne:  self.Bind(wx.wx.EVT_SASH_DRAGGED_RANGE, self.OnSashDrag, id=ID_WINDOW_TOP, id2=ID_WINDOW_BOTTOM,)
        self.Bind(wx.EVT_SIZE, self.OnSize)                              # Modifiee 04.06.2019, ancienne ligne:  self.Bind(wx.wx.EVT_SIZE, self.OnSize) 
                
        w,h = self.fenetreMedite.GetSize()
        w2 = (w//2)-10                                                   # Modifiee 24.06.2019, ancienne ligne: w2 = (w/2)-10
        ## line = wxStaticLine(self, -1, pos = wx.Point(0,0))
        
        # Fenetre d informations du dossier genetique charge
        infoDGWin = wx.adv.SashLayoutWindow(self, ID_WINDOW_TOP, wx.DefaultPosition,
                                 wx.Size(300, 200), wx.NO_BORDER|wx.adv.SW_3DSASH)              # Modifiee 05.06.2019, ancienne ligne:  infoDGWin = wx.SashLayoutWindow(self, ID_WINDOW_TOP, wx.DefaultPosition, wx.Size(300, 200), wx.NO_BORDER|wx.SW_3DSASH)
        infoDGWin.SetDefaultSize(wx.Size(1000, 50)) 
        infoDGWin.SetMinimumSizeY(50)
        infoDGWin.SetOrientation(wx.adv.LAYOUT_HORIZONTAL)                                  # Modifiee 05.06.2019, ancienne ligne:  infoDGWin.SetOrientation(wx.LAYOUT_HORIZONTAL)
        infoDGWin.SetAlignment(wx.adv.LAYOUT_TOP)                                           # Modifiee 05.06.2019, ancienne ligne:  infoDGWin.SetAlignment(wx.LAYOUT_TOP)
        infoDGWin.SetSashVisible(wx.adv.SASH_BOTTOM, True)                                  # Modifiee 05.06.2019, ancienne ligne:  infoDGWin.SetSashVisible(wx.SASH_BOTTOM, True) 

        #fe = wx.FontEnumerator()
        #fe.EnumerateFacenames()
        #listFont = fe.GetFacenames()
        #listFont.sort()
        #s1 = wx.StaticText(self, -1, "Police : ", (150, 10))
        #self.lbFont = wx.ListBox(self, -1, (190, 10), (150,100), 
        #                     listFont, wx.LB_SINGLE)
        #self.Bind(wx.EVT_LISTBOX, self.OnSelectFont, id=self.lbFont.GetId())
        
        btn = wx.Button(infoDGWin, -1, "Police", (200, 6))
        self.Bind(wx.EVT_BUTTON, self.OnSelectFont, btn)                                  # Modifiee 05.06.2019, ancienne ligne:  self.Bind(wx.wx.EVT_BUTTON, self.OnSelectFont, btn)
        
        self.textAuteur =  wx.StaticText(infoDGWin, -1, "Auteur : ", (10, 10))
        #nomAuteur = self.fenetreMedite.planTravail.getAuteur()
        nomAuteur = self.planTravail.getAuteur()
        if nomAuteur == '': ecrireA = u"DG Non Charg\xe9"
        else: ecrireA = nomAuteur
        ##        ecrireA = "DG Non Charg\xe9"
        self.textInfoAuteur= wx.StaticText(infoDGWin, -1, ecrireA, (70, 10))

        #nomOeuvre = self.fenetreMedite.planTravail.getOeuvre()
        nomOeuvre = self.planTravail.getOeuvre()
        if nomOeuvre == '': ecrireO =  u"DG Non Charg\xe9 "
        else: ecrireO = nomOeuvre
        ##        ecrireO =  "DG Non Charg\xe9 "
        self.textOeuvre =  wx.StaticText(infoDGWin, -1, "Oeuvre : ",(w2+100, 10), (90, -1))
        self.textInfoOeuvre= wx.StaticText(infoDGWin, -1,ecrireO,(w2+170, 10))

        #nomVS = self.fenetreMedite.planTravail.getVersionSource()        
        nomVS = self.planTravail.getVersionSource()
        self.textVS = wx.StaticText(infoDGWin, -1, "VS : ",(10, 30))
        self.textInfoVersionS= wx.StaticText(infoDGWin, -1, nomVS, (35, 30))

        #nomFS = self.fenetreMedite.planTravail.getEtatSource()
        nomFS = self.planTravail.getEtatSource()
        self.textFS = wx.StaticText(infoDGWin, -1, "FS : ",(200, 30))
        self.textInfoEtatS= wx.StaticText(infoDGWin, -1, nomFS, (225, 30))

        self.indiceS = wx.TextCtrl(infoDGWin, -1, "",wx.Point(w2-50,28),wx.Size(30,18),wx.TE_READONLY)

        #nomVC = self.fenetreMedite.planTravail.getVersionCible()        
        nomVC = self.planTravail.getVersionCible()
        self.textVC = wx.StaticText(infoDGWin, -1, "VC : ",(w2+100, 30))
        self.textInfoVersionC= wx.StaticText(infoDGWin, -1, nomVC, (w2+125, 30))

        #nomFC = self.fenetreMedite.planTravail.getEtatCible()        
        nomFC = self.planTravail.getEtatCible()
        self.textFC = wx.StaticText(infoDGWin, -1, "FC : ",(w2+300, 30))
        self.textInfoEtatC= wx.StaticText(infoDGWin, -1, nomFC, (w2+325, 30))

        self.indiceC = wx.TextCtrl(infoDGWin, -1, "",wx.Point(w2+20,28),wx.Size(30,18),wx.TE_READONLY)

        #infoDGWin.SetAutoLayout(True)
        self.topWindow = infoDGWin
        # print("32. Module: GUI.MainPanel, Class: ComparaisonPanel, Methode: __init__, Ligne 599, \nself.planTravail=", str(self.planTravail), ", \nnomAuteur=", nomAuteur, ", nomOeuvre=", nomOeuvre, ", nomVS=", nomVS, ", nomFS=", nomFS, ", nomVC=", nomVC, ", nomFC=", nomFC)

        # Fenetre avec un noteBook affichant les resultats d'une comparaison
        # le commentaire, la legende
        infoResultat = wx.adv.SashLayoutWindow(self, ID_WINDOW_BOTTOM,
                                 wx.DefaultPosition, wx.Size(300, 200),
                                 wx.NO_BORDER|wx.adv.SW_3D)                                 # Modifiee 05.06.2019, ancienne ligne:  infoResultat = wx.SashLayoutWindow(self, ID_WINDOW_BOTTOM, wx.DefaultPosition, wx.Size(300, 200), wx.NO_BORDER|wx.SW_3D)
        infoResultat.SetDefaultSize(wx.Size(1000, 250))                                     # Modifiee 17.06.2019, ancienne ligne:  infoResultat.SetDefaultSize(wx.Size(1000, 200))
        infoResultat.SetOrientation(wx.adv.LAYOUT_HORIZONTAL)                               # Modifiee 05.06.2019, ancienne ligne:  infoResultat.SetOrientation(wx.LAYOUT_HORIZONTAL)
        infoResultat.SetAlignment(wx.adv.LAYOUT_BOTTOM)                                     # Modifiee 05.06.2019, ancienne ligne:  infoResultat.SetAlignment(wx.LAYOUT_BOTTOM) 
        infoResultat.SetSashVisible(wx.adv.SASH_TOP, True)                                  # Modifiee 05.06.2019, ancienne ligne:  infoResultat.SetSashVisible(wx.SASH_TOP, True)
        
        ID_NB = 6545
        self.nb=wx.Notebook(infoResultat, ID_NB,  style=wx.NB_BOTTOM)
        #self.nb.SetBestFittingSize(wx.Size(1000, 200))
        self.nb.SetInitialSize(wx.Size(1000, 200))
        # transfo
        options = wx.TE_MULTILINE|wx.TE_READONLY|wx.TE_RICH2
        if __init__.RTL: options |= wx.TE_RIGHT                         # Modifie 05.02.2019, 13.05.2019, ancienne ligne:  if __main__.RTL: options |= wx.TE_RIGHT
        self.transformations=wx.TextCtrl(self.nb, -1, "", wx.DefaultPosition, wx.DefaultSize,
                                        options)
        self.nb.AddPage(self.transformations,"TRANSFORMATIONS")
        # comment
        self.commentaire=wx.TextCtrl(self.nb, -1, "", wx.DefaultPosition, wx.DefaultSize,
                                        wx.TE_MULTILINE|wx.TE_RICH2)
        self.nb.AddPage(self.commentaire,"COMMENTAIRE")
        # legende
        self.legende = PanelLegende(self.nb, self.fenetreMedite)
        self.nb.AddPage(self.legende,"LEGENDE")
        # Parametres
        self.param = PanelParametres(self.nb, self.fenetreMedite)
        self.nb.AddPage(self.param,"PARAMETRES")
        # wx.EVT_NOTEBOOK_PAGE_CHANGING(self,ID_NB, self.OnNBPageChanging)                # Desactivee 05.06.2019, remplacee par la ligne suivante:
        self.Bind(wx.EVT_NOTEBOOK_PAGE_CHANGING, self.OnNBPageChanging, id=ID_NB)
        self.bottomWindow = infoResultat
        self.bottomWindow.Refresh()

        # Fenetre affichant l'état source
        winLeft =  wx.adv.SashLayoutWindow(self, ID_WINDOW_LEFT,
                                  wx.DefaultPosition, wx.Size(200, 30),
                                  wx.NO_BORDER|wx.adv.SW_3D)                        # Modifiee 05.06.2019, ancienne ligne:  winLeft =  wx.SashLayoutWindow(self, ID_WINDOW_LEFT, wx.DefaultPosition, wx.Size(200, 30), wx.NO_BORDER|wx.SW_3D)
        ## w2 correspond a la largeur//2 de la fenetre Medite
        winLeft.SetDefaultSize(wx.Size(w2, 1000))                                   # Modifiee 17.06.2019, ancienne ligne:  winLeft.SetDefaultSize(wx.Size(w2, 1000))
        winLeft.SetOrientation(wx.adv.LAYOUT_VERTICAL)                              # Modifiee 05.06.2019, ancienne ligne:  winLeft.SetOrientation(wx.LAYOUT_VERTICAL)
        winLeft.SetAlignment(wx.adv.LAYOUT_LEFT)                                    # Modifiee 05.06.2019, ancienne ligne:  winLeft.SetAlignment(wx.LAYOUT_LEFT)
        winLeft.SetSashVisible(wx.adv.SASH_RIGHT, True)                             # Modifiee 05.06.2019, ancienne ligne:   winLeft.SetSashVisible(wx.SASH_RIGHT, True)
        winLeft.SetExtraBorderSize(0)
        options = wx.TE_MULTILINE|wx.TE_READONLY|wx.TE_RICH2
        if __init__.RTL: options |= wx.TE_RIGHT                         # Modifie 05.02.2019, 13.05.2019, ancienne ligne:  if __main__.RTL: options |= wx.TE_RIGHT
        self.textWindowLeft = wx.TextCtrl(winLeft, -1, "", wx.DefaultPosition, wx.DefaultSize,
                                options)
        #self.textWindowLeft = wx.stc.StyledTextCtrl(winLeft,-1)
        #self.textWindowLeft = stylTxt(winLeft,-1) 
        #self.textWindowLeft.SetValue(u"�tat source")
        # wx.EVT_LEFT_DOWN(self.textWindowLeft, self.indiceBlocLeft)                  # Desactivee 05.06.2019, remplacee par la ligne suivante:
        self.textWindowLeft.Bind(wx.EVT_LEFT_DOWN, self.indiceBlocLeft)
        # wx.EVT_LEFT_UP(self.textWindowLeft, self.selectBlocLeft)                    # Desactivee 05.06.2019, remplacee par la ligne suivante:
        self.textWindowLeft.Bind(wx.EVT_LEFT_UP, self.selectBlocLeft)
        self.leftWindow = winLeft

        # Fenetre affichant l'�tat cible
        winRight = wx.adv.SashLayoutWindow(self, ID_WINDOW_RIGHT,
                                 wx.DefaultPosition, wx.Size(200, 30),
                                 wx.NO_BORDER|wx.adv.SW_3D)                         # Modifiee 05.06.2019, ancienne ligne:  winRight = wx.SashLayoutWindow(self, ID_WINDOW_RIGHT, wx.DefaultPosition, wx.Size(200, 30), wx.NO_BORDER|wx.SW_3D) 
        winRight.SetDefaultSize(wx.Size(w2, 1000))                                  # Modifiee 17.06.2019, ancienne ligne:  winRight.SetDefaultSize(wx.Size(w2, 1000))
        winRight.SetOrientation(wx.adv.LAYOUT_VERTICAL)                                  # Modifiee 05.06.2019, ancienne ligne:  winRight.SetOrientation(wx.LAYOUT_VERTICAL) 
        winRight.SetAlignment(wx.adv.LAYOUT_RIGHT)                                       # Modifiee 05.06.2019, ancienne ligne:  winRight.SetAlignment(wx.LAYOUT_RIGHT) 
        winRight.SetSashVisible(wx.adv.SASH_LEFT, True)                                  # Modifiee 05.06.2019, ancienne ligne:  winRight.SetSashVisible(wx.SASH_LEFT, True)
        winRight.SetExtraBorderSize(0)
        self.textWindowRight = wx.TextCtrl(winRight, -1, "", wx.DefaultPosition, wx.DefaultSize,
                                options) 
        #self.textWindowRight = stylTxt(winRight,-1) #wx.stc.StyledTextCtrl(winRight,-1)                                
        #self.textWindowRight.SetValue(u"�tat cible")
        # wx.EVT_LEFT_DOWN(self.textWindowRight, self.indiceBlocRight)                    # Desactivee 05.06.2019, remplacee par la ligne suivante:
        self.textWindowRight.Bind(wx.EVT_LEFT_DOWN, self.indiceBlocRight)
        # wx.EVT_LEFT_UP(self.textWindowRight, self.selectBlocRight)                      # Desactivee 05.06.2019, remplacee par la ligne suivante:
        self.textWindowRight.Bind(wx.EVT_LEFT_UP, self.selectBlocRight)
        self.rightWindow = winRight
        # print("33. Module: GUI.MainPanel, Class: ComparaisonPanel, Methode: __init__, Ligne 677 ")
        
    def OnSelectFont(self, evt):
        data = wx.FontData()
        data.EnableEffects(True)
        textAttribute = wx.TextAttr()
        self.textWindowRight.GetStyle(0, textAttribute)
        #data.SetInitialFont(textAttribute.GetFont())
        data.SetInitialFont(self.textWindowLeft.GetFont())
        data.SetColour(textAttribute.GetTextColour())   
        
        dlg = wx.FontDialog(self, data)
        if dlg.ShowModal() == wx.ID_OK:
            data = dlg.GetFontData()
            font = data.GetChosenFont()
            colour = data.GetColour()
            self.textWindowLeft.SetFont(font)
            self.textWindowRight.SetFont(font)
            self.transformations.SetFont(font)
            self.commentaire.SetFont(font)
            self.fenetreMedite.affichageCouleur()
        dlg.Destroy()
        # print("34. Module: GUI.MainPanel, Class: ComparaisonPanel, Methode: OnSelectFont, Ligne 699 ")
        
class stylTxt(wx.stc.StyledTextCtrl):
    def __init__(self,parent,id):
        wx.stc.StyledTextCtrl.__init__(self,parent,id)
        self.SetMarginWidth(0, 0)
        self.SetMarginWidth(1, 0)
        self.SetMarginWidth(2, 0)
        self.StyleSetSpec(0, "bold,underline" ) #dep
        self.StyleSetSpec(1, "back:#0000FF" ) #ins
        self.StyleSetSpec(2, "back:#00FF00" ) #ins
        # print("35. Module: GUI.MainPanel, Class: stylTxt, Methode: __init__, Ligne 710 ")

    def GetInsertionPoint(self):
        # print("36. Module: GUI.MainPanel, Class: stylTxt, Methode: GetInsertionPoint, Ligne 713 ")
        return self.GetCurrentPos()
        
    def ShowPosition(self,pos):
        self.GotoPos(pos)    
        # print("37. Module: GUI.MainPanel, Class: stylTxt, Methode: ShowPosition, Ligne 718 ")
    def SetValue(self,texte):
        self.SetText(texte)
        # print("38. Module: GUI.MainPanel, Class: stylTxt, Methode: SetValue, Ligne 721 ")
        
    def SetStyle(self,deb,fin,style):
        self.StartStyling(deb, 0x1f)
        self.SetStyling(fin-deb, style)
        # print("39. Module: GUI.MainPanel, Class: stylTxt, Methode: SetStyle, Ligne 726 ")
        
