# -*- coding: UTF-8 -*-
# Copyright 2003 - 2008: Julien Bourdaillet (julien.bourdaillet@lip6.fr), Jean-Gabriel Ganascia (jean-gabriel.ganascia@lip6.fr)
# This file is part of MEDITE.
#
#    MEDITE is free software; you can redistribute it and/or modify
#    it under the terms of the GNU General Public License as published by
#    the Free Software Foundation; either version 2 of the License, or
#    (at your option) any later version.
#
#    MEDITE is distributed in the hope that it will be useful,
#    but WITHOUT ANY WARRANTY; without even the implied warranty of
#    MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
#    GNU General Public License for more details.
#
#    You should have received a copy of the GNU General Public License
#    along with Foobar; if not, write to the Free Software
#    Foundation, Inc., 51 Franklin St, Fifth Floor, Boston, MA  02110-1301  USA
#----------------------------------------------------------------------------
# Nom:          MainToolBar.py
# Objet:        Classe correspondant a la barre d'outil de l'interface medite
#----------------------------------------------------------------------------

#from wx.Python.wx. import *
import wx
from wx import ITEM_NORMAL
from Utile.constantesGUI import *
import os
from datetime import datetime               # Ajouter 05.06.2019 pour debogage
#----------------------------------------------------------------------------
#Classe correspondant a la barre d'outil de l'interface medite
class MainToolBar(wx.ToolBar):
    def __init__(self, parent):
        wx.ToolBar.__init__(self, parent, -1, wx.DefaultPosition, wx.DefaultSize,wx.TB_HORIZONTAL | wx.NO_BORDER)
        self.parent=parent
        # print("self.AddTool - help: ", str(help(self.AddTool)))
        # print("wx.ToolBar.AddTool - help: ", str(help(wx.ToolBar.AddTool)))
        # print("1. Module: GUI.MainToolBar, Class: MainToolBar, Methode: __init__, Ligne 37 ---> ", datetime.now().strftime("%d/%m/%Y - %H:%M:%S"), "---------------------------") 
        # self.AddTool(ID_ADD_AUTEUR, self.__getImg('newAuteur.bmp'), shortHelpString = "Enregistrer Auteur", longHelpString = "Enregistrer un nouvel auteur")             # Desactivee 03.06.2019, remplacee par la ligne suivante:  
        self.AddTool(ID_ADD_AUTEUR, '', self.__getImg('newAuteur.bmp'), wx.NullBitmap, kind=ITEM_NORMAL, shortHelp = "Enregistrer Auteur", longHelp = "Enregistrer un nouvel auteur")           # Modifiee 03.06.2019, ancienne ligne: self.AddTool(ID_ADD_AUTEUR, self.__getImg('newAuteur.bmp'),shortHelpString = "Enregistrer Auteur", longHelpString = "Enregistrer un nouvel auteur") 
        # self.Realize()
        # print("wx.EVT_TOOL - help: ", str(help(wx.EVT_TOOL)))
        # print("self.Bind - help: ", str(help(self.Bind)))
        # print("\n---------------------------------------------------------------") 
        # wx.EVT_TOOL(self, ID_ADD_AUTEUR, self.parent.enregistrerAuteur)                                # Desactivee 03.06.2019, remplacee par la ligne suivante: 
        self.Bind(wx.EVT_TOOL, self.parent.enregistrerAuteur, id=ID_ADD_AUTEUR)
        # print("\n---------------------------------------------------------------") 
        
        # self.AddTool(ID_ADD_OEUVRE,self.__getImg('newOeuvre.bmp'),shortHelpString = "Enregistrer Oeuvre", longHelpString = "Enregistrer une nouvelle oeuvre")            # Desactivee 03.06.2019, remplacee par la ligne suivante: 
        self.AddTool(ID_ADD_OEUVRE, '', self.__getImg('newOeuvre.bmp'), wx.NullBitmap, kind=ITEM_NORMAL, shortHelp = "Enregistrer Oeuvre", longHelp = "Enregistrer une nouvelle oeuvre")
        # wx.EVT_TOOL(self, ID_ADD_OEUVRE, self.parent.enregistrerOeuvre)                                # Desactivee 03.06.2019, remplacee par la ligne suivante: 
        self.Bind(wx.EVT_TOOL, self.parent.enregistrerOeuvre, id=ID_ADD_OEUVRE)

        self.AddSeparator()
        
        # self.AddTool(ID_CHARGER_DG,self.__getImg('chargeDG.bmp'),shortHelpString = "Charger DG", longHelpString = u"Charger un dossier g\xe9n\xe9tique")                # Desactivee 03.06.2019, remplacee par la ligne suivante: 
        self.AddTool(ID_CHARGER_DG, '', self.__getImg('chargeDG.bmp'), wx.NullBitmap, kind=ITEM_NORMAL, shortHelp = "Charger DG", longHelp = u"Charger un dossier g\xe9n\xe9tique")
        # wx.EVT_TOOL(self, ID_CHARGER_DG, self.parent.chargerDG)                                        # Desactivee 03.06.2019, remplacee par la ligne suivante: 
        self.Bind(wx.EVT_TOOL, self.parent.chargerDG, id=ID_CHARGER_DG)

        self.AddSeparator()
        
        # self.AddTool(ID_SOURCE,self.__getImg('ouvrirFS.bmp'),shortHelpString = "Ouvrir Source", longHelpString = u"Ouvrir un �tat source")                            # Desactivee 03.06.2019, remplacee par la ligne suivante: 
        self.AddTool(ID_SOURCE, '', self.__getImg('ouvrirFS.bmp'), wx.NullBitmap, kind=ITEM_NORMAL, shortHelp = "Ouvrir Source", longHelp = u"Ouvrir un \xe9tat source")
        # wx.EVT_TOOL(self, ID_SOURCE, self.parent.ouvrirFicSource)                                        # Desactivee 03.06.2019, remplacee par la ligne suivante: 
        self.Bind(wx.EVT_TOOL, self.parent.ouvrirFicSource, id=ID_SOURCE)
        self.EnableTool(ID_SOURCE, False)

        # self.AddTool(ID_CIBLE,self.__getImg('ouvrirFC.bmp'),shortHelpString = "Ouvrir Cible", longHelpString = u"Ouvrir un �tat cible")                                # Desactivee 03.06.2019, remplacee par la ligne suivante: 
        self.AddTool(ID_CIBLE, '', self.__getImg('ouvrirFC.bmp'), wx.NullBitmap, kind=ITEM_NORMAL, shortHelp = "Ouvrir Cible", longHelp = u"Ouvrir un \xe9tat cible")
        # wx.EVT_TOOL(self, ID_CIBLE, self.parent.ouvrirFicCible)                                            # Desactivee 03.06.2019, remplacee par la ligne suivante: 
        self.Bind(wx.EVT_TOOL, self.parent.ouvrirFicCible, id=ID_CIBLE)
        self.EnableTool(ID_CIBLE, False)

        # self.AddTool(ID_EXECUTER,self.__getImg('executerM.bmp'),shortHelpString = "Executer Medite", longHelpString = u"Executer Medite sur les deux �tats ouverts")            # Desactivee 03.06.2019, remplacee par la ligne suivante: 
        self.AddTool(ID_EXECUTER, '', self.__getImg('executerM.bmp'), wx.NullBitmap, kind=ITEM_NORMAL, shortHelp = "Executer Medite", longHelp = u"Executer Medite sur les deux \xe9tats ouverts")
        # wx.EVT_TOOL(self, ID_EXECUTER, self.parent.executerMedite)                                        # Desactivee 03.06.2019, remplacee par la ligne suivante: 
        self.Bind(wx.EVT_TOOL, self.parent.executerMedite, id=ID_EXECUTER)
        self.EnableTool(ID_EXECUTER, False)

        # self.AddTool(ID_INIT,self.__getImg('init.bmp'),shortHelpString = "init", longHelpString = u"init")
        # wx.EVT_TOOL(self, ID_INIT, self.parent.initialiserTextes)
        #self.EnableTool(ID_INIT, False)
        
        self.Realize()
        # print("2. Module: GUI.MainToolBar, Class: MainToolBar, Methode: __init__, Ligne 85 ") 
        
    def __getImg(self,pNom):
        chem=os.path.join(REPIMG,pNom)
        # print("3. Module: GUI.MainToolBar, Class: MainToolBar, Methode: __getImg, Ligne 89, \nchem= %s", chem, ", pNom=", pNom) 
        return wx.Bitmap(chem,wx.BITMAP_TYPE_BMP)
