# -*- coding: UTF-8 -*-
# Copyright 2003 - 2008: Julien Bourdaillet (julien.bourdaillet@lip6.fr), Jean-Gabriel Ganascia (jean-gabriel.ganascia@lip6.fr)
# This file is part of MEDITE.
#
#    MEDITE is free software; you can redistribute it and/or modify
#    it under the terms of the GNU General Public License as published by
#    the Free Software Foundation; either version 2 of the License, or
#    (at your option) any later version.
#
#    MEDITE is distributed in the hope that it will be useful,
#    but WITHOUT ANY WARRANTY; without even the implied warranty of
#    MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
#    GNU General Public License for more details.
#
#    You should have received a copy of the GNU General Public License
#    along with Foobar; if not, write to the Free Software
#    Foundation, Inc., 51 Franklin St, Fifth Floor, Boston, MA  02110-1301  USA
#----------------------------------------------------------------------------
# Nom:          Medite.py
# Objet:        Classe correspondant � l'interface medite du logiciel
#----------------------------------------------------------------------------
import sys, wx, wx.html 
from wx import * 
#from wxPython.wx import *
#import Utile
from Utile.constantesDonnees import *
from Utile.constantesGUI  import *
from Utile.exceptionsDonnees import *
from Utile.decodage import *

from GUI.FormulairesMenuDossiers import *
from GUI.FormulairesMenuGenetique import *
from GUI.FormulairesMenuMedite import *
from GUI.FormulairesMenuInformations import *
from GUI.MainPanel import MainPanel
from GUI.TreePanel import TreePanel
from GUI.MainToolBar import MainToolBar

from Donnees.planTravail import *

import constantes
import MediteApplication.synthetic
from Controleurs.cMedite import *

from Controleurs.cInformations import *
from Controleurs.cTravail import *
import Controleurs.FInfoManager
import Controleurs.DGManager
import profile
import copy
import webbrowser 
import MediteApplication.synthetic
from Donnees.resultatAppli import *

#---------------------------------------------------------------------------
#Classe principale pour la creation de l'interface
class MediteFrame(wx.Frame):
    def __init__(self, parent, ID, title):
        wx.Frame.__init__(self, parent, ID, title,
                         wx.Point(30, 30),wx.Size(1200, 900),style=wx.DEFAULT_FRAME_STYLE|wx.FULL_REPAINT_ON_RESIZE)           # Modifiee 17.06.2019, ancienne ligne:  wx.Frame.__init__(self, parent, ID, title,wx.DefaultPosition, wx.Size(900, 700),style=wx.DEFAULT_FRAME_STYLE|wx.FULL_REPAINT_ON_RESIZE)
                                
        self.CreateStatusBar()
        self.SetStatusText(u'Bienvenue sur Medite')

        #Menu Dossier
        mDossier = wx.Menu()
        smNouveauDossier=wx.Menu()
        smNouveauDossier.Append(ID_ADD_AUTEUR, 'Auteur',u'Cr\xe9er un nouvel auteur.')
        smNouveauDossier.Append(ID_ADD_OEUVRE, 'Oeuvre',u'Cr\xe9er une nouvelle oeuvre.')
        mDossier.Append(ID_NOUVEAU_DOSSIER, 'Nouveau', smNouveauDossier)                # Modifiee 29.05.2019, ancienne ligne:  mDossier.AppendMenu(ID_NOUVEAU_DOSSIER, 'Nouveau', smNouveauDossier) 
        mDossier.AppendSeparator()
        smSupprimerDossier=wx.Menu()
        smSupprimerDossier.Append(ID_SUPP_AUTEUR, 'Auteur','Supprimer un auteur.')
        smSupprimerDossier.Append(ID_SUPP_OEUVRE, 'Oeuvre','Supprimer une oeuvre.')
        mDossier.Append(ID_SUPPRIMER_DOSSIER, 'Supprimer', smSupprimerDossier)      # Modifiee 29.05.2019, ancienne ligne:  mDossier.AppendMenu(ID_SUPPRIMER_DOSSIER, 'Supprimer', smSupprimerDossier)
        mDossier.AppendSeparator()
        mDossier.Append(ID_QUITTER, 'Quitter','Quitter MEDITE.')


        #Menu Genetique
        mGenetique = wx.Menu()
        mGenetique.Append(ID_CHARGER_DG, u'Charger Dossier G\xe9n\xe9tique', u'Charger le dossier g\xe9n\xe9tique sur lequel vous voulez travailler')
        mGenetique.AppendSeparator()
        smCreerGenetique=wx.Menu()
        smCreerGenetique.Append(ID_CREER_VERSION, u'Version',u'Cr\xe9er un nouveau dossier version.')
        smCreerGenetique.Append(ID_CREER_ETAT, u'Etat',u'Cr\xe9er un nouvel \xe9tat.')
        mGenetique.Append(ID_CREER_GENE, u'Cr\xe9er', smCreerGenetique)             # Modifiee 29.05.2019, ancienne ligne:  mGenetique.AppendMenu(ID_CREER_GENE, u'Cr\xe9er', smCreerGenetique) 
        mGenetique.Append(ID_IMPORTER_TEXTES, u'Importer r\xe9pertoire de textes', u'Importer un r\xe9pertoire de textes dans un dossier g\xe9n\xe9tique')
        mGenetique.AppendSeparator()
        smSupprimerGenetique=wx.Menu()
        smSupprimerGenetique.Append(ID_SUPP_VERSION, 'Version','Supprimer un dossier version.')
        smSupprimerGenetique.Append(ID_SUPP_ETAT, 'Etat',u'Supprimer un \xe9tat.')
        mGenetique.Append(ID_SUPPRIMER_GENE, u'Supprimer', smSupprimerGenetique)        # Modifiee 29.05.2019, ancienne ligne:  mGenetique.AppendMenu(ID_SUPPRIMER_GENE, u'Supprimer', smSupprimerGenetique) 

        #Menu Informations
        self.mInformations = wx.Menu()
        self.mInformations.Append(ID_CHARGER_INFOS, 'Charger Informations', u'Charger les informations concernant deux \xe9tats')
        self.mInformations.Enable(ID_CHARGER_INFOS,False)
#        self.smInformations=wx.Menu()
#        self.smInformations.Append(ID_INFOS_DG, u'Dossier G\xe9n\xe9tique',u'Informe des tansformations enregistr\xe9es pour le dossier g\xe9n\xe9tique charg\xe9.')
#        self.smInformations.Append(ID_INFOS_CPLE, 'Etats',u'Informe des transformations enregistr\xe9es pour le couple d\'�tats charg\xe9s.')
#        self.mInformations.AppendMenu(ID_INFOS, 'Informations', self.smInformations)
        self.mInformations.AppendSeparator()
        self.smEnregistrer=wx.Menu()
        self.smEnregistrer.Append(ID_ADD_TRANSFOS, 'Transformations',u'Enregistrer les transformations de deux \xe9tats.')
        self.smEnregistrer.Enable(ID_ADD_TRANSFOS,False)
        self.smEnregistrer.Append(ID_ADD_COMMENT, 'Commentaire',u'Enregistrer le commentaire de deux \xe9tats.')
        self.smEnregistrer.Enable(ID_ADD_COMMENT,False)
        self.smEnregistrer.Append(ID_ADD_TRANSFOS_COMMENT, 'Transformations et Commentaire',u'Enregistrer les transformations et le commentaire de deux \xe9tats.')
        self.smEnregistrer.Enable(ID_ADD_TRANSFOS_COMMENT,False)
        self.smEnregistrer.AppendSeparator()
        self.smEnregistrer.Append(ID_ADD_ALL_TRANSFOS, 'Toutes les Transformations et Commentaires', u'Enregistrer les transformations et commentaires de toutes les comparaisons')
        self.mInformations.Append(ID_ENREGISTRER, 'Enregistrer', self.smEnregistrer)        # Modifiee 29.05.2019, ancienne ligne:  self.mInformations.AppendMenu(ID_ENREGISTRER, 'Enregistrer', self.smEnregistrer)
        self.mInformations.AppendSeparator()
        self.smSupprimerInformations=wx.Menu()
        self.smSupprimerInformations.Append(ID_SUPP_TRANSFOS_COMMENT, 'Informations',u"Supprimer les transformations et le commentaire d\'un couple d\'\xe9tats")
        self.smSupprimerInformations.Append(ID_SUPP_COMMENT, 'Commentaire','Supprimer un commentaire.')
        self.smSupprimerInformations.AppendSeparator()
        self.smSupprimerInformations.Append(ID_SUPP_ALL_TRANSFOS, 'Supprimer toutes les transformations et commentaires',u'Supprimer les transformations et commentaires de toutes les comparaisons')
        self.mInformations.Append(ID_SUPPRIMER_INFOS, 'Supprimer', self.smSupprimerInformations)        # Modifiee 29.05.2019, ancienne ligne:  self.mInformations.AppendMenu(ID_SUPPRIMER_INFOS, 'Supprimer', self.smSupprimerInformations)
        self.mInformations.AppendSeparator()
        self.smChargerInformations=wx.Menu()
        self.smChargerInformations.Append(ID_LOAD_ALL_TRANSFOS_COMMENT, 'Informations',u'Charger les transformations et commentaires de toutes les comparaisons enregistr\xe9es')
        self.mInformations.Append(ID_LOAD_INFOS, 'Charger', self.smChargerInformations)         # Modifiee 29.05.2019, ancienne ligne:  self.mInformations.AppendMenu(ID_LOAD_INFOS, 'Charger', self.smChargerInformations) 

        #Menu Medite
        self.mMedite = wx.Menu()
        self.smOuvrir=wx.Menu()
        self.smOuvrir.Append(ID_SOURCE, 'Etat Source',u'Ouvrir un \xe9tat source.')
        self.smOuvrir.Enable(ID_SOURCE, False)
        self.smOuvrir.Append(ID_CIBLE, 'Etat Cible',u'Ouvrir un \xe9tat cible.')
        self.smOuvrir.Enable(ID_CIBLE, False)
        self.mMedite.Append(ID_OUVRIR, 'Ouvrir', self.smOuvrir)                         # Modifiee 29.05.2019, ancienne ligne:  self.mMedite.AppendMenu(ID_OUVRIR, 'Ouvrir', self.smOuvrir) 
        self.mMedite.AppendSeparator()
        self.mMedite.Append(ID_EXECUTER, u'Ex\xe9cuter Medite', u'Appliquer Medite sur les deux \xe9tats charg\xe9s')
        self.mMedite.Enable(ID_EXECUTER, False)
        self.mMedite.AppendSeparator()
        self.mMedite.Append(ID_EXECUTERALL, u'Ex\xe9cuter toutes les Comparaisons', u"Ex\xe9cute toutes les comparaisons entre les \xe9tats de l\'arbre des versions.")
        self.mMedite.Enable(ID_EXECUTERALL, False)
        self.mMedite.AppendSeparator()
        self.mMedite.Append(ID_LAUNCH_STAT, u'Etiquetage', u"Lancer l'\xe9tiquetage morpho-syntaxique.")
        self.mMedite.Enable(ID_LAUNCH_STAT, True)
        
        # Menu Comparaison
        self.mComparaison = wx.Menu()
        self.mComparaison.Append(ID_NEWCOMP,"Nouvelle Comparaison","Ouvre un nouvel onglet de comparaison")
#       self.mComparaison.AppendSeparator()
#       self.mComparaison.Append(ID_CLOSECOMP,"Ferme Comparaison",u"Ferme l'onglet de la comparaison courante mais ne supprime pas les �ventuelles informations enregistr�es")
#       self.mComparaison.Append(ID_CLOSEALLCOMP,"Ferme toutes les Comparaison",u"Ferme les onglets de toutes comparaisons mais ne supprime pas les �ventuelles informations enregistr�es")
        self.mComparaison.AppendSeparator()     
        self.mComparaison.Append(ID_DELCOMP,"Supprime Comparaison",u"Supprime la comparaison courante et ses \xe9ventuelles informations enregistr\xe9es")
        self.mComparaison.Append(ID_DELALLCOMP,"Supprime toutes les Comparaisons",u"Supprime toutes les comparaisons et leurs \xe9ventuelles informations enregistr\xe9es")

###################################################################################################
        #Menu TRANSFORMATIONS
        self.mTransformations = wx.Menu()
        
        self.mTransformations.Append(ID_INSERTION_MAN,'Insertion')
        self.mTransformations.Append(ID_SUPPRESSION_MAN,'Suppression')
        self.mRemplacements = wx.Menu()
        self.mRemplacements.Append(ID_REMPLACEMENT_MAN_SOURCE,'Bloc source')
        self.mRemplacements.Append(ID_REMPLACEMENT_MAN_CIBLE,'Bloc cible')
        self.mTransformations.Append(ID_REMPLACEMENT_MAN,'Remplacement',self.mRemplacements)                # Modifiee 29.05.2019, ancienne ligne:  self.mTransformations.AppendMenu(ID_REMPLACEMENT_MAN,'Remplacement',self.mRemplacements) 
        self.mDeplacements=wx.Menu()
        self.mDeplacements.Append(ID_DEPLACEMENT_MAN_SOURCE,'Bloc source')
        self.mDeplacements.Append(ID_DEPLACEMENT_MAN_CIBLE,'Bloc cible')
        self.mTransformations.Append(ID_DEPLACEMENT_MAN,'Deplacement',self.mDeplacements)               # Modifiee 29.05.2019, ancienne ligne:  self.mTransformations.AppendMenu(ID_DEPLACEMENT_MAN,'Deplacement',self.mDeplacements)
        self.mBlocsCommuns=wx.Menu()
        self.mBlocsCommuns.Append(ID_BLOC_COMMUN_SOURCE,'Bloc source')
        self.mBlocsCommuns.Append(ID_BLOC_COMMUN_CIBLE,'Bloc cible')
        self.mTransformations.Append(ID_BLOC_COMMUN,'Bloc commun',self.mBlocsCommuns)                   # Modifiee 29.05.2019, ancienne ligne:  self.mTransformations.AppendMenu(ID_BLOC_COMMUN,'Bloc commun',self.mBlocsCommuns) 
        self.mTransformations.Append(ID_NON_DEF,'Non defini')
        # self.mTransformations.AppendSeparator()
        # self.mSupprimerTransfo = wx.Menu()
        # self.mSupprimerTransfo.Append(ID_SUPP_INS,'Insertions')
        # self.mSupprimerTransfo.Append(ID_SUPP_SUPP,'Suppressions')
        # self.mSupprimerTransfo.Append(ID_SUPP_REMP,'Remplacements')
        # self.mSupprimerTransfo.Append(ID_SUPP_DEP,'Deplacements')
        # self.mSupprimerTransfo.Append(ID_SUPP_BLOC,'Blocs Communs')
        # self.mSupprimerTransfo.AppendSeparator()
        # self.mSupprimerTransfo.Append(ID_SUPP_ALL,'Toutes les Transformations')
        # self.mTransformations.AppendMenu(ID_SUPP_TRANSFO,'Supprimer',self.mSupprimerTransfo)

        #self.mEdit = wx.Menu()
        self.mEdit = wx.Menu()
        self.mEdit.Append(ID_UNDO,'Annuler')
        self.mEdit.Append(ID_REDO,u'R\xe9p\xe9ter')
        self.mEdit.AppendSeparator()
        
#####################################################################################################
        
        # menu navigation
        self.mNavigation = wx.Menu()
        
        #Menu Aide
        mAide = wx.Menu()
        if wx.Platform == '__WXMSW__': 
                mAide.Append(ID_AIDE, 'Aide', 'Aide')
        mAide.Append(ID_APROPOS, 'A Propos de ...', 'A propos de ...')


        # Creation d'une barre de menu
        self.menu_bar = wx.MenuBar()
        #
        self.menu_bar.Append(mDossier, 'Dossier ')
        self.menu_bar.Append(mGenetique, u'G\xe9n\xe9tique')
        self.menu_bar.Append(self.mInformations, 'Informations')
        self.menu_bar.Append(self.mMedite, 'Medite')
        self.menu_bar.Append(self.mComparaison, 'Comparaison')
        self.menu_bar.Append(self.mEdit,'Edit')
        self.menu_bar.Append(self.mTransformations,'Transformations')
        self.menu_bar.Append(self.mNavigation, 'Navigation')
        self.menu_bar.Append(mAide, 'Aide')

        # set the menu bar (dit au systeme que c'est fait)
        self.SetMenuBar(self.menu_bar)

        #Creation de toolbar
        self.tb = MainToolBar(self)
        self.SetToolBar(self.tb)

        #Creation des instances des controleurs
        #self.cdon = CDonnees()
        #self.cdos = CDossierGenetique()
        self.cmed = CMedite()
        self.cinfos = CInformations()
        self.ctravail = CTravail()
        self.dgm = Controleurs.DGManager.DGManager()
        
        #Evenements sur Menu
###########################################################################
        
        
        # wx.EVT_MENU(self,ID_INSERTION_MAN,self.ajouterInsertion)                                    # Desactivee 03.06.2019, remplacee par la ligne suivante:
        self.Bind(wx.EVT_MENU, self.ajouterInsertion, id=ID_INSERTION_MAN)                          
        # wx.EVT_MENU(self,ID_SUPPRESSION_MAN,self.ajouterSuppression)                                    # Desactivee 03.06.2019, remplacee par la ligne suivante:
        self.Bind(wx.EVT_MENU, self.ajouterSuppression, id=ID_SUPPRESSION_MAN)
        # wx.EVT_MENU(self,ID_DEPLACEMENT_MAN_SOURCE,self.ajouterDeplacementL)                        # Desactivee 03.06.2019, remplacee par la ligne suivante: 
        self.Bind(wx.EVT_MENU, self.ajouterDeplacementL, id=ID_DEPLACEMENT_MAN_SOURCE)
        # wx.EVT_MENU(self,ID_DEPLACEMENT_MAN_CIBLE,self.ajouterDeplacementR)                         # Desactivee 03.06.2019, remplacee par la ligne suivante: 
        self.Bind(wx.EVT_MENU, self.ajouterDeplacementR, id=ID_DEPLACEMENT_MAN_CIBLE)
        # wx.EVT_MENU(self,ID_REMPLACEMENT_MAN_SOURCE,self.ajouterRemplacementL)                      # Desactivee 03.06.2019, remplacee par la ligne suivante: 
        self.Bind(wx.EVT_MENU, self.ajouterRemplacementL, id=ID_REMPLACEMENT_MAN_SOURCE)
        # wx.EVT_MENU(self,ID_REMPLACEMENT_MAN_CIBLE,self.ajouterRemplacementR)                       # Desactivee 03.06.2019, remplacee par la ligne suivante: 
        self.Bind(wx.EVT_MENU, self.ajouterRemplacementR, id=ID_REMPLACEMENT_MAN_CIBLE)
        # wx.EVT_MENU(self,ID_BLOC_COMMUN_SOURCE,self.ajouterBlocCommunL)                             # Desactivee 03.06.2019, remplacee par la ligne suivante: 
        self.Bind(wx.EVT_MENU, self.ajouterBlocCommunL, id=ID_BLOC_COMMUN_SOURCE)
        # wx.EVT_MENU(self,ID_BLOC_COMMUN_CIBLE,self.ajouterBlocCommunR)                              # Desactivee 03.06.2019, remplacee par la ligne suivante: 
        self.Bind(wx.EVT_MENU, self.ajouterBlocCommunR, id=ID_BLOC_COMMUN_CIBLE)
        # wx.EVT_MENU(self,ID_NON_DEF,self.ajouterNonDefini)                                          # Desactivee 03.06.2019, remplacee par la ligne suivante: 
        self.Bind(wx.EVT_MENU, self.ajouterNonDefini, id=ID_NON_DEF)

        # wx.EVT_MENU(self,ID_SUPP_INS,self.SupprimerInsertions)
        # wx.EVT_MENU(self,ID_SUPP_SUPP,self.SupprimerSuppressions)
        # wx.EVT_MENU(self,ID_SUPP_REMP,self.SupprimerRemplacements)
        # wx.EVT_MENU(self,ID_SUPP_DEP,self.SupprimerDeplacements)
        # wx.EVT_MENU(self,ID_SUPP_BLOC,self.SupprimerBlocsCommuns)
        # wx.EVT_MENU(self,ID_SUPP_ALL,self.SupprimerToutesTranformations)

        # wx.EVT_MENU(self,ID_UNDO,self.undo)                                                         # Desactivee 04.06.2019, remplacee par la ligne suivante: 
        self.Bind(wx.EVT_MENU, self.undo, id=ID_UNDO)
        # wx.EVT_MENU(self,ID_REDO,self.redo)                                                         # Desactivee 04.06.2019, remplacee par la ligne suivante: 
        self.Bind(wx.EVT_MENU, self.redo, id=ID_REDO)
        
##########################################################################
        # wx.EVT_MENU(self, ID_ADD_AUTEUR, self.enregistrerAuteur)                                    # Desactivee 04.06.2019, remplacee par la ligne suivante: 
        self.Bind(wx.EVT_MENU, self.enregistrerAuteur, id=ID_ADD_AUTEUR)
        # wx.EVT_MENU(self, ID_ADD_OEUVRE, self.enregistrerOeuvre)                                    # Desactivee 04.06.2019, remplacee par la ligne suivante: 
        self.Bind(wx.EVT_MENU, self.enregistrerOeuvre, id=ID_ADD_OEUVRE)
        # wx.EVT_MENU(self, ID_SUPP_AUTEUR, self.supprimerAuteur)                                     # Desactivee 04.06.2019, remplacee par la ligne suivante: 
        self.Bind(wx.EVT_MENU, self.supprimerAuteur, id=ID_SUPP_AUTEUR)
        # wx.EVT_MENU(self, ID_SUPP_OEUVRE, self.supprimerOeuvre)                                     # Desactivee 04.06.2019, remplacee par la ligne suivante: 
        self.Bind(wx.EVT_MENU, self.supprimerOeuvre, id=ID_SUPP_OEUVRE)
        # wx.EVT_MENU(self, ID_QUITTER, self.quitter)                                                 # Desactivee 04.06.2019, remplacee par la ligne suivante: 
        self.Bind(wx.EVT_MENU, self.quitter, id=ID_QUITTER)
        # wx.EVT_CLOSE(self, self.OnCloseWindow)                                                      # Desactivee 04.06.2019, remplacee par la ligne suivante: 
        self.Bind(wx.EVT_CLOSE, self.OnCloseWindow)


        # wx.EVT_MENU(self, ID_CHARGER_DG, self.chargerDG)                                            # Desactivee 04.06.2019, remplacee par la ligne suivante: 
        self.Bind(wx.EVT_MENU, self.chargerDG, id=ID_CHARGER_DG)
        # wx.EVT_MENU(self, ID_CREER_VERSION, self.creerDossierVersion)                               # Desactivee 04.06.2019, remplacee par la ligne suivante: 
        self.Bind(wx.EVT_MENU, self.creerDossierVersion, id=ID_CREER_VERSION)
        # wx.EVT_MENU(self, ID_CREER_ETAT, self.creerEtat)                                            # Desactivee 04.06.2019, remplacee par la ligne suivante: 
        self.Bind(wx.EVT_MENU, self.creerEtat, id=ID_CREER_ETAT)
        # wx.EVT_MENU(self, ID_SUPP_VERSION, self.supprimerDossierVersion)                             # Desactivee 04.06.2019, remplacee par la ligne suivante: 
        self.Bind(wx.EVT_MENU, self.supprimerDossierVersion, id=ID_SUPP_VERSION)
        # wx.EVT_MENU(self, ID_SUPP_ETAT, self.supprimerEtat)                                         # Desactivee 04.06.2019, remplacee par la ligne suivante: 
        self.Bind(wx.EVT_MENU, self.supprimerEtat, id=ID_SUPP_ETAT)
        # wx.EVT_MENU(self, ID_IMPORTER_TEXTES, self.importerRepertoire)                              # Desactivee 04.06.2019, remplacee par la ligne suivante: 
        self.Bind(wx.EVT_MENU, self.importerRepertoire, id=ID_IMPORTER_TEXTES)
        # wx.EVT_MENU(self, ID_CHARGER_INFOS, self.chargerInformations)                               # Desactivee 04.06.2019, remplacee par la ligne suivante: 
        self.Bind(wx.EVT_MENU, self.chargerInformations, id=ID_CHARGER_INFOS)
#        wx.EVT_MENU(self, ID_INFOS_DG, self.chargerInfosDG)
#        wx.EVT_MENU(self, ID_INFOS_CPLE, self.chargerInfosCple)
        # wx.EVT_MENU(self, ID_ADD_TRANSFOS, self.enregistrerTransformations)                         # Desactivee 04.06.2019, remplacee par la ligne suivante: 
        self.Bind(wx.EVT_MENU, self.enregistrerTransformations, id=ID_ADD_TRANSFOS)
        # wx.EVT_MENU(self, ID_ADD_COMMENT, self.enregistrerCommentaire)                              # Desactivee 04.06.2019, remplacee par la ligne suivante: 
        self.Bind(wx.EVT_MENU, self.enregistrerCommentaire, id=ID_ADD_COMMENT)
        # wx.EVT_MENU(self, ID_ADD_TRANSFOS_COMMENT, self.enregistrerInformations)                    # Desactivee 04.06.2019, remplacee par la ligne suivante: 
        self.Bind(wx.EVT_MENU, self.enregistrerInformations, id=ID_ADD_TRANSFOS_COMMENT)
        # wx.EVT_MENU(self, ID_ADD_ALL_TRANSFOS, self.enregistrerToutesInformations)                  # Desactivee 04.06.2019, remplacee par la ligne suivante: 
        self.Bind(wx.EVT_MENU, self.enregistrerToutesInformations, id=ID_ADD_ALL_TRANSFOS)
        # wx.EVT_MENU(self, ID_SUPP_TRANSFOS_COMMENT, self.supprimerInformations)                     # Desactivee 04.06.2019, remplacee par la ligne suivante: 
        self.Bind(wx.EVT_MENU, self.supprimerInformations, id=ID_SUPP_TRANSFOS_COMMENT)
        # wx.EVT_MENU(self, ID_SUPP_COMMENT, self.supprimerCommentaire)                               # Desactivee 04.06.2019, remplacee par la ligne suivante: 
        self.Bind(wx.EVT_MENU, self.supprimerCommentaire, id=ID_SUPP_COMMENT)
        # wx.EVT_MENU(self, ID_SUPP_ALL_TRANSFOS, self.supprimerToutesInformations)                   # Desactivee 04.06.2019, remplacee par la ligne suivante: 
        self.Bind(wx.EVT_MENU, self.supprimerToutesInformations, id=ID_SUPP_ALL_TRANSFOS)
        # wx.EVT_MENU(self, ID_LOAD_ALL_TRANSFOS_COMMENT, self.chargerInfosEtats)                     # Desactivee 04.06.2019, remplacee par la ligne suivante: 
        self.Bind(wx.EVT_MENU, self.chargerInfosEtats, id=ID_LOAD_ALL_TRANSFOS_COMMENT)


        # wx.EVT_MENU(self, ID_EXECUTER, self.executerMedite)                                         # Desactivee 04.06.2019, remplacee par la ligne suivante: 
        self.Bind(wx.EVT_MENU, self.executerMedite, id=ID_EXECUTER)
        # wx.EVT_MENU(self, ID_EXECUTERALL, self.executerAll)                                         # Desactivee 04.06.2019, remplacee par la ligne suivante: 
        self.Bind(wx.EVT_MENU, self.executerAll, id=ID_EXECUTERALL)
        # wx.EVT_MENU(self, ID_SOURCE, self.ouvrirFicSource)                                          # Desactivee 04.06.2019, remplacee par la ligne suivante: 
        self.Bind(wx.EVT_MENU, self.ouvrirFicSource, id=ID_SOURCE)
        # wx.EVT_MENU(self, ID_CIBLE, self.ouvrirFicCible)                                            # Desactivee 04.06.2019, remplacee par la ligne suivante: 
        self.Bind(wx.EVT_MENU, self.ouvrirFicCible, id=ID_CIBLE)
        # wx.EVT_MENU(self, ID_LAUNCH_STAT, self.launchTagger)                                        # Desactivee 04.06.2019, remplacee par la ligne suivante: 
        self.Bind(wx.EVT_MENU, self.launchTagger, id=ID_LAUNCH_STAT)
        
        # wx.EVT_MENU(self, ID_NEWCOMP, self.nouvelleComparaison)                                     # Desactivee 04.06.2019, remplacee par la ligne suivante: 
        self.Bind(wx.EVT_MENU, self.nouvelleComparaison, id=ID_NEWCOMP)
#       wx.EVT_MENU(self, ID_CLOSECOMP, self.fermeComparaison)
#       wx.EVT_MENU(self, ID_CLOSEALLCOMP, self.fermeToutesComparaisons)
        # wx.EVT_MENU(self, ID_DELCOMP, self.supprimeComparaison)                                     # Desactivee 04.06.2019, remplacee par la ligne suivante: 
        self.Bind(wx.EVT_MENU, self.supprimeComparaison, id=ID_DELCOMP)
        # wx.EVT_MENU(self, ID_DELALLCOMP, self.supprimeToutesComparaisons)                           # Desactivee 04.06.2019, remplacee par la ligne suivante: 
        self.Bind(wx.EVT_MENU, self.supprimeToutesComparaisons, id=ID_DELALLCOMP)
        # wx.EVT_MENU(self, ID_AIDE, self.aide)                                                       # Desactivee 04.06.2019, remplacee par la ligne suivante: 
        self.Bind(wx.EVT_MENU, self.aide, id=ID_AIDE)
        # wx.EVT_MENU(self, ID_APROPOS, self.aPropos)                                                 # Desactivee 04.06.2019, remplacee par la ligne suivante: 
        self.Bind(wx.EVT_MENU, self.aPropos, id=ID_APROPOS)


        ## Mise en place du plan de travail et des parametres (lissage, couleurs)
##        self.parDefaut()
        #self.miseEnPlacePlanTravailTOTAL()
        self.miseEnPlaceParametres()

        # Facade Panel principal
        self.nb = wx.Notebook(self)
        #self.nb.SetSize(size=wx.Size(900, 700))
        self.Bind(wx.EVT_NOTEBOOK_PAGE_CHANGED, self.OnNBPageChanged, self.nb)
        #win = wx.Window(self.nb)
        self.createTreePanel()
        # ok
#       panelAnonyme=MainPanel(self.nb)
#       p2=MainPanel(self.nb)
#       self.nb.AddPage(panelAnonyme,"Comparaison")
#       self.nb.AddPage(p2,"Comparaison2")
        
        #self.panelMain = win.panelMain
        
        #self.sizer = wx.FlexGridSizer()#(wx.VERTICAL)
        #self.sizer.Add(self.nb)
        #self.SetSizer(self.sizer)                         
        #self.SetAutoLayout(True) 
        #self.Bind(wx.EVT_SIZE, self.OnSize)

##############################################################################################

        self.procedureDeplacement= False
        self.procedureRemplacement = False
        self.procedureBlocCommun = False
        # print("1. Module: GUI.Medite, Class: MediteFrame, Methode: __init__, Ligne 369 ")

#############################################################################################

        ###########################################################################
        ###SELECTION TEXT
        ###########################################################################


    ########################test##############
    
    def enableMenuTransformationsLeft(self,evt,element):
        res=self.getCompPanel().resultatTransfo
        self.mTransformations.Enable(ID_INSERTION_MAN,False)
        
        self.mDeplacements.Enable(ID_DEPLACEMENT_MAN_SOURCE,True)
        self.mRemplacements.Enable(ID_REMPLACEMENT_MAN_SOURCE,True)
        self.mBlocsCommuns.Enable(ID_BLOC_COMMUN_SOURCE,True)
        self.mDeplacements.Enable(ID_DEPLACEMENT_MAN_CIBLE,False)
        self.mRemplacements.Enable(ID_REMPLACEMENT_MAN_CIBLE,False)
        self.mBlocsCommuns.Enable(ID_BLOC_COMMUN_CIBLE,False)
        
##        if res.isNonDef(element)[0]:
##            self.mTransformations.Enable(ID_NON_DEF,False)
##            self.mTransformations.Enable(ID_SUPPRESSION_MAN,True)
##            self.mTransformations.Enable(ID_DEPLACEMENT_MAN,True)
##            self.mTransformations.Enable(ID_REMPLACEMENT_MAN,True)
##            self.mTransformations.Enable(ID_BLOC_COMMUN,True)
##        else :
##            self.mTransformations.Enable(ID_NON_DEF,True)
##            self.mTransformations.Enable(ID_SUPPRESSION_MAN,False)
##            self.mTransformations.Enable(ID_DEPLACEMENT_MAN,False)
##            self.mTransformations.Enable(ID_REMPLACEMENT_MAN,False)
##            self.mTransformations.Enable(ID_BLOC_COMMUN,False)
 
        # if not res.isSuppression(element)[0]:
        self.mTransformations.Enable(ID_SUPPRESSION_MAN,True)
        # else :
            # self.mTransformations.Enable(ID_SUPPRESSION_MAN,False)

        # if not res.isDeplacement(element)[0] :
        self.mTransformations.Enable(ID_DEPLACEMENT_MAN,True)
        # else :
            # self.mTransformations.Enable(ID_DEPLACEMENT_MAN,False)

        # if not res.isRemplacement(element)[0]:
        self.mTransformations.Enable(ID_REMPLACEMENT_MAN,True)
        # else :
            # self.mTransformations.Enable(ID_REMPLACEMENT_MAN,False)

        # if not res.isBlocCommun(element)[0]:
        self.mTransformations.Enable(ID_BLOC_COMMUN,True)
        # else :
            # self.mTransformations.Enable(ID_BLOC_COMMUN,False)

        # if res.isNonDef(element)[0]:
        # self.mTransformations.Enable(ID_NON_DEF,False)
        # else :
        self.mTransformations.Enable(ID_NON_DEF,True)
        
        # self.menu_bar.EnableTop(5, True)
        # print("2. Module: GUI.Medite, Class: MediteFrame, Methode: enableMenuTransformationsLeft, Ligne 430, \nres= %s", res)
        
    def enableMenuTransformationsRight(self,evt,element):
        
        res=self.getCompPanel().resultatTransfo
        self.mTransformations.Enable(ID_SUPPRESSION_MAN,False)        
        self.mTransformations.Enable(ID_INSERTION_MAN,True)
        self.mDeplacements.Enable(ID_DEPLACEMENT_MAN_SOURCE,False)
        self.mRemplacements.Enable(ID_REMPLACEMENT_MAN_SOURCE,False)
        self.mBlocsCommuns.Enable(ID_BLOC_COMMUN_SOURCE,False)

        if self.procedureDeplacement :
            self.mTransformations.Enable(ID_DEPLACEMENT_MAN,True)
            self.mDeplacements.Enable(ID_DEPLACEMENT_MAN_CIBLE,True)
        else :
            self.mDeplacements.Enable(ID_DEPLACEMENT_MAN_CIBLE,False)

        if self.procedureRemplacement :
            self.mTransformations.Enable(ID_REMPLACEMENT_MAN,True)
            self.mRemplacements.Enable(ID_REMPLACEMENT_MAN_CIBLE,True)
        else :
            self.mRemplacements.Enable(ID_REMPLACEMENT_MAN_CIBLE,False)
        if self.procedureBlocCommun :
            self.mTransformations.Enable(ID_BLOC_COMMUN,True)
            self.mBlocsCommuns.Enable(ID_BLOC_COMMUN_CIBLE,True)     
        else:
            self.mBlocsCommuns.Enable(ID_BLOC_COMMUN_CIBLE,False)

        self.mTransformations.Enable(ID_NON_DEF,True)
        # print("3. Module: GUI.Medite, Class: MediteFrame, Methode: enableMenuTransformationsRight, Ligne 459, \nres= %s", res)
            
##        if res.isNonDef(element)[0]:
##            self.mTransformations.Enable(ID_NON_DEF,False)
##            self.mTransformations.Enable(ID_INSERTION_MAN,True)
##            self.mTransformations.Enable(ID_DEPLACEMENT_MAN,True)
##            self.mTransformations.Enable(ID_REMPLACEMENT_MAN,True)
##            self.mTransformations.Enable(ID_BLOC_COMMUN,True)
##        else :
##            self.mTransformations.Enable(ID_NON_DEF,True)
##            self.mTransformations.Enable(ID_INSERTION_MAN,False)
##            self.mTransformations.Enable(ID_DEPLACEMENT_MAN,False)
##            self.mTransformations.Enable(ID_REMPLACEMENT_MAN,False)
##            self.mTransformations.Enable(ID_BLOC_COMMUN,False)
##        if not res.isInsertion(element)[0]:
##            self.mTransformations.Enable(ID_INSERTION_MAN,True)
##        else :
##            self.mTransformations.Enable(ID_INSERTION_MAN,False)
##
##        if not res.isDeplacement(element)[0] and self.procedureDeplacement:
##            self.mTransformations.Enable(ID_DEPLACEMENT_MAN,True)
##        else :
##            self.mTransformations.Enable(ID_DEPLACEMENT_MAN,False)
##
##        if not res.isRemplacement(element)[0]  and self.procedureRemplacement:
##            self.mTransformations.Enable(ID_REMPLACEMENT_MAN,True)
##        else :
##            self.mTransformations.Enable(ID_REMPLACEMENT_MAN,False)
##
##        if not res.isBlocCommun(element)[0] and self.procedureBlocCommun:
##            self.mTransformations.Enable(ID_BLOC_COMMUN,True)
##        else :
##            self.mTransformations.Enable(ID_BLOC_COMMUN,False)
##
##        if res.isNonDef(element)[0]:
##            self.mTransformations.Enable(ID_NON_DEF,False)
##        else :
##            self.mTransformations.Enable(ID_NON_DEF,True)
##        ##if res.isTransformation(element):
#        self.menu_bar.EnableTop(5, True)
        
        
    def disableMenuTransformations(self):
        self.mTransformations.Enable(ID_INSERTION_MAN,False)
        self.mTransformations.Enable(ID_SUPPRESSION_MAN,False)
        self.mTransformations.Enable(ID_DEPLACEMENT_MAN,False)
        self.mTransformations.Enable(ID_REMPLACEMENT_MAN,False)
        self.mTransformations.Enable(ID_BLOC_COMMUN,False)
        self.mTransformations.Enable(ID_NON_DEF,False)
        
#        self.menu_bar.EnableTop(5, False)
        # print("4. Module: GUI.Medite, Class: MediteFrame, Methode: disableMenuTransformations, Ligne 510 ") 



    def ajouterNonDefini(self,evt):
##        self.noirSurBlanc()
##        self.affichageCouleur()
        panel=self.getCompPanel()
        panel.initialised = True
        selection = panel.textWindowRight.GetSelection()
        s2deb,s2fin = panel.textWindowLeft.GetSelection()
        deb,fin=selection
        if deb<fin:
            self.saveChangementStruct()
            panel.textWindowRight.SetSelection(fin,fin)
            panel.textWindowLeft.SetSelection(s2fin,s2fin)
            transfo = panel.resultatTransfo
            selection=(deb+transfo.getLgSource(),fin+transfo.getLgSource())
            deb,fin=selection
            
            liste=transfo.identifierBlocs(selection)
            liste[0]=((deb,liste[0][0][1]),liste[0][1])
            liste[-1]=((liste[-1][0][0],fin),liste[-1][1])
            listeBlocs = []
            for x in liste:
                listeBlocs.append(x[0])
            
            transfo.enleverTransformations(listeBlocs,2)
        
            self.affichageComparaisonChangements(transfo.listeChangements)
            # print("5. Module: GUI.Medite, Class: MediteFrame, Methode: ajouterNonDefini, Ligne 540, \ntransfo= %s", transfo) 
        selection = panel.textWindowLeft.GetSelection()
        s2deb,s2fin = panel.textWindowRight.GetSelection()
        deb,fin=selection
        if deb<fin:
            self.saveChangementStruct()
            panel.textWindowLeft.SetSelection(fin,fin)
            panel.textWindowRight.SetSelection(s2fin,s2fin)
            transfo = panel.resultatTransfo
            
            liste=transfo.identifierBlocs(selection)
            liste[0]=((deb,liste[0][0][1]),liste[0][1])
            liste[-1]=((liste[-1][0][0],fin),liste[-1][1])
            listeBlocs = []
            for x in liste:
                listeBlocs.append(x[0])
                
            transfo.enleverTransformations(listeBlocs,1)
        
            self.affichageComparaisonChangements(transfo.listeChangements)
            # print("6. Module: GUI.Medite, Class: MediteFrame, Methode: ajouterNonDefini, Ligne 560, \ntransfo= %s", transfo) 
        # print("7. Module: GUI.Medite, Class: MediteFrame, Methode: ajouterNonDefini, Ligne 561 ") 
        

    def ajouterInsertion(self,evt):
        panel=self.getCompPanel()
        selection = panel.textWindowRight.GetSelection()
        deb,fin=selection
        if deb<fin:
            self.saveChangementStruct()
            transfo = panel.resultatTransfo
            transfo.ajouterInsertion(selection)
            self.procedureRemplacement = False
            self.procedureDeplacement = False
            self.procedureBlocCommun = False
            
            self.affichageComparaisonChangements(transfo.listeChangements)
            # print("8. Module: GUI.Medite, Class: MediteFrame, Methode: ajouterInsertion, Ligne 577, \ntransfo= %s", transfo) 
        panel.textWindowRight.SetSelection(fin,fin)

          
    def ajouterSuppression(self,evt):
        panel=self.getCompPanel()
        selection = panel.textWindowLeft.GetSelection()
        deb,fin=selection
        if deb<fin:
            self.saveChangementStruct()
            transfo = panel.resultatTransfo
            transfo.ajouterSuppression(selection)
            self.procedureRemplacement = False
            self.procedureDeplacement = False
            self.procedureBlocCommun = False
            self.affichageComparaisonChangements(transfo.listeChangements)
            # print("9. Module: GUI.Medite, Class: MediteFrame, Methode: ajouterSuppression, Ligne 593, \ntransfo= %s", transfo) 
        panel.textWindowLeft.SetSelection(fin,fin)
        
    def ajouterDeplacementL(self,evt):
    
        panel=self.getCompPanel()
        selection = panel.textWindowLeft.GetSelection()
        deb,fin=selection
        if deb<fin:
            #panel.textWindowRight.SetSelection(0,0)
            transfo = panel.resultatTransfo
            transfo.ajouterDeplacement(selection,1)
            self.procedureDeplacement = True
            self.procedureRemplacement = False
            self.procedureBlocCommun = False
            # print("10. Module: GUI.Medite, Class: MediteFrame, Methode: ajouterDeplacementL, Ligne 608, \ntransfo= %s", transfo) 
            self.affichageComparaisonChangements(transfo.listeChangements)

    def ajouterDeplacementR(self,evt):
    
        panel=self.getCompPanel()
        selection = panel.textWindowRight.GetSelection()
        deb,fin=selection
        if deb<fin:
            self.saveChangementStruct()
            transfo = panel.resultatTransfo
            transfo.ajouterDeplacement(selection,2)
            self.procedureDeplacement = False
            # print("11. Module: GUI.Medite, Class: MediteFrame, Methode: ajouterDeplacementR, Ligne 621, \ntransfo= %s", transfo) 
            self.affichageComparaisonChangements(transfo.listeChangements)            


    
    def ajouterRemplacementL(self,evt):

        panel=self.getCompPanel()
        selection = panel.textWindowLeft.GetSelection()
        deb,fin=selection
        if deb<fin:

            #panel.textWindowRight.SetSelection(0,0)
            transfo = panel.resultatTransfo
            transfo.ajouterRemplacement(selection,1)
            self.procedureRemplacement = True
            self.procedureDeplacement = False
            self.procedureBlocCommun = False   
            self.affichageComparaisonChangements(transfo.listeChangements)		
            # print("12. Module: GUI.Medite, Class: MediteFrame, Methode: ajouterRemplacementL, Ligne 640, \ntransfo= %s", transfo) 

        
    def ajouterRemplacementR(self,evt):

        panel=self.getCompPanel()
        selection = panel.textWindowRight.GetSelection()
        deb,fin=selection
        if deb<fin:
            self.saveChangementStruct()
            transfo = panel.resultatTransfo
            transfo.ajouterRemplacement(selection,2)
            self.procedureRemplacement = False
            # print("13. Module: GUI.Medite, Class: MediteFrame, Methode: ajouterRemplacementR, Ligne 653, \ntransfo= %s", transfo) 
            self.affichageComparaisonChangements(transfo.listeChangements)

        #panel.textWindowRight.SetSelection(0,0)
        #panel.textWindowLeft.SetSelection(0,0)

        
    def ajouterBlocCommunL(self,evt):
        panel=self.getCompPanel()
        selection = panel.textWindowLeft.GetSelection()
        deb,fin=selection
        if deb<fin:
            #panel.textWindowRight.SetSelection(0,0)
            transfo = panel.resultatTransfo
            transfo.ajouterBlocCommun(selection,1)
            self.procedureBlocCommun = True
            self.procedureRemplacement = False
            self.procedureDeplacement = False
            # print("14. Module: GUI.Medite, Class: MediteFrame, Methode: ajouterBlocCommunL, Ligne 671, \ntransfo= %s", transfo)
            self.affichageComparaisonChangements(transfo.listeChangements)
        
    def ajouterBlocCommunR(self,evt):
        
        panel=self.getCompPanel()
        selection = panel.textWindowRight.GetSelection()
        deb,fin=selection
        if deb<fin:
            self.saveChangementStruct()
            transfo = panel.resultatTransfo
            transfo.ajouterBlocCommun(selection,2)
            self.procedureBlocCommun = False
            # print("15. Module: GUI.Medite, Class: MediteFrame, Methode: ajouterBlocCommunR, Ligne 684, \ntransfo= %s", transfo)
            self.affichageComparaisonChangements(transfo.listeChangements)

        #panel.textWindowRight.SetSelection(0,0)
        #panel.textWindowLeft.SetSelection(0,0)

        
    def SupprimerInsertions(self,evt):
        self.saveChangementStruct()
        self.getCompPanel().resultatTransfo.SupprimerInsertions()
        self.affichageComparaison()
        
        self.getCompPanel().textWindowRight.SetSelection(0,0)
        self.getCompPanel().textWindowLeft.SetSelection(0,0)
        # print("16. Module: GUI.Medite, Class: MediteFrame, Methode: SupprimerInsertions, Ligne 698 ")
        
    def SupprimerSuppressions(self,evt):
        self.saveChangementStruct()
        self.getCompPanel().resultatTransfo.SupprimerSuppressions()
        self.affichageComparaison()

        self.getCompPanel().textWindowRight.SetSelection(0,0)
        self.getCompPanel().textWindowLeft.SetSelection(0,0)
        # print("17. Module: GUI.Medite, Class: MediteFrame, Methode: SupprimerSuppressions, Ligne 707 ")
        
    def SupprimerRemplacements(self,evt):
        self.saveChangementStruct()
        self.getCompPanel().resultatTransfo.SupprimerRemplacements()
        self.affichageComparaison()

        self.getCompPanel().textWindowRight.SetSelection(0,0)
        self.getCompPanel().textWindowLeft.SetSelection(0,0)
        # print("18. Module: GUI.Medite, Class: MediteFrame, Methode: SupprimerRemplacements, Ligne 716 ")
        
    def SupprimerDeplacements(self,evt):
        self.saveChangementStruct()
        self.getCompPanel().resultatTransfo.SupprimerDeplacements()
        self.affichageComparaison()

        self.getCompPanel().textWindowRight.SetSelection(0,0)
        self.getCompPanel().textWindowLeft.SetSelection(0,0)
        # print("19. Module: GUI.Medite, Class: MediteFrame, Methode: SupprimerDeplacements, Ligne 725 ")
        
    def SupprimerBlocsCommuns(self,evt):
        self.saveChangementStruct()
        self.getCompPanel().resultatTransfo.SupprimerBlocsCommuns()
        self.affichageComparaison()

        self.getCompPanel().textWindowRight.SetSelection(0,0)
        self.getCompPanel().textWindowLeft.SetSelection(0,0)
        # print("20. Module: GUI.Medite, Class: MediteFrame, Methode: SupprimerBlocsCommuns, Ligne 734 ")
        
    def SupprimerToutesTranformations(self,evt):
        self.saveChangementStruct()
        self.getCompPanel().resultatTransfo.SupprimerToutesTransformations()
        self.affichageComparaison()

        self.getCompPanel().textWindowRight.SetSelection(0,0)
        self.getCompPanel().textWindowLeft.SetSelection(0,0)
        # print("21. Module: GUI.Medite, Class: MediteFrame, Methode: SupprimerToutesTranformations, Ligne 743 ")

    def saveChangementStruct(self):
        self.lastStruct = copy.deepcopy(self.getCompPanel().resultatTransfo)
        self.changementStruct = True
        # print("22. Module: GUI.Medite, Class: MediteFrame, Methode: saveChangementStruct, Ligne 748 ")

    def undo(self,evt):
        if self.changementStruct :
            self.nextStruct = copy.deepcopy(self.getCompPanel().resultatTransfo)
            self.getCompPanel().resultatTransfo = self.lastStruct
            self.affichageComparaison()
        # print("23. Module: GUI.Medite, Class: MediteFrame, Methode: undo, Ligne 755 ")

    def redo(self,evt):
        if self.changementStruct :
            self.getCompPanel().resultatTransfo = self.nextStruct
            self.affichageComparaison()
        # print("24. Module: GUI.Medite, Class: MediteFrame, Methode: redo, Ligne 761 ")

    # recharge le menu de Navigation
    def reloadNavMenu(self):
        if self.mNavigation.GetMenuItemCount():
            lItems = self.mNavigation.GetMenuItems()
            for item in lItems:
                self.mNavigation.Delete(item.GetId())
#           i = 1
#           while i<self.mNavigation.GetMenuItemCount():
#               sys.stderr.write("i = "+str(i)+"\n")
#               sys.stderr.flush()
#               self.mNavigation.Remove(i)
#               i+=1
            #self.mNavigation.Destroy()
            #self.mNavigation = wx.Menu()
        #navMenu = wx.Menu()
        i = 0
        while i<self.nb.GetPageCount():
            self.mNavigation.Append(ID_NAVMENU+i, str(self.nb.GetPage(i).getTitre()),'')
            #sys.stderr.write('x'+self.nb.GetPage(i).getTitre()+'x\n')
            # wx.EVT_MENU(self, ID_NAVMENU+i, self.selectPage)                                # Desactivee 19.06.2019, remplacee par la ligne suivante:
            self.Bind(wx.EVT_MENU, self.selectPage, id=ID_NAVMENU+i)
            i+=1
            self.changementStruct = False
        #self.mNavigation.AppendMenu(ID_NAVMENU, 'Ouvrir', self.smOuvrir)
        # print("25. Module: GUI.Medite, Class: MediteFrame, Methode: reloadNavMenu, Ligne 787 ")

    def selectPage(self,event):
        # print("26. Module: GUI.Medite, Class: MediteFrame, Methode: selectPage, Ligne 790 ")
        self.nb.SetSelection(event.GetId()-ID_NAVMENU)
        
    def getMainPanel(self):
        """ Pointe sur le MainPanel associe a l'onglet courant du notebook """
        # print("27. Module: GUI.Medite, Class: MediteFrame, Methode: getMainPanel, Ligne 795 ")
        return self.nb.GetPage(self.nb.GetSelection())
        
    def getCompPanel(self):
        """ Pointe sur le ComparaisonPanel associe a l'onglet courant du notebook """
        # print("28. Module: GUI.Medite, Class: MediteFrame, Methode: getCompPanel, Ligne 800 ")
        return self.getMainPanel().getComparaisonPanel()
        
    def getPlanTravail(self):
        """ Pointe sur le plan de travail associe a l'onglet courant """
        # print("29. Module: GUI.Medite, Class: MediteFrame, Methode: getPlanTravail, Ligne 805, \nplanTravail=", str(self.getMainPanel().planTravail))
        return self.getMainPanel().planTravail 
        
    def OnNBPageChanged(self,event):
        """ Changement de pane, gestion des menus """
        if self.getMainPanel().isTreePanel():
            self.disableMenuDGCharge()
            self.disableMenuArbre()
            self.disableMenuTransformations()
        elif self.getPlanTravail().getAuteur() != '' and self.getPlanTravail().getOeuvre() != '':
            self.enableMenuDGCharge()
            self.enableMenuArbre()
            #self.enableMenuTransformations()
        else:
            self.disableMenuDGCharge()
            self.enableMenuArbre()
            #self.enableMenuTransformations()
        # print("30. Module: GUI.Medite, Class: MediteFrame, Methode: OnNBPageChanged, Ligne 822 ")
     
    def OnSize(self, event):
        wx.Frame.OnSize(self,event)
        wx.LayoutAlgorithm().LayoutFrame(self)
        # print("31. Module: GUI.Medite, Class: MediteFrame, Methode: OnSize, Ligne 827 ")
        
        
    def enableMenuArbre(self):
        """ Autorise les menus interdits lorque l'on quitte le treePanel """
        #self.mComparaison.Enable(ID_NEWCOMP,True)
        self.mComparaison.Enable(ID_DELCOMP,True)
        self.mComparaison.Enable(ID_DELALLCOMP,True)
        #self.mComparaison.Enable(ID_CLOSECOMP,True)
        #self.mComparaison.Enable(ID_CLOSEALLCOMP,True)
        self.menu_bar.EnableTop(2, True)
        self.menu_bar.EnableTop(3, True)
        # print("32. Module: GUI.Medite, Class: MediteFrame, Methode: enableMenuArbre, Ligne 839 ")
        
    def disableMenuArbre(self):
        """ Interdit certains menus lorsque l'on est sur le treepanel """
        #self.mComparaison.Enable(ID_NEWCOMP,False)
        self.mComparaison.Enable(ID_DELCOMP,False)
        self.mComparaison.Enable(ID_DELALLCOMP,False)
        #self.mComparaison.Enable(ID_CLOSECOMP,False)
        #self.mComparaison.Enable(ID_CLOSEALLCOMP,False)
        self.menu_bar.EnableTop(2, False)
        self.menu_bar.EnableTop(3, False)
        # print("33. Module: GUI.Medite, Class: MediteFrame, Methode: disableMenuArbre, Ligne 850 ")
        
    def nouvelleComparaison(self,event):
        """ Cree une nouvelle de comparaison """
        newplan = PlanTravail("","","","","","",Parametres())  
        self.listePlanTravail.appendPlanTravail(newplan)
        newpanel=MainPanel(self.nb,newplan)
        newpanel.initialised = False
        # chargement du dossier g�n�tique comme dans FormulaireMenuGenetique
        if self.DGLoaded:
            newpanel.getComparaisonPanel().textInfoAuteur.SetLabel(self.DGAuteur)
            newpanel.getComparaisonPanel().textInfoOeuvre.SetLabel(self.DGOeuvre)
            ### Mise a jour du plan de travail
            newpanel.getComparaisonPanel().planTravail.setAuteur(self.DGAuteur)
            newpanel.getComparaisonPanel().planTravail.setOeuvre(self.DGOeuvre)
            newpanel.getComparaisonPanel().planTravail.setVersionSource('')
            newpanel.getComparaisonPanel().planTravail.setEtatSource('')
            newpanel.getComparaisonPanel().planTravail.setVersionCible('')
            newpanel.getComparaisonPanel().planTravail.setEtatCible('')
            self.disableMenuDGCharge()
            self.enableMenuDGCharge()
        # ajout de la page
        self.nb.AddPage(newpanel,newplan.getEtatSource()+"-"+newplan.getEtatCible())
        self.nb.SetSelection(self.nb.GetPageCount()-1)
        self.reloadNavMenu()
        # print("34. Module: GUI.Medite, Class: MediteFrame, Methode: nouvelleComparaison, Ligne 875, \nself.DGAuteur=", self.DGAuteur, ", self.DGOeuvre=", self.DGOeuvre)
        
    # supprime le panel courant
    def supprimeComparaison(self,event):
        plan = self.getPlanTravail()
        # demande de suppression des infos enregistrées dans informations.xml
#       if ((self.getCompPanel().initialised) and 
#           self.cinfos.existeInformations(self.getPlanTravail()):
#           phrase = u"Voulez-vous supprimer les informations enregistrées associées à cette comparaison ?"
#            dlg = wx.MessageDialog(self,phrase,"Suppression",wx.YES|wx.CANCEL)
#           res = dlg.ShowModal() 
#           dlg.Destroy()
#           if res == wx.ID_CANCEL:
#               return
#           elif res == wx.ID_YES:
#               self.cinfos.supprimerInformations(self.getPlanTravail())       

        if ((self.getCompPanel().initialised) and self.cinfos.existeInformations(self.getPlanTravail())):
            self.cinfos.supprimerInformations(self.getPlanTravail())                                                    
        # suppression de l'onglet et de son plan de travail associé
        self.nb.DeletePage(self.nb.GetSelection())
        self.listePlanTravail.deletePlanTravail(plan)
        self.reloadNavMenu()
        # print("35. Module: GUI.Medite, Class: MediteFrame, Methode: supprimeComparaison, Ligne 898, \nplan=", str(plan))

    # supprime tous les panels de comparaison
    def supprimeToutesComparaisons(self,event): 
        while self.nb.GetPageCount() != 1:
            self.nb.SetSelection(self.nb.GetPageCount()-1)
            self.supprimeComparaison(None)
        self.nouvelleComparaison(None)
        # print("36. Module: GUI.Medite, Class: MediteFrame, Methode: supprimeToutesComparaisons, Ligne 906 ")
    # supprime le panel courant
#    def fermeComparaison(self,event):
#       plan = self.getPlanTravail()
#       # suppression de l'onglet et de son plan de travail associé
#       self.nb.DeletePage(self.nb.GetSelection())
#       self.listePlanTravail.deletePlanTravail(plan)
#       self.reloadNavMenu()    
#       
#    # supprime tous les panels de comparaison
#    def fermeToutesComparaisons(self,event): 
#       while self.nb.GetPageCount() != 1:
#           self.nb.SetSelection(self.nb.GetPageCount()-1)
#           self.fermeComparaison(NULL)
#       self.nouvelleComparaison(NULL)
        
    def createTreePanel(self):
        self.treePanel = TreePanel(self.nb, self)
        self.nb.InsertPage(0,self.treePanel,"Arbre")
        # print("37. Module: GUI.Medite, Class: MediteFrame, Methode: supprimeToutesComparaisons, Ligne 925 ")
        
    def quitter(self, event):
        # print("38. Module: GUI.Medite, Class: MediteFrame, Methode: quitter, Ligne 928 ")
        self.Close(True)
        
    def OnCloseWindow(self, event):
        text='Voulez vous vraiment quitter MEDITE ?'
        dlg = wx.MessageDialog(self, text, 'Quitter',wx.YES_NO)
        if dlg.ShowModal() == wx.ID_YES:
            dlg.Destroy()
            self.enregistrerPlanTravailTOTAL()
            self.enregistrerToutesInformations(None)
            self.Destroy()
        else :
            dlg.Destroy()
        # print("39. Module: GUI.Medite, Class: MediteFrame, Methode: OnCloseWindow, Ligne 941 ")

    def enregistrerPlanTravailTOTAL(self):
        """ Enregistrement de tout le plan de travail (plan, parametres, couleurs) """
        try:
            self.ctravail.enregistrerListePlans(self.listePlanTravail)
            self.ctravail.enregistrerCouleurs(self.couleursTransfo)
            self.ctravail.enregistrerParametres(self.parametres)
            # print("40. Module: GUI.Medite, Class: MediteFrame, Methode: enregistrerPlanTravailTOTAL, Ligne 949, \nself.listePlanTravail=", str(self.listePlanTravail), ", \nself.couleursTransfo=", str(self.couleursTransfo), ", \nself.parametres=", str(self.parametres))
        except Exception as e:  # Modifie 06.02.2019, old line:  except Exception,e: 
            sys.stderr.write(str(e))  
            traceback.print_exc()
            sys.stderr.flush()
        # print("41. Module: GUI.Medite, Class: MediteFrame, Methode: enregistrerPlanTravailTOTAL, Ligne 954 ")

    def launchTagger(self, evt):
        """ Etiquetage """
        self.SetCursor(wx.HOURGLASS_CURSOR)
        if self.getCompPanel().initialised == True:
            try:
                tagger = MediteApplication.synthetic.TaggerExtension(self.getCompPanel().resultatTransfo)
                frequencyMatrix = tagger.run()
                textMatrix = MediteApplication.synthetic.TextFrequencyMatrix(self.getCompPanel().resultatTransfo)
                self.getMainPanel().addStatPanel(frequencyMatrix,textMatrix)
            except Exception as e1:  # Modifie 06.02.2019, old line:  except Exception,e1: 
                traceback.print_exc()
                sys.stderr.flush()
                dlg=wx.MessageDialog(self,str(e1),"Erreur",wx.OK)
                dlg.ShowModal()
                dlg.Destroy()
        self.SetCursor(wx.STANDARD_CURSOR)
        # print("42. Module: GUI.Medite, Class: MediteFrame, Methode: launchTagger, Ligne 972 ")
        
    # Mise en place du plan de travail et des parametres (lissage, couleurs)
    #def miseEnPlacePlanTravailTOTAL(self):
    def miseEnPlaceParametres(self):
        # chargement plan de travail
#        try :
#            self.planTravail = self.ctravail.chargerPlan()
#            if self.planTravail.getAuteur() != '' and self.planTravail.getOeuvre() != '':
#                self.enableMenuDGCharge()
#        except FichierNonTrouve, eFNT :
#            self.planTravail = PlanTravail("","","","","","")   #auteur,oeuvre,versSource,etatS,verCible,etatC
        # chargement couleurs
        try :
            self.couleursTransfo = self.ctravail.chargerCouleurs()
        except FichierNonTrouve as eFNT :  # Modifie 06.02.2019, old line:  except Exception,eFNT: 
            self.couleursTransfo = self.ctravail.chargerCouleursDefaut()
        # chargement parametres
        try :
            self.parametres = self.ctravail.chargerParametres()
            #sys.stderr.write("param = "+self.parametres.toString())
        except FichierNonTrouve as eFNT:  # Modifie 06.02.2019, old line:  except Exception,eFNT: 
            self.parametres = self.ctravail.chargerParametresDefaut()
        # print("43. Module: GUI.Medite, Class: MediteFrame, Methode: miseEnPlaceParametres, Ligne 995 ")

    # Mise en place du plan de travail, des couleurs et des parametres par defaut
#    def parDefaut(self):
#        #Variables concernant le dossier genetique courant
#        self.planTravail = PlanTravail("","","","","","")   #auteur,oeuvre,versSource,etatS,verCible,etatC
#        #couleurs des transformations
#        self.couleursTransfo = self.ctravail.chargerCouleursDefaut()
#        #parametres de lissage
#        self.parametres = self.ctravail.chargerParametresDefaut()
            
    # Methode qui ouvre une fenetre d'aide
    def aide(self,evt):
        # if 'win' in sys.platform:                        # Desactive 04.10.2019 
            # import wx.lib.iewin 
        self.newFenetre = wx.Frame(None, ID_AIDE, 'aide', pos=(30,30),size=(1800,1000))                # Modifie 02.10.2019, ancienne: self.newFenetre = wx.Frame(None, -6, 'aide')
        self.newFenetre.html = wx.html.HtmlWindow(self.newFenetre, -1, pos=DefaultPosition, size=DefaultSize, style=wx.NO_FULL_REPAINT_ON_RESIZE, name="Aide4.0.html")        # Modifie 07.10.2019, ancienne: self.newFenetre.html = wx.lib.iewin.IEHtmlWindow(self.newFenetre, -1, style=wx.NO_FULL_REPAINT_ON_RESIZE)
            # self.newFenetre.html.Navigate(os.path.join(constantes.REPMEDITE,'Aide4.0.html'))           # Modifie 02.10.2019, ancienne: self.newFenetre.html.Navigate(os.path.join(constantes.REPMEDITE,'aide.html'))
        self.newFenetre.html.LoadPage(os.path.join(constantes.REPMEDITE,"Aide4.0.html"))                            # Modifie 02.10.2019, ancienne: self.newFenetre.Show()
        self.newFenetre.Show()
        # print("44. Module: GUI.Medite, Class: MediteFrame, Methode: aide, Ligne 1014, \nconstantes.REPMEDITE+Aide4.0.html=", os.path.join(constantes.REPMEDITE,"Aide4.0.html"), " ") 
                                                                                                        # urlaide = "file://" + os.path.join(constantes.REPMEDITE,"Aide4.0.html") 
                                                                                                        # webbrowser.open(urlaide, new=2) 
    # Methode qui ouvre une fenetre A propos        
    def aPropos(self, evt):
        text=u"                      MEDITE - Machine EDITE\n\n                     Etude Diachronomique et  \n           Interpr\xe9tative des Textes d'Ecrivains\n\n           Application imagin\xe9e et r\xe9alis\xe9e par\n\n        Jean-Gabriel Ganascia, Alexandre Guilbaud, Julien Bourdaillet et Yeugene Covanov\n\nJean-Gabriel.Ganascia@lip6.fr - alexandre.guilbaud@imj-prg.fr - yeugene.covanov@upmc.fr    \n\n                            Version 4.0"   # Ligne est mise à jour 19.07.2019, 07.10.2019.  
        dlg = wx.MessageDialog(self, text, 'A propos...',wx.OK | wx.ICON_INFORMATION) 
        dlg.ShowModal() 
        dlg.Destroy()
        # print("45. Module: GUI.Medite, Class: MediteFrame, Methode: aPropos, Ligne 1024 ") 


    # Methode qui appelle le formulaire de saisie pour enregistrer un auteur
    def enregistrerAuteur(self,evt):
        formulaire=FormAuteur(self,-1)
        formulaire.Show(True)
        # print("46. Module: GUI.Medite, Class: MediteFrame, Methode: enregistrerAuteur, Ligne 1031 ") 

    # Methode qui appelle le formulaire de saisie pour enregitrer une oeuvre
    def enregistrerOeuvre(self,evt):
        feo = FormEnregistrerOeuvre(self)
        # print("47. Module: GUI.Medite, Class: MediteFrame, Methode: enregistrerOeuvre, Ligne 1036 ") 

    # Methode qui appelle le formulaire de saisie pour supprimer un auteur
    def supprimerAuteur(self,evt):
        fsa = FormSupprimerAuteur(self)
        # print("48. Module: GUI.Medite, Class: MediteFrame, Methode: supprimerAuteur, Ligne 1041 ") 

    # Methode qui appelle le formulaire de saisie pour supprimer une oeuvre
    def supprimerOeuvre(self,evt):
        formulaire=FormSupprimerOeuvre(self)
        formulaire.Show(1)
        # print("49. Module: GUI.Medite, Class: MediteFrame, Methode: supprimerOeuvre, Ligne 1047 ") 

    # Methode qui rend actifs les menus et les boutons permettant d'ouvrir les fichiers source
    # et cible   
    def enableMenuDGCharge(self):
        self.smOuvrir.Enable(ID_SOURCE, True)
        self.tb.EnableTool(ID_SOURCE, True)
        self.smOuvrir.Enable(ID_CIBLE, True)
        self.tb.EnableTool(ID_CIBLE, True)  
        self.mMedite.Enable(ID_EXECUTER,True)
        self.tb.EnableTool(ID_EXECUTER,True)
        self.mMedite.Enable(ID_EXECUTERALL,True)
        # print("50. Module: GUI.Medite, Class: MediteFrame, Methode: enableMenuDGCharge, Ligne 1059 ") 
        
    def disableMenuDGCharge(self):
        self.smOuvrir.Enable(ID_SOURCE, False)
        self.tb.EnableTool(ID_SOURCE, False)
        self.smOuvrir.Enable(ID_CIBLE, False)
        self.tb.EnableTool(ID_CIBLE, False)  
        self.mMedite.Enable(ID_EXECUTER,False)
        self.tb.EnableTool(ID_EXECUTER,False)
        self.mMedite.Enable(ID_EXECUTERALL,False)
        # print("51. Module: GUI.Medite, Class: MediteFrame, Methode: disableMenuDGCharge, Ligne 1069 ") 
        
    # Methode qui rend inactifs les menus et les boutons permettant de charger ou d'enregistrer 
    # les informations, d'executer medite et reinitialise les variables du dossier genetique
    # courant ainsi que les fenêtres de visualisation
    def disableDGCharge(self):
        self.getPlanTravail().setVersionSource('')
        self.getPlanTravail().setEtatSource('')
        self.getPlanTravail().setVersionCible('')
        self.getPlanTravail().setEtatCible('')
        
        self.mInformations.Enable(ID_CHARGER_INFOS,False)
        self.smEnregistrer.Enable(ID_ADD_TRANSFOS, False)
        self.smEnregistrer.Enable(ID_ADD_COMMENT, False)
        self.smEnregistrer.Enable(ID_ADD_TRANSFOS_COMMENT, False)
        self.mMedite.Enable(ID_EXECUTER, False)
        self.tb.EnableTool(ID_EXECUTER, False)

        self.getCompPanel().textWindowLeft.SetValue(u"etat source")
        self.getCompPanel().textWindowRight.SetValue(u"etat cible")
        self.getCompPanel().textInfoVersionS.SetLabel("")
        self.getCompPanel().textInfoEtatS.SetLabel("")
        self.getCompPanel().textInfoVersionC.SetLabel("")
        self.getCompPanel().textInfoEtatC.SetLabel("")
        self.getCompPanel().transformations.SetValue("")
        # print("52. Module: GUI.Medite, Class: MediteFrame, Methode: disableDGCharge, Ligne 1094 ") 

    # Methode qui appelle le formulaire de saisie pour charger DG        
    def chargerDG(self,evt):
        formulaire=FormChargerDG(self)
        formulaire.Show(True)
        # print("53. Module: GUI.Medite, Class: MediteFrame, Methode: chargerDG, Ligne 1100 ") 
            
    # Methode qui appelle le formulaire de saisie pour creer un dossier version
    def creerDossierVersion(self,evt):
        formulaire=FormCreerVersion(self)
        formulaire.Show(True)
        # print("54. Module: GUI.Medite, Class: MediteFrame, Methode: creerDossierVersion, Ligne 1106 ") 
        
    # Methode qui appelle le formulaire de saisie pour creer un etat
    def creerEtat(self,evt):
        formulaire=FormCreerEtat(self)
        formulaire.Show(True)
        # print("55. Module: GUI.Medite, Class: MediteFrame, Methode: creerEtat, Ligne 1112 ") 
        
    # Methode qui appelle le formulaire de saisie pour supprimer un dossier version
    def supprimerDossierVersion(self,evt):
        formulaire=FormSupprimerVersion(self)
        formulaire.Show(True)
        # print("56. Module: GUI.Medite, Class: MediteFrame, Methode: supprimerDossierVersion, Ligne 1118 ")
        
    # Methode qui appelle le formulaire de saisie pour supprimer un �tat
    def supprimerEtat(self,evt):
        formulaire=FormSupprimerEtat(self)
        formulaire.Show(True)
        # print("57. Module: GUI.Medite, Class: MediteFrame, Methode: supprimerEtat, Ligne 1124 ")

    def importerRepertoire(self,evt):
        formulaire=FormImporterRepertoire(self)
        formulaire.Show(True)
        # print("58. Module: GUI.Medite, Class: MediteFrame, Methode: importerRepertoire, Ligne 1129 ")
        
    # Methode qui va charger les informations d'une comparaison des deux �tats ouverts
    # et va rendre inactifs les boutons et menus enregistrer les informations
    def chargerInformations(self,evt):
        try:
            self.__chargement(None)
        except InformationsNonTrouvees as eINT:  # Modifie 06.02.2019, old line:  except Exception,eINT: 
            dlg=wx.MessageDialog(self, u"Les informations n'ont pas \xe9t\xe9 trouv\xe9es !!","Attention",wx.OK)
            dlg.ShowModal()
            dlg.Destroy()
        # print("59. Module: GUI.Medite, Class: MediteFrame, Methode: chargerInformations, Ligne 1140 ")

    # Methode qui va enregistrer les transformations, resultats de la comparaison des deux
    # états ouverts
    def enregistrerTransformations(self,evt):
        self.supprimerToutesInformations(evt)
        self.cinfos.enregistrerTransformations(self.getPlanTravail(),self.getCompPanel().resultatTransfo)
        # print("60. Module: GUI.Medite, Class: MediteFrame, Methode: enregistrerTransformations, Ligne 1147, \nresultatTransfo=", str(self.getPlanTravail(),self.getCompPanel().resultatTransfo))

    # Methode qui enregistre le commentaire sur un couple d'états, edite par l'utilisateur
    # Le commentaire n'est pas enregistre si il est vide
    # Si un commentaire existe deja pour ce couple d'états, la methode appele le formulaire
    # de choix qui lui permet de choisir soit d'ecraser l'ancien commentaire par le nouveau
    # soit d'ajouter le nouveau a l'ancien commentaire
    # Si l'application n'a pas ete execute sur le couple d'états,
    # le commentaire n'est pas enregistre
    def enregistrerCommentaire(self,evt):
        if (self.getCompPanel().commentaire.GetValue()!=""):
            try:
                self.cinfos.enregistrerCommentaire(self.getPlanTravail(),self.getCompPanel().commentaire.GetValue())
            except CommentaireDejaExistant as eCDE:                                                 # Modifie 06.02.2019, old line:  except Exception,eCDE: 
                formulaire=FormEnregistrerCommentaire(self,eCDE.getCommentaire().getCommentaire(),
                                                      self.parametres)
                formulaire.Show(True)
            except InformationsNonTrouvees as eINT:  # Modifie 06.02.2019, old line:  except Exception,eINT: 
                self.__choixParametres()
##                msg = "Les transformations concernant les deux \xe9tats n'ont pas \xe9t\xe9 enregistr\xe9"
##                msg += '\nPour enregistrer le commentaire vous devez cliquer, dans la barre de menu "Informations", sur "Enregistrer" puis sur " Transformations et Commentaire"'
##                dlg=wx.MessageDialog(self, msg,"Attention",wx.OK)
##                dlg.ShowModal()
##                dlg.Destroy()
        else:
            dlg=wx.MessageDialog(self, "Le commentaire est vide","Attention",wx.OK)
            dlg.ShowModal()
            dlg.Destroy()
        # print("61. Module: GUI.Medite, Class: MediteFrame, Methode: enregistrerCommentaire, Ligne 1175 ")
        
    # Methode qui appelle le formulaire de saisie pour supprimer les informations d'un
    # couple d'états
    def supprimerInformations(self,evt):
        formulaire=FormSupprimerInformations(self, "Supprimer les informations")
        formulaire.Show(True)
        # print("62. Module: GUI.Medite, Class: MediteFrame, Methode: supprimerInformations, Ligne 1182 ") 
    
    def supprimerToutesInformations(self,evt):
        page = self.nb.GetSelection()
        self.SetCursor(wx.HOURGLASS_CURSOR)
        maxnb = self.nb.GetPageCount()  # Modifiee 07.02.2019, ancienne ligne:  max = self.nb.GetPageCount()
        i = 1
        while i < self.nb.GetPageCount() :
            self.nb.SetSelection(i)
            if self.getCompPanel().initialised == False:
                i+=1
                continue
            #try:
            self.cinfos.supprimerInformations(self.getPlanTravail())
            #finally:                                           
            i+=1
        self.nb.SetSelection(page) 
        self.SetCursor(wx.STANDARD_CURSOR)
        # print("63. Module: GUI.Medite, Class: MediteFrame, Methode: supprimerToutesInformations, Ligne 1200 ") 
        
    # Methode qui appelle le formulaire de saisie pour supprimer le commentaire d'un
    # couple de états
    def supprimerCommentaire(self,evt):
        formulaire=FormSupprimerCommentaire(self, "Supprimer Commentaire")
        formulaire.Show(True)
        # print("64. Module: GUI.Medite, Class: MediteFrame, Methode: supprimerCommentaire, Ligne 1207 ") 

    # Methode qui permet d'enregistrer les transformations et le commentaire d'un
    # couple de états    
    def enregistrerInformations(self,evt):
        # print("65. Module: GUI.Medite, Class: MediteFrame, Methode: enregistrerInformations, Ligne 1212 ") 
        if self.getCompPanel().initialised == False:
            #sys.stderr.write("panel not init\n")
            sys.stderr.flush()
            return
        
        self.supprimerToutesInformations(evt)
        self.cinfos.enregistrerTransformations(self.getPlanTravail(),self.getCompPanel().resultatTransfo)
        # print("66. Module: GUI.Medite, Class: MediteFrame, Methode: enregistrerInformations, Ligne 1220, \nresultatTransfo=", str(self.getCompPanel().resultatTransfo)) 
        if self.getCompPanel().commentaire.GetValue() !='' :
            try:    
                self.cinfos.enregistrerCommentaire(self.getPlanTravail(),self.getCompPanel().commentaire.GetValue())
            except AuteurNonTrouve as eANT:  # Modifie 06.02.2019, old line:  except Exception,eANT: 
                dlg=wx.MessageDialog(self, u"L'auteur n'a pas \xe9t\xe9 trouv\xe9!!","Attention",wx.OK)
                dlg.ShowModal()
                dlg.Destroy()
            except OeuvreNonTrouvee as eONT:  # Modifie 06.02.2019, old line:  except Exception,eONT: 
                dlg=wx.MessageDialog(self, u"L'oeuvre n'a pas \xe9t\xe9 trouv\xe9e!!","Attention",wx.OK)
                dlg.ShowModal()
                dlg.Destroy()
            except CommentaireDejaExistant as eCDE:  # Modifie 06.02.2019, old line:  except Exception,eCDE: 
                if evt!=None:
                    formulaire=FormEnregistrerCommentaire(self,eCDE.getCommentaire().getCommentaire(),
                                                      self.parametres)
                    formulaire.Show(True)
                     
    def enregistrerToutesInformations(self,evt):
        page = self.nb.GetSelection()
        self.SetCursor(wx.HOURGLASS_CURSOR)
        
        i = 1
        while i < self.nb.GetPageCount():
            self.nb.SetSelection(i)
            self.enregistrerInformations(None)
            i+=1
        self.nb.SetSelection(page)   
        self.SetCursor(wx.STANDARD_CURSOR)
        # print("67. Module: GUI.Medite, Class: MediteFrame, Methode: enregistrerToutesInformations, Ligne 1249 ") 
            
    # Methode qui rend actifs les boutons et menus Charger les informations,
    # enregistrer commentaire et executer medite apres l'ouverture d'un couple de �tats                
    def enableMenuEtatsOuverts(self):
        if ((self.getPlanTravail().getEtatSource() !="") & (self.getPlanTravail().getEtatCible() !="")):
            self.mInformations.Enable(ID_CHARGER_INFOS,True)
            self.smEnregistrer.Enable(ID_ADD_COMMENT, True)
            self.mMedite.Enable(ID_EXECUTER, True)
            self.tb.EnableTool(ID_EXECUTER, True)
        # print("67. Module: GUI.Medite, Class: MediteFrame, Methode: enableMenuEtatsOuverts, Ligne 1259 ") 

    # Methode  qui appelle le formulaire de saisie pour ouvrir un état Source      
    def ouvrirFicSource(self,evt):
        #Mise en forme du texte
        formulaire=FormOuvrirFichier(self,u"Ouvrir un etat Source","Source")
        formulaire.Show(1)
        # print("68. Module: GUI.Medite, Class: MediteFrame, Methode: ouvrirFicSource, Ligne 1266 ") 

    # Methode qui appelle le formulaire de saisie pour ouvrir un �tat Cible    
    def ouvrirFicCible(self,evt):
        #Mise en forme du texte
        formulaire=FormOuvrirFichier(self,u"Ouvrir un etat Cible","Cible")
        formulaire.Show(1)
        # print("69. Module: GUI.Medite, Class: MediteFrame, Methode: ouvrirFicCible, Ligne 1273 ") 
        

        
    def executerAll(self,evt):
        # print("70. Module: GUI.Medite, Class: MediteFrame, Methode: executerAll, Ligne 1278 ") 
        if not self.DGLoaded:
            return
        
        self.SetCursor(wx.HOURGLASS_CURSOR)
        # print("71. Module GUI.Medite.py, Class: MediteFrame, Methode: executerAll, ligne 1283, Auteur=", str(self.DGAuteur), " Oeuvre=", str(self.DGOeuvre))
        
        # Ligne est desactivee 06.02.2019, a la place la ligne suivante modifiee est ajoutee. 
        # fim = Controleurs.FInfoManager.FInfoManager.FInfoManager(Controleurs.DGManager.Auteur(self.DGAuteur),Controleurs.DGManager.Oeuvre(self.DGOeuvre))
        fim = Controleurs.FInfoManager.FInfoManager(Controleurs.DGManager.Auteur(self.DGAuteur),Controleurs.DGManager.Oeuvre(self.DGOeuvre))
        lEtats = fim.getArbre().getListePlateEtats()
        # print("72. Module GUI.Medite.py, ligne 1289, \nlEtats=", str(lEtats)) 
        while not lEtats == []:
            (etatS,versionS) = lEtats.pop(0)
            for (etatC, versionC) in lEtats:
                # création PlanTravail et Panel
                plan = PlanTravail(self.DGAuteur, self.DGOeuvre, versionS.getNom(), etatS.getNom(), versionC.getNom(), etatC.getNom(),self.parametres)
                self.listePlanTravail.appendPlanTravail(plan)
                panel=MainPanel(self.nb,plan)
                self.nb.AddPage(panel,plan.getEtatSource()+"-"+plan.getEtatCible())
                self.nb.SetSelection(self.nb.GetPageCount()-1)
                fontDefault=wx.Font(10,wx.DEFAULT,wx.NORMAL,wx.NORMAL,encoding=wx.FONTENCODING_UTF8)       # Modifie 25.09.2019, ancienne: fontDefault=wx.Font(10,wx.DEFAULT,wx.NORMAL,wx.NORMAL,encoding=wx.FONTENCODING_ISO8859_1)
                # chargement état Source
                cheminS=self.dgm.getEtatPath(self.DGAuteur, self.DGOeuvre, versionS.getNom(), etatS.getNom())
                self.getCompPanel().textWindowLeft.SetStyle(0,0,wx.TextAttr(wx.BLACK, wx.WHITE))         # Modifiee 28.06.2019, ancienne ligne:  self.getCompPanel().textWindowLeft.SetStyle(0,0,wx.TextAttr(wx.BLACK,wx.WHITE,fontDefault))
                self.getCompPanel().textWindowLeft.SetFont(fontDefault)                                 # Ajoutee 28.06.2019. 
                self.getCompPanel().textWindowLeft.SetValue(loadFile(cheminS))
                # chargement �tat cible
                cheminC=self.dgm.getEtatPath(self.DGAuteur, self.DGOeuvre, versionC.getNom(), etatC.getNom())
                self.getCompPanel().textWindowRight.SetStyle(0,0,wx.TextAttr(wx.BLACK, wx.WHITE))        # Modifiee 28.06.2019, ancienne ligne:  self.getCompPanel().textWindowRight.SetStyle(0,0,wx.TextAttr(wx.BLACK,wx.WHITE,fontDefault)) 
                self.getCompPanel().textWindowRight.SetFont(fontDefault)                                 # Ajoutee 28.06.2019. 
                self.getCompPanel().textWindowRight.SetValue(loadFile(cheminC))
                self.getCompPanel().initialised = True
                self.executerMedite(None)
        self.reloadNavMenu()
        self.SetCursor(wx.STANDARD_CURSOR)
        # print("73. Module: GUI.Medite, Class: MediteFrame, Methode: executerAll, Ligne 1314 ") 
        
#############################################################################################
##      CHECK BUTTON                                                              ##
#############################################################################################
    def initialiserTextes(self,evt):
        
##        blocs = self.getCompPanel().resultatTransfo.identifierBlocs(self.getCompPanel().textWindowLeft.GetSelection())
##        textConca = self.getCompPanel().resultatTransfo.getTextesConcatenes()
##	per = [textConca[x[0][0]:x[0][1]] for x in blocs ]
##        print '\n',per
#        self.affichageCouleur()
#        self.affichageTransformations()

##        panel = self.getCompPanel()
##        panel.textWindowRight.SetSelection(0,0)
##        panel.textWindowLeft.SetSelection(0,0)
##        print '\nRight: ',panel.textWindowRight.GetSelection()
##        print '\nLeft: ',panel.textWindowLeft.GetSelection()
##

##        
##        com=self.getCompPanel().resultatTransfo.getListeDeplacements()
##        textConca = self.getCompPanel().resultatTransfo.getTextesConcatenes()
##        per = [textConca[x[0]:x[1]] for x in com ]
##        print '\n',per

#        self.affichageCouleur()
##        self.getCompPanel().resultatTransfo.checkDeplacements()
##        self.affichageTransformations()
      
        
        
##        com=self.getCompPanel().resultatTransfo.getListeDeplacements()
##        textConca = self.getCompPanel().resultatTransfo.getTextesConcatenes()
##        per = [textConca[x[0]:x[1]] for x in com ]
##        print '\n',per
##        
##        print self.parametres.getp1()
##        print self.parametres.getp2()
##        print self.parametres.getp3()
##        print self.parametres.getp4()
##        print self.parametres.getp5()
##        print self.parametres.getp6()
##        print self.parametres.getp7()

##        selection = self.getCompPanel().textWindowLeft.GetSelection()
##        transfo =self.getCompPanel().resultatTransfo
##        if transfo.isDeplacement(selection):
##            print 'yes'
##        else:
##            print 'no'    
##        #self.getCompPanel().initialiser()
##        res =self.getCompPanel().resultatTransfo =  Resultat([], [], [], [], 0, '', [], [])
##        print res.getListeDeplacements()
##        self.affichageCouleur()
        
##        self.enregistrerTransformations(evt)
        #self.chargerInformations(evt)
        blocs=self.getCompPanel().resultatTransfo.getPairesBlocsDeplaces()
        dep=self.getCompPanel().resultatTransfo.getListeDeplacements()
        textConca = self.getCompPanel().resultatTransfo.getTextesConcatenes()
        ##print dep
        ##print blocs
        self.logDep = open("dep.txt",'w')
        self.logpDep= open("pdep.txt",'w')
        d=0
        pd=0
        for x in dep :
            self.logDep.write('- '+textConca[x[0]:x[1]]+'\n')
            d+=1
        self.logDep.write(str(d))
        self.logDep.close()
        for x in blocs :
            self.logpDep.write('- '+textConca[x[0][0]:x[0][1]]+'-->'+textConca[x[1][0]:x[1][1]]+'\n')
            pd+=1
        self.logpDep.write(str(pd))
        self.logpDep.close()
##        paires = [ x for x in blocs if (textConca[x[1][0]:x[1][1]] == " aussi ")]
##        per1 = [(textConca[x[0][0]:x[0][1]],textConca[y[0][0]:y[0][1]]) for x in blocs for y in blocs if x[0]!=y[0] and x[1]==y[1]]
##        per2 = [(textConca[x[0][0]:x[0][1]],textConca[y[0][0]:y[0][1]]) for x in blocs for y in blocs if x[1]!=y[1] and x[0]==y[0]]
##        print paires
##        print textConca[23440:23455]
        
        
##        print blocs
##        print per1
##        print per2
        #print 'longueur deplacements : ',len(dep),'\n','longueur blocs : ',len(blocs),'\n'
        # print("74. Module: GUI.Medite, Class: MediteFrame, Methode: initialiserTextes, Ligne 1403 ") 
        

    # Methode qui appelle la méthode comparerEtats du controleur Medite afin de comparer
    # les deux états ouverts    
    def executerMedite(self,evt):
        logging.info('lancement comparaison')
        # print("75. Module: GUI.Medite, Class: MediteFrame, Methode: executerMedite, Ligne 1410,---> Lancement comparaison ") 
        self.noirSurBlanc()
        try :
            maxprogress = 20  # Valeur maximale de la barre de progression. # Modifiee 07.02.2019, remplace max ---> maxprogress
            self.prog = wx.ProgressDialog('Attendre','Excecution de la comparaison', maxprogress, self, style = wx.PD_AUTO_HIDE | wx.PD_APP_MODAL ) # | wxPD_ESTIMATED_TIME )
            self.prog.Show(show=1)              # Ajoutee 11.09.2019
            count = 0
            while count < (maxprogress-4)//2:                        # Modifiee 07.02.2019, remplace max ---> maxprogress
                count = count + 2
                #wxSleep(1)
                self.prog.Update(count)
            # print("75-1. Module: GUI.Medite, Class: MediteFrame, Methode: executerMedite, Ligne 1421 ---> self.parametres=", self.parametres, " ") 
            #sys.stderr.write( 'pParametres = '+self.parametres.toString())
            self.getPlanTravail().setParam(self.parametres)
            self.getCompPanel().resultatTransfo = self.cmed.comparerEtats(self.getPlanTravail())
            self.getCompPanel().initialised = True  
            
            self.prog.Update(10,"Affichage des transformations")
            while count < maxprogress-2: # Modifiee 07.02.2019, remplace max ---> maxprogress
                count = count + 2
                #wxSleep(1)
                self.prog.Update(count)
            self.affichageComparaison()
            
            sys.stderr.flush()
            self.prog.Update(maxprogress) # Modifiee 07.02.2019, remplace max ---> maxprogress
            # print("76. Module GUI.Medite.py, Class: MediteFrame, Methode: executerMedite, ligne 1436, executeMedite - try, \nself.parametres=[", self.parametres.getp1(), self.parametres.getp2(), self.parametres.getp3(), self.parametres.getp4(), self.parametres.getp5(), self.parametres.getp6(), self.parametres.getp7(), "] ")
            self.prog.Destroy()             # Ajoutee 11.09.2019
        except Exception as e: # Modifie 06.02.2019, ancienne ligne:  except Exception,e: 
            print (e)
            self.prog.Update(maxprogress) # Modifiee 07.02.2019, remplace max ---> maxprogress
#           dlg=wx.MessageDialog(self,str(e),wx.OK)
#            dlg.ShowModal()
#            dlg.Destroy()
            sys.stderr.write( str(e))  
            traceback.print_exc()
            sys.stderr.flush()
            # print("77. Module GUI.Medite.py, Class: MediteFrame, Methode: executerMedite, ligne 1447, executeMedite - except")
            self.prog.Destroy()             # Ajoutee 11.09.2019
    def reverseString(self, chaine):
        # print("78. Module GUI.Medite, Class: MediteFrame, Methode: reverseString, ligne 1450, \nchaine=", chaine) 
        if isinstance(chaine,str): # Modifiee 06.02.2019, ancienne ligne:  if isinstance(chaine,unicode):
            uni = [c for c in chaine]
            uni.reverse()
            # print("79. Module GUI.Medite, Class: MediteFrame, Methode: reverseString, ligne 1454, \nuni=", ''.join(uni)) 
            return ''.join(uni)
        else:   # bytes         # Modifiee, ancienne ligne contenait:  # str   
            # print("80. Module GUI.Medite, Class: MediteFrame, Methode: reverseString, ligne 1457, \nchaine=", chaine) 
            uni = chaine.decode('UTF-8')  # Modifiee 06.02.2019, ancienne ligne:  uni = unicode(chaine, 'utf-8')  bytedata.decode('UTF-8')
            uni = [c for c in uni]
            uni.reverse()
            uni = ''.join(uni) 
            # print("81. Module GUI.Medite, Class: MediteFrame, Methode: reverseString, ligne 1462, \nuni=", uni)
            # print("82. Module GUI.Medite, Class: MediteFrame, Methode: reverseString, ligne 1463, \nuni.encode('UTF-8')=", uni.encode('UTF-8'))
            return uni.encode('UTF-8')
        
    # Methode qui permet d'afficher les resultats de la comparaison dans la fenetre Transformations
    def affichageTransformations(self, reverse=False):
        # print("83. Module GUI.Medite, Class: MediteFrame, Methode: affichageTransformations, ligne 1468 ")
        texteAffichage= []
        textConca = self.getCompPanel().resultatTransfo.getTextesConcatenes()
        #print "recharger affichageTransformations type(texte) ",type(textConca)#,unicode(textConca,'utf-8')
        ## liste des sequences de caracteres inseres
        texteAffichage.append("\t\t Insertions : \n\n")
        for X in self.getCompPanel().resultatTransfo.getListeInsertions() :
            chaine = [ ' - ', textConca[X[0]:X[1]], '\n']
            #if reverse: 
            #    chaine = self.reverseString(chaine) 
            texteAffichage.extend(chaine)
        ## liste des sequences de caracteres supprimes
        texteAffichage+="\n\t\t Suppressions :\n\n"
        for X in self.getCompPanel().resultatTransfo.getListeSuppressions():
            chaine = [' - ', textConca[X[0]:X[1]], '\n']
            #print chaine
            #if reverse: 
            #    chaine = self.reverseString(chaine) 
            texteAffichage.extend(chaine)
        ## liste des sequences de caracteres deplaces
        texteAffichage+="\n\t\t Deplacements : \n\n"
        ldRes = self.getCompPanel().resultatTransfo.getPairesBlocsDeplaces()
        for X in ldRes:
            chaine = [' - ',textConca[X[0][0]:X[0][1]],' -> ',textConca[X[1][0]:X[1][1]],'\n']
            #if reverse: 
            #    chaine = self.reverseString(chaine)
            texteAffichage.extend(chaine) 
        ## liste des sequences de caracteres remplaces
        texteAffichage.append("\n\t\t Remplacements : \n\n")     
        lrRes = self.getCompPanel().resultatTransfo.getListeRemplacements()
        longueur = len(lrRes)//2                                             # Modifiee 24.06.2019, ancienne ligne:  longueur = len(lrRes)/2 
        i = 0
        for X in lrRes[0:longueur]:
            #if reverse: 
            #    chaine = self.reverseString(textConca[lrRes[i+longueur][0]:lrRes[i+longueur][1]]) + \
            #             " <---- "+self.reverseString(" - "+textConca[lrRes[i][0]:lrRes[i][1]])+'\n'   
            #else:
            chaine = [" - ",textConca[lrRes[i][0]:lrRes[i][1]], " ----> ",textConca[lrRes[i+longueur][0]:lrRes[i+longueur][1]],'\n']
            texteAffichage.extend(chaine)
            i+=1

######## Liste des blocs communs
        texteAffichage.append("\n\t\t Blocs Communs \n\n")
        com=self.getCompPanel().resultatTransfo.getBlocsCommuns()
        ln=len(com)//2                                                       # Modifiee 24.06.2019, ancienne ligne:  ln=len(com)/2 
        for i in range(ln):
            chaine = [ ' - ', textConca[com[i][0]:com[i][1]] ,"/",textConca[com[i+ln][0]:com[i+ln][1]] , '\n']
            texteAffichage.extend(chaine)

######## Liste des blocs non Definis
        texteAffichage.append("\n\t\t Blocs Non Definis :\n\n")
        for X in self.getCompPanel().resultatTransfo.getNonDef() :
            chaine = [ ' - ', textConca[X[0]:X[1]], '\n']
            texteAffichage.extend(chaine)

        # print ("84. Module GUI.Medite, Class: MediteFrame, Methode: affichageTransformations, ligne 1523, recharger affichageTransformations, \ntype(texteAffichage)=", type(texteAffichage)) 
        # print ("85. Module GUI.Medite, Class: MediteFrame, Methode: affichageTransformations, ligne 1524, recharger affichageTransformations \ntexteAffichage= %s", texteAffichage)           
        return ''.join(texteAffichage)

        
    def affichageCouleur(self):
        """ Methode qui permet d'afficher les resultats de la comparaison sur le texte Source
        et Cible a l'aide couleur et de font
        Les insertions seront reperees par du texte Bleu sur le texte cible
        Les suppressions seront reperees par du texte Rouge sur le texte source
        Les deplacements seront reperes par du texte en gras et souligne dans les deux textes
        Les remplacements seront reperes par du texte en violine-rose dans les deux textes """

        try:
            lgSource = self.getCompPanel().resultatTransfo.getLgSource()
        except AttributeError:
            return # resultatTransfo n'existe pas donc pas de couleur à afficher
            
        #texte = self.getCompPanel().textWindowLeft.GetValue() + self.getCompPanel().textWindowRight.GetValue()
        texte = self.getCompPanel().resultatTransfo.getTextesConcatenes()
        #print "affichageCouleur type(texte) ",type(texte)
        # chaine,y,enc = decode_string_heuristically(texte)            # Desactive 24.09.2019 
        # print ("86. Module GUI.Medite, Class: MediteFrame, Methode: affichageCouleur, ligne 1545, \ntexte=", texte, " ") #, \nchaine=", chaine, ", \ny=", y, ", enc=", enc, " ")
        #if isinstance(texte, unicode):
        # if enc == 'utf-8':                                        # Desactive 24.09.2019 
            #print texte.encode('utf-8'),len(texte),len(texte.encode('utf-8'))
            # print ("87. Module GUI.Medite, Class: MediteFrame, Methode: affichageCouleur, ligne 1548, \ntexte.encode('utf-8')=", texte.encode('utf-8'), ", \nlen(texte)= %s", len(texte), ", len(texte.encode('utf-8'))= %s", len(texte.encode('utf-8')))
            # backup = self.getCompPanel().resultatTransfo                # Desactive 19.09.2019
            #print backup,backup.getTextesConcatenes()
            # mapper = Utile.decodage.mapperUnicodeUtf(chaine, 'utf-8')   #backup.getTextesConcatenes())     # Desactive 19.09.2019
            # res = mapper.utfToUniResultat(backup)                        # Desactive 19.09.2019
            # self.getCompPanel().resultatTransfo = res                    # Desactive 19.09.2019
            # self.getCompPanel().resultatTransfoAffichageOnly = self.getCompPanel().resultatTransfo      # Desactive 24.09.2019 # Modifie 19.09.2019, ancienne:  self.getCompPanel().resultatTransfoAffichageOnly = res
            # self.affichageCouleur_()                                    # Desactive 24.09.2019 
            # self.getCompPanel().resultatTransfo = backup                # Desactive 19.09.2019
        # else:                                                            # Desactive 24.09.2019 
        self.getCompPanel().resultatTransfoAffichageOnly = self.getCompPanel().resultatTransfo
        self.affichageCouleur_()
        # print ("88. Module GUI.Medite, Class: MediteFrame, Methode: affichageCouleur, ligne 1561 ")
        
    def affichageCouleur_(self):            
        # Resultats de la comparaison sur les textes avec les couleurs
        lgSource = self.getCompPanel().resultatTransfo.getLgSource()
        self.getCompPanel().textWindowRight.Freeze()
        self.getCompPanel().textWindowLeft.Freeze()
        self.noirSurBlanc()
        #print "affichageCouleur type(self.getCompPanel().resultatTransfo.getTextesConcatenes()) ",type(self.getCompPanel().resultatTransfo.getTextesConcatenes())
        #print "affichageCouleur type(self.getCompPanel().textWindowLeft ",type(self.getCompPanel().textWindowLeft.GetValue())
        # Deplacements
        lSource = []
        lCible = []
        for X in self.getCompPanel().resultatTransfo.getListeDeplacements():
            if X[0]<lgSource:
                lSource.append((X[0],X[1]))
            else:
                lCible.append((X[0]-lgSource,X[1]-lgSource))
        #lSource.sort()
        #lCible.sort()
        
        if (self.couleursTransfo.getDeplacement() & 2)==2 : italic = wx.ITALIC
        else: italic = wx.NORMAL        
        if (self.couleursTransfo.getDeplacement() & 4)==4 : weight = wx.BOLD
        else: weight = wx.NORMAL
        if (self.couleursTransfo.getDeplacement() & 8)==8 : underline = True
        else: underline = False
        #fontDepl=wx.Font(10,wx.DEFAULT,italic,weight,underline,encoding=wx.FONTENCODING_ISO8859_1)
        fontDepl = self.getCompPanel().textWindowLeft.GetFont()
        fontDepl.SetStyle(italic)
        fontDepl.SetWeight(weight)
        fontDepl.SetUnderlined(underline)
        textColourDepl = wx.Colour(0, 0, 0)                        
        backgroundColourDepl = wx.Colour(255, 255, 255, wx.ALPHA_TRANSPARENT)         # Modifie 26.09.2019, ancienne:     backgroundColourDepl = wx.Colour(225, 205, 155)         
        # print ("89. Module GUI.Medite, Class: MediteFrame, Methode: affichageCouleur_, ligne 1595, ---> \nlSource=\n", str(lSource), ", \nlCible=\n", str(lCible), " \nfontDepl.GetStyle()=[", fontDepl.GetStyle(), "] ")
        # insertions
        for X in self.getCompPanel().resultatTransfo.getListeInsertions():
            i1 = X[0] - lgSource
            if i1 < 0: i1 = 0
            i2 = X[1] - lgSource
            self.getCompPanel().textWindowRight.SetStyle(i1,i2,wx.TextAttr(self.couleursTransfo.getEcriture(),self.couleursTransfo.getCoulInsert()))
        # print ("90. Module GUI.Medite, Class: MediteFrame, Methode: affichageCouleur_, ligne 1602, \nInsertions=\n", str(self.getCompPanel().resultatTransfo.getListeInsertions()))
        # suppressions
        for X in self.getCompPanel().resultatTransfo.getListeSuppressions():
            i1 = X[0] ; i2 = X[1]
            self.getCompPanel().textWindowLeft.SetStyle(i1,i2,wx.TextAttr(self.couleursTransfo.getEcriture(),self.couleursTransfo.getCoulSupp()))
        # print ("91. Module GUI.Medite, Class: MediteFrame, Methode: affichageCouleur_, ligne 1607, \nSuppressions=", str(self.getCompPanel().resultatTransfo.getListeSuppressions()))
            
        # Remplacements
        for X in self.getCompPanel().resultatTransfo.getListeRemplacements():
            if X[0]<lgSource:# Texte Source
                i1 = X[0] ; i2 = X[1]
                self.getCompPanel().textWindowLeft.SetStyle(i1,i2,wx.TextAttr(self.couleursTransfo.getEcriture(),self.couleursTransfo.getCoulRemp()))
            else: # texte Cible
                i1 = X[0] -  lgSource ; i2 = X[1] - lgSource
                self.getCompPanel().textWindowRight.SetStyle(i1,i2,wx.TextAttr(self.couleursTransfo.getEcriture(),self.couleursTransfo.getCoulRemp()))
        # print ("92. Module GUI.Medite, Class: MediteFrame, Methode: affichageCouleur_, ligne 1617, \nRemplacements=", str(self.getCompPanel().resultatTransfo.getListeRemplacements()))

        #deplacements        
        for d1,d2 in lSource:
            textAttr = wx.TextAttr()
            res = self.getCompPanel().textWindowLeft.GetStyle(d1, textAttr) 
            if res: textAttr.SetFont(fontDepl)                                                          # !!! A modifier plus tard !!!  19.07.2019
            else: textAttr = wx.TextAttr(font=fontDepl)                                                # !!! A modifier plus tard !!!  19.07.2019 
            textAttr.SetBackgroundColour(backgroundColourDepl)                # Désactive 26.09.2019
            textAttr.SetTextColour(textColourDepl)                            # Désactive 26.09.2019
            self.getCompPanel().textWindowLeft.SetStyle(d1, d2, textAttr)           # Modifiee 28.06.2019, ancienne ligne:  self.getCompPanel().textWindowLeft.SetStyle(d1,d2,wx.TextAttr(font=fontDepl)) # Ancienne 25.09.2019:  self.getCompPanel().textWindowLeft.SetStyle(d1,d2,wx.TextAttr(wx.BLACK, wx.WHITE)) 
            # print("92-1. Module GUI.Medite, Class: MediteFrame, Methode: affichageCouleur_, ligne 1628, ---> \ntextAttr.GetBackgroundColour()=[", textAttr.GetBackgroundColour(), "], \ textAttr.GetTextColour()=[", textAttr.GetTextColour(), "], \ntextAttr.GetFont()=[", textAttr.GetFont(), "], \ntextAttr.GetFontAttributes()=[", textAttr.GetFontAttributes(textAttr.GetFont(), flags=TEXT_ATTR_FONT), "] ")     # self.getCompPanel().textWindowLeft.SetFont(fontDepl)                                      # Ajoutee 27.06.2019. 
        for d1,d2 in lCible:
            textAttr = wx.TextAttr()
            res = self.getCompPanel().textWindowRight.GetStyle(d1, textAttr)
            if res: textAttr.SetFont(fontDepl)                                              # ???Modifiee 28.06.2019, ancienne ligne:  if res: textAttr.SetFont(fontDepl)
            else: textAttr = wx.TextAttr(font=fontDepl)                                     # ???Modifiee 28.06.2019, ancienne ligne:  else: textAttr = wx.TextAttr(font=fontDepl)  
            textAttr.SetBackgroundColour(backgroundColourDepl)                # Désactive 26.09.2019
            textAttr.SetTextColour(textColourDepl)                            # Désactive 26.09.2019
            self.getCompPanel().textWindowRight.SetStyle(d1, d2, textAttr)      # Modifiee 28.06.2019, ancienne ligne:  self.getCompPanel().textWindowRight.SetStyle(d1,d2,wx.TextAttr(font=fontDepl)) # Ancienne 25.09.2019:  self.getCompPanel().textWindowRight.SetStyle(d1,d2,wx.TextAttr(wx.BLACK, wx.WHITE))
            # print("92-2. Module GUI.Medite, Class: MediteFrame, Methode: affichageCouleur_, ligne 1637, ---> textAttr.GetBackgroundColour()=[", textAttr.GetBackgroundColour(), "], textAttr.GetTextColour()=[", textAttr.GetTextColour(), "], textAttr.GetFont()=[", textAttr.GetFont(), "] ") # self.getCompPanel().textWindowRight.SetFont(fontDepl)                                   # Ajoutee 27.06.2019.

        # non Definis
        for X in self.getCompPanel().resultatTransfo.getNonDef():
            if X[0]<lgSource:
                i1 = X[0] ; i2 = X[1]
                self.getCompPanel().textWindowLeft.SetStyle(i1,i2,wx.TextAttr(self.couleursTransfo.getEcriture(),self.couleursTransfo.getCoulNonDef()))
            else: # texte Cible
                i1 = X[0] -  lgSource ; i2 = X[1] - lgSource
                self.getCompPanel().textWindowRight.SetStyle(i1,i2,wx.TextAttr(self.couleursTransfo.getEcriture(),self.couleursTransfo.getCoulNonDef()))
        # print ("93. Module GUI.Medite, Class: MediteFrame, Methode: affichageCouleur_, ligne 1647, \nnon_Definis=", str(self.getCompPanel().resultatTransfo.getNonDef()))
        self.getCompPanel().textWindowRight.Thaw()
        self.getCompPanel().textWindowLeft.Thaw()
        # print ("94. Module GUI.Medite, Class: MediteFrame, Methode: affichageCouleur_, ligne 1650, \ntextWindowLeft=", self.getCompPanel().textWindowLeft.GetValue(), ", \ntextWindowRight=", self.getCompPanel().textWindowRight.GetValue())
        
    def affichageCouleur___(self):            
        # Resultats de la comparaison sur les textes avec les couleurs
        lgSource = self.getCompPanel().resultatTransfo.getLgSource()
        self.getCompPanel().textWindowRight.Freeze()
        self.getCompPanel().textWindowLeft.Freeze()
        #print "affichageCouleur type(self.getCompPanel().resultatTransfo.getTextesConcatenes()) ",type(self.getCompPanel().resultatTransfo.getTextesConcatenes())
        #print "affichageCouleur type(self.getCompPanel().textWindowLeft ",type(self.getCompPanel().textWindowLeft.GetValue())
        # Deplacements
        lSource = []
        lCible = []
        for X in self.getCompPanel().resultatTransfo.getListeDeplacements():
            if X[0]<lgSource:
                lSource.append((X[0],X[1]))
            else:
                lCible.append((X[0]-lgSource,X[1]-lgSource))
        lSource.sort()
        lCible.sort()
        
        if (self.couleursTransfo.getDeplacement() & 2)==2 : italic = wx.ITALIC
        else: italic = wx.NORMAL        
        if (self.couleursTransfo.getDeplacement() & 4)==4 : weight = wx.BOLD
        else: weight = wx.NORMAL
        if (self.couleursTransfo.getDeplacement() & 8)==8 : underline = True
        else: underline = False
        #fontDepl=wx.Font(10,wx.DEFAULT,italic,weight,underline,encoding=wx.FONTENCODING_ISO8859_1)
        fontDepl = self.getCompPanel().textWindowLeft.GetFont()
        fontDepl.SetStyle(italic)
        fontDepl.SetWeight(weight)
        fontDepl.SetUnderlined(underline)
        textColourDepl = wx.Colour(0, 0, 0) 
        backgroundColourDepl = wx.Colour(255, 255, 255, wx.ALPHA_TRANSPARENT)                 # Modifie 26.09.2019, ancienne:   backgroundColourDepl = wx.Colour(225, 205, 155)
        # print ("95. Module GUI.Medite, Class: MediteFrame, Methode: affichageCouleur___, ligne 1683,  \nDeplacements--> \nlSource=", str(lSource), ", \nlCible=", str(lCible))
        
        # Deplacements seuls
        for d1,d2 in lSource:
            textAttr = wx.TextAttr()                                                                    #  ajoute 25.09.2019
            res = self.getCompPanel().textWindowLeft.GetStyle(d1, textAttr)                             #  ajoute 25.09.2019 
            if res: textAttr.SetFont(fontDepl)                                                          #  ajoute 25.09.2019
            else: textAttr = wx.TextAttr(font=fontDepl)                                                 #  ajoute 25.09.2019
            textAttr.SetBackgroundColour(backgroundColourDepl)                    # Désactive 26.09.2019
            textAttr.SetTextColour(textColourDepl)                                # Désactive 26.09.2019
            self.getCompPanel().textWindowLeft.SetStyle(d1, d2, textAttr)                               #  ajoute 25.09.2019  
            #        self.getCompPanel().textWindowLeft.SetStyle(d1,d2,wx.TextAttr(wx.BLACK, wx.WHITE))          # Desactive 25.09.2019 # Modifiee 28.06.2019, ancienne ligne:  self.getCompPanel().textWindowLeft.SetStyle(d1,d2,wx.TextAttr(font=fontDepl)) # Ancienne 25.09.2019:  self.getCompPanel().textWindowLeft.SetStyle(d1,d2,wx.TextAttr(wx.BLACK, wx.WHITE))
            # self.getCompPanel().textWindowLeft.SetFont(fontDepl)                                        # Ajoutee 28.06.2019.
            #self.getCompPanel().textWindowLeft.SetStyle(d1, d2,0)
            #print d1,d2
        for d1,d2 in lCible:
            textAttr = wx.TextAttr()                                                                    #  ajoute 25.09.2019
            res = self.getCompPanel().textWindowRight.GetStyle(d1, textAttr)                             #  ajoute 25.09.2019 
            if res: textAttr.SetFont(fontDepl)                                                          #  ajoute 25.09.2019
            else: textAttr = wx.TextAttr(font=fontDepl)                                                 #  ajoute 25.09.2019
            textAttr.SetBackgroundColour(backgroundColourDepl)                    # Désactive 26.09.2019
            textAttr.SetTextColour(textColourDepl)                                # Désactive 26.09.2019
            self.getCompPanel().textWindowRight.SetStyle(d1, d2, textAttr)                               #  ajoute 25.09.2019  
            #        self.getCompPanel().textWindowRight.SetStyle(d1,d2,wx.TextAttr(wx.BLACK, wx.WHITE))          # Desactive 25.09.2019 # Modifiee 28.06.2019, ancienne ligne:  self.getCompPanel().textWindowRight.SetStyle(d1,d2,wx.TextAttr(font=fontDepl)) # Ancienne 25.09.2019:  self.getCompPanel().textWindowRight.SetStyle(d1,d2,wx.TextAttr(wx.BLACK, wx.WHITE))
            # self.getCompPanel().textWindowRight.SetFont(fontDepl)                                       # Ajoutee 28.06.2019.
            #self.getCompPanel().textWindowRight.SetStyle(d1, d2,0)
            #print d1+lgSource,d2+lgSource
        # Insertions
        t=self.getCompPanel().resultatTransfo.getTextesConcatenes()
        #print lgSource,len(t)
        #print t
        # print ("96. Module GUI.Medite, Class: MediteFrame, Methode: affichageCouleur___, ligne 1714, \nInsertions=", t)
        # print ("97. Module GUI.Medite, Class: MediteFrame, Methode: affichageCouleur___, ligne 1715, \nInsertions=", str(self.getCompPanel().resultatTransfo.getListeInsertions()))
        for X in self.getCompPanel().resultatTransfo.getListeInsertions():
            #sys.stderr.write("INS3 : "+t[X[0]:X[1]]+"\n")
            #self.getCompPanel().textWindowRight.SetInsertionPoint(0)
            i1 = X[0]-lgSource
            if i1<0:i1=0
            i2 = X[1]-lgSource
            #sys.stderr.write("X="+str(X)+" / i1="+str(i1)+" / i2="+str(i2)+"\n")
            self.getCompPanel().textWindowRight.SetStyle(i1,i2,wx.TextAttr(self.couleursTransfo.getEcriture(),self.couleursTransfo.getCoulInsert()))
            #self.getCompPanel().textWindowRight.SetStyle(i1, i2, 0)
            for d1,d2 in lCible: # Déplacements dans des insertions
                if ((i1<=d1<=i2) or (i1<=d2<=i2) or ((d1<=i1)and(d2>=i2))):
                    #sys.stderr.write("dep : "+t[d1:d2]+"\n")
                    if (d1<=i1):
                        if (d2<=i2):
                            self.getCompPanel().textWindowRight.SetStyle(i1,d2,wx.TextAttr(self.couleursTransfo.getEcriture(),self.couleursTransfo.getCoulInsert(),fontDepl))       # Modifiee 28.06.2019, ancienne ligne:  self.getCompPanel().textWindowRight.SetStyle(i1,d2,wx.TextAttr(self.couleursTransfo.getEcriture(),self.couleursTransfo.getCoulInsert(),fontDepl))
                            # self.getCompPanel().textWindowRight.SetFont(fontDepl)                     # Ajoutee 28.06.2019. 
                            #self.getCompPanel().textWindowRight.SetStyle(i1, d2, 0)
                        else:
                            self.getCompPanel().textWindowRight.SetStyle(i1,i2,wx.TextAttr(self.couleursTransfo.getEcriture(),self.couleursTransfo.getCoulInsert(),fontDepl))   # Modifiee 28.06.2019, ancienne ligne:  self.getCompPanel().textWindowRight.SetStyle(i1,i2,wx.TextAttr(self.couleursTransfo.getEcriture(),self.couleursTransfo.getCoulInsert(),fontDepl))
                            # self.getCompPanel().textWindowRight.SetFont(fontDepl)                     # Ajoutee 28.06.2019. 
                    else:
                        if(d2<=i2):
                            self.getCompPanel().textWindowRight.SetStyle(d1,d2,wx.TextAttr(self.couleursTransfo.getEcriture(),self.couleursTransfo.getCoulInsert(),fontDepl))    # Modifiee 28.06.2019, ancienne ligne: self.getCompPanel().textWindowRight.SetStyle(d1,d2,wx.TextAttr(self.couleursTransfo.getEcriture(),self.couleursTransfo.getCoulInsert(),fontDepl)) 
                            # self.getCompPanel().textWindowRight.SetFont(fontDepl)                     # Ajoutee 28.06.2019. 
                        else:
                            self.getCompPanel().textWindowRight.SetStyle(d1,i2,wx.TextAttr(self.couleursTransfo.getEcriture(),self.couleursTransfo.getCoulInsert(),fontDepl))   # Modifiee 28.06.2019, ancienne ligne: self.getCompPanel().textWindowRight.SetStyle(d1,i2,wx.TextAttr(self.couleursTransfo.getEcriture(),self.couleursTransfo.getCoulInsert(),fontDepl))
                            # self.getCompPanel().textWindowRight.SetFont(fontDepl)                     # Ajoutee 28.06.2019.

        # Suppressions
        #t=self.getCompPanel().resultatTransfo.getTextesConcatenes()
        for X in self.getCompPanel().resultatTransfo.getListeSuppressions():
            #self.getCompPanel().textWindowLeft.SetInsertionPoint(0)
            i1 = X[0]
            i2 = X[1]
            self.getCompPanel().textWindowLeft.SetStyle(i1,i2,wx.TextAttr(self.couleursTransfo.getEcriture(),self.couleursTransfo.getCoulSupp()))
            #self.getCompPanel().textWindowLeft.SetStyle(i1, i2, 0)
            for d1,d2 in lSource: # Déplacements dans Suppresion
                if ((i1<=d1<=i2) or (i1<=d2<=i2) or ((d1<=i1)and(d2>=i2))):
                    if (d1<=i1):
                        if (d2<=i2):
                            self.getCompPanel().textWindowLeft.SetStyle(i1,d2,wx.TextAttr(self.couleursTransfo.getEcriture(),self.couleursTransfo.getCoulSupp(),fontDepl))
                            #self.getCompPanel().textWindowLeft.SetStyle(i1, d2, 0)
                        else:
                            self.getCompPanel().textWindowLeft.SetStyle(i1,i2,wx.TextAttr(self.couleursTransfo.getEcriture(),self.couleursTransfo.getCoulSupp(),fontDepl))
                    else:
                        if(d2<=i2):
                            self.getCompPanel().textWindowLeft.SetStyle(d1,d2,wx.TextAttr(self.couleursTransfo.getEcriture(),self.couleursTransfo.getCoulSupp(),fontDepl))
                        else:
                            self.getCompPanel().textWindowLeft.SetStyle(d1,i2,wx.TextAttr(self.couleursTransfo.getEcriture(),self.couleursTransfo.getCoulSupp(),fontDepl))
        # print ("98. Module GUI.Medite, Class: MediteFrame, Methode: affichageCouleur___, ligne 1765, \nSuppressions=", str(self.getCompPanel().resultatTransfo.getListeSuppressions()))

        # Remplacements
        for X in self.getCompPanel().resultatTransfo.getListeRemplacements():
            if X[0]<lgSource:# Texte Source
                #self.getCompPanel().textWindowLeft.SetInsertionPoint(0)
                i1 = X[0]
                i2 = X[1]
                self.getCompPanel().textWindowLeft.SetStyle(i1,i2,wx.TextAttr(self.couleursTransfo.getEcriture(),self.couleursTransfo.getCoulRemp()))
                for d1,d2 in lSource: # déplacement dans remplacement
                    if ((i1<=d1<=i2) or (i1<=d2<=i2) or ((d1<=i1)and(d2>=i2))):
                        if (d1<=i1):
                            if (d2<=i2):
                                self.getCompPanel().textWindowLeft.SetStyle(i1,d2,wx.TextAttr(self.couleursTransfo.getEcriture(),self.couleursTransfo.getCoulRemp(),fontDepl))
                            else:
                                self.getCompPanel().textWindowLeft.SetStyle(i1,i2,wx.TextAttr(self.couleursTransfo.getEcriture(),self.couleursTransfo.getCoulRemp(),fontDepl))
                        else:
                            if(d2<=i2):
                                self.getCompPanel().textWindowLeft.SetStyle(d1,d2,wx.TextAttr(self.couleursTransfo.getEcriture(),self.couleursTransfo.getCoulRemp(),fontDepl))
                            else:
                                self.getCompPanel().textWindowLeft.SetStyle(d1,i2,wx.TextAttr(self.couleursTransfo.getEcriture(),self.couleursTransfo.getCoulRemp(),fontDepl))
            else: # texte Cible
                #self.getCompPanel().textWindowRight.SetInsertionPoint(0)
                i1 = X[0]-lgSource
                i2 = X[1]-lgSource
                self.getCompPanel().textWindowRight.SetStyle(i1,i2,wx.TextAttr(self.couleursTransfo.getEcriture(),self.couleursTransfo.getCoulRemp()))
                for d1,d2 in lCible: # déplacement dans remplacement
                    if ((i1<=d1<=i2) or (i1<=d2<=i2) or ((d1<=i1)and(d2>=i2))):
                        if (d1<=i1):
                            if (d2<=i2):
                                self.getCompPanel().textWindowRight.SetStyle(i1,d2,wx.TextAttr(self.couleursTransfo.getEcriture(),self.couleursTransfo.getCoulRemp(),fontDepl))
                            else:
                                self.getCompPanel().textWindowRight.SetStyle(i1,i2,wx.TextAttr(self.couleursTransfo.getEcriture(),self.couleursTransfo.getCoulRemp(),fontDepl))
                        else:
                            if(d2<=i2):
                                self.getCompPanel().textWindowRight.SetStyle(d1,d2,wx.TextAttr(self.couleursTransfo.getEcriture(),self.couleursTransfo.getCoulRemp(),fontDepl))
                            else:
                                self.getCompPanel().textWindowRight.SetStyle(d1,i2,wx.TextAttr(self.couleursTransfo.getEcriture(),self.couleursTransfo.getCoulRemp(),fontDepl))
        # print ("99. Module GUI.Medite, Class: MediteFrame, Methode: affichageCouleur___, ligne 1803, \nRemplacements=", str(self.getCompPanel().resultatTransfo.getListeRemplacements()))
        
        self.getCompPanel().textWindowRight.Thaw()
        self.getCompPanel().textWindowLeft.Thaw()
        # print ("100. Module GUI.Medite, Class: MediteFrame, Methode: affichageCouleur___, ligne 1807, \ntextWindowLeft=", self.getCompPanel().textWindowLeft.GetValue(), ", \ntextWindowRight=", self.getCompPanel().textWindowRight.GetValue())
        
    def affichageComparaison(self):
        #Listes des transformations affichees dans la fenetre transformations
        logging.debug('begin affichageTransformations') 
        trans = self.affichageTransformations()         #reverse=True)
        logging.debug('fin affichageTransformations')
        chaine = trans # Modifie 24.09.2019, ancienne:  chaine,num,encodage = decode_string_heuristically(trans)
        # print ("100-1. Module GUI.Medite, Class: MediteFrame, Methode: affichageComparaison, ligne 1815 ---> \nchaine=\n", chaine, " ") # , \nnum=", num, ", \nencodage=", encodage, " ")
        # if encodage == 'utf-8':                    # Desactive 24.09.2019 
        fontDefault=wx.Font(10,wx.DEFAULT,wx.NORMAL,wx.NORMAL,encoding=wx.FONTENCODING_DEFAULT)            # Modifie 25.09.2019, ancienne:  fontDefault=wx.Font(10,wx.DEFAULT,wx.NORMAL,wx.NORMAL,encoding=wx.FONTENCODING_UTF8)
        # else:                                                                    # Desactive 24.09.2019 
            # fontDefault=wx.Font(10,wx.DEFAULT,wx.NORMAL,wx.NORMAL)                # Desactive 24.09.2019 
        #print "affichageComparaison type(chaine) ",type(chaine),len(chaine)    
        # print("100-2. Module GUI.Medite, Class: MediteFrame, Methode: affichageComparaison, ligne 1821, ---> \naffichage des attributes de wx.TextAttr: ", wx.TextAttr.__dict__.keys())  
        # print("101. Module GUI.Medite, Class: MediteFrame, Methode: affichageComparaison, ligne 1822, ---> \naffichage des attributes de wx.TextCtrl: ", wx.TextCtrl.__dict__.keys())  
        # print("Trace 1_22 ---> module GUI.Medite.py (ligne 1717) ---  ---> class(wx.TextAttr)=", wx.TextAttr.__class__.__name__) 
        # print("Trace 1_23 ---> module GUI.Medite.py (ligne 1718) ---  ---> class(wx.TextCtrl)=", wx.TextCtrl.__class__.__name__) 
        # print("Trace 1_24 ---> module GUI.Medite.py (ligne 1719) ---  ---> type(wx.TextAttr)=", type(wx.TextAttr)) 
        # print("Trace 1_25 ---> module GUI.Medite.py (ligne 1720) ---  ---> type(wx.TextCtrl)=", type(wx.TextCtrl))                   
        self.getCompPanel().transformations.SetFont(fontDefault)              # Modifiee 27.06.2019, ancienne ligne:  self.getCompPanel().transformations.SetDefaultStyle(wx.TextAttr(Font=fontDefault)) # self.getCompPanel().transformations.SetDefaultStyle(wx.TextAttr(wx.DEFAULT, wx.NullColour, fontDefault))
        # self.getCompPanel().transformations.default_font = fontDefault
        #s = unicode(self.getCompPanel().resultatTransfo.getTextesConcatenes(),'utf-8')
        #print s.encode('raw_unicode_escape')
        #print s[:25].encode('raw_unicode_escape')
        #s = self.reverseString(s[:25])
        #print s.encode('unicode_escape')
        #print "affichageComparaison type(chaine) ",type(chaine),len(chaine)
        #print "affichageComparaison type(trans) ",type(trans),len(trans)
        self.getCompPanel().transformations.Clear()
        self.getCompPanel().transformations.SetValue(chaine)
        logging.debug('begin affichageCouleur') 
        self.affichageCouleur()
        logging.debug('fin affichageCouleur') 
        #Rendre accessible les fonctionnalites enregistrer transformations et les informations
        self.smEnregistrer.Enable(ID_ADD_TRANSFOS, True)
        self.smEnregistrer.Enable(ID_ADD_TRANSFOS_COMMENT, True)
        # print("102. Module GUI.Medite, Class: MediteFrame, Methode: affichageComparaison, ligne 1844, fin affichageCouleur, \n\nchaine=\n", chaine)

    def affichageCouleurChangements(self,Lchangements):
        """ Methode qui permet d'afficher les resultats de la comparaison sur le texte Source
        et Cible a l'aide couleur et de font
        Les insertions seront reperees par du texte Bleu sur le texte cible
        Les suppressions seront reperees par du texte Rouge sur le texte source
        Les deplacements seront reperes par du texte en gras et souligne dans les deux textes
        Les remplacements seront reperes par du texte en violine-rose dans les deux textes """

        try:
            lgSource = self.getCompPanel().resultatTransfo.getLgSource()
        except AttributeError:
            return # resultatTransfo n'existe pas donc pas de couleur � afficher
            
        #texte = self.getCompPanel().textWindowLeft.GetValue() + self.getCompPanel().textWindowRight.GetValue()
        texte = self.getCompPanel().resultatTransfo.getTextesConcatenes()
        #print "affichageCouleur type(texte) ",type(texte)
        # chaine,y,enc = decode_string_heuristically(texte)                    # Desactive 24.09.2019 
        # print("103. Module GUI.Medite, Class: MediteFrame, Methode: affichageCouleurChangements, ligne 1863, \ntexte=", texte, " ") #, \nchaine=", chaine, ", \ny= %s", y, ", enc= %s", enc)
        #if isinstance(texte, unicode):
        # if enc == 'utf-8':                        # Desactive 24.09.2019 
            #print texte.encode('utf-8'),len(texte),len(texte.encode('utf-8'))
            # print ("104. Module GUI.Medite, Class: MediteFrame, Methode: affichageCouleurChangements, ligne 1844, \ntexte.encode('utf-8')=", texte.encode('utf-8'), ", \nlen(texte)= %s", len(texte), ", len(texte.encode('utf-8'))= %s", len(texte.encode('utf-8')))
            # backup = self.getCompPanel().resultatTransfo        # Desactive 20.09.2019 
            #print backup,backup.getTextesConcatenes()
            # print ("105. Module GUI.Medite, Class: MediteFrame, Methode: affichageCouleurChangements, ligne 1847, \nbackup=", backup, ", \nbackup.getTextesConcatenes()=", backup.getTextesConcatenes())
            # mapper = Utile.decodage.mapperUnicodeUtf(chaine, 'utf-8')   #backup.getTextesConcatenes())     # Desactive 20.09.2019 
            
            # res = mapper.utfToUniResultat(backup)                        # Desactive 20.09.2019 
            # print ("106. Module GUI.Medite, Class: MediteFrame, Methode: affichageCouleurChangements, ligne 1851, \nmapper=", str(mapper), ", \nres=", str(res))
            # self.getCompPanel().resultatTransfo = res                    # Desactive 20.09.2019 
            # self.getCompPanel().resultatTransfoAffichageOnly = self.getCompPanel().resultatTransfo      # Desactive 24.09.2019 # Modifie 20.09.2019, ancienne:  self.getCompPanel().resultatTransfoAffichageOnly = res
            # self.affichageCouleur_()                                    # Desactive 24.09.2019 
            # self.getCompPanel().resultatTransfo = backup                # Desactive 20.09.2019
        # else:                                                            # Desactive 24.09.2019 
        self.getCompPanel().resultatTransfoAffichageOnly = self.getCompPanel().resultatTransfo
        self.affichageCouleur_Changements(Lchangements)
        # print ("107. Module GUI.Medite, Class: MediteFrame, Methode: affichageCouleurChangements, ligne 1882 ")

    def affichageCouleur_Changements(self,Lchangements):

        #fontDefault=wx.Font(10,wx.DEFAULT,wx.NORMAL,wx.NORMAL,encoding=wx.FONTENCODING_ISO8859_1)
        fontDefault=self.getCompPanel().textWindowLeft.GetFont()

        
        # Resultats de la comparaison sur les textes avec les couleurs
        lgSource = self.getCompPanel().resultatTransfo.getLgSource()
        self.getCompPanel().textWindowRight.Freeze()
        self.getCompPanel().textWindowLeft.Freeze()
#        self.noirSurBlanc()
        # print ("108. Module GUI.Medite, Class: MediteFrame, Methode: affichageCouleur_Changements, ligne 1895--->affichageCouleur \ntype(self.getCompPanel().resultatTransfo.getTextesConcatenes())=", type(self.getCompPanel().resultatTransfo.getTextesConcatenes())) 
        # print ("109. Module GUI.Medite, Class: MediteFrame, Methode: affichageCouleur_Changements, ligne 1896---> affichageCouleur \ntype(self.getCompPanel().textWindowLeft ", type(self.getCompPanel().textWindowLeft.GetValue()))    
        # print ("110. Module GUI.Medite, Class: MediteFrame, Methode: affichageCouleur_Changements, ligne 1897, \ntextWindowLeft=", self.getCompPanel().textWindowLeft.GetValue(), ", \ntextWindowRight=", self.getCompPanel().textWindowRight.GetValue())   

        if (self.couleursTransfo.getDeplacement() & 2)==2 : italic = wx.ITALIC
        else: italic = wx.NORMAL        
        if (self.couleursTransfo.getDeplacement() & 4)==4 : weight = wx.BOLD
        else: weight = wx.NORMAL
        if (self.couleursTransfo.getDeplacement() & 8)==8 : underline = True
        else: underline = False
        #fontDepl=wx.Font(10,wx.DEFAULT,italic,weight,underline,encoding=wx.FONTENCODING_ISO8859_1)
        fontDepl = self.getCompPanel().textWindowLeft.GetFont()
        fontDepl.SetStyle(italic)
        fontDepl.SetWeight(weight)
        fontDepl.SetUnderlined(underline)
        textColourDepl = wx.Colour(0, 0, 0) 
        backgroundColourDepl = wx.Colour(255, 255, 255, wx.ALPHA_TRANSPARENT)                  # Modifie 26.09.2019, ancienne:   backgroundColourDepl = wx.Colour(225, 205, 155) 
        transfo = self.getCompPanel().resultatTransfo
        # print ("111. Module GUI.Medite, Class: MediteFrame, Methode: affichageCouleur_Changements, ligne 1913, \ntransfo=", self.getCompPanel().resultatTransfo.getTextesConcatenes())

        #Insertions
        Linsertions  = [x for x in Lchangements if transfo.isInsertion(x)[0]]

        for X in Linsertions:
            i1 = X[0] - lgSource
            if i1 < 0: i1 = 0
            i2 = X[1] - lgSource
            self.getCompPanel().textWindowRight.SetStyle(i1,i2,wx.TextAttr(wx.BLACK, wx.WHITE, fontDefault))      # Modifiee 01.07.2019, ancienne ligne: self.getCompPanel().textWindowRight.SetStyle(i1,i2,wx.TextAttr(wx.BLACK,wx.WHITE,fontDefault))
            # self.getCompPanel().textWindowRight.SetFont(fontDefault)                                # Ajoutee 01.07.2019
            self.getCompPanel().textWindowRight.SetStyle(i1,i2,wx.TextAttr(self.couleursTransfo.getEcriture(),self.couleursTransfo.getCoulInsert()))
        # print ("112. Module GUI.Medite, Class: MediteFrame, Methode: affichageCouleur_Changements, ligne 1925, \nLinsertions=", str(Linsertions))

        #Suppressions
        Lsuppressions = [ x for x in Lchangements if transfo.isSuppression(x)[0]]

        for X in Lsuppressions:
            i1 = X[0] ; i2 = X[1]
            self.getCompPanel().textWindowLeft.SetStyle(i1,i2,wx.TextAttr(wx.BLACK, wx.WHITE, fontDefault))       # Modifiee 01.07.2019, ancienne ligne: self.getCompPanel().textWindowLeft.SetStyle(i1,i2,wx.TextAttr(wx.BLACK,wx.WHITE,fontDefault))
            # self.getCompPanel().textWindowLeft.SetFont(fontDefault)                                 # Ajoutee 01.07.2019 
            self.getCompPanel().textWindowLeft.SetStyle(i1,i2,wx.TextAttr(self.couleursTransfo.getEcriture(),self.couleursTransfo.getCoulSupp()))
        # print ("113. Module GUI.Medite, Class: MediteFrame, Methode: affichageCouleur_Changements, ligne 1935, \nLsuppressions=", str(Lsuppressions))

        #Remplacements
        Lremplacements = [x for x in Lchangements if transfo.isRemplacement(x)[0]]

        for X in Lremplacements:
            if X[0]<lgSource:# Texte Source
                i1 = X[0] ; i2 = X[1]
                self.getCompPanel().textWindowLeft.SetStyle(i1,i2,wx.TextAttr(wx.BLACK,wx.WHITE, fontDefault))       # Modifiee 01.07.2019, ancienne ligne: self.getCompPanel().textWindowLeft.SetStyle(i1,i2,wx.TextAttr(wx.BLACK,wx.WHITE))
                # self.getCompPanel().textWindowLeft.SetFont(fontDefault)                                 # Ajoutee 01.07.2019
                self.getCompPanel().textWindowLeft.SetStyle(i1,i2,wx.TextAttr(self.couleursTransfo.getEcriture(),self.couleursTransfo.getCoulRemp()))
            else: # texte Cible
                i1 = X[0] -  lgSource ; i2 = X[1] - lgSource
                self.getCompPanel().textWindowRight.SetStyle(i1,i2,wx.TextAttr(wx.BLACK,wx.WHITE, fontDefault))      # Modifiee 01.07.2019, ancienne ligne: self.getCompPanel().textWindowRight.SetStyle(i1,i2,wx.TextAttr(wx.BLACK,wx.WHITE, fontDefault))
                # self.getCompPanel().textWindowRight.SetFont(fontDefault)                                # Ajoutee 01.07.2019 
                self.getCompPanel().textWindowRight.SetStyle(i1,i2,wx.TextAttr(self.couleursTransfo.getEcriture(),self.couleursTransfo.getCoulRemp()))
        # print ("114. Module GUI.Medite, Class: MediteFrame, Methode: affichageCouleur_Changements, ligne 1951, \nLremplacements=", str(Lremplacements))

        #Déplacements :
        Ldeplacements = [ x for x in Lchangements if transfo.isDeplacement(x)[0]]

        lSource = []
        lCible = []
        for X in Ldeplacements:
            if X[0]<lgSource:
                lSource.append((X[0],X[1]))
            else:
                lCible.append((X[0]-lgSource,X[1]-lgSource))

        for d1,d2 in lSource:
            textAttr = wx.TextAttr()
            res = self.getCompPanel().textWindowLeft.GetStyle(d1, textAttr) 
            if res: textAttr.SetFont(fontDepl)
            else: textAttr = wx.TextAttr(font=fontDepl)
            textAttr.SetBackgroundColour(backgroundColourDepl)                    # Désactive 26.09.2019
            textAttr.SetTextColour(textColourDepl)                                # Désactive 26.09.2019
            self.getCompPanel().textWindowLeft.SetStyle(d1, d2, textAttr)       # Modifiee 01.07.2019, ancienne ligne: self.getCompPanel().textWindowLeft.SetStyle(d1,d2,wx.TextAttr(wx.BLACK,wx.WHITE,fontDefault))
            self.getCompPanel().textWindowLeft.SetStyle(d1,d2,wx.TextAttr(font=fontDepl))               # Desactivee 28.06.2019
            self.getCompPanel().textWindowLeft.SetFont(fontDepl)                                      # Ajoutee 28.06.2019
        for d1,d2 in lCible:
            textAttr = wx.TextAttr()
            res = self.getCompPanel().textWindowRight.GetStyle(d1, textAttr)
            if res: textAttr.SetFont(fontDepl)
            else: textAttr = wx.TextAttr(font=fontDepl)
            textAttr.SetBackgroundColour(backgroundColourDepl)                    # Désactive 26.09.2019
            textAttr.SetTextColour(textColourDepl)                                # Désactive 26.09.2019
            self.getCompPanel().textWindowRight.SetStyle(d1, d2, textAttr)      # Modifiee 01.07.2019, ancienne ligne: self.getCompPanel().textWindowRight.SetStyle(d1,d2,wx.TextAttr(wx.BLACK,wx.WHITE,fontDefault))
            # self.getCompPanel().textWindowRight.SetStyle(d1,d2,wx.TextAttr(font=fontDepl))        # Desactivee 28.06.2019
            # self.getCompPanel().textWindowRight.SetFont(fontDepl)                                      # Ajoutee 28.06.2019 
        # print ("115. Module GUI.Medite, Class: MediteFrame, Methode: affichageCouleur_Changements, ligne 1984, \nLdeplacements=", str(Ldeplacements))
        
        #Blocs Communs
        LBC = [x for x in Lchangements if transfo.isBlocCommun(x)[0]]

        for X in LBC :
            if X[0]<lgSource:
                i1 = X[0]; i2 = X[1]
                self.getCompPanel().textWindowLeft.SetStyle(i1,i2,wx.TextAttr(wx.BLACK,wx.WHITE))       # Modifiee 01.07.2019, ancienne ligne: self.getCompPanel().textWindowLeft.SetStyle(i1,i2,wx.TextAttr(wx.BLACK,wx.WHITE,fontDefault))
                # self.getCompPanel().textWindowLeft.SetFont(fontDefault)                                 # Ajoutee 28.06.2019 
            else: # texte Cible
                i1 = X[0] -  lgSource ; i2 = X[1] - lgSource
                self.getCompPanel().textWindowRight.SetStyle(i1,i2,wx.TextAttr(wx.BLACK,wx.WHITE))      # Modifiee 01.07.2019, ancienne ligne: self.getCompPanel().textWindowRight.SetStyle(i1,i2,wx.TextAttr(wx.BLACK,wx.WHITE,fontDefault)) 
                # self.getCompPanel().textWindowRight.SetFont(fontDefault)                                   # Ajoutee 28.06.2019 
        # print ("116. Module GUI.Medite, Class: MediteFrame, Methode: affichageCouleur_Changements, ligne 1998, \nBlocs_Communs=", str(LBC))
                
        #Non Definis
        LNonDef = [ x for x in Lchangements if transfo.isNonDef(x)[0]]
##        print Lchangements
##        print self.getCompPanel().resultatTransfo.getNonDef()

        for X in LNonDef :
            if X[0]<lgSource:
                i1 = X[0] ; i2 = X[1]
                self.getCompPanel().textWindowLeft.SetStyle(i1,i2,wx.TextAttr(wx.BLACK,wx.WHITE))       # Modifiee 01.07.2019, ancienne ligne: self.getCompPanel().textWindowLeft.SetStyle(i1,i2,wx.TextAttr(wx.BLACK,wx.WHITE,fontDefault))
                # self.getCompPanel().textWindowLeft.SetFont(fontDefault)                                 # Ajoutee 28.06.2019
                self.getCompPanel().textWindowLeft.SetStyle(i1,i2,wx.TextAttr(self.couleursTransfo.getEcriture(),self.couleursTransfo.getCoulNonDef()))
            else: # texte Cible
                i1 = X[0] -  lgSource ; i2 = X[1] - lgSource
                self.getCompPanel().textWindowRight.SetStyle(i1,i2,wx.TextAttr(wx.BLACK,wx.WHITE))      # Modifiee 01.07.2019, ancienne ligne: self.getCompPanel().textWindowRight.SetStyle(i1,i2,wx.TextAttr(wx.BLACK,wx.WHITE,fontDefault))
                # self.getCompPanel().textWindowRight.SetFont(fontDefault)                                # Ajoutee 28.06.2019
                self.getCompPanel().textWindowRight.SetStyle(i1,i2,wx.TextAttr(self.couleursTransfo.getEcriture(),self.couleursTransfo.getCoulNonDef()))
        # print ("117. Module GUI.Medite, Class: MediteFrame, Methode: affichageCouleur_Changements, ligne 2016, \nNon_Definis=", str(LNonDef))   
        
        self.getCompPanel().textWindowRight.Thaw()
        self.getCompPanel().textWindowLeft.Thaw()
        # print ("118. Module GUI.Medite, Class: MediteFrame, Methode: affichageCouleur_Changements, ligne 2020, \ntextWindowLeft=", self.getCompPanel().textWindowLeft.GetValue(), ", \ntextWindowRight=", self.getCompPanel().textWindowRight.GetValue())

    def affichageComparaisonChangements(self,Lchangements):
        #Listes des transformations affichees dans la fenetre transformations
        logging.debug('begin affichageTransformations') 
        trans = self.affichageTransformations() #reverse=True)
        logging.debug('fin affichageTransformations')
        chaine = trans              # chaine,num,encodage = decode_string_heuristically(trans)            # Desactive 24.09.2019 
        # print ("119. Module GUI.Medite, Class: MediteFrame, Methode: affichageComparaisonChangements, ligne 2028, \nLchangements=\n[", Lchangements, ",], \nchaine=\n", chaine, " ") # , \nnum= %s", num, ", encodage= %s", encodage)
        # if encodage == 'utf-8':                            # Desactive 24.09.2019 
        fontDefault=wx.Font(10,wx.DEFAULT,wx.NORMAL,wx.NORMAL,encoding=wx.FONTENCODING_UTF8)
        # else:                                                # Desactive 24.09.2019 
            # fontDefault=wx.Font(10,wx.DEFAULT,wx.NORMAL,wx.NORMAL)            # Desactive 24.09.2019 
        #print "affichageComparaison type(chaine) ",type(chaine),len(chaine)                
        # print ("120. Module GUI.Medite, Class: MediteFrame, Methode: affichageComparaisonChangements, ligne 2006, \naffichageComparaison--->type(chaine)=", type(chaine), ", len(chaine)=", len(chaine))
        self.getCompPanel().transformations.SetDefaultStyle(wx.TextAttr(wx.BLACK, wx.WHITE))      # Modifiee 01.07.2019, ancienne ligne: self.getCompPanel().transformations.SetDefaultStyle(wx.TextAttr(font=fontDefault))
        self.getCompPanel().transformations.SetFont(fontDefault)                                    # Ajoutee 28.06.2019
        #s = unicode(self.getCompPanel().resultatTransfo.getTextesConcatenes(),'utf-8')
        #print s.encode('raw_unicode_escape')
        #print s[:25].encode('raw_unicode_escape')
        #s = self.reverseString(s[:25])
        #print s.encode('unicode_escape')
        #print "affichageComparaison type(chaine) ",type(chaine),len(chaine)
        #print "affichageComparaison type(trans) ",type(trans),len(trans)
        self.getCompPanel().transformations.Clear()
        self.getCompPanel().transformations.SetValue(chaine)
        
        logging.debug('begin affichageCouleur') 
        self.affichageCouleurChangements(Lchangements)
        logging.debug('fin affichageCouleur') 
        #Rendre accessible les fonctionnalites enregistrer transformations et les informations
        self.smEnregistrer.Enable(ID_ADD_TRANSFOS, True)
        self.smEnregistrer.Enable(ID_ADD_TRANSFOS_COMMENT, True)
        # print ("121. Module GUI.Medite, Class: MediteFrame, Methode: affichageComparaisonChangements, ligne 2053, \nLchangements=", str(Lchangements))

    def __chargerInfosEtats(self,event):
        self.SetCursor(wx.HOURGLASS_CURSOR)
        listeInfos = self.cinfos.rechercherLInformationsDG(self.DGAuteur, self.DGOeuvre)
        for infos in listeInfos: 
            plan = PlanTravail(self.DGAuteur, self.DGOeuvre,
                        infos.getVersionSource(), infos.getEtatSource(),
                        infos.getVersionCible(), infos.getEtatCible(),infos.getParametres())
            self.listePlanTravail.appendPlanTravail(plan)
            panel=MainPanel(self.nb,plan)
            self.nb.AddPage(panel,plan.getEtatSource()+"-"+plan.getEtatCible())
            if plan.getAuteur() != '' and plan.getOeuvre() != '':
                self.enableMenuDGCharge()
            self.nb.SetSelection(self.nb.GetPageCount()-1)
            self.rechargerEtats(infos)
            infos = None
        listeInfos = None
        self.reloadNavMenu()
        self.SetCursor(wx.STANDARD_CURSOR)
        # print ("122. Module GUI.Medite, Class: MediteFrame, Methode: __chargerInfosEtats, ligne 2073, \nPlanTravail=", str(plan))
        
    def chargerInfosEtats(self,event):
        self.SetCursor(wx.HOURGLASS_CURSOR)
        #listeInfos = self.cinfos.rechercherLInformationsDG(self.DGAuteur, self.DGOeuvre)
        for infos in self.cinfos.generateLInformationsDG(self.DGAuteur, self.DGOeuvre): 
            plan = PlanTravail(self.DGAuteur, self.DGOeuvre,
                        infos.getVersionSource(), infos.getEtatSource(),
                        infos.getVersionCible(), infos.getEtatCible(),infos.getParametres())
            self.listePlanTravail.appendPlanTravail(plan)
            panel=MainPanel(self.nb,plan)
            self.nb.AddPage(panel,plan.getEtatSource()+"-"+plan.getEtatCible())
            if plan.getAuteur() != '' and plan.getOeuvre() != '':
                self.enableMenuDGCharge()
            self.nb.SetSelection(self.nb.GetPageCount()-1)
            self.rechargerEtats(infos)
            #infos = None
        #listeInfos = None
        self.reloadNavMenu()
        self.SetCursor(wx.STANDARD_CURSOR)
        # print ("123. Module GUI.Medite, Class: MediteFrame, Methode: chargerInfosEtats, ligne 2093, \nPlanTravail=", str(plan))
        
    def rechargerListeEtats(self):
        # chargement de la liste des plans de travail
        # print ("124. Module GUI.Medite, Class: MediteFrame, Methode: rechargerListeEtats, ligne 2097 ")
        try :
            self.listePlanTravail = self.ctravail.chargerListePlans()
            # print("Trace 1_1--->Module: GUI.Medite,   self.ctravail.chargerListePlans() ---> ", str(self.listePlanTravail))
#            if self.planTravail.getAuteur() != '' and self.planTravail.getOeuvre() != '':
#                self.enableMenuDGCharge()
        except FichierNonTrouve as eFNT :  # Modifiee 07.02.2019,  ancienne ligne:  except FichierNonTrouve, eFNT :
            # on crée une nouvelle liste dans laquelle ion insère un plan
            self.listePlanTravail = ListePlanTravail()
            plan = PlanTravail("","","","","","",Parametres())   #auteur,oeuvre,versSource,etatS,verCible,etatC
            self.listePlanTravail.appendPlanTravail(plan)
            panel=MainPanel(self.nb,plan)
            panel.initialised = False
            self.nb.AddPage(panel,plan.getEtatSource()+"-"+plan.getEtatCible())
            self.nb.SetSelection(self.nb.GetPageCount()-1)
            return
        #sys.stderr.write(self.listePlanTravail.toString())    
        if self.listePlanTravail.estVide() or self.listePlanTravail.getListe()[0].getAuteur()=='':
            self.DGLoaded = False
            # on crée une nouvelle liste dans laquelle on insère un plan
            self.listePlanTravail = ListePlanTravail()
            plan = PlanTravail("","","","","","",Parametres())   
            self.listePlanTravail.appendPlanTravail(plan)
            panel=MainPanel(self.nb,plan)
            panel.initialised = False
            self.nb.AddPage(panel,plan.getEtatSource()+"-"+plan.getEtatCible())
            self.nb.SetSelection(self.nb.GetPageCount()-1)
            return
        else:
            self.DGAuteur = self.listePlanTravail.getListe()[0].getAuteur()
            self.DGOeuvre = self.listePlanTravail.getListe()[0].getOeuvre()
            self.DGLoaded = True
            self.treePanel.initTree(self.DGAuteur,self.DGOeuvre)
        # création d'un panel par plan
        for plan in self.listePlanTravail.getListe():
            panel=MainPanel(self.nb,plan)
            # print("125. Module GUI.Medite, Class: MediteFrame, Methode: rechargerListeEtats, ligne 2133, \nfor plan in self.listePlanTravail.getListe(), \nplan=", str(plan))
            self.nb.AddPage(panel,plan.getEtatSource()+"-"+plan.getEtatCible())
            if plan.getAuteur() != '' and plan.getOeuvre() != '':
                self.enableMenuDGCharge()
            # print("126. Module GUI.Medite, Class: MediteFrame, Methode: rechargerListeEtats, ligne 2137, \nif plan.getAuteur() != '' and plan.getOeuvre() != '': ---> Auteur, Oeuvre=", str(plan.getAuteur()), ", ", str(plan.getOeuvre()))
            # print("Trace 1_3--->Module: GUI.Medite,   self.nb.SetSelection(self.nb.GetPageCount()-1) ---> ", (self.nb.GetPageCount()-1))
            self.nb.SetSelection(self.nb.GetPageCount()-1)
            # print("127. Module GUI.Medite, Class: MediteFrame, Methode: rechargerListeEtats, ligne 2140, \nif plan.getAuteur() != '' and plan.getOeuvre() != '': ---> Auteur, Oeuvre=", str(plan.getAuteur()), ", ", str(plan.getOeuvre()))
            self.rechargerEtats()
            # print("128. Module GUI.Medite, Class: MediteFrame, Methode: rechargerListeEtats, ligne 2142, \nif plan.getAuteur() != '' and plan.getOeuvre() != '': ---> Auteur, Oeuvre=", str(plan.getAuteur()), ", ", str(plan.getOeuvre()))
            self.getCompPanel().sizeF()
            # print("Trace 1_6--->Module: GUI.Medite,   if plan.getAuteur() != '' and plan.getOeuvre() != '': ---> ", str(plan.getAuteur()), ", ", str(plan.getOeuvre()))
            self.getCompPanel().Refresh()
            # print("Trace 1_7--->Module: GUI.Medite,   if plan.getAuteur() != '' and plan.getOeuvre() != '': ---> ", str(plan.getAuteur()), ", ", str(plan.getOeuvre()))
            self.nb.Refresh()
            self.Refresh()
            self.SendSizeEvent()
        self.reloadNavMenu()
        # print("129. Module GUI.Medite, Class: MediteFrame, Methode: rechargerListeEtats, ligne 2151,   \nself.reloadNavMenu() ---> Auteur, Oeuvre=", str(plan.getAuteur()), ", ", str(plan.getOeuvre()))
            
    # fonction pour recharger les états du plan de travail enregistre
    def rechargerEtats(self, infos=None):
        # print("130. Module GUI.Medite, Class: MediteFrame, Methode: rechargerEtats, ligne 2128 ")
        vSource = self.getPlanTravail().getVersionSource()
        # print("131. Module GUI.Medite, Class: MediteFrame, Methode: rechargerEtats, ligne 2157 ")
        fSource = self.getPlanTravail().getEtatSource()
        # print("Trace 1_9_3--->Module: GUI.Medite, methode: rechargerEtats() ")
        vCible = self.getPlanTravail().getVersionCible()
        # print("Trace 1_9_4--->Module: GUI.Medite, methode: rechargerEtats() ")
        fCible = self.getPlanTravail().getEtatCible()
        # print("132. Module GUI.Medite, Class: MediteFrame, Methode: rechargerEtats, ligne 2163, \nfSource = self.getPlanTravail().getEtatSource(), fCible = self.getPlanTravail().getEtatCible() ---> \nfSource=", fSource, ", \nfCible=", fCible)
        fontDefault=wx.Font(10, wx.DEFAULT, wx.NORMAL,wx.NORMAL, encoding=wx.FONTENCODING_DEFAULT)           # Modifie 25.09.2019, ancienne:  fontDefault=wx.Font(10,wx.DEFAULT,wx.NORMAL,wx.NORMAL,encoding=wx.FONTENCODING_ISO8859_1)
        if vSource != '' and fSource !='':
            # source
            # print("133. Module GUI.Medite, Class: MediteFrame, Methode: rechargerEtats, ligne 2167,  \nfSource = self.getPlanTravail().getEtatSource(), fCible = self.getPlanTravail().getEtatCible() ---> \nfSource=", fSource, ", \nfCible=", fCible)
            cheminS=self.dgm.getEtatPath(self.getPlanTravail().getAuteur(), self.getPlanTravail().getOeuvre(), vSource, fSource)    
            self.getCompPanel().textWindowLeft.Clear()
            fS = open(cheminS,'r')                                #self.getCompPanel().textWindowLeft.SetValue('')
            texteSource = fS.read()           # Modifie 25.09.2019, ancienne:  texte,enc = loadFile(cheminS,renvoieEnc=True)
            #print "recharger etat type(texte) ",type(texte),cheminS
            # print("134. Module GUI.Medite, Class: MediteFrame, Methode: rechargerEtats, ligne 2174, \ntexte=", texteSource, " ") #, \nenc=", enc)
            # if enc == 'utf-8':                # Desactive 25.09.2019
                #pass
                #print "uni"
            fontDefault=wx.Font(10, wx.DEFAULT, wx.NORMAL,wx.NORMAL, encoding=wx.FONTENCODING_DEFAULT)            # Modifie 25.09.2019, ancienne:  fontDefault=wx.Font(10,wx.DEFAULT,wx.NORMAL,wx.NORMAL,encoding=wx.FONTENCODING_UTF8) 
                #self.getCompPanel().textWindowLeft.SetCodePage(wx.stc.STC_CP_UTF8)
            #self.getCompPanel().textWindowLeft.SetStyle(0,0,wx.TextAttr(wx.BLACK,wx.WHITE,fontDefault))            
            self.getCompPanel().textWindowLeft.SetDefaultStyle(wx.TextAttr(wx.BLACK,wx.WHITE))       # Modifiee 01.07.2019, ancienne ligne: self.getCompPanel().textWindowLeft.SetDefaultStyle(wx.TextAttr(font=fontDefault))
            self.getCompPanel().textWindowLeft.SetFont(fontDefault)
            # self.getCompPanel().textWindowLeft.SetFont(fontDefault)                                 # Ajoutee 28.06.2019 
            #self.getCompPanel().textWindowLeft.LoadFile(cheminS)
            #self.getCompPanel().textWindowLeft.SetValue(loadFile(cheminS))
            
            self.getCompPanel().textWindowLeft.SetValue(texteSource)
            #self.getCompPanel().textWindowLeft.SetTextRaw(texte.encode('utf-8'))
            #self.getCompPanel().textWindowLeft.LoadFile(cheminS)
            #print loadFile(cheminS).encode('utf-8')
            # print("135. Module GUI.Medite, Class: MediteFrame, Methode: rechargerEtats, ligne 2191, \ntextWindowLeft=", self.getCompPanel().textWindowLeft.GetValue())
          
        if vCible !='' and fCible !='':
            # cible
            cheminC=self.dgm.getEtatPath(self.getPlanTravail().getAuteur(),
                    self.getPlanTravail().getOeuvre(),vCible,fCible)    
            self.getCompPanel().textWindowRight.Clear()                     
            fC = open(cheminC,'r')                      # if enc == 'utf-8':            # Desactive 25.09.2019 
            texteCible = fC.read()                      #pass
            fontDefault=wx.Font(10, wx.DEFAULT, wx.NORMAL, wx.NORMAL, encoding=wx.FONTENCODING_DEFAULT)
            #self.getCompPanel().textWindowRight.SetStyle(0,0,wx.TextAttr(wx.BLACK,wx.WHITE,fontDefault))
            #self.getCompPanel().textWindowRight.SetDefaultStyle(wx.TextAttr(wx.BLACK,wx.WHITE,fontDefault))
            self.getCompPanel().textWindowRight.SetDefaultStyle(wx.TextAttr(wx.BLACK,wx.WHITE))         # Modifiee 01.07.2019, ancienne ligne: self.getCompPanel().textWindowRight.SetDefaultStyle(wx.TextAttr(font=fontDefault))
            self.getCompPanel().textWindowRight.SetFont(fontDefault)                                    # Ajoutee 28.06.2019
            #self.getCompPanel().textWindowRight.LoadFile(cheminC)
            self.getCompPanel().textWindowRight.SetValue(texteCible)                 # Modifie 25.09.2019, ancienne:  self.getCompPanel().textWindowRight.SetValue(loadFile(cheminC))
            #self.getCompPanel().textWindowRight.SetText(loadFile(cheminC))
            # print("136. Module GUI.Medite, Class: MediteFrame, Methode: rechargerEtats, ligne 2208, \ntextWindowRight=", self.getCompPanel().textWindowRight.GetValue())
            
        if vSource != '' and fSource !='' and vCible !='' and fCible !='':
            self.enableMenuEtatsOuverts()
#            dlg=wx.MessageDialog(self,"Nous cherchons les informations pour ce couple d'�tats","Attention",wx.OK)
#            dlg.ShowModal()
#            dlg.Destroy()
            self.__chargement(infos)
        else:
            self.getCompPanel().initialised = False
        # print("137. Module GUI.Medite, Class: MediteFrame, Methode: rechargerEtats, ligne 2218 ")

    ## fonction privee pour charger toutes les informations d'un couple d'�tats           
    def __chargement(self, infos):
##        # objet Informations déjà fourni, inutile de le rechercher
##        if infos != None:
##            self.__chargementUnique(infos)
##            return
##        if not self.getPlanTravail().getParam().isNull():
##            info2=self.cinfos.rechercherInformations(self.getPlanTravail())
##            if  info2 != None:
##                self.getCompPanel().initialised = True
##                self.__chargementUnique(info2)
##                return
        # 1ere etape : rechercher toutes les infos existantes pour le couple d'états charge
        liste=self.cinfos.rechercherToutesInformations(self.getPlanTravail())
        # print("138. Module GUI.Medite, Class: MediteFrame, Methode: __chargement, ligne 2234, \nliste=", str(liste))
        if len(liste) == 0:
            
            self.getCompPanel().initialised = False
#           self.getCompPanel().infosChargees=InformationsChargees(None, None, None)
#            dlg=wx.MessageDialog(self, u"Les informations n'ont pas \xe9t\xe9 trouv\xe9es !!","Attention",wx.OK)
#            dlg.ShowModal()
#            dlg.Destroy()           
        elif len(liste) == 1 :
#        else:
            self.getCompPanel().initialised = True
            self.__chargementUnique(liste[0])
        else :
            self.getCompPanel().initialised = True
            # 2eme etape : choix des parametres
            listeParam = []
            for i in liste :
                param = i.getParametres()
                lpara = '(%s,%s,%s,%s,%s,%s,%s)'%(param.getp1(),param.getp2(),param.getp3(),param.getp4(),param.getp5(),param.getp6(),param.getp7())
                listeParam.append(lpara)
                # print("139. Module GUI.Medite, Class: MediteFrame, Methode: __chargement, ligne 2254, \nlisteParam=[", param.getp1(), param.getp2(), param.getp3(), param.getp4(), param.getp5(), param.getp6(), param.getp7(), "] ")    
            phrase = u"Il existe plusieurs informations concernant ces \xe9tats.\n   Choisissez les param\xe8tres\n  (lg pivot, ratio, seuil, car/mot, casse, s\xe9parateur)"
            dlg = wx.SingleChoiceDialog(self,phrase,u"Choix des informations \xe0 charger",listeParam,
                                                  wx.OK|wx.CANCEL)
            if dlg.ShowModal() == wx.ID_OK:
                choix = dlg.GetStringSelection()
                n = 0
                for p in listeParam :
                    if choix == p :
                        self.__chargementUnique(liste[n])
                        return
                    else :
                        n+=1


    # Methode privee pour le chargement definitif des infos
    def __chargementUnique(self, pInfos):
        logging.debug('begin chargement unique')
        # print("140. Module GUI.Medite, Class: MediteFrame, Methode: __chargementUnique, ligne 2272 ") 
        try :
            #maxprogress = 20  # Modifiee 07.02.2019, remplace max ---> maxprogress
            #self.progressChargement = wx.ProgressDialog('Attendre','Recherche des informations',maxprogress,self,  # Modifiee 07.02.2019, remplace max ---> maxprogress
            #                                           style = wx.PD_AUTO_HIDE | wx.PD_APP_MODAL ) # | wxPD_ESTIMATED_TIME 
            #count = 0
            #while count < 8:
            #    count = count + 2
                #wxSleep(1)
            #    self.progressChargement.Update(count)           
            self.getCompPanel().infosChargees = pInfos
            #self.progressChargement.Update(10,"Affichage des transformations")
            #while count < maxprogress-4: # Modifiee 07.02.2019, remplace max ---> maxprogress
            #    count = count + 2
                #wxSleep(1)
            #    self.progressChargement.Update(count)
                
            self.getCompPanel().resultatTransfo = self.getCompPanel().infosChargees.getTransformations()
            self.getCompPanel().commentaire.SetValue(self.getCompPanel().infosChargees.getCommentaire().getCommentaire())
            self.getPlanTravail().setParam(self.getCompPanel().infosChargees.getParametres())
            self.getCompPanel().param.chargerParametres(self.getPlanTravail().getParam())
            logging.debug('begin affichageComparaison') 
            self.affichageComparaison()
            logging.debug('fin affichageComparaison') 
            #bbl = MediteAppli.synthetic.BiBlocListWD(self.getCompPanel().resultatTransfo,self.getPlanTravail())
            #bbl.print_html()  
            self.smEnregistrer.Enable(ID_ADD_TRANSFOS, False)
            self.smEnregistrer.Enable(ID_ADD_TRANSFOS_COMMENT, False)
            # print("141. Module GUI.Medite, Class: MediteFrame, Methode: __chargementUnique, ligne 2300, \nresultatTransfo=", str(self.getCompPanel().resultatTransfo)) 
            
            #while count < maxprogress : # Modifiee 07.02.2019, remplace max ---> maxprogress
            #    count = count + 2
                #wxSleep(1)
            #    self.progressChargement.Update(count)
            #self.progressChargement.Update(20)
                
        except InformationsNonTrouvees as eINT:  # Modifiee 07.02.2019, ancienne ligne:  except InformationsNonTrouvees, eINT:
            pass
            #self.progressChargement.Update(20)
            #dlg=wx.MessageDialog(self, u"Les informations n'ont pas \xe9t\xe9 trouv\xe9es !!","Attention",wx.OK)
            #dlg.ShowModal()
            # dlg.Destroy()
        logging.debug('fin chargement unique')
        # print("142. Module GUI.Medite, Class: MediteFrame, Methode: __chargementUnique, ligne 2315, Fin chargement unique ")

    # Methode privee permettant le choix des parametres associes a un cple d'états
    # pour l'enregistrement d'un commentaire
    def __choixParametres(self):
        # 1ere etape : rechercher toutes les infos existantes pour le couple d'états charge
        liste=self.cinfos.rechercherToutesInformations(self.getPlanTravail())
        if len(liste) == 0:
            fake=1
#            dlg=wx.MessageDialog(self, u"Les informations n'ont pas \xe9t\xe9 trouv\xe9es !!","Attention",wx.OK)
#            dlg.ShowModal()
#            dlg.Destroy()
        else:
            # 2eme etape : choix des parametres
            listeParam = []
            for i in liste :
                param = i.getParametres()
                lpara = '(%s,%s,%s,%s,%s,%s,%s)'%(param.getp1(),param.getp2(),param.getp3(),param.getp4(),param.getp5(),param.getp6(),param.getp7())
                listeParam.append(lpara)
                
            phrase = u"Il existe plusieurs informations concernant ces \xe9tats.\n   Choisissez les param\xe8tres\n  (lg pivot, ratio, seuil, car/mot, casse, s\xe9parateur)"
            dlg = wx.SingleChoiceDialog(self,phrase,u"Choix des informations \xe0 charger",listeParam,
                                                  wx.OK|wx.CANCEL)
            if dlg.ShowModal() == wx.ID_OK:
                choix = dlg.GetStringSelection()
                n = 0
                for p in listeParam :
                    if choix == p :
                        try:
                            planTravail=PlanTravail(self.getPlanTravail().getAuteur(),self.getPlanTravail().getOeuvre(),
                               self.getPlanTravail().getVersionSource(),self.getPlanTravail().getEtatSource(),
                               self.getPlanTravail().getVersionCible(),self.getPlanTravail().getEtatCible(),
                               liste[n].getParametres())
                            self.cinfos.enregistrerCommentaire(planTravail,self.getCompPanel().commentaire.GetValue())
                        except CommentaireDejaExistant as eCDE:    # Modifiee 07.02.2019, ancienne ligne:  except CommentaireDejaExistant, eCDE:
                            formulaire=FormEnregistrerCommentaire(self,eCDE.getCommentaire().getCommentaire(),
                                                                  liste[n].getParametres())
                            formulaire.Show(True)
                    else :
                        n+=1
        # print("143. Module GUI.Medite, Class: MediteFrame, Methode: __choixParametres, ligne 2355, \nlisteParam=", str(listeParam))

    # Methode pour reafficher les états sans les transformations
    def noirSurBlanc(self):
        fontDefault=wx.Font(10,wx.DEFAULT,wx.NORMAL,wx.NORMAL,encoding=wx.FONTENCODING_ISO8859_1)
        texte = self.getCompPanel().textWindowLeft.GetValue()
        self.getCompPanel().textWindowLeft.Clear()  #SetValue('')
        self.getCompPanel().textWindowLeft.SetStyle(0, 0, wx.TextAttr(wx.BLACK,wx.WHITE))         # Modifiee 28.06.2019, ancienne ligne: self.getCompPanel().textWindowLeft.SetStyle(0,0,wx.TextAttr(wx.BLACK,wx.WHITE,fontDefault))
        self.getCompPanel().textWindowLeft.SetFont(fontDefault)                                 # Ajoutee  28.06.2019
        self.getCompPanel().textWindowLeft.SetValue(texte)
        # print("144. Module GUI.Medite, Class: MediteFrame, Methode: noirSurBlanc, ligne 2365, \ntextWindowLeft=", texte)
        texte = self.getCompPanel().textWindowRight.GetValue()
        self.getCompPanel().textWindowRight.Clear() #SetValue('')
        self.getCompPanel().textWindowRight.SetStyle(0, 0, wx.TextAttr(wx.BLACK,wx.WHITE))        # Modifiee 28.06.2019, ancienne ligne: self.getCompPanel().textWindowRight.SetStyle(0,0,wx.TextAttr(wx.BLACK,wx.WHITE,fontDefault))
        self.getCompPanel().textWindowRight.SetFont(fontDefault)                                 # Ajoutee  28.06.2019
        self.getCompPanel().textWindowRight.SetValue(texte)
        # print("145. Module GUI.Medite, Class: MediteFrame, Methode: noirSurBlanc, ligne 2371, \ntextWindowRight=", texte)
        
    def noirSurBlanc__(self):
        self.getCompPanel().textWindowLeft.StyleClearAll()
        self.getCompPanel().textWindowRight.StyleClearAll()
        # print("146. Module GUI.Medite, Class: MediteFrame, Methode: noirSurBlanc__, ligne 2376 ")
        
    def chargerInfosDG(self,evt):
        # 1ere etape : rechercher toutes les infos existantes pour le couple de �tats charge
        liste=self.cinfos.rechercherToutesInformationsDG(self.getPlanTravail().getAuteur(),
                                                       self.getPlanTravail().getOeuvre())
        if len(liste) == 0:
            dlg=wx.MessageDialog(self, u"Les informations n'ont pas \xe9t\xe9 trouv\xe9es !!","Attention",wx.OK)
            dlg.ShowModal()
            dlg.Destroy()
        else:
            # 2eme etape : visualiser les differentes informations
            listeInfos = []
            for i in liste :
                text = "(%s, %s)  (%s, %s)    (%s, %s, %s, %s)" %(i[0],i[1],i[2],i[3],i[4],i[5],i[6],i[7])
                listeInfos.append(text)
                
            phrase = u"Les informations concernant le dossier g\xe9n\xe9tique charg\xe9 sont les suivantes."
            phrase += "\n    (VS,FS)  (VC,FC)  (lg pivot, ratio, seuil, car/mot)"
            dlg = wx.SingleChoiceDialog(self,phrase,"Informations",listeInfos,wx.OK|wx.CANCEL)
            dlg.ShowModal()
        # print("147. Module GUI.Medite, Class: MediteFrame, Methode: chargerInfosDG, ligne 2398, \nliste=", str(liste), ", \nlisteInfos=", str(listeInfos))
        
    def chargerInfosCple(self,evt):
        # 1ere etape : rechercher toutes les infos existantes pour le couple de états charge
        liste=self.cinfos.rechercherToutesInformations(self.getPlanTravail())
        if len(liste) == 0:
            dlg=wx.MessageDialog(self, u"Les informations n'ont pas \xe9t\xe9 trouv\xe9es !!","Attention",wx.OK)
            dlg.ShowModal()
            dlg.Destroy()
        else:
            # 2eme etape : visualiser les differentes informations
            listeParam = []
            for i in liste :
                param = i.getParametres()
                lpara = '(%s,%s,%s)'%(param.getp1(),param.getp2(),param.getp3())
                listeParam.append(lpara)
                
            phrase = u"Les informations concernant les \xe9tats charg\xe9s sont les suivantes."
            dlg = wx.SingleChoiceDialog(self,phrase,"Informations",listeParam,wx.OK|wx.CANCEL)
##            if
            dlg.ShowModal()
        # print("148. Module GUI.Medite, Class: MediteFrame, Methode: chargerInfosCple, ligne 2418, \nliste=", str(liste), ", \nlisteParam=", str(listeParam))
##            == wx.ID_OK:
##                return

            

        
