# -*- coding: iso-8859-1 -*-
# Copyright 2003 - 2008: Julien Bourdaillet (julien.bourdaillet@lip6.fr), Jean-Gabriel Ganascia (jean-gabriel.ganascia@lip6.fr)
# This file is part of MEDITE.
#
#    MEDITE is free software; you can redistribute it and/or modify
#    it under the terms of the GNU General Public License as published by
#    the Free Software Foundation; either version 2 of the License, or
#    (at your option) any later version.
#
#    MEDITE is distributed in the hope that it will be useful,
#    but WITHOUT ANY WARRANTY; without even the implied warranty of
#    MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
#    GNU General Public License for more details.
#
#    You should have received a copy of the GNU General Public License
#    along with Foobar; if not, write to the Free Software
#    Foundation, Inc., 51 Franklin St, Fifth Floor, Boston, MA  02110-1301  USA

import unittest, logging, os, os.path, sys                         # Modifiee 15.04.2019, ancienne ligne:  import unittest, contract, logging, os, os.path   
import pickle                                               # Ajoutee 15.04.2019 
import MediteApplication.MediteAppli, MediteApplication.synthetic
from . import test_data
import Donnees.resultatAppli 
import Donnees.planTravail
import Controleurs.cInformations, Controleurs.DGManager
import profile              # Ajoutee 15.02.2019
import cProfile             # Ajoutee 15.02.2019
import pstats               # Ajoutee 15.02.2019
# vrification des contrats
# contract.checkmod(MediteAppli.MediteAppli)                          # Desactivee 15.04.2019  
# contract.checkmod(Donnees.resultatAppli)                            # Desactivee 15.04.2019  

class Test_MediteAppli(unittest.TestCase):
        
    def setUp(self):
        f = test_data.TestDataFactory()
        #self.td = f.getTestData(test_data.ClaudeBernard,"2")
        #self.td = f.getTestData(test_data.Traduction,"1")
        #self.td = f.getTestData(test_data.Chedid,"1")
        #self.td.texte1 = 'ABCDA' ; self.td.texte2 = 'ZADW'
        #self.td = f.getTestData(test_data.Bovary,"1")
        #self.td = f.getTestData(test_data.Verne,"1")
        self.td = f.getTestData(test_data.Brousse,"1")
        self.planTravail = Donnees.planTravail.PlanTravail('pAuteur', 'pOeuvre', 
            'pVS', 'pFS', 'pVC', 'pFC', Donnees.planTravail.Parametres())
    def test_ecartTextesRecur(self):
        self.texte=self.td.gettexte1()+self.td.gettexte2()
        self.et = MediteApplication.MediteAppli.ecartTextesRecur(self.td.gettexte1(),self.td.gettexte2(),
            self.td.getp1(),self.td.getp2(),self.td.getp3(),
            self.td.getpcarOuMot(),self.td.getpcaseSensitive(),
            self.td.getpseparatorSensivitive(),self.td.getpdiacriticSensitive())
        res = self.et.run()
        self.__test_ecartTextesRecur(res)
        
    def test_ecartTextesRecur2(self):
        self.planTravail = Donnees.planTravail.PlanTravail('Traduction', 'Traduction', 
            'pVS', self.td.file1, 'pVC', self.td.file2, Donnees.planTravail.Parametres(self.td.getp1(),
            self.td.getp2()*25,self.td.getp3()*1000,self.td.getpcarOuMot(),self.td.getpcaseSensitive(),
            self.td.getpseparatorSensivitive(),self.td.getpdiacriticSensitive()))
        self.texte=self.td.gettexte1()+self.td.gettexte2()
        self.et = MediteApplication.MediteAppli.ecartTextesRecur2(self.td.gettexte1(),self.td.gettexte2(),
            self.td.getp1(),self.td.getp2(),self.td.getp3(),
            self.td.getpcarOuMot(),self.td.getpcaseSensitive(),
            self.td.getpseparatorSensivitive(),self.td.getpdiacriticSensitive(),
            self.planTravail)
        dgm = Controleurs.DGManager.DGManager()            
        res = self.et.run(textesApparies=False, dossierRapport=dgm.getDG('Traduction', 'Traduction'))
        #trace("res = self.et.run(textesApparies=True, dossierRapport=dgm.getDG('Traduction', 'Traduction'))",locals())
        #self.__test_ecartTextesRecur(res)
        logging.debug('cinfos.enregistrerTransformations()')
        cinfos = Controleurs.cInformations.CInformations(stream=True)
        cinfos.enregistrerTransformations(self.planTravail,res)
        self.et.xpNgram()
        logging.debug('FIN') 
        
    def test_ecartTextesRecur3(self):
        self.planTravail = Donnees.planTravail.PlanTravail('Traduction', 'Traduction', 
            'pVS', self.td.file1, 'pVC', self.td.file2, Donnees.planTravail.Parametres(self.td.getp1(),
            self.td.getp2()*25,self.td.getp3()*1000,self.td.getpcarOuMot(),self.td.getpcaseSensitive(),
            self.td.getpseparatorSensivitive(),self.td.getpdiacriticSensitive()))
        self.texte=self.td.gettexte1()+self.td.gettexte2()
        self.et = MediteApplication.MediteAppli.ecartTextesRecur3(self.td.gettexte1(),self.td.gettexte2(),
            self.td.getp1(),self.td.getp2(),self.td.getp3(),
            self.td.getpcarOuMot(),self.td.getpcaseSensitive(),
            self.td.getpseparatorSensivitive(),self.td.getpdiacriticSensitive(),
            self.planTravail)
        dgm = Controleurs.DGManager.DGManager()            
        res = self.et.run(textesApparies=True, dossierRapport=dgm.getDG('Traduction', 'Traduction'))
        #trace("res = self.et.run(textesApparies=True, dossierRapport=dgm.getDG('Traduction', 'Traduction'))",locals())
        #self.__test_ecartTextesRecur(res)
        logging.debug('cinfos.enregistrerTransformations()')
        cinfos = Controleurs.cInformations.CInformations(stream=True)
        cinfos.enregistrerTransformations(self.planTravail,res)
        logging.debug('FIN') 
        
    def test_ecartTextesRecur3Stream(self):
        self.planTravail = Donnees.planTravail.PlanTravail('Traduction', 'Traduction', 
            'pVS', self.td.file1, 'pVC', self.td.file2, Donnees.planTravail.Parametres(self.td.getp1(),
            self.td.getp2()*25,self.td.getp3()*1000,self.td.getpcarOuMot(),self.td.getpcaseSensitive(),
            self.td.getpseparatorSensivitive(),self.td.getpdiacriticSensitive()))
        self.texte=self.td.gettexte1()+self.td.gettexte2()
        self.et = MediteApplication.MediteAppli.ecartTextesRecur3(self.td.gettexte1(),self.td.gettexte2(),
            self.td.getp1(),self.td.getp2(),self.td.getp3(),
            self.td.getpcarOuMot(),self.td.getpcaseSensitive(),
            self.td.getpseparatorSensivitive(),self.td.getpdiacriticSensitive(),
            self.planTravail)
        dgm = Controleurs.DGManager.DGManager()            
        #res = self.et.runStream(textesApparies=True, dossierRapport=dgm.getDG('Traduction', 'Traduction'))
        res = self.et.run(textesApparies=True, dossierRapport=dgm.getDG('Traduction', 'Traduction'))
        #trace("res = self.et.run(textesApparies=True, dossierRapport=dgm.getDG('Traduction', 'Traduction'))",locals())
        #self.__test_ecartTextesRecur(res)
        #logging.debug('cinfos.enregistrerTransformations()')
        #cinfos = Controleurs.cInformations.CInformations(stream=True)
        #cinfos.enregistrerTransformations(self.planTravail,res)
        
        logging.debug('FIN') 
        
    def test_ecartTextesRecur2diff(self):
        """Teste la difference symetrique entre la vieille facon de creer les dep et la nouvelle avec la bibloclist"""
        self.texte=self.td.gettexte1()+self.td.gettexte2()
        self.et = MediteApplication.MediteAppli.ecartTextesRecur2(self.td.gettexte1(),self.td.gettexte2(),
            self.td.getp1(),self.td.getp2(),self.td.getp3(),
            self.td.getpcarOuMot(),self.td.getpcaseSensitive(),
            self.td.getpseparatorSensivitive(),self.td.getpdiacriticSensitive(),
            self.planTravail)
        res1 = self.et.run()
        res2 = self.et.run__()
        resDiffSym = res1 ^ res2 # xor ici diffrence symtrique par surcharge d'oprateurs
        rd1 = res1 - res2
        rd2 = res2 - res1
        print (resDiffSym)                                            # Modifiee 15.04.2019, ancienne ligne:  print resDiffSym
        print (resDiffSym.toString())                                 # Modifiee 15.04.2019, ancienne ligne:  print resDiffSym.toString()
        print ('---------------------------------')                   # Modifiee 15.04.2019, ancienne ligne:  print '---------------------------------' 
        print (rd1.toString())                                        # Modifiee 15.04.2019, ancienne ligne:  print rd1.toString()
        print ('---------------------------------')                   # Modifiee 15.04.2019, ancienne ligne:  print '---------------------------------'  
        print (rd2.toString())                                        # Modifiee 15.04.2019, ancienne ligne:  print rd2.toString()  
        print (rd2)                                                   # Modifiee 15.04.2019, ancienne ligne:  print rd2
        
    def __test_ecartTextesRecur(self,res):
        # teste que les elements d'une liste sont bien ordonns entre eux        
        self.__testOrdre(res.getListeSuppressions(),0,len(self.td.gettexte1()))
        self.__testOrdre(res.getListeInsertions(),len(self.td.gettexte1()),len(self.td.gettexte1())+len(self.td.gettexte2()))
        self.__testOrdre(res.getListeRemplacementsT1(),0,len(self.td.gettexte1()))
        self.__testOrdre(res.getListeRemplacementsT2(),len(self.td.gettexte1()),len(self.td.gettexte1())+len(self.td.gettexte2()))
        self.__testOrdre(res.getBlocsCommunsT1(),0,len(self.td.gettexte1()))
        self.__testOrdre(res.getBlocsCommunsT2(),len(self.td.gettexte1()),len(self.td.gettexte1())+len(self.td.gettexte2()))
        self.__testOrdre(res.getListeDeplacementsT1(),0,len(self.td.gettexte1()))
        self.__testOrdre(res.getListeDeplacementsT2(),len(self.td.gettexte1()),len(self.td.gettexte1())+len(self.td.gettexte2()))

        # teste si il n'ya pas de recouvrements entre llistes
        self.__testRecouvrements(res.getBlocsCommuns(),res.getListeSuppressions())
        self.__testRecouvrements(res.getBlocsCommuns(),res.getListeInsertions())
        self.__testRecouvrements(res.getBlocsCommuns(),res.getListeRemplacements())
        self.__testRecouvrements(res.getBlocsCommuns(),res.getListeDeplacements())
        self.__testRecouvrements(res.getListeRemplacements(),res.getListeSuppressions())
        self.__testRecouvrements(res.getListeRemplacements(),res.getListeInsertions())
        
    def __testOrdre(self,L1,d1,f1):
        if len(L1) == 0: return
        self.assert_(d1<=L1[0][0]<=L1[0][1]<=f1,str(L1[0]))
        for i in range(1,len(L1)):                                         # Modifiee 15.04.2019, ancienne ligne:  for i in xrange(1,len(L1)):
            self.assert_(d1<=L1[i-1][1]<=L1[i][0]<=f1)
        self.assert_(d1<=L1[-1][0]<=L1[-1][1]<=f1)
        
            
    def __testRecouvrements(self,L1,L2):
        #res=""
        for (d1,f1) in L1:
            for (d2,f2) in L2:
                self.assert_(not(d1<=d2<f1 or d2<=d1<f2),str((d1,f1))+str((d2,f2))+
                    self.texte[d1:f1]+"/"+self.texte[d2:f2])
                #if (d1<=d2<f1 or d2<=d1<f2): 
                #    res+= str((d1,f1))+str((d2,f2))+self.texte[d1:f1]+"/"+self.texte[d2:f2] +"\n"
        #return res
          
    def test_separator(self):
        self.texte=self.td.gettexte1()+self.td.gettexte2()
        #self.et = MediteAppli.MediteAppli.ecartTextesRecur(self.td.gettexte1(),self.td.gettexte2(),
        #    self.td.getp1(),self.td.getp2(),self.td.getp3(),
        #    self.td.getpcarOuMot(),self.td.getpcaseSensitive(),
        #    self.td.getpseparatorSensivitive(),self.td.getpdiacriticSensitive())
        self.et = MediteApplication.MediteAppli.ecartTextesRecur("ab.cd..e.....f","ab.cd.e",
            self.td.getp1(),self.td.getp2(),self.td.getp3(),
            self.td.getpcarOuMot(),self.td.getpcaseSensitive(),
            self.td.getpseparatorSensivitive(),self.td.getpdiacriticSensitive())            
        res = self.et.run()
        
    def test_duplicateLinkage(self):
        # import cPickle                        # Desactivee 15.04.2019 
        import MediteApplication.RecordLinkage as rl
        file_pickle = os.path.join(os.getcwd(),'test_MediteAppli_bbl.pkl')
        if os.path.isfile(file_pickle):
            pkl_file = open(file_pickle, 'rb')
            bbl = pickle.load(pkl_file)                                    # Modifiee 15.04.2019, ancienne ligne:  bbl = cPickle.load(pkl_file)
            pkl_file.close()
        else:
            f = test_data.TestDataFactory()
            self.td = f.getTestData(test_data.Resto,"1")
            self.planTravail = Donnees.planTravail.PlanTravail('Resto', 'Resto', 
                'pVS', self.td.file1, 'pVC', self.td.file2, Donnees.planTravail.Parametres(self.td.getp1(),
                self.td.getp2()*25,self.td.getp3()*1000,self.td.getpcarOuMot(),self.td.getpcaseSensitive(),
                self.td.getpseparatorSensivitive(),self.td.getpdiacriticSensitive()))
            self.texte=self.td.gettexte1()+self.td.gettexte2()
            self.et = MediteApplication.MediteAppli.ecartTextesRecur2(self.td.gettexte1(),self.td.gettexte2(),
                self.td.getp1(),self.td.getp2(),self.td.getp3(), self.td.getpcarOuMot(),self.td.getpcaseSensitive(),
                self.td.getpseparatorSensivitive(),self.td.getpdiacriticSensitive(),self.planTravail)
            dgm = Controleurs.DGManager.DGManager()            
            res = self.et.run(textesApparies=False)
            bbl = self.et.bbl
            output = open(file_pickle, 'wb')
            pickle.dump(bbl, output)                                   # Modifiee 15.04.2019, ancienne ligne:  cPickle.dump(bbl, output) 
            output.close()
            #trace("res = self.et.run(textesApparies=True, dossierRapport=dgm.getDG('Traduction', 'Traduction'))",locals())
            #self.__test_ecartTextesRecur(res)
        dc = rl.DuplicateChecker(bbl)
        dc.run()
        logging.debug('FIN') 
        
def suite():
    suite = unittest.TestSuite()
    #suite.addTest(Test_MediteAppli("test_ecartTextesRecur"))
    #suite.addTest(Test_MediteAppli("test_ecartTextesRecur2"))
    #suite.addTest(Test_MediteAppli("test_ecartTextesRecur3"))
    #suite.addTest(Test_MediteAppli("test_ecartTextesRecur3Stream"))
    #suite.addTest(Test_MediteAppli("test_ecartTextesRecur2diff"))
    #suite.addTest(Test_MediteAppli("test_separator"))
    suite.addTest(Test_MediteAppli("test_duplicateLinkage"))
    return suite
    
def trace(commande,dic_locals):
    # import hotshot, hotshot.stats, sys
    #import profile,pstats,sys
    #profile.runctx(commande,globals(), dic_locals,'c:\workspace\medite\statFile')
    #s = pstats.Stats('c:\workspace\medite\statFile')
    #s.sort_stats('time')
    #s.print_stats()
    #sys.stderr.flush()
    #sys.stdout.flush()
    prof = cProfile.Profile()                    # Modifiee 15.02.2019, ancienne ligne:  prof = hotshot.Profile("c:\workspace\medite\statFile")
    prof.enable()
    benchtime = cProfile.runctx(commande,globals(), dic_locals, 'c:\meditework\medite40\statFile') 
    # prof = hotshot.Profile("c:\workspace\medite\statFile")
    # benchtime = prof.runctx(commande,globals(), dic_locals)
    prof.close()
    stats = pstats.Stats.load_stats("c:\workspace\medite\statFile")
    #stats.strip_dirs()
    stats.sort_stats('time', 'calls')
    stats.print_stats(50)
    
if __name__ == '__main__':
    logging.basicConfig(level=logging.DEBUG,#INFO,
                            format='%(asctime)s %(levelname)s %(message)s',
                            #datefmt='%H:%M:%S',
                            filename=os.path.join(os.getcwd(),'log.txt'),
                            filemode='w')
    console = logging.StreamHandler()
    console.setLevel(logging.INFO)  
    #logging.getLogger('').addHandler(console)
    
    unittest.TextTestRunner(verbosity=2).run(suite())

    

          