# -*- coding: iso-8859-1 -*-
# Copyright 20003 - 2008: Julien Bourdaillet (julien.bourdaillet@lip6.fr), Jean-Gabriel Ganascia (jean-gabriel.ganascia@lip6.fr)
# This file is part of MEDITE.
#
#    MEDITE is free software; you can redistribute it and/or modify
#    it under the terms of the GNU General Public License as published by
#    the Free Software Foundation; either version 2 of the License, or
#    (at your option) any later version.
#
#    MEDITE is distributed in the hope that it will be useful,
#    but WITHOUT ANY WARRANTY; without even the implied warranty of
#    MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
#    GNU General Public License for more details.
#
#    You should have received a copy of the GNU General Public License
#    along with Foobar; if not, write to the Free Software
#    Foundation, Inc., 51 Franklin St, Fifth Floor, Boston, MA  02110-1301  USA

import MediteApplication.aligne
import sys

#on fait un traitement des parametres tres sommaire
algo=sys.argv[1].lower()
    

if algo == "lcis" :
    aligneur = MediteApplication.aligne.AlignLIS()
elif algo == "glouton" :
    aligneur = MediteApplication.aligne.AlignGlouton()
elif algo == "progdyn" :
    aligneur = MediteApplication.aligne.AlignProgDyn()
else :
    print ("Parametre ", algo," invalide")
    print ("Usage : ",sys.argv[0]," [lcis|glouton|progdyn]")
    sys.exit(1)
    
#on definit les textes sur lesquels on veut tester l'algo


texte1 ="annie bertrand annie charles david bertrand alfred magique dada"
texte2 ="bertrand annie david charles david annie bertrand magique dada"




#creation des listes de blocs
       
print ("texte1 (",len(texte1),") : ",texte1)
print ("texte2 (",len(texte2),") : ",texte2)
        
texteBlocs1=texte1.split()
texteBlocs2=texte2.split()
        
blocs1=[]
pos=0
for i in range(len(texteBlocs1)):
    lenBloc = len(texteBlocs1[i])
    blocs1.append([pos,pos+lenBloc-1])
    pos += lenBloc+1            
print ("liste blocs 1 :",blocs1)

blocs2=[]
pos=0
for i in range(len(texteBlocs2)):
    lenBloc = len(texteBlocs2[i])
    blocs2.append([pos,pos+lenBloc-1])
    pos += lenBloc+1            
print ("liste blocs 2 :",blocs2)


res1,res2 = aligneur.alignement(blocs1,blocs2,texte1,texte2,0)


print (u"blocs aligns 1 :",res1)
print (u"blocs aligns 2 :",res2)

#test du resultat

out = ""
for bloc in res1 :
    
    if bloc[0] == None :
        aligne = ""
    else :
        aligne = texte1[bloc[0][0]:bloc[0][1]+1]
        
    if len(bloc[1]) != 0:
        afficher = "[ "
        for dep in bloc[1]:
            afficher = afficher+texte1[dep[0]:dep[1]+1]+" "    
        afficher = afficher+"]"
        out = out+afficher+aligne
    else :
        out = out+" "+aligne        
print (out)    

out = ""
for bloc in res2 :
    
    if bloc[0] == None :
        aligne = ""
    else :
        aligne = texte2[bloc[0][0]:bloc[0][1]+1]
        
    if len(bloc[1]) != 0:
        afficher = "[ "
        for dep in bloc[1]:
            afficher = afficher+texte2[dep[0]:dep[1]+1]+" "  
        afficher = afficher+"]"  
        out = out+afficher+aligne
    else :
        out = out+" "+aligne  
print (out)               