# -*- coding: iso-8859-1 -*-
# Copyright 2003 - 2008: Julien Bourdaillet (julien.bourdaillet@lip6.fr), Jean-Gabriel Ganascia (jean-gabriel.ganascia@lip6.fr)
# This file is part of MEDITE.
#
#    MEDITE is free software; you can redistribute it and/or modify
#    it under the terms of the GNU General Public License as published by
#    the Free Software Foundation; either version 2 of the License, or
#    (at your option) any later version.
#
#    MEDITE is distributed in the hope that it will be useful,
#    but WITHOUT ANY WARRANTY; without even the implied warranty of
#    MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
#    GNU General Public License for more details.
#
#    You should have received a copy of the GNU General Public License
#    along with Foobar; if not, write to the Free Software
#    Foundation, Inc., 51 Franklin St, Fifth Floor, Boston, MA  02110-1301  USA

import unittest, sys, time, logging, os       # Modifiee 27.02.2019, 15.04.2019, ancienne ligne:  import unittest, contract, sys, time, logging, os, ConfigParser 
import configparser          # Modifiee 27.02.2019, ancienne ligne:  import ConfigParser
import MediteApplication.alignement
from . import test_data      # Modifiee 27.02.2019, ancienne ligne:  import test_data
# import psyco               # Desactivee 27.02.2019. 
from Donnees.resultatAppli import * 
import profile               # Ajoutee 27.02.2019. 
import cProfile              # Ajoutee 27.02.2019. 
import pstats                # Ajoutee 27.02.2019. 
# vrification des contrats
#contract.checkmod(MediteAppli.alignement)

class Test_AlignementCas1(unittest.TestCase):
    def _readFile(self,name):
        """ Lit un fichier dans le dossier courant et renvoie une chaine """
        path=os.path.join(os.getcwd(),"MediteAppli","test",name)
        f = open(path)
        res = f.read()
        f.close()
        return res
    def err(self,text):
        sys.stderr.write(str(time.clock())+" : "+text+"\n")
        sys.stderr.flush()
    def setUp(self):
        f = test_data.TestDataFactory()
        self.td = f.getTestData(test_data.Chedid,"1")
        
    def test_deplacements_pond_Dicho(self):
        self.align = MediteApplication.alignement.AlignDicho(self.td.gettexte1()+self.td.gettexte2())
        occs_deplaces,blocsCommuns = self.align.deplacements_pond(self.td.getL1(),self.td.getL2())
        self.__check_deplacements_pond(occs_deplaces,blocsCommuns)
        
    def test_deplacements_pond_Astar(self):
        self.align = MediteApplication.alignement.AlignAstar(self.td.gettexte1()+self.td.gettexte2())
        occs_deplaces,blocsCommuns = self.align.deplacements_pond(self.td.getL1(),self.td.getL2())
        self.__check_deplacements_pond(occs_deplaces,blocsCommuns)
        
    def test_deplacements_pond_Astar2(self):
        self.align = MediteApplication.alignement.AlignAstar2(self.td.gettexte1()+self.td.gettexte2())
        occs_deplaces,blocsCommuns = self.align.deplacements_pond(self.td.getL1(),self.td.getL2())
        self.__check_deplacements_pond(occs_deplaces,blocsCommuns)
        
    def test_deplacements_pond_AstarRecur(self):
        self.align = MediteApplication.alignement.AlignAstarRecur2(self.td.gettexte1()+self.td.gettexte2())
        occs_deplaces,blocsCommuns = self.align.deplacements_pond(self.td.getL1(),self.td.getL2())
        self.__check_deplacements_pond(occs_deplaces,blocsCommuns)
    
    def test_deplacements_pond_AstarRecur2(self):
        self.align = MediteApplication.alignement.AlignAstarRecur2(len(self.td.gettexte1()),long_min_pivots=5)
        #occs_deplaces,blocsCommuns = self.align.deplacements_pond(self.td.getL1(),self.td.getL2())
        occs_deplaces,blocsCommuns = self.align.run(self.td.gettexte1(),self.td.gettexte2())
        #self.__check_deplacements_pond(occs_deplaces,blocsCommuns)

    def test_preTraitDiffSymVect(self):
        self.align = MediteApplication.alignement.AlignAstarRecur(self.td.gettexte1()+self.td.gettexte2())
        LH1 = eval(self._readFile('bovaryLH1.txt'))
        LH2 = eval(self._readFile('bovaryLH2.txt'))
        dicoPos = eval(self._readFile('bovaryDicoPos.txt'))
        diffSym = self.align.preTraitDiffSymVect(LH1,LH2,dicoPos)
        #trace('diffSym = self.align.preTraitDiffSymVect(LH1,LH2,dicoPos)',locals())
        
    def test_deplacements_pond_AstarRecur3(self):
        self.align = MediteApplication.alignement.AlignAstarRecur3(self.td.gettexte1()+self.td.gettexte2(),len(self.td.gettexte1()),self.td.getp1())
        occs_deplaces,blocsCommuns,LUnique = self.align.deplacements_pond(self.td.getL1(),self.td.getL2())
        self.__check_deplacements_pond(occs_deplaces,blocsCommuns)  
        texte=self.td.gettexte1()+self.td.gettexte2()
        for i in range(0,len(LUnique)):                                                              # Modifiee 27.02.2019, ancienne ligne:   for i in xrange(0,len(LUnique)): 
            j=self.__interInclus(LUnique[i],occs_deplaces)
            self.assert_(j==-1,texte[LUnique[i][0]:LUnique[i][1]]+str(occs_deplaces[j])+str(LUnique[i]))
            j=self.__interInclus(LUnique[i],blocsCommuns)
            self.assert_(j==-1,texte[LUnique[i][0]:LUnique[i][1]]+str(blocsCommuns[j])+str(LUnique[i]))

            
    def test_deplacements_pond_AstarRecur4(self):
        self.align = MediteApplication.alignement.AlignAstarRecur4(self.td.gettexte1()+self.td.gettexte2(),len(self.td.gettexte1()),self.td.getp1())
        occs_deplaces,blocsCommuns,LUnique = self.align.deplacements_pond(self.td.getL1(),self.td.getL2())
        self.__check_deplacements_pond(occs_deplaces,blocsCommuns)  
        texte=self.td.gettexte1()+self.td.gettexte2()
        for i in range(0,len(LUnique)):                                                                 # Modifiee 27.02.2019, ancienne ligne:   for i in xrange(0,len(LUnique)):  
            j=self.__interInclus(LUnique[i],occs_deplaces)
            self.assert_(j==-1,texte[LUnique[i][0]:LUnique[i][1]]+str(occs_deplaces[j])+str(LUnique[i]))
            j=self.__interInclus(LUnique[i],blocsCommuns)
            self.assert_(j==-1,texte[LUnique[i][0]:LUnique[i][1]]+str(blocsCommuns[j])+str(LUnique[i]))
            
    def test_deplacements_pond_AstarRecur5(self):
        self.align = MediteApplication.alignement.AlignAstarRecur4(self.td.gettexte1()+self.td.gettexte2(),len(self.td.gettexte1()),self.td.getp1())       # Modifiee 27.02.2019, ancienne ligne:   self.align = MediteAppli.alignement.AlignAstarRecur5(self.td.gettexte1()+self.td.gettexte2(),len(self.td.gettexte1()),self.td.getp1()) (methode AlignAstarRecur5 est absent dans le module alignement et dans le projet). 
        #trace('occs_deplaces,blocsCommuns = self.align.run(self.td.gettexte1(),self.td.gettexte2())',locals())
        occs_deplaces,blocsCommuns = self.align.run(self.td.gettexte1(),self.td.gettexte2())
        self.__check_deplacements_pond(occs_deplaces,blocsCommuns)  
        #texte=self.td.gettexte1()+self.td.gettexte2()
        #for i in xrange(0,len(LUnique)):
        #    j=self.__interInclus(LUnique[i],occs_deplaces)
        #    self.assert_(j==-1,texte[LUnique[i][0]:LUnique[i][1]]+str(occs_deplaces[j])+str(LUnique[i]))
        #    j=self.__interInclus(LUnique[i],blocsCommuns)
        #    self.assert_(j==-1,texte[LUnique[i][0]:LUnique[i][1]]+str(blocsCommuns[j])+str(LUnique[i]))
            
    def test_deplacements_pond_AstarRecurNew(self):
        self.align = MediteApplication.alignement.AlignAstarRecur(len(self.td.gettexte1()),5)
        #trace('occs_deplaces,blocsCommuns = self.align.run(self.td.gettexte1(),self.td.gettexte2())',locals())
        occs_deplaces,blocsCommuns = self.align.run(self.td.gettexte1(),self.td.gettexte2())
        self.__check_deplacements_pond(occs_deplaces,blocsCommuns)  
        
    def test_deplacements_pond_ShapiraRecur(self):
        self.align = MediteApplication.alignement.AlignShapiraRecur(len(self.td.gettexte1()),5)
        #trace('occs_deplaces,blocsCommuns = self.align.run(self.td.gettexte1(),self.td.gettexte2())',locals())
        occs_deplaces,blocsCommuns = self.align.run(self.td.gettexte1(),self.td.gettexte2())
        self.__check_deplacements_pond(occs_deplaces,blocsCommuns)  
        
    def __check_deplacements_pond(self,occs_deplaces,blocsCommuns):
        texte=self.td.gettexte1()+self.td.gettexte2()
        self.assert_(isinstance(occs_deplaces,list))
        self.assert_(isinstance(blocsCommuns,list))
        #self.assertNotEqual(len(occs_deplaces),0)
        self.assertNotEqual(len(blocsCommuns),0)
        self.assert_(isinstance(blocsCommuns[0],list))
        self.assert_(isinstance(blocsCommuns[0][0],int))
        self.assert_(isinstance(blocsCommuns[0][1],int))
        for i in range(1,len(blocsCommuns)):                                                        # Modifiee 27.02.2019, ancienne ligne:   for i in xrange(1,len(blocsCommuns)): 
            self.assert_(isinstance(blocsCommuns[i],list),str(type(blocsCommuns[i])))
            self.assert_(isinstance(blocsCommuns[i][0],int))
            self.assert_(isinstance(blocsCommuns[i][1],int))
            # les BC sont ordonns
            self.assert_(0<=blocsCommuns[i-1][1]<=blocsCommuns[i][0]<=len(texte))
        if len(occs_deplaces)>0:
            self.assert_(isinstance(occs_deplaces[0],list))
            self.assert_(isinstance(occs_deplaces[0][0],int))
            self.assert_(isinstance(occs_deplaces[0][1],int))
            for i in range(1,len(occs_deplaces)):                                                  # Modifiee 27.02.2019, ancienne ligne:   for i in xrange(1,len(occs_deplaces)): 
                self.assert_(isinstance(occs_deplaces[i],list))
                self.assert_(isinstance(occs_deplaces[i][0],int))
                self.assert_(isinstance(occs_deplaces[i][1],int))
                self.assert_(0<=occs_deplaces[i-1][1]<=occs_deplaces[i][0]<=len(texte),
                             str(occs_deplaces[i-1])+' '+str(occs_deplaces[i]))
        # liste des intervalles entre les blocs communs
        lDep=[(0,blocsCommuns[0][0])]
        for i in range(1,len(blocsCommuns)):                                                       # Modifiee 27.02.2019, ancienne ligne:   for i in xrange(1,len(blocsCommuns)): 
            lDep.append((blocsCommuns[i-1][1],blocsCommuns[i][0]))
        lDep.append((blocsCommuns[-1][1],len(texte)))
        for i in range(0,len(occs_deplaces)):                                                      # Modifiee 27.02.2019, ancienne ligne:   for i in xrange(0,len(occs_deplaces)): 
            j=self.__interInclus(occs_deplaces[i],lDep)
            self.assert_(j>=0,texte[occs_deplaces[i][0]:occs_deplaces[i][1]])
        
    def __interInclus(self,i1,i2): # i1 inclus dans un des inter de [i2] ?
        for i in range(len(i2)):                                                                   # Modifiee 27.02.2019, ancienne ligne:   for i in xrange(len(i2)):  
            if i1[0]>=i2[i][0] and i1[1]<=i2[i][1]: return i
        return -1

class Test_AlignementCas2(Test_AlignementCas1):
    def setUp(self):
        f = test_data.TestDataFactory()
        self.td = f.getTestData(test_data.ClaudeBernard,"2")
class Test_AlignementCas3(Test_AlignementCas1):
    def setUp(self):
        f = test_data.TestDataFactory()
        self.td = f.getTestData(test_data.ClaudeBernard,"3")
class Test_AlignementCas4(Test_AlignementCas1):
    def setUp(self):
        f = test_data.TestDataFactory()
        self.td = f.getTestData(test_data.ClaudeBernard,"4")     
class Test_AlignementCas5(Test_AlignementCas1):
    def setUp(self):
        f = test_data.TestDataFactory()
        self.td = f.getTestData(test_data.ClaudeBernard,"5")      
class Test_AlignementCharroiCas1(Test_AlignementCas1):
    def setUp(self):
        f = test_data.TestDataFactory()
        self.td = f.getTestData(test_data.Charroi,"1")    
class Test_AlignementBioCas1(Test_AlignementCas1):
    def setUp(self):
        f = test_data.TestDataFactory()
        self.td = f.getTestData(test_data.Bio,"1")    
class Test_AlignementCondorcetCas1(Test_AlignementCas1):
    def setUp(self):
        f = test_data.TestDataFactory()
        self.td = f.getTestData(test_data.Condorcet,"1")    
class Test_AlignementCondorcetCas2(Test_AlignementCas1):
    def setUp(self):
        f = test_data.TestDataFactory()
        self.td = f.getTestData(test_data.Condorcet,"2")
class Test_AlignementTraductionCas1(Test_AlignementCas1):
    def setUp(self):
        f = test_data.TestDataFactory()
        self.td = f.getTestData(test_data.Traduction,"1")   
    def test_preTraitDiffSym_AstarRecur5(self):
        config = configparser.ConfigParser()           # Modifiee 27.02.2019, ancienne ligne:  config = ConfigParser.ConfigParser()
        config.read(os.path.join(os.getcwd(),'MediteAppli','test','traduc.ini'))
        L1 = eval(config.get('listes','L1'))
        L2 = eval(config.get('listes','L2'))
        logging.debug('len(L1)='+str(len(L1))+' / len(L2)='+str(len(L2)))
        texte = self.td.gettexte1()+self.td.gettexte2()
        self.align = MediteApplication.alignement.AlignAstarRecur4(texte,len(self.td.gettexte1()),self.td.getp1())         # Modifiee 27.02.2019, ancienne ligne:   self.align = MediteAppli.alignement.AlignAstarRecur5(texte,len(self.td.gettexte1()),self.td.getp1()) (methode AlignAstarRecur5 est absente dans le module alignement et dans le projet).  
        logging.debug("debut _appelAstar")
        LC1 = [] ; LC2 = [] ; Lcf1 = [] ; Lcf2 = [] ; LH1 = [] ; LH2 = []
        for bloc in L1:
            cle = hash(texte[bloc[0]:bloc[1]])
            LC1.append(cle)
            Lcf1.append((cle,bloc[1]-bloc[0]))
            LH1.append((cle, bloc[0], bloc[1]))
        #print LH1            
        logging.debug('init L1 done')            
        for bloc in L2:
            cle = hash(texte[bloc[0]:bloc[1]])
            LC2.append(cle)
            Lcf2.append((cle,bloc[1]-bloc[0]))
            LH2.append((cle, bloc[0], bloc[1]))
        dicoPos = {} 
        coutFixe = {}
        dicoPos[1], coutFixe[1] = self.align.calcPosCoutFixe(Lcf1,texte)
        dicoPos[2], coutFixe[2] = self.align.calcPosCoutFixe(Lcf2,texte)
        for cle in dicoPos[1]: assert cle in dicoPos[2], str([texte[d:f] for d,f in L1])+' '+str([texte[d:f] for d,f in L2])
        for cle in dicoPos[2]: assert cle in dicoPos[1]
        logging.debug("fin  calcPosCoutFixe")
#       self.align.preTraitDiffSym = psyco.proxy(self.align.preTraitDiffSym)        #  Desactivee et remplace par la ligne suivante (psyco n'existe plus).
        self.align.preTraitDiffSym 
        diffSym = self.align.preTraitDiffSym(LH1,LH2,texte,dicoPos) # pr-calcul des diffrences symtriques
        logging.debug('len(diffSym)='+str(len(diffSym)))
        logging.debug("fin  preTraitDiffSym")
        
class Test_AlignementAlthusserCas1(Test_AlignementCas1):
    def setUp(self):
        f = test_data.TestDataFactory()
        self.td = f.getTestData(test_data.Althusser,"1")      
class Test_AlignementAlthusserCas2(Test_AlignementCas1):
    def setUp(self):
        f = test_data.TestDataFactory()
        self.td = f.getTestData(test_data.Althusser,"2")
        
class Test_AlignementChedidCas1(Test_AlignementCas1):
    def setUp(self):
        f = test_data.TestDataFactory()
        self.td = f.getTestData(test_data.Chedid,"1") 
        
class Test_AlignementSuite(unittest.TestSuite):
    def __init__(self):
        unittest.TestSuite.__init__(self,map(Test_AlignementCas1,(
        "test_deplacements_pond"
        )))                                                     # Modifiee 27.02.2019, ancienne ligne:    unittest.TestSuite.__init__(self,map(Test_Alignement,("test_deplacements_pond" ))) 

def suite():
    suite1 = unittest.TestSuite()
    #suite1.addTest(Test_AlignementCas1("test_deplacements_pond_Dicho"))
    #suite1.addTest(Test_AlignementCas1("test_deplacements_pond_Astar2"))
    #suite1.addTest(Test_AlignementCas1("test_deplacements_pond_AstarRecur"))
    #suite1.addTest(Test_AlignementCas1("test_deplacements_pond_AstarRecur2"))
    #suite1.addTest(Test_AlignementCas1("test_deplacements_pond_AstarRecur3"))
    #suite1.addTest(Test_AlignementCas1("test_deplacements_pond_AstarRecur4"))
    #suite1.addTest(Test_AlignementCas1("test_deplacements_pond_AstarRecur5"))
    suite2 = unittest.TestSuite()
    #suite2.addTest(Test_AlignementCas2("test_deplacements_pond_Dicho"))
    #suite2.addTest(Test_AlignementCas2("test_deplacements_pond_Astar2"))
    #suite2.addTest(Test_AlignementCas2("test_deplacements_pond_AstarRecur"))
    suite2.addTest(Test_AlignementCas2("test_deplacements_pond_AstarRecur2"))
    #suite2.addTest(Test_AlignementCas2("test_deplacements_pond_AstarRecur3"))
    #suite2.addTest(Test_AlignementCas2("test_deplacements_pond_AstarRecur4"))
    #suite2.addTest(Test_AlignementCas2("test_deplacements_pond_AstarRecur5"))
    #suite2.addTest(Test_AlignementCas2("test_deplacements_pond_AstarRecurNew"))
    #suite2.addTest(Test_AlignementChedidCas1("test_deplacements_pond_ShapiraRecur"))
    #suite2.addTest(Test_AlignementChedidCas1("test_preTraitDiffSymVect"))
    suite3 = unittest.TestSuite()
    #suite3.addTest(Test_AlignementCas3("test_deplacements_pond_AstarRecur3"))
    #suite3.addTest(Test_AlignementCas3("test_deplacements_pond_AstarRecur2"))
    suite4 = unittest.TestSuite()
    #suite4.addTest(Test_AlignementCas4("test_deplacements_pond_AstarRecur3"))
    #suite4.addTest(Test_AlignementCas4("test_deplacements_pond_AstarRecur2"))
    suite5 = unittest.TestSuite()
    #suite5.addTest(Test_AlignementCas5("test_deplacements_pond_AstarRecur3"))
    #suite5.addTest(Test_AlignementCas5("test_deplacements_pond_AstarRecur2"))
    suite6 = unittest.TestSuite()
    #suite6.addTest(Test_AlignementCharroiCas1("test_deplacements_pond_AstarRecur5"))
    #suite6.addTest(Test_AlignementCharroiCas1("test_deplacements_pond_AstarRecur2"))
    suite7 = unittest.TestSuite()
    #suite7.addTest(Test_AlignementBioCas1("test_deplacements_pond_AstarRecur5"))
    #suite7.addTest(Test_AlignementBioCas1("test_deplacements_pond_AstarRecur2"))
    suite8 = unittest.TestSuite()
    #suite8.addTest(Test_AlignementCondorcetCas1("test_deplacements_pond_AstarRecur5"))
    #suite8.addTest(Test_AlignementCondorcetCas2("test_deplacements_pond_AstarRecur5"))
    #suite8.addTest(Test_AlignementTraductionCas1("test_deplacements_pond_AstarRecur5"))
    #suite8.addTest(Test_AlignementTraductionCas1("test_preTraitDiffSym_AstarRecur5"))
    #suite8.addTest(Test_AlignementAlthusserCas1("test_deplacements_pond_AstarRecur5"))
    #suite8.addTest(Test_AlignementAlthusserCas2("test_deplacements_pond_AstarRecur5"))
    #suite8.addTest(Test_AlignementCas3("test_deplacements_pond_AstarRecur2"))
    suite = unittest.TestSuite((suite1, suite2, suite3, suite4, suite5, suite6,suite7,suite8))
    return suite

def trace(commande,dic_locals):
#   import hotshot,hotshot.stats,sys                                                                 # Desactivee 27.02.2019. 
    #import profile,pstats,sys
    #profile.runctx(commande,globals(), dic_locals,'c:\workspace\medite\statFile')
    #s = pstats.Stats('c:\workspace\medite\statFile')
    #s.sort_stats('time')
    #s.print_stats()
    #sys.stderr.flush()
    #sys.stdout.flush()
    prof = cProfile.Profile()                                                                         # Ajoutee 27.02.2019. 
    prof.enable()                                                                                     # Ajoutee 27.02.2019. 
    benchtime = cProfile.runctx(commande,globals(), dic_locals, 'c:\meditework\medite42\statFile')    # Ajoutee 27.02.2019. 
    prof.disable()                                                                                    # Ajoutee 27.02.2019. 
#   prof = hotshot.Profile("c:\workspace\medite\statFile")                                            # Desactivee 27.02.2019. 
#   benchtime = prof.runctx(commande,globals(), dic_locals)                                           # Desactivee 27.02.2019. 
#   prof.close()                                                                                      # Desactivee 27.02.2019. 
    stats = pstats.Stats.load_stats('c:\meditework\medite42\statFile')                                # Modifiee 27.02.2019, ancienne ligne:   stats = hotshot.stats.load("c:\workspace\medite\statFile")
    stats.strip_dirs()                                                                                # Activee 27.02.2019   
    stats.sort_stats('cumulative', 'time', 'calls')
    stats.print_stats()
    
if __name__ == '__main__':
    logging.basicConfig(level=logging.DEBUG,#INFO,
                            format='%(asctime)s %(levelname)s %(message)s',
                            #datefmt='%H:%M:%S',
                            filename=os.path.join(os.getcwd(),'log.txt'),
                            filemode='w')
    #console = logging.StreamHandler()
    #console.setLevel(logging.INFO)  
    #logging.getLogger('').addHandler(console)
    
    unittest.TextTestRunner(verbosity=2).run(suite())
    #unittest.TextTestRunner(verbosity=2).run(Test_MediteAppliSuite())
    
    
          