# -*- coding: UTF-8 -*-
# Copyright 20003 - 2008: Julien Bourdaillet (julien.bourdaillet@lip6.fr), Jean-Gabriel Ganascia (jean-gabriel.ganascia@lip6.fr)
# This file is part of MEDITE.
#
#    MEDITE is free software; you can redistribute it and/or modify
#    it under the terms of the GNU General Public License as published by
#    the Free Software Foundation; either version 2 of the License, or
#    (at your option) any later version.
#
#    MEDITE is distributed in the hope that it will be useful,
#    but WITHOUT ANY WARRANTY; without even the implied warranty of
#    MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
#    GNU General Public License for more details.
#
#    You should have received a copy of the GNU General Public License
#    along with Foobar; if not, write to the Free Software
#    Foundation, Inc., 51 Franklin St, Fifth Floor, Boston, MA  02110-1301  USA

# enable contract checking
#import contract,suffix_tree
#contract.checkmod(suffix_tree)
import MediteApplication.suffix_tree
import bisect, string, logging, os, os.path, time, unittest            # Modifiee 15.04.2019, ancienne ligne:  import psyco,bisect,string,logging,os,os.path, time,unittest 
# import contract                                                    # Desactivee 15.04.2019 
import numpy as np                                                  # Ajoutee 23.07.2019 
# import numpy.numarray as numarray                                    # Desactivee 23.07.2019
# import MediteAppli.suffix_tree                                     # Desactivee 07.06.2019 (ligne doublee)
# from . import test_data                                           # Desactivee 23.07.2019 .....  # Modifiee 15.04.2019, ancienne ligne:    import test_data
import MediteApplication.test.test_data                                   # Ajoutee 23.07.2019
# contract.checkmod(MediteAppli.suffix_tree)                        # Desactivee 15.04.2019 

class TestSuffixTree(unittest.TestCase):
    """Teste les SuffixTree"""
    def setUp(self):
        td = MediteApplication.test.test_data.Test_Data()
        self.texte = "cacaoccaocaococaica" #td._readFile('final.fr.txt')#td._readFile('Alth1v1.txt') #+td._readFile('Alth1v2.txt')+td._readFile('Condorcet_Esimpr2.txt')#
        # "cacaocaoco" "cacaoccaocaococaica" "self.texte1Zself.texte2"
        sequences = self.texte
        #sequences = "cacao"
        a = time.time()
        self.st = MediteApplication.suffix_tree.SuffixTree(sequences)
        b = time.time()
        logging.debug('construction st done')
        print ('temps construction = ',b-a)                           # Modifiee 15.04.2019, ancienne ligne:   print 'temps construction = ',b-a
        #print self.st
        c = d = e = 0 
        for n in self.st.generate_leaves(): c += 1
        for n in self.st.generate_inner_nodes(): d += 1
        for n in self.st.generate_post_order_nodes(): e += 1
        print ('size=',len(self.texte),'/ leaves=',c,'/ inner=',d,'/ all=',e)             # Modifiee 15.04.2019, ancienne ligne:  print 'size=',len(self.texte),'/ leaves=',c,'/ inner=',d,'/ all=',e 
        a = time.time()
        self.LL = self.st.get_MEM()
        #trace('self.LL = self.st.get_MEM()',locals())
        b = time.time()
        print ('temps MEM = ',b-a)                                    # Modifiee 15.04.2019, ancienne ligne:  print 'temps MEM = ',b-a 
        for size in self.LL:
            x = ''
            for pos in self.LL[size]:
                x +=  self.texte[pos:pos+size] +' '
            #print x   
        #print self.st.root.__str__(self.texte, short=True)            
    def test1(self):
        #self.assert_(isinstance(self.st,MediteAppli.suffix_tree.SuffixTree))
        pass          
        #print self.LL
        #self.assert_(len(self.LL)>0)
        
class TestGeneralisedSuffixTree(unittest.TestCase):
    """Teste les GeneralisedSuffixTree"""
    def setUp(self):
        self.td = MediteApplication.test.test_data.Test_Data()
        #sequences = [td._readFile('Alth1v1.txt'),td._readFile('Alth1v2.txt')]#+td._readFile('Condorcet_Esimpr2.txt')]
        #sequences = [td._readFile('final.fr200.txt'),td._readFile('final-en2fr200.txt')]
        #sequences = [td._readFile('chedidtapuscrit.txt'),td._readFile('chedidcor.txt')]
        #sequences = [td._readFile('CB_experience.txt'),td._readFile('CB_Texte_de_1857.txt')]
        #sequences = ["self.texte1", "self.texte2"]
        #sequences = ["cacaoccaocaococaica", "cacaocaoco"]
        self.texte1 = self.td._readFile('CB_experience.txt') ; self.texte2 = self.td._readFile('CB_Texte_de_1857.txt')
        #texte1 = td._readFile('bovary1.txt') ; texte2 = td._readFile('bovary2.txt')
        #texte1 = "le cat is vert. vraiment vert" ; texte2 = "le cat is bleu. it is vert"
        #texte1 = td._readFile('chedidtapuscrit.txt') ; texte2 = td._readFile('chedidcor.txt')
        #texte1 = td._readFile('IP_823.txt') ; texte2 = td._readFile('Macadam.txt')
        #self.texte1 = td._self.readFile('Condorcet_Esimpr1.txt') ; self.texte2 = self.td._readFile('Condorcet_Esimpr2.txt')
        #print len(texte1),len(texte2)
        
    def test(self):        
        texte1 = self.texte1.lower()  ; texte2 = self.texte2.lower()  
        sepTable = str.maketrans("çéèàùâêîôûäëïöüÿÇÉÈÀÙÂÊÎÔÛÄËÏÖÜ","ceeauaeiouaeiouyCEEAUAEIOUAEIOU")                # Modifiee 15.04.2019, ancienne ligne:  sepTable = string.maketrans("�������������������������������","ceeauaeiouaeiouyCEEAUAEIOUAEIOU") 
        texte1 = texte1.translate(sepTable)
        texte2 = texte2.translate(sepTable)
        sepTable2 = str.maketrans(""" !\r,\n:\t;-?"'`’()""","................")                                      # Modifiee 15.04.2019, ancienne ligne:  sepTable2 = string.maketrans(""" !\r,\n:\t;-?"'`�()""","................")
        texte1 = texte1.translate(sepTable2)
        texte2 = texte2.translate(sepTable2)
        self.dictPosSuppression={}
        self.tabNbSuppression={}
        texte1,texte2=self.preTraitSuppSep(texte1,texte2)
        lt1 = len(texte1) ; lt2 = len(texte2)
        
        sequences = [texte1,texte2]
        logging.debug('debut')
        a = time.time()
        #psyco.bind(MediteAppli.suffix_tree.GeneralisedSuffixTree)
        #self.st = MediteAppli.suffix_tree.GeneralisedSuffixTree(sequences)
        # psyco.bind(MediteAppli.suffix_tree.GeneralisedSuffixTree)                    # Desactivee 15.04.2019, psyco est obsolete et n'existe plus surtout pour 64 bits
        self.st = MediteApplication.suffix_tree.GeneralisedSuffixTree(sequences)
        b = time.time()
        logging.debug('construction st done')
        #self.LL = self.st.shared_substrings3(1)
        #for chaine,lpos in iter(self.LL.items()):                    # Modifiee 16.04.2019, ancienne ligne:   #for chaine,lpos in self.LL.iteritems(): 
        #    if 'mouvements' in chaine:
        #        print '1',chaine,lpos
        #print self.LL
        #trace('self.LL = self.st.shared_substrings3(1)',locals())
        #trace('self.LL2 = self.st.get_MEM_index_chaine()',locals())
        #psyco.bind(self.st.get_MEM_index_chaine3)
        #f = psyco.proxy(self.st.get_MEM_index_chaine3)
        self.LL2 = self.st.get_MEM_index_chaine3(just_keep_words=True)
        #print self.st.root.__str__(sequences[0]+sequences[1],charOnly='.')
        #for chaine,lpos in iter(self.LL2.items()):                    # Modifiee 16.04.2019, ancienne ligne:   #for chaine,lpos in self.LL2.iteritems():  
        #    if 'mouvements' in chaine:
        #        print '2',chaine,lpos
        #print self.LL2
        c = time.time()
        #print len(self.LL2), len(self.LL2)
        
        #print self.LL
        logging.debug('temps construction = %f',b-a)
        logging.debug('temps MEM = %f',c-b) 
        #c = d = e = 0 
        #for n in self.st.generate_leaves(): c += 1
        #for n in self.st.generate_inner_nodes(): d += 1
        #for n in self.st.generate_post_order_nodes(): e += 1
        #logging.debug('size='+str(len(sequences[0])+len(sequences[1]))+'/ leaves='+str(c)+'/ inner='+str(d)+'/ all='+str(e))
        
        # affichage des SMEM
        top = [] 
        for (cle,longueur),liste_pos in iter(self.LL2.items()):                           # Modifiee 16.04.2019, ancienne ligne:  for (cle,longueur),liste_pos in self.LL2.iteritems(): 
            nb = len(liste_pos) ; chaine = texte1[liste_pos[0]:liste_pos[0]+longueur]
            assert cle == hash(chaine)
            bisect.insort_left(top,(nb,chaine,liste_pos))
        cumul_len = cumul_2 = cumul_3 = 0.0
        top.reverse()
        for x in top:
            t = x[0]*len(x[1])
            cumul_len += t
            if x[0] <= 2: cumul_2 += t
            else: cumul_3 += t
            #logging.debug(str(x)+' / cumul % texte total='+str(100*cumul_len/(lt1+lt2)))            
        logging.debug('cumul_2 % texte total='+str(100*cumul_2/(lt1+lt2)))
        logging.debug('cumul_2 % texte répété='+str(100*cumul_2/(cumul_2+cumul_3)))
        logging.debug('cumul_3 % texte total='+str(100*cumul_3/(lt1+lt2)))
        logging.debug('cumul_3 % texte répété='+str(100*cumul_3/(cumul_2+cumul_3)))
        logging.debug('cumul_2+cumul_3 % texte total='+str(100*(cumul_2+cumul_3)/(lt1+lt2)))
        
        #affichage des mots
        texte = texte1+texte2
        liste = texte.split('.')
        dic = {}
        for i in liste:
            try:
                dic[i] += 1
            except KeyError:
                dic[i] = 1
        n=len(liste) ; liste = []      
        for mot,nb in iter(dic.items()):                       # Modifiee 16.04.2019, ancienne ligne:  for mot,nb in dic.iteritems(): 
            bisect.insort_right(liste,(nb,mot))
        liste.reverse()
        cumul = cumul_2 = cumul_3 = 0.0 ; nb_mot = 0 #; nb_mot1 = nb_mot2 = 0
        for (nb,mot) in liste:
            nb_mot += nb
            t = len(mot)*nb 
            if nb > 2: cumul_3 += t
            elif nb == 2: cumul_2 += t
            cumul += t
            #logging.debug(str((nb,mot))+' / cumul % texte total='+str(100*cumul/(lt1+lt2)))
        assert n == nb_mot            
        logging.debug('cumul_2 % texte total='+str(100*cumul_2/(lt1+lt2)))
        logging.debug('cumul_2 % texte répété='+str(100*cumul_2/(cumul_2+cumul_3)))
        logging.debug('cumul_3 % texte total='+str(100*cumul_3/(lt1+lt2)))
        logging.debug('cumul_3 % texte répété='+str(100*cumul_3/(cumul_2+cumul_3)))
        logging.debug('cumul_2+cumul_3 % texte total='+str(100*(cumul_2+cumul_3)/(lt1+lt2)))
        #logging.debug('nb_mot = '+str(nb_mot))
        
        # affichage des mots de + de 3 carac
        cumul = cumul_2 = cumul_3 = cumul_nb = 0.0
        ch_excel = [] ; ch_nb = []
        stopWords = ['avec','dans','pour','sous','mais','encore','quand','cette','notre', 'votre', 'leur', 'leurs','donc','puis',
                    'comme', 'lorsque', 'puisque', 'quand', 'quoique', 'afin', 'ainsi', 'avant', 'comme',
                    'aucun', 'aucune', 'autre', 'certain', 'certaine', 'certaines', 'certains', 'chaque', 'plusieurs', "quelqu'",' quelque', 'quelques' , 
                    'telle', 'telles', 'tous', 'tout', 'toute', 'toutes', 'lequel', 'laquelle', 'lesquels', 'lesquelles',
                    'duquel', 'dequels', 'dequelles', 'auquel', 'auxquels', 'auxquelles',
                    'quel', 'quelle', 'quelles', 'quels',
                     'elle', 'nous', 'vous','elles',
                     'celui', 'celle', 'ceux', 'celles', 'ceci', 'cela',
                     'aucun', 'aucune', 'autre', 'autrui', 'certains', 'chacun', 'quiconque', 'rien']
        #for (nb,mot) in liste:
        #    if len(mot)>3:
        #        cumul_nb += n
        ch4 = [] ; i = 0
        global NOMB,CUM
        for (nb,mot) in liste:
            if len(mot)>3 and mot not in stopWords:
                t = len(mot)*nb
                if nb > 2: cumul_3 += t
                elif nb == 2: cumul_2 += t
                cumul += t
                logging.debug(str((nb,mot))+' / cumul % texte total='+str(100*cumul/(lt1+lt2)))
                ch_excel.append(str(nb)+';')
                ch_nb.append(nb)
                cumul_nb += nb
                ch4.append(str(round(100*cumul/(lt1+lt2),2))+';')
                if i< 200:
                    CUM[i] += round(100*cumul/(lt1+lt2),2) ; i += 1
        NOMB += 1
        ch_nb2 = [(0.0+nb)/(cumul_2+cumul_3) for nb in ch_nb]
        ch_nb3 = [str(nb)+';' for nb in ch_nb2]
        logging.debug('cumul_2 % texte total='+str(100*cumul_2/(lt1+lt2)))
        logging.debug('cumul_2 % texte répété='+str(100*cumul_2/(cumul_2+cumul_3)))
        logging.debug('cumul_3 % texte total='+str(100*cumul_3/(lt1+lt2)))
        logging.debug('cumul_3 % texte répété='+str(100*cumul_3/(cumul_2+cumul_3)))
        logging.debug('cumul_2+cumul_3 % texte total='+str(100*(cumul_2+cumul_3)/(lt1+lt2)))
        logging.debug('chaine excel = '+''.join(ch_excel))
        logging.debug('chaine excel2 = '+''.join(ch_nb3))
        logging.debug('nb total = %d / nb moyen = %f / nb médian = %d',cumul_nb,cumul_nb/len(liste),ch_nb[len(ch_nb)//2])            # Modifiee 24.06.2019, ancienne ligne: logging.debug('nb total = %d / nb moyen = %f / nb m�dian = %d',cumul_nb,cumul_nb/len(liste),ch_nb[len(ch_nb)/2]) 
        #logging.critical(''.join(ch4))
    def test1(self):
        self.assert_(isinstance(self.st,MediteApplication.suffix_tree.GeneralisedSuffixTree))
        #print self.LL
        #self.assert_(len(self.LL)>0)

    def preTraitSuppSep(self,texte1,texte2):
        """ Prétraitement supprimant plusieurs séparateurs se suivant et n'en laissant qu'un
        Prend en entrée texte1 et texte2 et les renvoie traités """
        debut=0
        j=0
        comptSuppression=0
        res=[]
        for texte in [texte1,texte2]:
            i=0
            lTexte=[]
            while i<len(texte)-1:
                if texte[i]=='.' and texte[i+1]=='.': 
                    comptSuppression+=1
                    # position du texte original ou un séparateur a été supprimé
                    self.dictPosSuppression[i+debut]='.' 
                else: 
                    lTexte.append(texte[i])
                    # � chaque position du nouveau texte est associé le nb de suppression
                    # de séparateur jusqu'à cette position
                    self.tabNbSuppression[j]=comptSuppression
                    j+=1
                i+=1
            lTexte.append(texte[i])
            self.tabNbSuppression[j]=comptSuppression
            j+=1
            debut=i+1
            res.append(''.join(lTexte)) # chaine
        self.tabNbSuppression[j]=comptSuppression            
        return res[0],res[1]
        
    def postTraitSuppSep2(self,listeOcc):
        res=[]
        for (occ1,occ2) in listeOcc: 
            Nocc1 = occ1+self.tabNbSuppression[occ1]
            Nocc2 = occ2+self.tabNbSuppression[occ2]
            res.append((Nocc1,Nocc2))
        return res  

class TestGeneralisedSuffixTreeChedid(TestGeneralisedSuffixTree):
    """Teste les GeneralisedSuffixTree"""
    def setUp(self):
        self.td = MediteApplication.test.test_data.Test_Data()
        self.texte1 = self.td._readFile('chedidtapuscrit.txt') ; self.texte2 = self.td._readFile('chedidcor.txt')
        self.texte1 = self.texte1[:8000] ; self.texte2 = self.texte2[:8000]
        
class TestGeneralisedSuffixTreeBrousse(TestGeneralisedSuffixTree):
    """Teste les GeneralisedSuffixTree"""
    def setUp(self):
        self.td = MediteApplication.test.test_data.Test_Data()
        self.texte1 = self.td._readFile('IP_823.txt') ; self.texte2 = self.td._readFile('Macadam.txt')
        self.texte1 = self.texte1[:8000] ; self.texte2 = self.texte2[:8000]
        
class TestGeneralisedSuffixTreeCondo(TestGeneralisedSuffixTree):
    """Teste les GeneralisedSuffixTree"""
    def setUp(self):
        self.td = MediteApplication.test.test_data.Test_Data()
        self.texte1 = self.td._readFile('CONDORCET_IMPOT_1.txt') ; self.texte2 = self.td._readFile('CONDORCET_IMPOT_10.txt')
        self.texte1 = self.texte1[:8000] ; self.texte2 = self.texte2[:8000]
        
class TestGeneralisedSuffixTreeCondo2(TestGeneralisedSuffixTree):
    """Teste les GeneralisedSuffixTree"""
    def setUp(self):
        self.td = MediteApplication.test.test_data.Test_Data()
        self.texte1 = self.td._readFile('Condorcet_Esimpr1.txt') ; self.texte2 = self.td._readFile('Condorcet_Esimpr2.txt')
        self.texte1 = self.texte1[:8000] ; self.texte2 = self.texte2[:8000]        
        
class TestGeneralisedSuffixTreeAlthu(TestGeneralisedSuffixTree):
    """Teste les GeneralisedSuffixTree"""
    def setUp(self):
        self.td = MediteApplication.test.test_data.Test_Data()
        self.texte1 = self.td._readFile('Alth1v1.txt') ; self.texte2 = self.td._readFile('Alth1v2.txt')
        self.texte1 = self.texte1[:8000] ; self.texte2 = self.texte2[:8000]
        
class TestGeneralisedSuffixTreeBernon(TestGeneralisedSuffixTree):
    """Teste les GeneralisedSuffixTree"""
    def setUp(self):
        self.td = MediteApplication.test.test_data.Test_Data()
        self.texte1 = self.td._readFile('bernon1.txt') ; self.texte2 = self.td._readFile('bernon5-18_5.txt')
        self.texte1 = self.texte1[:8000] ; self.texte2 = self.texte2[:8000]
        
class TestGeneralisedSuffixTreeCupidon(TestGeneralisedSuffixTree):
    """Teste les GeneralisedSuffixTree"""
    def setUp(self):
        self.td = MediteApplication.test.test_data.Test_Data()
        self.texte1 = self.td._readFile('dactylo-1.txt') ; self.texte2 = self.td._readFile('dactylo-11-rouge.txt')
        self.texte1 = self.texte1[:8000] ; self.texte2 = self.texte2[:8000]
        
class TestGeneralisedSuffixTreeRamuz1(TestGeneralisedSuffixTree):
    """Teste les GeneralisedSuffixTree"""
    def setUp(self):
        self.td = MediteApplication.test.test_data.Test_Data()
        self.texte1 = self.td._readFile('Tout-vieux orig.txt') ; self.texte2 = self.td._readFile('tout-vieux1909.txt')
        self.texte1 = self.texte1[:8000] ; self.texte2 = self.texte2[:8000]                          
        
def _test():
    logging.basicConfig(level=logging.DEBUG,
                            format='%(asctime)s %(levelname)s %(message)s',
                            datefmt='%H:%M:%S')
    suite1 = unittest.makeSuite(TestSuffixTree)
    suite2 = unittest.TestSuite()
    #suite2.addTest(TestGeneralisedSuffixTree('test'))
    suite2.addTest(TestGeneralisedSuffixTreeChedid('test'))
#     suite2.addTest(TestGeneralisedSuffixTreeBrousse('test'))
#     suite2.addTest(TestGeneralisedSuffixTreeCondo('test'))
#     suite2.addTest(TestGeneralisedSuffixTreeCondo2('test'))
#     suite2.addTest(TestGeneralisedSuffixTreeAlthu('test'))
#     suite2.addTest(TestGeneralisedSuffixTreeBernon('test'))
#     suite2.addTest(TestGeneralisedSuffixTreeCupidon('test'))
    # suite2.addTest(TestGeneralisedSuffixTreeRamuz1('test'))
    suite = unittest.TestSuite(( suite2))
    #suite = unittest.TestSuite((suite1, suite2))
    unittest.TextTestRunner(verbosity=2).run(suite)

def trace(commande,dic_locals):
    import profile,pstats,sys
    #profile.runctx(commande,globals(), locals(),'Z:\workspace\medite\statFile')
    profile.runctx(commande,globals(), dic_locals,'c:\workspace\medite\statFile')
    s = pstats.Stats('c:\workspace\medite\statFile')
    s.sort_stats('time')
    s.print_stats()
    sys.stderr.flush()
    sys.stdout.flush()
    
CUM = np.zeros(200)                # Modifiee 23.07.2019, ancienne ligne:  CUM = numarray.zeros(200,numarray.Float)
NOMB = 0
if __name__ == '__main__':
    logging.basicConfig(level=5,#logging.DEBUG,#INFO,
                            format='%(asctime)s %(levelname)s %(message)s',
                            #datefmt='%H:%M:%S',
                            filename=os.path.join(os.getcwd(),'log.txt'),
                            filemode='w')
    console = logging.StreamHandler()
    console.setLevel(logging.INFO)  
    log = logging.FileHandler(filename=os.path.join(os.getcwd(),'log_MA.txt'),mode='w')
    log.setLevel(logging.CRITICAL)
    log.setFormatter(logging.Formatter(''))#%(asctime)s %(levelname)s %(message)s'))
    logging.getLogger('').addHandler(log)
    _test()
    print ("10. Module: MediteAppli.test.test_suffix_tree, Class: TestSuffixTree, Methode: trace, Ligne 368, \nCUM= %s ", CUM)              # Modifiee 15.04.2019, ancienne ligne:  print CUM 
    a = np.around(CUM / NOMB, decimals=2) ; ch = []             # Modifiee 23.07.2019, ancienne ligne:  a = numarray.around(CUM / NOMB,2) ; ch = []
    print ("11. Module: MediteAppli.test.test_suffix_tree, Class: TestSuffixTree, Methode: trace, Ligne 370, \na=[ %s ", a, "] ")
    for nb in a:
        ch.append(str(nb)+';')
    print ("12. Module: MediteAppli.test.test_suffix_tree, Class: TestSuffixTree, Methode: trace, Ligne 373, \nch=[", ch, "] ")
    
    logging.critical(''.join(ch))
    
    