# -*- coding: UTF-8 -*-
# Copyright 2003 - 2008: Julien Bourdaillet (julien.bourdaillet@lip6.fr), Jean-Gabriel Ganascia (jean-gabriel.ganascia@lip6.fr)
# This file is part of MEDITE.
#
#    MEDITE is free software; you can redistribute it and/or modify
#    it under the terms of the GNU General Public License as published by
#    the Free Software Foundation; either version 2 of the License, or
#    (at your option) any later version.
#
#    MEDITE is distributed in the hope that it will be useful,
#    but WITHOUT ANY WARRANTY; without even the implied warranty of
#    MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
#    GNU General Public License for more details.
#
#    You should have received a copy of the GNU General Public License
#    along with Foobar; if not, write to the Free Software
#    Foundation, Inc., 51 Franklin St, Fifth Floor, Boston, MA  02110-1301  USA
#----------------------------------------------------------------------------
# Nom:          codageXml.py
# Objet:        fichier qui contient des methodes qui aide a la constructions
#               des fichiers xml
#----------------------------------------------------------------------------
# import Ft.Xml#, Ft.Xml.Domlette                                                                               # Desactivee 28.02.2019, 4Suite n'existe plus. 
# ligne ci-dessous n�cessaire car sinon lors du freeze avec cxfreeze il a besoin
# de cet import qui n'est pas import� normalement
# import Ft.Xml.XInclude                                                                                        # Desactivee 28.02.2019, 4Suite n'existe plus. 
# import Ft.Xml.XPath, Ft.Xml.XPath.ParsedPredicateList, Ft.Xml.XPath.ParsedAbbreviatedAbsoluteLocationPath     # Desactivee 28.02.2019, 4Suite n'existe plus. 
# import Ft.Xml.XPath.ParsedAbbreviatedRelativeLocationPath                                                     # Desactivee 28.02.2019, 4Suite n'existe plus. 
import xml                                                  # Ajoutee 28.02.2019 
import xml.dom                                          # Ajoutee 28.02.2019 
import xml.dom.minidom                                      # Ajoutee 28.02.2019 
from xml.dom.minidom import *
import lxml                                                 # Ajoutee 28.02.2019 
from lxml import *
# import lxml.includes 
# import lxml.etree                                           # Ajoutee 28.02.2019 
# import lxml.etree.XPath                                     # Ajoutee 28.02.2019 
# from lxml.entree import *
#from xml.dom.pulldom import *
import sys

## astuce pour l'encoding du fichier xml
def encodingXml(pChemin):
    # print("1. Module Utile.codageXML, Class: , Methode: encodingXml, Ligne: 44 ---> pChemin=", pChemin, " ")
    f = open(pChemin)
    debut = f.read(23)
    # print("2. Module Utile.codageXML, Class: , Methode: encodingXml, Ligne: 47 ---> debut=", debut, " ")
    debut = debut[0:20] + ' encoding="utf-8" ' +debut[20:]                     # Modifiee 11.09.2019  # iso-8859-1
    # print("3. Module Utile.codageXML, Class: , Methode: encodingXml, Ligne: 49 ---> debut=\n", debut, " ")
    reste = f.read()
    # print("4. Module Utile.codageXML, Class: , Methode: encodingXml, Ligne: 51 ---> reste=\n", reste, " ")
    ts = debut + reste
    # print("5. Module Utile.codageXML, Class: , Methode: encodingXml, Ligne: 53 ---> ts=\n", ts, " ")
    f.close()
    f = open(pChemin,'w')
    f.write(ts)
    f.close()
##    pass


## astuce pour l'encodage des noeuds des balises
def encodingNode(pNode):
    # print("6. Module Utile.codageXML, Class: , Methode: encodingNode, Ligne: 63 ---> pNode=", pNode.toxml(), " ")
    if not isinstance(pNode,str):                           # Modifiee 28.02.2019, ancienne ligne:  if not isinstance(pNode,unicode): 
        # print("7. Module Utile.codageXML, Class: , Methode: encodingNode, Ligne: 65 ---> ")
        code = pNode.decode(encoding="utf-8", errors="ignore")                   # Modifiee 28.02.2019, ancienne ligne:  code = unicode(pNode, 'iso-8859-1')  (? a verifier !)
    else: code = pNode
    # print("8. Module Utile.codageXML, Class: , Methode: encodingNode, Ligne: 68 ---> code=", code.toxml(), " ")
    return code

## Methode pour parser un fichier xml accentue
def lireDocXml(pChemin):
    # print("9. Module Utile.codageXML, Class: , Methode: lireDocXml, Ligne: 73 ---> pChemin=", pChemin, " ")
    f = open(pChemin)
    text = f.read()
    f.close()
    # print text
    #textDoc = unicode(text,'iso-8859-1')
    # print("10. Module Utile.codageXML, Class: , Methode: lireDocXml, Ligne: 79 ---> text=\n", text, " ")
    ficXML = xml.dom.minidom.parseString(text)
    return ficXML
#    return xml.dom.pulldom.parse(pChemin)

## Methode pour parser un fichier xml accentue avec Ft.Xml
def lireDocXmlFt(pChemin):
    # print("11. Module Utile.codageXML, Class: , Methode: lireDocXmlFt, Ligne: 86 ---> pChemin=\n", pChemin, " ")
    f = open(pChemin)
    text = f.read()
    f.close()
    # print text
    #textDoc = unicode(text,'iso-8859-1')
    # print("12. Module Utile.codageXML, Class: , Methode: lireDocXmlFt, Ligne: 92 ---> text=\n", text, " ")
    ficXML = xml.dom.minidom.parseString(text)                               # Modifiee 28.02.2019, ancienne ligne:  ficXML = Ft.Xml.Parse(text) 
    return ficXML
#    return xml.dom.pulldom.parse(pChemin)

## Methode pour parser un fichier xml en ne lisant que l'arbre des versions
def lireDocXmlVersionTree(pChemin):
    # print("13. Module Utile.codageXML, Class: , Methode: lireDocXmlVersionTree, Ligne: 99 ---> pChemin=\n", pChemin, " ")
    f = open(pChemin)
    text = f.read()
    f.close()
    # print("14. Module Utile.codageXML, Class: , Methode: lireDocXmlVersionTree, Ligne: 103 ---> text=\n", text, " ")
    # on coupe après arbre pour ne garder que les infos de l'arbre des versions
    pos = text.find('</arbre>')
    text = text[:pos+8] + '</root>'
    # print("15. Module Utile.codageXML, Class: , Methode: lireDocXmlVersionTree, Ligne: 107 ---> text=\n", text, " ")
    ficXML = xml.dom.minidom.parseString(text)
    return ficXML
    
## Methode pour ecrire un doc xml dans un fichier
def ecrireDocXml(pChemin,pDocument):
    # print("16. Module Utile.codageXML, Class: , Methode: ecrireDocXml, Ligne: 113 ---> pChemin=", pChemin, ", pDocument=", pDocument.toxml(), " ")
    filexml = open(pChemin,'w')        # Modifie 12.09.2019:  f = open(pChemin,'w')
                                        # Desactive 112.09.2019: content = pDocument.toxml()
                                        # print("17. Module Utile.codageXML, Class: , Methode: ecrireDocXml, Ligne: 116 ---> content=", content, " ")
    #d = SAX2DOM(pDocument)
    #content = d.toxml()
#    if isinstance(pDocument,xml.dom.minidom.Document):
#       content = pDocument.toxml()
#    else: #pullDom
#        sys.stderr.write(str(type(pDocument)))
#        sys.stderr.write(str(pDocument))
#        if pDocument == None:
#           sys.stderr.write("none")
#        sys.stderr.flush()
#        for event, node in pDocument:
#           sys.stderr.write("d\n")
#           sys.stderr.write(str(event)+" "+str(node.nodeName)+" d \n")
#            sys.stderr.flush()
#            if (event=='START_DOCUMENT'):
#                pDocument.expandNode(node)
#                content = node.toxml()
#                break
#            elif (event!='START_DOCUMENT' and node.nodeName!='root'):
#               pDocument.expandNode(node)
#               sys.stderr.write("d"+node.toxml()+"\n")
#               sys.stderr.flush()
                
    pDocument.writexml(filexml)                 # Modifie 12.09.2019:  f.write(content.encode('iso-8859-1'))
    filexml.close()
    encodingXml(pChemin)

    
## Methode pour ecrire un doc xml dans un fichier avec Ft.Xml
def ecrireDocXmlFt(pChemin,pDocument):
    # print("18. Module Utile.codageXML, Class: , Methode: ecrireDocXmlFt, Ligne: 147 ---> \npChemin=", pChemin, ", \npDocument=", pDocument.toxml(), " ")
    filexml = open(pChemin,'w')                                            # f = open(pChemin,'w') 
    #content = pDocument.toxml()
    #f.write(content.encode('iso-8859-1'))
    #parser_pDoc = etree.XMLParser(resolve_entities=False, strip_cdata=False)
    # parsed_pDoc = xml.dom.minidom.parseString(pDocument, parser=None)        # Modifiee 28.02.2019, ancienne ligne:  Ft.Xml.Domlette.Print(pDocument, stream=f, encoding='iso-8859-1')   
    # f.write(parsed_pDoc.toprettyxml(encoding='utf-8'))                       # Desactive 11.09.2019    # Ajoutee 28.02.2019. 
    # f.close()                                                                # Desactive 11.09.2019
    #encodingXml(pChemin)
    pDocument.writexml(filexml)                           # Modifie 12.09.2019 - # Ajoutee 28.02.2019: f.write(pDocument.toprettyxml(encoding='utf-8'))
    filexml.close()

    
