# -*- coding: UTF-8 -*-
# Copyright 20003 - 2008: Julien Bourdaillet (julien.bourdaillet@lip6.fr), Jean-Gabriel Ganascia (jean-gabriel.ganascia@lip6.fr)
# This file is part of MEDITE.
#
#    MEDITE is free software; you can redistribute it and/or modify
#    it under the terms of the GNU General Public License as published by
#    the Free Software Foundation; either version 2 of the License, or
#    (at your option) any later version.
#
#    MEDITE is distributed in the hope that it will be useful,
#    but WITHOUT ANY WARRANTY; without even the implied warranty of
#    MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
#    GNU General Public License for more details.
#
#    You should have received a copy of the GNU General Public License
#    along with Foobar; if not, write to the Free Software
#    Foundation, Inc., 51 Franklin St, Fifth Floor, Boston, MA  02110-1301  USA
#----------------------------------------------------------------------------
# Nom:          constantesDonnees.py
# Objet:        Fichier qui regroupe les differentes constantes utiles dans
#               l'implementation
#----------------------------------------------------------------------------

import os,constantes

#######################
#  Repertoire  des DG
#######################
DG_REP = os.path.join(constantes.REPMEDITE, 'GLOBAL')
DG_AUTEUR_FILE = "auteur.json"                            # Modifie 12.09.2019, ancienne:  DG_AUTEUR_FILE = "auteur.dg" 
DG_AUTEUR_CLE = "cle_auteur"
DG_FILE_INFO = "Informations.xml"
#######################
LEURREP = os.path.join(constantes.REPMEDITE, 'LEUR')        # Ajoutee 21.03.2019. 

#######################
#  Repertoire  des param�tres
#######################
REPPRIVE = os.path.join(constantes.REPMEDITE, 'PRIVE')

#######################################
#  Fichier de sauvegarde des donnees  #
#######################################
FICDONNEES = 'NosDonnees'                                   # Modifiee 04.06.2019, ancienne ligne:  FICDONNEES = 'NosDonnees' 
NOSDONNEES = os.path.join(REPPRIVE, FICDONNEES)

##################################################
#  Fichier de sauvegarde des donnees de travail  #
##################################################
FICTRAVAIL = 'PlanTravail'                              # Modifiee 13.09.2019,  04.06.2019, ancienne ligne:  FICTRAVAIL = 'PlanTravail' 
PLANTRAVAIL = os.path.join(REPPRIVE, FICTRAVAIL)
FIC_COULEURS = os.path.join(REPPRIVE, 'Couleurs.json')           # Modifiee 17.09.2019,  04.06.2019, ancienne ligne:  FIC_COULEURS = os.path.join(REPPRIVE, 'Couleurs') 
FIC_PARAMETRES = os.path.join(REPPRIVE,'Parametres.json')        # Modifiee 13.09.2019, 04.06.2019, ancienne ligne:  FIC_PARAMETRES = os.path.join(REPPRIVE,'Parametres') 

##########################
#  COULEURS PAR DEFAULT  #
##########################

DEFAUT_INSERTION = [0,200,0]
DEFAUT_SUPPRESSION =  [255, 0, 0]
DEFAUT_REMPLACEMENT = [0,0,255]
DEFAUT_NONDEFINIS = [255,150,0]
DEFAUT_ECRITURE_BLANC = [255, 255, 255]
# utilisé tout le temps sous sa forme binaire de 3 bits 111,011,001 ...
# 1er bit soulignement / 2e gras / 3e italique
#                             1   1   1
DEFAUT_SOULIGNE_DEPLACEMENT = 8 + 4 + 2 

######################################
#  PARAMETRE DE LISSAGE PAR DEFAULT  #
######################################

DEFAUT__LONG_MIN_PIVOT = 5
DEFAUT_RATION__MIN_REMP=  50
DEFAUT_RATIO_SEUIL_LISSAGE = 50
DEFAULT_CAR_OU_MOT = 0

####################
#   Fichier XML    #
####################

FICHIER_INFO = 'Informations.xml'
## Balises ##
B_ROOT = 'root'
B_AUTEUR = 'auteur'
B_NOM = 'nom'
B_PRENOM = 'prenom'
B_NAISSANCE = 'naissance'
B_DECES = 'deces'
B_OEUVRE = 'oeuvre'
B_TITRE = 'titre'
B_EDITION = 'edition'
B_PUBLICATION = 'publication'
B_INFORMATIONS = u'informations'
B_VERS_SOURCE = u'vsource'
B_ETAT_SOURCE = 'fsource'
B_VERS_CIBLE = u'vcible'
B_ETAT_CIBLE = u'fcible'
B_PARAM_1 = u'lg_pivot'
B_PARAM_2 = u'ratio'
B_PARAM_3 = u'seuil'
B_PARAM_4 = u'car_mot'
B_PARAM_5 = u'caseSensitive'
B_PARAM_6 = u'sepSensitive'
B_PARAM_7 = u'diacriSensitive'
B_TRANSFORMATIONS = u'transformations'
B_LGSOURCE = u'lgsource'
B_INSERTIONS = u'insertions'
B_SUPPRESSIONS = u'suppressions'
B_DEPLACEMENTS = u'deplacements'
B_REMPLACEMENTS = u'remplacements'
B_BLOCSCOMMUNS = u'blocscommuns'
B_BLOCSDEPLACES = u'blocsdeplaces'
B_NONDEF = u'blocsNonDefinis'
B_LG = u'lg'
B_INS = u'ins'
B_SUP = u'sup'
B_DEP = u'dep'
B_REMP = u'remp'
B_BC = u'bc'
B_ND = u'nd'
B_MOT = u'mot'
B_DEB = u'd'
B_FIN = u'f'
B_DEP = u'bd'
B1_D = u'b1d'
B1_F = u'b1f'
B2_D = u'b2d'
B2_F = u'b2f'
#B_REMP = 'remp'
B_MOT_AVANT = 'motavant'
B_MOT_APRES = 'motapres'
B_TEXT_SOURCE = 'textsource'
B_TEXT_CIBLE = 'textcible'
B_TEXT = 'tcommun'
B_TEXT_INSER = 'tinsertion'
B_TEXT_SUPP = 'tsuppression'
B_TEXT_DEPL = 'tdeplacement'
B_TEXT_REMP = 'tremplacement'
B_COMMENTAIRE = 'commentaire'

B_ARBRE = 'arbre'
B_VERSION = 'version'
B_ETAT = 'etat'
B_ID = "id"


