# -*- coding: iso-8859-1 -*-
# Copyright 20003 - 2008: Julien Bourdaillet (julien.bourdaillet@lip6.fr), Jean-Gabriel Ganascia (jean-gabriel.ganascia@lip6.fr)
# This file is part of MEDITE.
#
#    MEDITE is free software; you can redistribute it and/or modify
#    it under the terms of the GNU General Public License as published by
#    the Free Software Foundation; either version 2 of the License, or
#    (at your option) any later version.
#
#    MEDITE is distributed in the hope that it will be useful,
#    but WITHOUT ANY WARRANTY; without even the implied warranty of
#    MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
#    GNU General Public License for more details.
#
#    You should have received a copy of the GNU General Public License
#    along with Foobar; if not, write to the Free Software
#    Foundation, Inc., 51 Franklin St, Fifth Floor, Boston, MA  02110-1301  USA

import os,regex        # Modifiee 16.04.2019, ancienne ligne:  import os,re

class Extracteur(object):
    def extractionApprenantClavardage(self, personne, seance):
        """Extrait des fichiers texte d'une sessions de clavardage les interventions 
        des chaque apprenant 
        
        @param personne: nom de la personne  extraire
        @param fichier: nom du fichier de la session de clavardage"""
        fichier = os.path.join(os.getcwd(), 'mulce', seance + ".txt")
        fout = os.path.join(os.getcwd(), 'mulce', seance + "_" + personne + ".txt")
        dz = open(fichier, 'r')
        out = open(fout,'w')
        
        ldz = dz.readlines()
        dz.close()
        lLines = ldz 
        if len(lLines)==0: raise ValueError('Fichier vide')                   # Modifiee 20.03.2019, ancienne ligne:  if len(lLines)==0: raise ValueError,u"Fichier vide"
        # recherche la personne, case sensitive
        regexpattern = regex.compile("^"+personne)                 # Modifiee 16.04.2019, ancienne ligne:  regex = re.compile("^"+personne)
        nb_ligne = 0
        for ligne in lLines:
            if regexpattern.match(ligne):                          # Modifiee 16.04.2019, ancienne ligne:  if regex.match(ligne): 
                # match le dbut rel de l'interventino de la personne
                pos_dialogue = ligne.find('>>') 
                out.write(ligne[pos_dialogue+2:])
                nb_ligne += 1
        out.close()
        if nb_ligne == 0:
            os.remove(fout)
            
if __name__ == '__main__':
    ex = Extracteur()
    gens = ['Alba', 'Alan','Annie', 'Matt', 'Niels', 'Camille', 'Gary', 'Raymond', 'Ben', 'Sabrina']
    seances = ['e0a3_clavardage','e2a4_clavardage', 'e2a4menu']
    for personne in gens:
        for seance in seances:
            ex.extractionApprenantClavardage(personne, seance)
            